SET NAMES utf8mb4;
SET FOREIGN_KEY_CHECKS = 0;

CREATE TABLE `idtoad` (
  `id` int(6) unsigned NOT NULL DEFAULT 0,
  `province_id` int(2) unsigned NOT NULL DEFAULT 0 COMMENT '省ID',
  `city_id` int(2) unsigned NOT NULL DEFAULT 0 COMMENT '市ID',
  `county_id` int(2) unsigned NOT NULL DEFAULT 0 COMMENT '区县ID',
  `province_name` varchar(200) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '省名',
  `city_name` varchar(200) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '市名',
  `count_name` varchar(200) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '区县名',
  `status` tinyint(1) unsigned NOT NULL DEFAULT 0 COMMENT '是否有效(为0表示已经不存在或被合并)',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

BEGIN;
INSERT INTO `idtoad` VALUES (110000, 11, 0, 0, '北京', '', '', 0);
INSERT INTO `idtoad` VALUES (110100, 11, 1, 0, '北京', '市辖区', '', 0);
INSERT INTO `idtoad` VALUES (110101, 11, 1, 1, '北京', '北京', '东城区', 1);
INSERT INTO `idtoad` VALUES (110102, 11, 1, 2, '北京', '北京', '西城区', 1);
INSERT INTO `idtoad` VALUES (110103, 11, 1, 3, '北京', '北京', '崇文区', 0);
INSERT INTO `idtoad` VALUES (110104, 11, 1, 4, '北京', '北京', '宣武区', 0);
INSERT INTO `idtoad` VALUES (110105, 11, 1, 5, '北京', '北京', '朝阳区', 1);
INSERT INTO `idtoad` VALUES (110106, 11, 1, 6, '北京', '北京', '丰台区', 1);
INSERT INTO `idtoad` VALUES (110107, 11, 1, 7, '北京', '北京', '石景山区', 1);
INSERT INTO `idtoad` VALUES (110108, 11, 1, 8, '北京', '北京', '海淀区', 1);
INSERT INTO `idtoad` VALUES (110109, 11, 1, 9, '北京', '北京', '门头沟区', 1);
INSERT INTO `idtoad` VALUES (110111, 11, 1, 11, '北京', '北京', '房山区', 1);
INSERT INTO `idtoad` VALUES (110112, 11, 1, 12, '北京', '北京', '通州区', 1);
INSERT INTO `idtoad` VALUES (110113, 11, 1, 13, '北京', '北京', '顺义区', 1);
INSERT INTO `idtoad` VALUES (110114, 11, 1, 14, '北京', '北京', '昌平区', 1);
INSERT INTO `idtoad` VALUES (110115, 11, 1, 15, '北京', '北京', '大兴区', 1);
INSERT INTO `idtoad` VALUES (110116, 11, 1, 16, '北京', '北京', '怀柔区', 1);
INSERT INTO `idtoad` VALUES (110117, 11, 1, 17, '北京', '北京', '平谷区', 1);
INSERT INTO `idtoad` VALUES (110118, 11, 1, 18, '北京', '北京', '密云区', 1);
INSERT INTO `idtoad` VALUES (110119, 11, 1, 19, '北京', '北京', '延庆区', 1);
INSERT INTO `idtoad` VALUES (110200, 11, 2, 0, '北京', '市县', '', 0);
INSERT INTO `idtoad` VALUES (110221, 11, 2, 21, '北京', '北京', '昌平县', 0);
INSERT INTO `idtoad` VALUES (110224, 11, 2, 24, '北京', '北京', '大兴县', 0);
INSERT INTO `idtoad` VALUES (110226, 11, 2, 26, '北京', '北京', '平谷县', 0);
INSERT INTO `idtoad` VALUES (110227, 11, 2, 27, '北京', '北京', '怀柔县', 0);
INSERT INTO `idtoad` VALUES (110228, 11, 2, 28, '北京', '北京', '密云县', 0);
INSERT INTO `idtoad` VALUES (110229, 11, 2, 29, '北京', '北京', '延庆县', 0);
INSERT INTO `idtoad` VALUES (120000, 12, 0, 0, '天津', '', '', 0);
INSERT INTO `idtoad` VALUES (120100, 12, 1, 0, '天津', '市辖区', '', 0);
INSERT INTO `idtoad` VALUES (120101, 12, 1, 1, '天津', '天津', '和平区', 1);
INSERT INTO `idtoad` VALUES (120102, 12, 1, 2, '天津', '天津', '河东区', 1);
INSERT INTO `idtoad` VALUES (120103, 12, 1, 3, '天津', '天津', '河西区', 1);
INSERT INTO `idtoad` VALUES (120104, 12, 1, 4, '天津', '天津', '南开区', 1);
INSERT INTO `idtoad` VALUES (120105, 12, 1, 5, '天津', '天津', '河北区', 1);
INSERT INTO `idtoad` VALUES (120106, 12, 1, 6, '天津', '天津', '红桥区', 1);
INSERT INTO `idtoad` VALUES (120107, 12, 1, 7, '天津', '天津', '塘沽区', 0);
INSERT INTO `idtoad` VALUES (120108, 12, 1, 8, '天津', '天津', '汉沽区', 0);
INSERT INTO `idtoad` VALUES (120109, 12, 1, 9, '天津', '天津', '大港区', 0);
INSERT INTO `idtoad` VALUES (120110, 12, 1, 10, '天津', '天津', '东丽区', 1);
INSERT INTO `idtoad` VALUES (120111, 12, 1, 11, '天津', '天津', '西青区', 1);
INSERT INTO `idtoad` VALUES (120112, 12, 1, 12, '天津', '天津', '津南区', 1);
INSERT INTO `idtoad` VALUES (120113, 12, 1, 13, '天津', '天津', '北辰区', 1);
INSERT INTO `idtoad` VALUES (120114, 12, 1, 14, '天津', '天津', '武清区', 1);
INSERT INTO `idtoad` VALUES (120115, 12, 1, 15, '天津', '天津', '宝坻区', 1);
INSERT INTO `idtoad` VALUES (120116, 12, 1, 16, '天津', '天津', '滨海新区', 1);
INSERT INTO `idtoad` VALUES (120117, 12, 1, 17, '天津', '天津', '宁河区', 1);
INSERT INTO `idtoad` VALUES (120118, 12, 1, 18, '天津', '天津', '静海区', 1);
INSERT INTO `idtoad` VALUES (120119, 12, 1, 19, '天津', '天津', '蓟州区', 1);
INSERT INTO `idtoad` VALUES (120200, 12, 2, 0, '天津', '市县', '', 0);
INSERT INTO `idtoad` VALUES (120221, 12, 2, 21, '天津', '天津', '宁河县', 0);
INSERT INTO `idtoad` VALUES (120222, 12, 2, 22, '天津', '天津', '武清县', 0);
INSERT INTO `idtoad` VALUES (120223, 12, 2, 23, '天津', '天津', '静海县', 0);
INSERT INTO `idtoad` VALUES (120224, 12, 2, 24, '天津', '天津', '宝坻县', 0);
INSERT INTO `idtoad` VALUES (120225, 12, 2, 25, '天津', '天津', '蓟县', 0);
INSERT INTO `idtoad` VALUES (130000, 13, 0, 0, '河北', '', '', 0);
INSERT INTO `idtoad` VALUES (130100, 13, 1, 0, '河北', '石家庄', '', 0);
INSERT INTO `idtoad` VALUES (130101, 13, 1, 1, '河北', '石家庄', '市辖区', 0);
INSERT INTO `idtoad` VALUES (130102, 13, 1, 2, '河北', '石家庄', '长安区', 1);
INSERT INTO `idtoad` VALUES (130103, 13, 1, 3, '河北', '石家庄', '桥东区', 0);
INSERT INTO `idtoad` VALUES (130104, 13, 1, 4, '河北', '石家庄', '桥西区', 1);
INSERT INTO `idtoad` VALUES (130105, 13, 1, 5, '河北', '石家庄', '新华区', 1);
INSERT INTO `idtoad` VALUES (130106, 13, 1, 6, '河北', '石家庄', '郊区', 0);
INSERT INTO `idtoad` VALUES (130107, 13, 1, 7, '河北', '石家庄', '井陉矿区', 1);
INSERT INTO `idtoad` VALUES (130108, 13, 1, 8, '河北', '石家庄', '裕华区', 1);
INSERT INTO `idtoad` VALUES (130109, 13, 1, 9, '河北', '石家庄', '藁城区', 1);
INSERT INTO `idtoad` VALUES (130110, 13, 1, 10, '河北', '石家庄', '鹿泉区', 1);
INSERT INTO `idtoad` VALUES (130111, 13, 1, 11, '河北', '石家庄', '栾城区', 1);
INSERT INTO `idtoad` VALUES (130121, 13, 1, 21, '河北', '石家庄', '井陉县', 1);
INSERT INTO `idtoad` VALUES (130123, 13, 1, 23, '河北', '石家庄', '正定县', 1);
INSERT INTO `idtoad` VALUES (130124, 13, 1, 24, '河北', '石家庄', '栾城县', 0);
INSERT INTO `idtoad` VALUES (130125, 13, 1, 25, '河北', '石家庄', '行唐县', 1);
INSERT INTO `idtoad` VALUES (130126, 13, 1, 26, '河北', '石家庄', '灵寿县', 1);
INSERT INTO `idtoad` VALUES (130127, 13, 1, 27, '河北', '石家庄', '高邑县', 1);
INSERT INTO `idtoad` VALUES (130128, 13, 1, 28, '河北', '石家庄', '深泽县', 1);
INSERT INTO `idtoad` VALUES (130129, 13, 1, 29, '河北', '石家庄', '赞皇县', 1);
INSERT INTO `idtoad` VALUES (130130, 13, 1, 30, '河北', '石家庄', '无极县', 1);
INSERT INTO `idtoad` VALUES (130131, 13, 1, 31, '河北', '石家庄', '平山县', 1);
INSERT INTO `idtoad` VALUES (130132, 13, 1, 32, '河北', '石家庄', '元氏县', 1);
INSERT INTO `idtoad` VALUES (130133, 13, 1, 33, '河北', '石家庄', '赵县', 1);
INSERT INTO `idtoad` VALUES (130181, 13, 1, 81, '河北', '石家庄', '辛集市', 1);
INSERT INTO `idtoad` VALUES (130182, 13, 1, 82, '河北', '石家庄', '藁城市', 0);
INSERT INTO `idtoad` VALUES (130183, 13, 1, 83, '河北', '石家庄', '晋州市', 1);
INSERT INTO `idtoad` VALUES (130184, 13, 1, 84, '河北', '石家庄', '新乐市', 1);
INSERT INTO `idtoad` VALUES (130185, 13, 1, 85, '河北', '石家庄', '鹿泉市', 0);
INSERT INTO `idtoad` VALUES (130200, 13, 2, 0, '河北', '唐山', '', 0);
INSERT INTO `idtoad` VALUES (130201, 13, 2, 1, '河北', '唐山', '市辖区', 0);
INSERT INTO `idtoad` VALUES (130202, 13, 2, 2, '河北', '唐山', '路南区', 1);
INSERT INTO `idtoad` VALUES (130203, 13, 2, 3, '河北', '唐山', '路北区', 1);
INSERT INTO `idtoad` VALUES (130204, 13, 2, 4, '河北', '唐山', '古冶区', 1);
INSERT INTO `idtoad` VALUES (130205, 13, 2, 5, '河北', '唐山', '开平区', 1);
INSERT INTO `idtoad` VALUES (130206, 13, 2, 6, '河北', '唐山', '新区', 0);
INSERT INTO `idtoad` VALUES (130207, 13, 2, 7, '河北', '唐山', '丰南区', 1);
INSERT INTO `idtoad` VALUES (130208, 13, 2, 8, '河北', '唐山', '丰润区', 1);
INSERT INTO `idtoad` VALUES (130209, 13, 2, 9, '河北', '唐山', '曹妃甸区', 1);
INSERT INTO `idtoad` VALUES (130221, 13, 2, 21, '河北', '唐山', '丰润县', 0);
INSERT INTO `idtoad` VALUES (130223, 13, 2, 23, '河北', '唐山', '滦县', 0);
INSERT INTO `idtoad` VALUES (130224, 13, 2, 24, '河北', '唐山', '滦南县', 1);
INSERT INTO `idtoad` VALUES (130225, 13, 2, 25, '河北', '唐山', '乐亭县', 1);
INSERT INTO `idtoad` VALUES (130227, 13, 2, 27, '河北', '唐山', '迁西县', 1);
INSERT INTO `idtoad` VALUES (130229, 13, 2, 29, '河北', '唐山', '玉田县', 1);
INSERT INTO `idtoad` VALUES (130230, 13, 2, 30, '河北', '唐山', '唐海县', 0);
INSERT INTO `idtoad` VALUES (130281, 13, 2, 81, '河北', '唐山', '遵化市', 1);
INSERT INTO `idtoad` VALUES (130282, 13, 2, 82, '河北', '唐山', '丰南市', 0);
INSERT INTO `idtoad` VALUES (130283, 13, 2, 83, '河北', '唐山', '迁安市', 1);
INSERT INTO `idtoad` VALUES (130284, 13, 2, 84, '河北', '唐山', '滦州市', 1);
INSERT INTO `idtoad` VALUES (130300, 13, 3, 0, '河北', '秦皇岛', '', 0);
INSERT INTO `idtoad` VALUES (130301, 13, 3, 1, '河北', '秦皇岛', '市辖区', 0);
INSERT INTO `idtoad` VALUES (130302, 13, 3, 2, '河北', '秦皇岛', '海港区', 1);
INSERT INTO `idtoad` VALUES (130303, 13, 3, 3, '河北', '秦皇岛', '山海关区', 1);
INSERT INTO `idtoad` VALUES (130304, 13, 3, 4, '河北', '秦皇岛', '北戴河区', 1);
INSERT INTO `idtoad` VALUES (130306, 13, 3, 6, '河北', '秦皇岛', '抚宁区', 1);
INSERT INTO `idtoad` VALUES (130321, 13, 3, 21, '河北', '秦皇岛', '青龙满族自治县', 1);
INSERT INTO `idtoad` VALUES (130322, 13, 3, 22, '河北', '秦皇岛', '昌黎县', 1);
INSERT INTO `idtoad` VALUES (130323, 13, 3, 23, '河北', '秦皇岛', '抚宁县', 0);
INSERT INTO `idtoad` VALUES (130324, 13, 3, 24, '河北', '秦皇岛', '卢龙县', 1);
INSERT INTO `idtoad` VALUES (130400, 13, 4, 0, '河北', '邯郸', '', 0);
INSERT INTO `idtoad` VALUES (130401, 13, 4, 1, '河北', '邯郸', '市辖区', 0);
INSERT INTO `idtoad` VALUES (130402, 13, 4, 2, '河北', '邯郸', '邯山区', 1);
INSERT INTO `idtoad` VALUES (130403, 13, 4, 3, '河北', '邯郸', '丛台区', 1);
INSERT INTO `idtoad` VALUES (130404, 13, 4, 4, '河北', '邯郸', '复兴区', 1);
INSERT INTO `idtoad` VALUES (130406, 13, 4, 6, '河北', '邯郸', '峰峰矿区', 1);
INSERT INTO `idtoad` VALUES (130407, 13, 4, 7, '河北', '邯郸', '肥乡区', 1);
INSERT INTO `idtoad` VALUES (130408, 13, 4, 8, '河北', '邯郸', '永年区', 1);
INSERT INTO `idtoad` VALUES (130421, 13, 4, 21, '河北', '邯郸', '邯郸县', 0);
INSERT INTO `idtoad` VALUES (130423, 13, 4, 23, '河北', '邯郸', '临漳县', 1);
INSERT INTO `idtoad` VALUES (130424, 13, 4, 24, '河北', '邯郸', '成安县', 1);
INSERT INTO `idtoad` VALUES (130425, 13, 4, 25, '河北', '邯郸', '大名县', 1);
INSERT INTO `idtoad` VALUES (130426, 13, 4, 26, '河北', '邯郸', '涉县', 1);
INSERT INTO `idtoad` VALUES (130427, 13, 4, 27, '河北', '邯郸', '磁县', 1);
INSERT INTO `idtoad` VALUES (130428, 13, 4, 28, '河北', '邯郸', '肥乡县', 0);
INSERT INTO `idtoad` VALUES (130429, 13, 4, 29, '河北', '邯郸', '永年县', 0);
INSERT INTO `idtoad` VALUES (130430, 13, 4, 30, '河北', '邯郸', '邱县', 1);
INSERT INTO `idtoad` VALUES (130431, 13, 4, 31, '河北', '邯郸', '鸡泽县', 1);
INSERT INTO `idtoad` VALUES (130432, 13, 4, 32, '河北', '邯郸', '广平县', 1);
INSERT INTO `idtoad` VALUES (130433, 13, 4, 33, '河北', '邯郸', '馆陶县', 1);
INSERT INTO `idtoad` VALUES (130434, 13, 4, 34, '河北', '邯郸', '魏县', 1);
INSERT INTO `idtoad` VALUES (130435, 13, 4, 35, '河北', '邯郸', '曲周县', 1);
INSERT INTO `idtoad` VALUES (130481, 13, 4, 81, '河北', '邯郸', '武安市', 1);
INSERT INTO `idtoad` VALUES (130500, 13, 5, 0, '河北', '邢台', '', 0);
INSERT INTO `idtoad` VALUES (130501, 13, 5, 1, '河北', '邢台', '市辖区', 0);
INSERT INTO `idtoad` VALUES (130502, 13, 5, 2, '河北', '邢台', '襄都区', 1);
INSERT INTO `idtoad` VALUES (130503, 13, 5, 3, '河北', '邢台', '信都区', 1);
INSERT INTO `idtoad` VALUES (130505, 13, 5, 5, '河北', '邢台', '任泽区', 1);
INSERT INTO `idtoad` VALUES (130506, 13, 5, 6, '河北', '邢台', '南和区', 1);
INSERT INTO `idtoad` VALUES (130521, 13, 5, 21, '河北', '邢台', '邢台县', 0);
INSERT INTO `idtoad` VALUES (130522, 13, 5, 22, '河北', '邢台', '临城县', 1);
INSERT INTO `idtoad` VALUES (130523, 13, 5, 23, '河北', '邢台', '内丘县', 1);
INSERT INTO `idtoad` VALUES (130524, 13, 5, 24, '河北', '邢台', '柏乡县', 1);
INSERT INTO `idtoad` VALUES (130525, 13, 5, 25, '河北', '邢台', '隆尧县', 1);
INSERT INTO `idtoad` VALUES (130526, 13, 5, 26, '河北', '邢台', '任县', 0);
INSERT INTO `idtoad` VALUES (130527, 13, 5, 27, '河北', '邢台', '南和县', 0);
INSERT INTO `idtoad` VALUES (130528, 13, 5, 28, '河北', '邢台', '宁晋县', 1);
INSERT INTO `idtoad` VALUES (130529, 13, 5, 29, '河北', '邢台', '巨鹿县', 1);
INSERT INTO `idtoad` VALUES (130530, 13, 5, 30, '河北', '邢台', '新河县', 1);
INSERT INTO `idtoad` VALUES (130531, 13, 5, 31, '河北', '邢台', '广宗县', 1);
INSERT INTO `idtoad` VALUES (130532, 13, 5, 32, '河北', '邢台', '平乡县', 1);
INSERT INTO `idtoad` VALUES (130533, 13, 5, 33, '河北', '邢台', '威县', 1);
INSERT INTO `idtoad` VALUES (130534, 13, 5, 34, '河北', '邢台', '清河县', 1);
INSERT INTO `idtoad` VALUES (130535, 13, 5, 35, '河北', '邢台', '临西县', 1);
INSERT INTO `idtoad` VALUES (130581, 13, 5, 81, '河北', '邢台', '南宫市', 1);
INSERT INTO `idtoad` VALUES (130582, 13, 5, 82, '河北', '邢台', '沙河市', 1);
INSERT INTO `idtoad` VALUES (130600, 13, 6, 0, '河北', '保定', '', 0);
INSERT INTO `idtoad` VALUES (130601, 13, 6, 1, '河北', '保定', '市辖区', 0);
INSERT INTO `idtoad` VALUES (130602, 13, 6, 2, '河北', '保定', '竞秀区', 1);
INSERT INTO `idtoad` VALUES (130603, 13, 6, 3, '河北', '保定', '北市区', 0);
INSERT INTO `idtoad` VALUES (130604, 13, 6, 4, '河北', '保定', '南市区', 0);
INSERT INTO `idtoad` VALUES (130606, 13, 6, 6, '河北', '保定', '莲池区', 1);
INSERT INTO `idtoad` VALUES (130607, 13, 6, 7, '河北', '保定', '满城区', 1);
INSERT INTO `idtoad` VALUES (130608, 13, 6, 8, '河北', '保定', '清苑区', 1);
INSERT INTO `idtoad` VALUES (130609, 13, 6, 9, '河北', '保定', '徐水区', 1);
INSERT INTO `idtoad` VALUES (130621, 13, 6, 21, '河北', '保定', '满城县', 0);
INSERT INTO `idtoad` VALUES (130622, 13, 6, 22, '河北', '保定', '清苑县', 0);
INSERT INTO `idtoad` VALUES (130623, 13, 6, 23, '河北', '保定', '涞水县', 1);
INSERT INTO `idtoad` VALUES (130624, 13, 6, 24, '河北', '保定', '阜平县', 1);
INSERT INTO `idtoad` VALUES (130625, 13, 6, 25, '河北', '保定', '徐水县', 0);
INSERT INTO `idtoad` VALUES (130626, 13, 6, 26, '河北', '保定', '定兴县', 1);
INSERT INTO `idtoad` VALUES (130627, 13, 6, 27, '河北', '保定', '唐县', 1);
INSERT INTO `idtoad` VALUES (130628, 13, 6, 28, '河北', '保定', '高阳县', 1);
INSERT INTO `idtoad` VALUES (130629, 13, 6, 29, '河北', '保定', '容城县', 1);
INSERT INTO `idtoad` VALUES (130630, 13, 6, 30, '河北', '保定', '涞源县', 1);
INSERT INTO `idtoad` VALUES (130631, 13, 6, 31, '河北', '保定', '望都县', 1);
INSERT INTO `idtoad` VALUES (130632, 13, 6, 32, '河北', '保定', '安新县', 1);
INSERT INTO `idtoad` VALUES (130633, 13, 6, 33, '河北', '保定', '易县', 1);
INSERT INTO `idtoad` VALUES (130634, 13, 6, 34, '河北', '保定', '曲阳县', 1);
INSERT INTO `idtoad` VALUES (130635, 13, 6, 35, '河北', '保定', '蠡县', 1);
INSERT INTO `idtoad` VALUES (130636, 13, 6, 36, '河北', '保定', '顺平县', 1);
INSERT INTO `idtoad` VALUES (130637, 13, 6, 37, '河北', '保定', '博野县', 1);
INSERT INTO `idtoad` VALUES (130638, 13, 6, 38, '河北', '保定', '雄县', 1);
INSERT INTO `idtoad` VALUES (130681, 13, 6, 81, '河北', '保定', '涿州市', 1);
INSERT INTO `idtoad` VALUES (130682, 13, 6, 82, '河北', '保定', '定州市', 1);
INSERT INTO `idtoad` VALUES (130683, 13, 6, 83, '河北', '保定', '安国市', 1);
INSERT INTO `idtoad` VALUES (130684, 13, 6, 84, '河北', '保定', '高碑店市', 1);
INSERT INTO `idtoad` VALUES (130700, 13, 7, 0, '河北', '张家口', '', 0);
INSERT INTO `idtoad` VALUES (130701, 13, 7, 1, '河北', '张家口', '市辖区', 0);
INSERT INTO `idtoad` VALUES (130702, 13, 7, 2, '河北', '张家口', '桥东区', 1);
INSERT INTO `idtoad` VALUES (130703, 13, 7, 3, '河北', '张家口', '桥西区', 1);
INSERT INTO `idtoad` VALUES (130705, 13, 7, 5, '河北', '张家口', '宣化区', 1);
INSERT INTO `idtoad` VALUES (130706, 13, 7, 6, '河北', '张家口', '下花园区', 1);
INSERT INTO `idtoad` VALUES (130708, 13, 7, 8, '河北', '张家口', '万全区', 1);
INSERT INTO `idtoad` VALUES (130709, 13, 7, 9, '河北', '张家口', '崇礼区', 1);
INSERT INTO `idtoad` VALUES (130721, 13, 7, 21, '河北', '张家口', '宣化县', 0);
INSERT INTO `idtoad` VALUES (130722, 13, 7, 22, '河北', '张家口', '张北县', 1);
INSERT INTO `idtoad` VALUES (130723, 13, 7, 23, '河北', '张家口', '康保县', 1);
INSERT INTO `idtoad` VALUES (130724, 13, 7, 24, '河北', '张家口', '沽源县', 1);
INSERT INTO `idtoad` VALUES (130725, 13, 7, 25, '河北', '张家口', '尚义县', 1);
INSERT INTO `idtoad` VALUES (130726, 13, 7, 26, '河北', '张家口', '蔚县', 1);
INSERT INTO `idtoad` VALUES (130727, 13, 7, 27, '河北', '张家口', '阳原县', 1);
INSERT INTO `idtoad` VALUES (130728, 13, 7, 28, '河北', '张家口', '怀安县', 1);
INSERT INTO `idtoad` VALUES (130729, 13, 7, 29, '河北', '张家口', '万全县', 0);
INSERT INTO `idtoad` VALUES (130730, 13, 7, 30, '河北', '张家口', '怀来县', 1);
INSERT INTO `idtoad` VALUES (130731, 13, 7, 31, '河北', '张家口', '涿鹿县', 1);
INSERT INTO `idtoad` VALUES (130732, 13, 7, 32, '河北', '张家口', '赤城县', 1);
INSERT INTO `idtoad` VALUES (130733, 13, 7, 33, '河北', '张家口', '崇礼县', 0);
INSERT INTO `idtoad` VALUES (130800, 13, 8, 0, '河北', '承德', '', 0);
INSERT INTO `idtoad` VALUES (130801, 13, 8, 1, '河北', '承德', '市辖区', 0);
INSERT INTO `idtoad` VALUES (130802, 13, 8, 2, '河北', '承德', '双桥区', 1);
INSERT INTO `idtoad` VALUES (130803, 13, 8, 3, '河北', '承德', '双滦区', 1);
INSERT INTO `idtoad` VALUES (130804, 13, 8, 4, '河北', '承德', '鹰手营子矿区', 1);
INSERT INTO `idtoad` VALUES (130821, 13, 8, 21, '河北', '承德', '承德县', 1);
INSERT INTO `idtoad` VALUES (130822, 13, 8, 22, '河北', '承德', '兴隆县', 1);
INSERT INTO `idtoad` VALUES (130823, 13, 8, 23, '河北', '承德', '平泉县', 0);
INSERT INTO `idtoad` VALUES (130824, 13, 8, 24, '河北', '承德', '滦平县', 1);
INSERT INTO `idtoad` VALUES (130825, 13, 8, 25, '河北', '承德', '隆化县', 1);
INSERT INTO `idtoad` VALUES (130826, 13, 8, 26, '河北', '承德', '丰宁满族自治县', 1);
INSERT INTO `idtoad` VALUES (130827, 13, 8, 27, '河北', '承德', '宽城满族自治县', 1);
INSERT INTO `idtoad` VALUES (130828, 13, 8, 28, '河北', '承德', '围场满族蒙古族自治县', 1);
INSERT INTO `idtoad` VALUES (130881, 13, 8, 81, '河北', '承德', '平泉市', 1);
INSERT INTO `idtoad` VALUES (130900, 13, 9, 0, '河北', '沧州', '', 0);
INSERT INTO `idtoad` VALUES (130901, 13, 9, 1, '河北', '沧州', '市辖区', 0);
INSERT INTO `idtoad` VALUES (130902, 13, 9, 2, '河北', '沧州', '新华区', 1);
INSERT INTO `idtoad` VALUES (130903, 13, 9, 3, '河北', '沧州', '运河区', 1);
INSERT INTO `idtoad` VALUES (130921, 13, 9, 21, '河北', '沧州', '沧县', 1);
INSERT INTO `idtoad` VALUES (130922, 13, 9, 22, '河北', '沧州', '青县', 1);
INSERT INTO `idtoad` VALUES (130923, 13, 9, 23, '河北', '沧州', '东光县', 1);
INSERT INTO `idtoad` VALUES (130924, 13, 9, 24, '河北', '沧州', '海兴县', 1);
INSERT INTO `idtoad` VALUES (130925, 13, 9, 25, '河北', '沧州', '盐山县', 1);
INSERT INTO `idtoad` VALUES (130926, 13, 9, 26, '河北', '沧州', '肃宁县', 1);
INSERT INTO `idtoad` VALUES (130927, 13, 9, 27, '河北', '沧州', '南皮县', 1);
INSERT INTO `idtoad` VALUES (130928, 13, 9, 28, '河北', '沧州', '吴桥县', 1);
INSERT INTO `idtoad` VALUES (130929, 13, 9, 29, '河北', '沧州', '献县', 1);
INSERT INTO `idtoad` VALUES (130930, 13, 9, 30, '河北', '沧州', '孟村回族自治县', 1);
INSERT INTO `idtoad` VALUES (130981, 13, 9, 81, '河北', '沧州', '泊头市', 1);
INSERT INTO `idtoad` VALUES (130982, 13, 9, 82, '河北', '沧州', '任丘市', 1);
INSERT INTO `idtoad` VALUES (130983, 13, 9, 83, '河北', '沧州', '黄骅市', 1);
INSERT INTO `idtoad` VALUES (130984, 13, 9, 84, '河北', '沧州', '河间市', 1);
INSERT INTO `idtoad` VALUES (131000, 13, 10, 0, '河北', '廊坊', '', 0);
INSERT INTO `idtoad` VALUES (131001, 13, 10, 1, '河北', '廊坊', '市辖区', 0);
INSERT INTO `idtoad` VALUES (131002, 13, 10, 2, '河北', '廊坊', '安次区', 1);
INSERT INTO `idtoad` VALUES (131003, 13, 10, 3, '河北', '廊坊', '广阳区', 1);
INSERT INTO `idtoad` VALUES (131022, 13, 10, 22, '河北', '廊坊', '固安县', 1);
INSERT INTO `idtoad` VALUES (131023, 13, 10, 23, '河北', '廊坊', '永清县', 1);
INSERT INTO `idtoad` VALUES (131024, 13, 10, 24, '河北', '廊坊', '香河县', 1);
INSERT INTO `idtoad` VALUES (131025, 13, 10, 25, '河北', '廊坊', '大城县', 1);
INSERT INTO `idtoad` VALUES (131026, 13, 10, 26, '河北', '廊坊', '文安县', 1);
INSERT INTO `idtoad` VALUES (131028, 13, 10, 28, '河北', '廊坊', '大厂回族自治县', 1);
INSERT INTO `idtoad` VALUES (131081, 13, 10, 81, '河北', '廊坊', '霸州市', 1);
INSERT INTO `idtoad` VALUES (131082, 13, 10, 82, '河北', '廊坊', '三河市', 1);
INSERT INTO `idtoad` VALUES (131100, 13, 11, 0, '河北', '衡水', '', 0);
INSERT INTO `idtoad` VALUES (131101, 13, 11, 1, '河北', '衡水', '市辖区', 0);
INSERT INTO `idtoad` VALUES (131102, 13, 11, 2, '河北', '衡水', '桃城区', 1);
INSERT INTO `idtoad` VALUES (131103, 13, 11, 3, '河北', '衡水', '冀州区', 1);
INSERT INTO `idtoad` VALUES (131121, 13, 11, 21, '河北', '衡水', '枣强县', 1);
INSERT INTO `idtoad` VALUES (131122, 13, 11, 22, '河北', '衡水', '武邑县', 1);
INSERT INTO `idtoad` VALUES (131123, 13, 11, 23, '河北', '衡水', '武强县', 1);
INSERT INTO `idtoad` VALUES (131124, 13, 11, 24, '河北', '衡水', '饶阳县', 1);
INSERT INTO `idtoad` VALUES (131125, 13, 11, 25, '河北', '衡水', '安平县', 1);
INSERT INTO `idtoad` VALUES (131126, 13, 11, 26, '河北', '衡水', '故城县', 1);
INSERT INTO `idtoad` VALUES (131127, 13, 11, 27, '河北', '衡水', '景县', 1);
INSERT INTO `idtoad` VALUES (131128, 13, 11, 28, '河北', '衡水', '阜城县', 1);
INSERT INTO `idtoad` VALUES (131181, 13, 11, 81, '河北', '衡水', '冀州市', 0);
INSERT INTO `idtoad` VALUES (131182, 13, 11, 82, '河北', '衡水', '深州市', 1);
INSERT INTO `idtoad` VALUES (140000, 14, 0, 0, '山西', '', '', 0);
INSERT INTO `idtoad` VALUES (140100, 14, 1, 0, '山西', '太原', '', 0);
INSERT INTO `idtoad` VALUES (140101, 14, 1, 1, '山西', '太原', '市辖区', 0);
INSERT INTO `idtoad` VALUES (140105, 14, 1, 5, '山西', '太原', '小店区', 1);
INSERT INTO `idtoad` VALUES (140106, 14, 1, 6, '山西', '太原', '迎泽区', 1);
INSERT INTO `idtoad` VALUES (140107, 14, 1, 7, '山西', '太原', '杏花岭区', 1);
INSERT INTO `idtoad` VALUES (140108, 14, 1, 8, '山西', '太原', '尖草坪区', 1);
INSERT INTO `idtoad` VALUES (140109, 14, 1, 9, '山西', '太原', '万柏林区', 1);
INSERT INTO `idtoad` VALUES (140110, 14, 1, 10, '山西', '太原', '晋源区', 1);
INSERT INTO `idtoad` VALUES (140121, 14, 1, 21, '山西', '太原', '清徐县', 1);
INSERT INTO `idtoad` VALUES (140122, 14, 1, 22, '山西', '太原', '阳曲县', 1);
INSERT INTO `idtoad` VALUES (140123, 14, 1, 23, '山西', '太原', '娄烦县', 1);
INSERT INTO `idtoad` VALUES (140181, 14, 1, 81, '山西', '太原', '古交市', 1);
INSERT INTO `idtoad` VALUES (140200, 14, 2, 0, '山西', '大同', '', 0);
INSERT INTO `idtoad` VALUES (140201, 14, 2, 1, '山西', '大同', '市辖区', 0);
INSERT INTO `idtoad` VALUES (140202, 14, 2, 2, '山西', '大同', '城区', 0);
INSERT INTO `idtoad` VALUES (140203, 14, 2, 3, '山西', '大同', '矿区', 0);
INSERT INTO `idtoad` VALUES (140211, 14, 2, 11, '山西', '大同', '南郊区', 0);
INSERT INTO `idtoad` VALUES (140212, 14, 2, 12, '山西', '大同', '新荣区', 1);
INSERT INTO `idtoad` VALUES (140213, 14, 2, 13, '山西', '大同', '平城区', 1);
INSERT INTO `idtoad` VALUES (140214, 14, 2, 14, '山西', '大同', '云冈区', 1);
INSERT INTO `idtoad` VALUES (140215, 14, 2, 15, '山西', '大同', '云州区', 1);
INSERT INTO `idtoad` VALUES (140221, 14, 2, 21, '山西', '大同', '阳高县', 1);
INSERT INTO `idtoad` VALUES (140222, 14, 2, 22, '山西', '大同', '天镇县', 1);
INSERT INTO `idtoad` VALUES (140223, 14, 2, 23, '山西', '大同', '广灵县', 1);
INSERT INTO `idtoad` VALUES (140224, 14, 2, 24, '山西', '大同', '灵丘县', 1);
INSERT INTO `idtoad` VALUES (140225, 14, 2, 25, '山西', '大同', '浑源县', 1);
INSERT INTO `idtoad` VALUES (140226, 14, 2, 26, '山西', '大同', '左云县', 1);
INSERT INTO `idtoad` VALUES (140227, 14, 2, 27, '山西', '大同', '大同县', 0);
INSERT INTO `idtoad` VALUES (140300, 14, 3, 0, '山西', '阳泉', '', 0);
INSERT INTO `idtoad` VALUES (140301, 14, 3, 1, '山西', '阳泉', '市辖区', 0);
INSERT INTO `idtoad` VALUES (140302, 14, 3, 2, '山西', '阳泉', '城区', 1);
INSERT INTO `idtoad` VALUES (140303, 14, 3, 3, '山西', '阳泉', '矿区', 1);
INSERT INTO `idtoad` VALUES (140311, 14, 3, 11, '山西', '阳泉', '郊区', 1);
INSERT INTO `idtoad` VALUES (140321, 14, 3, 21, '山西', '阳泉', '平定县', 1);
INSERT INTO `idtoad` VALUES (140322, 14, 3, 22, '山西', '阳泉', '盂县', 1);
INSERT INTO `idtoad` VALUES (140400, 14, 4, 0, '山西', '长治', '', 0);
INSERT INTO `idtoad` VALUES (140401, 14, 4, 1, '山西', '长治', '市辖区', 0);
INSERT INTO `idtoad` VALUES (140402, 14, 4, 2, '山西', '长治', '城区', 0);
INSERT INTO `idtoad` VALUES (140403, 14, 4, 3, '山西', '长治', '潞州区', 1);
INSERT INTO `idtoad` VALUES (140404, 14, 4, 4, '山西', '长治', '上党区', 1);
INSERT INTO `idtoad` VALUES (140405, 14, 4, 5, '山西', '长治', '屯留区', 1);
INSERT INTO `idtoad` VALUES (140406, 14, 4, 6, '山西', '长治', '潞城区', 1);
INSERT INTO `idtoad` VALUES (140411, 14, 4, 11, '山西', '长治', '郊区', 0);
INSERT INTO `idtoad` VALUES (140421, 14, 4, 21, '山西', '长治', '长治县', 0);
INSERT INTO `idtoad` VALUES (140423, 14, 4, 23, '山西', '长治', '襄垣县', 1);
INSERT INTO `idtoad` VALUES (140424, 14, 4, 24, '山西', '长治', '屯留县', 0);
INSERT INTO `idtoad` VALUES (140425, 14, 4, 25, '山西', '长治', '平顺县', 1);
INSERT INTO `idtoad` VALUES (140426, 14, 4, 26, '山西', '长治', '黎城县', 1);
INSERT INTO `idtoad` VALUES (140427, 14, 4, 27, '山西', '长治', '壶关县', 1);
INSERT INTO `idtoad` VALUES (140428, 14, 4, 28, '山西', '长治', '长子县', 1);
INSERT INTO `idtoad` VALUES (140429, 14, 4, 29, '山西', '长治', '武乡县', 1);
INSERT INTO `idtoad` VALUES (140430, 14, 4, 30, '山西', '长治', '沁县', 1);
INSERT INTO `idtoad` VALUES (140431, 14, 4, 31, '山西', '长治', '沁源县', 1);
INSERT INTO `idtoad` VALUES (140481, 14, 4, 81, '山西', '长治', '潞城市', 0);
INSERT INTO `idtoad` VALUES (140500, 14, 5, 0, '山西', '晋城', '', 0);
INSERT INTO `idtoad` VALUES (140501, 14, 5, 1, '山西', '晋城', '市辖区', 0);
INSERT INTO `idtoad` VALUES (140502, 14, 5, 2, '山西', '晋城', '城区', 1);
INSERT INTO `idtoad` VALUES (140521, 14, 5, 21, '山西', '晋城', '沁水县', 1);
INSERT INTO `idtoad` VALUES (140522, 14, 5, 22, '山西', '晋城', '阳城县', 1);
INSERT INTO `idtoad` VALUES (140524, 14, 5, 24, '山西', '晋城', '陵川县', 1);
INSERT INTO `idtoad` VALUES (140525, 14, 5, 25, '山西', '晋城', '泽州县', 1);
INSERT INTO `idtoad` VALUES (140581, 14, 5, 81, '山西', '晋城', '高平市', 1);
INSERT INTO `idtoad` VALUES (140600, 14, 6, 0, '山西', '朔州市', '', 0);
INSERT INTO `idtoad` VALUES (140601, 14, 6, 1, '山西', '晋城', '市辖区', 0);
INSERT INTO `idtoad` VALUES (140602, 14, 6, 2, '山西', '朔州', '朔城区', 1);
INSERT INTO `idtoad` VALUES (140603, 14, 6, 3, '山西', '朔州', '平鲁区', 1);
INSERT INTO `idtoad` VALUES (140621, 14, 6, 21, '山西', '朔州', '山阴县', 1);
INSERT INTO `idtoad` VALUES (140622, 14, 6, 22, '山西', '朔州', '应县', 1);
INSERT INTO `idtoad` VALUES (140623, 14, 6, 23, '山西', '朔州', '右玉县', 1);
INSERT INTO `idtoad` VALUES (140624, 14, 6, 24, '山西', '朔州', '怀仁县', 0);
INSERT INTO `idtoad` VALUES (140681, 14, 6, 81, '山西', '朔州', '怀仁市', 1);
INSERT INTO `idtoad` VALUES (140702, 14, 7, 2, '山西', '晋中', '榆次区', 1);
INSERT INTO `idtoad` VALUES (140703, 14, 7, 3, '山西', '晋中', '太谷区', 1);
INSERT INTO `idtoad` VALUES (140721, 14, 7, 21, '山西', '晋中', '榆社县', 1);
INSERT INTO `idtoad` VALUES (140722, 14, 7, 22, '山西', '晋中', '左权县', 1);
INSERT INTO `idtoad` VALUES (140723, 14, 7, 23, '山西', '晋中', '和顺县', 1);
INSERT INTO `idtoad` VALUES (140724, 14, 7, 24, '山西', '晋中', '昔阳县', 1);
INSERT INTO `idtoad` VALUES (140725, 14, 7, 25, '山西', '晋中', '寿阳县', 1);
INSERT INTO `idtoad` VALUES (140726, 14, 7, 26, '山西', '晋中', '太谷县', 0);
INSERT INTO `idtoad` VALUES (140727, 14, 7, 27, '山西', '晋中', '祁县', 1);
INSERT INTO `idtoad` VALUES (140728, 14, 7, 28, '山西', '晋中', '平遥县', 1);
INSERT INTO `idtoad` VALUES (140729, 14, 7, 29, '山西', '晋中', '灵石县', 1);
INSERT INTO `idtoad` VALUES (140781, 14, 7, 81, '山西', '晋中', '介休市', 1);
INSERT INTO `idtoad` VALUES (140802, 14, 8, 2, '山西', '运城', '盐湖区', 1);
INSERT INTO `idtoad` VALUES (140821, 14, 8, 21, '山西', '运城', '临猗县', 1);
INSERT INTO `idtoad` VALUES (140822, 14, 8, 22, '山西', '运城', '万荣县', 1);
INSERT INTO `idtoad` VALUES (140823, 14, 8, 23, '山西', '运城', '闻喜县', 1);
INSERT INTO `idtoad` VALUES (140824, 14, 8, 24, '山西', '运城', '稷山县', 1);
INSERT INTO `idtoad` VALUES (140825, 14, 8, 25, '山西', '运城', '新绛县', 1);
INSERT INTO `idtoad` VALUES (140826, 14, 8, 26, '山西', '运城', '绛县', 1);
INSERT INTO `idtoad` VALUES (140827, 14, 8, 27, '山西', '运城', '垣曲县', 1);
INSERT INTO `idtoad` VALUES (140828, 14, 8, 28, '山西', '运城', '夏县', 1);
INSERT INTO `idtoad` VALUES (140829, 14, 8, 29, '山西', '运城', '平陆县', 1);
INSERT INTO `idtoad` VALUES (140830, 14, 8, 30, '山西', '运城', '芮城县', 1);
INSERT INTO `idtoad` VALUES (140881, 14, 8, 81, '山西', '运城', '永济市', 1);
INSERT INTO `idtoad` VALUES (140882, 14, 8, 82, '山西', '运城', '河津市', 1);
INSERT INTO `idtoad` VALUES (140902, 14, 9, 2, '山西', '忻州', '忻府区', 1);
INSERT INTO `idtoad` VALUES (140921, 14, 9, 21, '山西', '忻州', '定襄县', 1);
INSERT INTO `idtoad` VALUES (140922, 14, 9, 22, '山西', '忻州', '五台县', 1);
INSERT INTO `idtoad` VALUES (140923, 14, 9, 23, '山西', '忻州', '代县', 1);
INSERT INTO `idtoad` VALUES (140924, 14, 9, 24, '山西', '忻州', '繁峙县', 1);
INSERT INTO `idtoad` VALUES (140925, 14, 9, 25, '山西', '忻州', '宁武县', 1);
INSERT INTO `idtoad` VALUES (140926, 14, 9, 26, '山西', '忻州', '静乐县', 1);
INSERT INTO `idtoad` VALUES (140927, 14, 9, 27, '山西', '忻州', '神池县', 1);
INSERT INTO `idtoad` VALUES (140928, 14, 9, 28, '山西', '忻州', '五寨县', 1);
INSERT INTO `idtoad` VALUES (140929, 14, 9, 29, '山西', '忻州', '岢岚县', 1);
INSERT INTO `idtoad` VALUES (140930, 14, 9, 30, '山西', '忻州', '河曲县', 1);
INSERT INTO `idtoad` VALUES (140931, 14, 9, 31, '山西', '忻州', '保德县', 1);
INSERT INTO `idtoad` VALUES (140932, 14, 9, 32, '山西', '忻州', '偏关县', 1);
INSERT INTO `idtoad` VALUES (140981, 14, 9, 81, '山西', '忻州', '原平市', 1);
INSERT INTO `idtoad` VALUES (141002, 14, 10, 2, '山西', '临汾', '尧都区', 1);
INSERT INTO `idtoad` VALUES (141021, 14, 10, 21, '山西', '临汾', '曲沃县', 1);
INSERT INTO `idtoad` VALUES (141022, 14, 10, 22, '山西', '临汾', '翼城县', 1);
INSERT INTO `idtoad` VALUES (141023, 14, 10, 23, '山西', '临汾', '襄汾县', 1);
INSERT INTO `idtoad` VALUES (141024, 14, 10, 24, '山西', '临汾', '洪洞县', 1);
INSERT INTO `idtoad` VALUES (141025, 14, 10, 25, '山西', '临汾', '古县', 1);
INSERT INTO `idtoad` VALUES (141026, 14, 10, 26, '山西', '临汾', '安泽县', 1);
INSERT INTO `idtoad` VALUES (141027, 14, 10, 27, '山西', '临汾', '浮山县', 1);
INSERT INTO `idtoad` VALUES (141028, 14, 10, 28, '山西', '临汾', '吉县', 1);
INSERT INTO `idtoad` VALUES (141029, 14, 10, 29, '山西', '临汾', '乡宁县', 1);
INSERT INTO `idtoad` VALUES (141030, 14, 10, 30, '山西', '临汾', '大宁县', 1);
INSERT INTO `idtoad` VALUES (141031, 14, 10, 31, '山西', '临汾', '隰县', 1);
INSERT INTO `idtoad` VALUES (141032, 14, 10, 32, '山西', '临汾', '永和县', 1);
INSERT INTO `idtoad` VALUES (141033, 14, 10, 33, '山西', '临汾', '蒲县', 1);
INSERT INTO `idtoad` VALUES (141034, 14, 10, 34, '山西', '临汾', '汾西县', 1);
INSERT INTO `idtoad` VALUES (141081, 14, 10, 81, '山西', '临汾', '侯马市', 1);
INSERT INTO `idtoad` VALUES (141082, 14, 10, 82, '山西', '临汾', '霍州市', 1);
INSERT INTO `idtoad` VALUES (141102, 14, 11, 2, '山西', '吕梁', '离石区', 1);
INSERT INTO `idtoad` VALUES (141121, 14, 11, 21, '山西', '吕梁', '文水县', 1);
INSERT INTO `idtoad` VALUES (141122, 14, 11, 22, '山西', '吕梁', '交城县', 1);
INSERT INTO `idtoad` VALUES (141123, 14, 11, 23, '山西', '吕梁', '兴县', 1);
INSERT INTO `idtoad` VALUES (141124, 14, 11, 24, '山西', '吕梁', '临县', 1);
INSERT INTO `idtoad` VALUES (141125, 14, 11, 25, '山西', '吕梁', '柳林县', 1);
INSERT INTO `idtoad` VALUES (141126, 14, 11, 26, '山西', '吕梁', '石楼县', 1);
INSERT INTO `idtoad` VALUES (141127, 14, 11, 27, '山西', '吕梁', '岚县', 1);
INSERT INTO `idtoad` VALUES (141128, 14, 11, 28, '山西', '吕梁', '方山县', 1);
INSERT INTO `idtoad` VALUES (141129, 14, 11, 29, '山西', '吕梁', '中阳县', 1);
INSERT INTO `idtoad` VALUES (141130, 14, 11, 30, '山西', '吕梁', '交口县', 1);
INSERT INTO `idtoad` VALUES (141181, 14, 11, 81, '山西', '吕梁', '孝义市', 1);
INSERT INTO `idtoad` VALUES (141182, 14, 11, 82, '山西', '吕梁', '汾阳市', 1);
INSERT INTO `idtoad` VALUES (142200, 14, 22, 0, '山西', '忻州地区', '', 0);
INSERT INTO `idtoad` VALUES (142201, 14, 22, 1, '山西', '忻州地区', '忻州市', 0);
INSERT INTO `idtoad` VALUES (142202, 14, 22, 2, '山西', '忻州地区', '原平市', 0);
INSERT INTO `idtoad` VALUES (142222, 14, 22, 22, '山西', '忻州地区', '定襄县', 0);
INSERT INTO `idtoad` VALUES (142223, 14, 22, 23, '山西', '忻州地区', '五台县', 0);
INSERT INTO `idtoad` VALUES (142225, 14, 22, 25, '山西', '忻州地区', '代县', 0);
INSERT INTO `idtoad` VALUES (142226, 14, 22, 26, '山西', '忻州地区', '繁峙县', 0);
INSERT INTO `idtoad` VALUES (142227, 14, 22, 27, '山西', '忻州地区', '宁武县', 0);
INSERT INTO `idtoad` VALUES (142228, 14, 22, 28, '山西', '忻州地区', '静乐县', 0);
INSERT INTO `idtoad` VALUES (142229, 14, 22, 29, '山西', '忻州地区', '神池县', 0);
INSERT INTO `idtoad` VALUES (142230, 14, 22, 30, '山西', '忻州地区', '五寨县', 0);
INSERT INTO `idtoad` VALUES (142231, 14, 22, 31, '山西', '忻州地区', '岢岚县', 0);
INSERT INTO `idtoad` VALUES (142232, 14, 22, 32, '山西', '忻州地区', '河曲县', 0);
INSERT INTO `idtoad` VALUES (142233, 14, 22, 33, '山西', '忻州地区', '保德县', 0);
INSERT INTO `idtoad` VALUES (142234, 14, 22, 34, '山西', '忻州地区', '偏关县', 0);
INSERT INTO `idtoad` VALUES (142300, 14, 23, 0, '山西', '忻州地区吕梁地区', '', 0);
INSERT INTO `idtoad` VALUES (142301, 14, 23, 1, '山西', '忻州地区吕梁地区', '孝义市', 0);
INSERT INTO `idtoad` VALUES (142302, 14, 23, 2, '山西', '忻州地区吕梁地区', '离石市', 0);
INSERT INTO `idtoad` VALUES (142303, 14, 23, 3, '山西', '忻州地区吕梁地区', '汾阳市', 0);
INSERT INTO `idtoad` VALUES (142322, 14, 23, 22, '山西', '忻州地区吕梁地区', '文水县', 0);
INSERT INTO `idtoad` VALUES (142323, 14, 23, 23, '山西', '忻州地区吕梁地区', '交城县', 0);
INSERT INTO `idtoad` VALUES (142325, 14, 23, 25, '山西', '忻州地区吕梁地区', '兴县', 0);
INSERT INTO `idtoad` VALUES (142326, 14, 23, 26, '山西', '忻州地区吕梁地区', '临县', 0);
INSERT INTO `idtoad` VALUES (142327, 14, 23, 27, '山西', '忻州地区吕梁地区', '柳林县', 0);
INSERT INTO `idtoad` VALUES (142328, 14, 23, 28, '山西', '忻州地区吕梁地区', '石楼县', 0);
INSERT INTO `idtoad` VALUES (142329, 14, 23, 29, '山西', '忻州地区吕梁地区', '岚县', 0);
INSERT INTO `idtoad` VALUES (142330, 14, 23, 30, '山西', '忻州地区吕梁地区', '方山县', 0);
INSERT INTO `idtoad` VALUES (142332, 14, 23, 32, '山西', '忻州地区吕梁地区', '中阳县', 0);
INSERT INTO `idtoad` VALUES (142333, 14, 23, 33, '山西', '忻州地区吕梁地区', '交口县', 0);
INSERT INTO `idtoad` VALUES (142400, 14, 24, 0, '山西', '晋中地区', '', 0);
INSERT INTO `idtoad` VALUES (142401, 14, 24, 1, '山西', '晋中地区', '榆次市', 0);
INSERT INTO `idtoad` VALUES (142402, 14, 24, 2, '山西', '晋中地区', '介休市', 0);
INSERT INTO `idtoad` VALUES (142421, 14, 24, 21, '山西', '晋中地区', '榆社县', 0);
INSERT INTO `idtoad` VALUES (142422, 14, 24, 22, '山西', '晋中地区', '左权县', 0);
INSERT INTO `idtoad` VALUES (142423, 14, 24, 23, '山西', '晋中地区', '和顺县', 0);
INSERT INTO `idtoad` VALUES (142424, 14, 24, 24, '山西', '晋中地区', '昔阳县', 0);
INSERT INTO `idtoad` VALUES (142427, 14, 24, 27, '山西', '晋中地区', '寿阳县', 0);
INSERT INTO `idtoad` VALUES (142429, 14, 24, 29, '山西', '晋中地区', '太谷县', 0);
INSERT INTO `idtoad` VALUES (142430, 14, 24, 30, '山西', '晋中地区', '祁县', 0);
INSERT INTO `idtoad` VALUES (142431, 14, 24, 31, '山西', '晋中地区', '平遥县', 0);
INSERT INTO `idtoad` VALUES (142433, 14, 24, 33, '山西', '晋中地区', '灵石县', 0);
INSERT INTO `idtoad` VALUES (142600, 14, 26, 0, '山西', '临汾地区', '', 0);
INSERT INTO `idtoad` VALUES (142601, 14, 26, 1, '山西', '临汾地区', '临汾市', 0);
INSERT INTO `idtoad` VALUES (142602, 14, 26, 2, '山西', '临汾地区', '侯马市', 0);
INSERT INTO `idtoad` VALUES (142603, 14, 26, 3, '山西', '临汾地区', '霍州市', 0);
INSERT INTO `idtoad` VALUES (142621, 14, 26, 21, '山西', '临汾地区', '曲沃县', 0);
INSERT INTO `idtoad` VALUES (142622, 14, 26, 22, '山西', '临汾地区', '翼城县', 0);
INSERT INTO `idtoad` VALUES (142623, 14, 26, 23, '山西', '临汾地区', '襄汾县', 0);
INSERT INTO `idtoad` VALUES (142625, 14, 26, 25, '山西', '临汾地区', '洪洞县', 0);
INSERT INTO `idtoad` VALUES (142627, 14, 26, 27, '山西', '临汾地区', '古县', 0);
INSERT INTO `idtoad` VALUES (142628, 14, 26, 28, '山西', '临汾地区', '安泽县', 0);
INSERT INTO `idtoad` VALUES (142629, 14, 26, 29, '山西', '临汾地区', '浮山县', 0);
INSERT INTO `idtoad` VALUES (142630, 14, 26, 30, '山西', '临汾地区', '吉县', 0);
INSERT INTO `idtoad` VALUES (142631, 14, 26, 31, '山西', '临汾地区', '乡宁县', 0);
INSERT INTO `idtoad` VALUES (142632, 14, 26, 32, '山西', '临汾地区', '蒲县', 0);
INSERT INTO `idtoad` VALUES (142633, 14, 26, 33, '山西', '临汾地区', '大宁县', 0);
INSERT INTO `idtoad` VALUES (142634, 14, 26, 34, '山西', '临汾地区', '永和县', 0);
INSERT INTO `idtoad` VALUES (142635, 14, 26, 35, '山西', '临汾地区', '隰县', 0);
INSERT INTO `idtoad` VALUES (142636, 14, 26, 36, '山西', '临汾地区', '汾西县', 0);
INSERT INTO `idtoad` VALUES (142700, 14, 27, 0, '山西', '运城地区', '', 0);
INSERT INTO `idtoad` VALUES (142701, 14, 27, 1, '山西', '运城地区', '运城市', 0);
INSERT INTO `idtoad` VALUES (142702, 14, 27, 2, '山西', '运城地区', '永济市', 0);
INSERT INTO `idtoad` VALUES (142703, 14, 27, 3, '山西', '运城地区', '河津市', 0);
INSERT INTO `idtoad` VALUES (142723, 14, 27, 23, '山西', '运城地区', '芮城县', 0);
INSERT INTO `idtoad` VALUES (142724, 14, 27, 24, '山西', '运城地区', '临猗县', 0);
INSERT INTO `idtoad` VALUES (142725, 14, 27, 25, '山西', '运城地区', '万荣县', 0);
INSERT INTO `idtoad` VALUES (142726, 14, 27, 26, '山西', '运城地区', '新绛县', 0);
INSERT INTO `idtoad` VALUES (142727, 14, 27, 27, '山西', '运城地区', '稷山县', 0);
INSERT INTO `idtoad` VALUES (142729, 14, 27, 29, '山西', '运城地区', '闻喜县', 0);
INSERT INTO `idtoad` VALUES (142730, 14, 27, 30, '山西', '运城地区', '夏县', 0);
INSERT INTO `idtoad` VALUES (142731, 14, 27, 31, '山西', '运城地区', '绛县', 0);
INSERT INTO `idtoad` VALUES (142732, 14, 27, 32, '山西', '运城地区', '平陆县', 0);
INSERT INTO `idtoad` VALUES (142733, 14, 27, 33, '山西', '运城地区', '垣曲县', 0);
INSERT INTO `idtoad` VALUES (150000, 15, 0, 0, '内蒙古', '', '', 0);
INSERT INTO `idtoad` VALUES (150100, 15, 1, 0, '内蒙古', '呼和浩特', '', 0);
INSERT INTO `idtoad` VALUES (150101, 15, 1, 1, '内蒙古', '呼和浩特市', '市辖区', 0);
INSERT INTO `idtoad` VALUES (150102, 15, 1, 2, '内蒙古', '呼和浩特', '新城区', 1);
INSERT INTO `idtoad` VALUES (150103, 15, 1, 3, '内蒙古', '呼和浩特', '回民区', 1);
INSERT INTO `idtoad` VALUES (150104, 15, 1, 4, '内蒙古', '呼和浩特', '玉泉区', 1);
INSERT INTO `idtoad` VALUES (150105, 15, 1, 5, '内蒙古', '呼和浩特', '赛罕区', 1);
INSERT INTO `idtoad` VALUES (150121, 15, 1, 21, '内蒙古', '呼和浩特', '土默特左旗', 1);
INSERT INTO `idtoad` VALUES (150122, 15, 1, 22, '内蒙古', '呼和浩特', '托克托县', 1);
INSERT INTO `idtoad` VALUES (150123, 15, 1, 23, '内蒙古', '呼和浩特', '和林格尔县', 1);
INSERT INTO `idtoad` VALUES (150124, 15, 1, 24, '内蒙古', '呼和浩特', '清水河县', 1);
INSERT INTO `idtoad` VALUES (150125, 15, 1, 25, '内蒙古', '呼和浩特', '武川县', 1);
INSERT INTO `idtoad` VALUES (150200, 15, 2, 0, '内蒙古', '包头', '', 0);
INSERT INTO `idtoad` VALUES (150201, 15, 2, 1, '内蒙古', '包头', '市辖区', 0);
INSERT INTO `idtoad` VALUES (150202, 15, 2, 2, '内蒙古', '包头', '东河区', 1);
INSERT INTO `idtoad` VALUES (150203, 15, 2, 3, '内蒙古', '包头', '昆都仑区', 1);
INSERT INTO `idtoad` VALUES (150204, 15, 2, 4, '内蒙古', '包头', '青山区', 1);
INSERT INTO `idtoad` VALUES (150205, 15, 2, 5, '内蒙古', '包头', '石拐区', 1);
INSERT INTO `idtoad` VALUES (150206, 15, 2, 6, '内蒙古', '包头', '白云鄂博矿区', 1);
INSERT INTO `idtoad` VALUES (150207, 15, 2, 7, '内蒙古', '包头', '九原区', 1);
INSERT INTO `idtoad` VALUES (150221, 15, 2, 21, '内蒙古', '包头', '土默特右旗', 1);
INSERT INTO `idtoad` VALUES (150222, 15, 2, 22, '内蒙古', '包头', '固阳县', 1);
INSERT INTO `idtoad` VALUES (150223, 15, 2, 23, '内蒙古', '包头', '达尔罕茂明安联合旗', 1);
INSERT INTO `idtoad` VALUES (150300, 15, 3, 0, '内蒙古', '乌海', '', 0);
INSERT INTO `idtoad` VALUES (150301, 15, 3, 1, '内蒙古', '乌海', '市辖区', 0);
INSERT INTO `idtoad` VALUES (150302, 15, 3, 2, '内蒙古', '乌海', '海勃湾区', 1);
INSERT INTO `idtoad` VALUES (150303, 15, 3, 3, '内蒙古', '乌海', '海南区', 1);
INSERT INTO `idtoad` VALUES (150304, 15, 3, 4, '内蒙古', '乌海', '乌达区', 1);
INSERT INTO `idtoad` VALUES (150400, 15, 4, 0, '内蒙古', '赤峰', '', 0);
INSERT INTO `idtoad` VALUES (150401, 15, 4, 1, '内蒙古', '赤峰', '市辖区', 0);
INSERT INTO `idtoad` VALUES (150402, 15, 4, 2, '内蒙古', '赤峰', '红山区', 1);
INSERT INTO `idtoad` VALUES (150403, 15, 4, 3, '内蒙古', '赤峰', '元宝山区', 1);
INSERT INTO `idtoad` VALUES (150404, 15, 4, 4, '内蒙古', '赤峰', '松山区', 1);
INSERT INTO `idtoad` VALUES (150421, 15, 4, 21, '内蒙古', '赤峰', '阿鲁科尔沁旗', 1);
INSERT INTO `idtoad` VALUES (150422, 15, 4, 22, '内蒙古', '赤峰', '巴林左旗', 1);
INSERT INTO `idtoad` VALUES (150423, 15, 4, 23, '内蒙古', '赤峰', '巴林右旗', 1);
INSERT INTO `idtoad` VALUES (150424, 15, 4, 24, '内蒙古', '赤峰', '林西县', 1);
INSERT INTO `idtoad` VALUES (150425, 15, 4, 25, '内蒙古', '赤峰', '克什克腾旗', 1);
INSERT INTO `idtoad` VALUES (150426, 15, 4, 26, '内蒙古', '赤峰', '翁牛特旗', 1);
INSERT INTO `idtoad` VALUES (150428, 15, 4, 28, '内蒙古', '赤峰', '喀喇沁旗', 1);
INSERT INTO `idtoad` VALUES (150429, 15, 4, 29, '内蒙古', '赤峰', '宁城县', 1);
INSERT INTO `idtoad` VALUES (150430, 15, 4, 30, '内蒙古', '赤峰', '敖汉旗', 1);
INSERT INTO `idtoad` VALUES (150502, 15, 5, 2, '内蒙古', '通辽', '科尔沁区', 1);
INSERT INTO `idtoad` VALUES (150521, 15, 5, 21, '内蒙古', '通辽', '科尔沁左翼中旗', 1);
INSERT INTO `idtoad` VALUES (150522, 15, 5, 22, '内蒙古', '通辽', '科尔沁左翼后旗', 1);
INSERT INTO `idtoad` VALUES (150523, 15, 5, 23, '内蒙古', '通辽', '开鲁县', 1);
INSERT INTO `idtoad` VALUES (150524, 15, 5, 24, '内蒙古', '通辽', '库伦旗', 1);
INSERT INTO `idtoad` VALUES (150525, 15, 5, 25, '内蒙古', '通辽', '奈曼旗', 1);
INSERT INTO `idtoad` VALUES (150526, 15, 5, 26, '内蒙古', '通辽', '扎鲁特旗', 1);
INSERT INTO `idtoad` VALUES (150581, 15, 5, 81, '内蒙古', '通辽', '霍林郭勒市', 1);
INSERT INTO `idtoad` VALUES (150602, 15, 6, 2, '内蒙古', '鄂尔多斯', '东胜区', 1);
INSERT INTO `idtoad` VALUES (150603, 15, 6, 3, '内蒙古', '鄂尔多斯', '康巴什区', 1);
INSERT INTO `idtoad` VALUES (150621, 15, 6, 21, '内蒙古', '鄂尔多斯', '达拉特旗', 1);
INSERT INTO `idtoad` VALUES (150622, 15, 6, 22, '内蒙古', '鄂尔多斯', '准格尔旗', 1);
INSERT INTO `idtoad` VALUES (150623, 15, 6, 23, '内蒙古', '鄂尔多斯', '鄂托克前旗', 1);
INSERT INTO `idtoad` VALUES (150624, 15, 6, 24, '内蒙古', '鄂尔多斯', '鄂托克旗', 1);
INSERT INTO `idtoad` VALUES (150625, 15, 6, 25, '内蒙古', '鄂尔多斯', '杭锦旗', 1);
INSERT INTO `idtoad` VALUES (150626, 15, 6, 26, '内蒙古', '鄂尔多斯', '乌审旗', 1);
INSERT INTO `idtoad` VALUES (150627, 15, 6, 27, '内蒙古', '鄂尔多斯', '伊金霍洛旗', 1);
INSERT INTO `idtoad` VALUES (150702, 15, 7, 2, '内蒙古', '呼伦贝尔', '海拉尔区', 1);
INSERT INTO `idtoad` VALUES (150703, 15, 7, 3, '内蒙古', '呼伦贝尔', '扎赉诺尔区', 1);
INSERT INTO `idtoad` VALUES (150721, 15, 7, 21, '内蒙古', '呼伦贝尔', '阿荣旗', 1);
INSERT INTO `idtoad` VALUES (150722, 15, 7, 22, '内蒙古', '呼伦贝尔', '莫力达瓦达斡尔族自治旗', 1);
INSERT INTO `idtoad` VALUES (150723, 15, 7, 23, '内蒙古', '呼伦贝尔', '鄂伦春自治旗', 1);
INSERT INTO `idtoad` VALUES (150724, 15, 7, 24, '内蒙古', '呼伦贝尔', '鄂温克族自治旗', 1);
INSERT INTO `idtoad` VALUES (150725, 15, 7, 25, '内蒙古', '呼伦贝尔', '陈巴尔虎旗', 1);
INSERT INTO `idtoad` VALUES (150726, 15, 7, 26, '内蒙古', '呼伦贝尔', '新巴尔虎左旗', 1);
INSERT INTO `idtoad` VALUES (150727, 15, 7, 27, '内蒙古', '呼伦贝尔', '新巴尔虎右旗', 1);
INSERT INTO `idtoad` VALUES (150781, 15, 7, 81, '内蒙古', '呼伦贝尔', '满洲里市', 1);
INSERT INTO `idtoad` VALUES (150782, 15, 7, 82, '内蒙古', '呼伦贝尔', '牙克石市', 1);
INSERT INTO `idtoad` VALUES (150783, 15, 7, 83, '内蒙古', '呼伦贝尔', '扎兰屯市', 1);
INSERT INTO `idtoad` VALUES (150784, 15, 7, 84, '内蒙古', '呼伦贝尔', '额尔古纳市', 1);
INSERT INTO `idtoad` VALUES (150785, 15, 7, 85, '内蒙古', '呼伦贝尔', '根河市', 1);
INSERT INTO `idtoad` VALUES (150802, 15, 8, 2, '内蒙古', '巴彦淖尔', '临河区', 1);
INSERT INTO `idtoad` VALUES (150821, 15, 8, 21, '内蒙古', '巴彦淖尔', '五原县', 1);
INSERT INTO `idtoad` VALUES (150822, 15, 8, 22, '内蒙古', '巴彦淖尔', '磴口县', 1);
INSERT INTO `idtoad` VALUES (150823, 15, 8, 23, '内蒙古', '巴彦淖尔', '乌拉特前旗', 1);
INSERT INTO `idtoad` VALUES (150824, 15, 8, 24, '内蒙古', '巴彦淖尔', '乌拉特中旗', 1);
INSERT INTO `idtoad` VALUES (150825, 15, 8, 25, '内蒙古', '巴彦淖尔', '乌拉特后旗', 1);
INSERT INTO `idtoad` VALUES (150826, 15, 8, 26, '内蒙古', '巴彦淖尔', '杭锦后旗', 1);
INSERT INTO `idtoad` VALUES (150902, 15, 9, 2, '内蒙古', '乌兰察布', '集宁区', 1);
INSERT INTO `idtoad` VALUES (150921, 15, 9, 21, '内蒙古', '乌兰察布', '卓资县', 1);
INSERT INTO `idtoad` VALUES (150922, 15, 9, 22, '内蒙古', '乌兰察布', '化德县', 1);
INSERT INTO `idtoad` VALUES (150923, 15, 9, 23, '内蒙古', '乌兰察布', '商都县', 1);
INSERT INTO `idtoad` VALUES (150924, 15, 9, 24, '内蒙古', '乌兰察布', '兴和县', 1);
INSERT INTO `idtoad` VALUES (150925, 15, 9, 25, '内蒙古', '乌兰察布', '凉城县', 1);
INSERT INTO `idtoad` VALUES (150926, 15, 9, 26, '内蒙古', '乌兰察布', '察哈尔右翼前旗', 1);
INSERT INTO `idtoad` VALUES (150927, 15, 9, 27, '内蒙古', '乌兰察布', '察哈尔右翼中旗', 1);
INSERT INTO `idtoad` VALUES (150928, 15, 9, 28, '内蒙古', '乌兰察布', '察哈尔右翼后旗', 1);
INSERT INTO `idtoad` VALUES (150929, 15, 9, 29, '内蒙古', '乌兰察布', '四子王旗', 1);
INSERT INTO `idtoad` VALUES (150981, 15, 9, 81, '内蒙古', '乌兰察布', '丰镇市', 1);
INSERT INTO `idtoad` VALUES (152100, 15, 21, 0, '内蒙古', '呼伦贝尔盟', '', 0);
INSERT INTO `idtoad` VALUES (152101, 15, 21, 1, '内蒙古', '呼伦贝尔盟', '海拉尔市', 0);
INSERT INTO `idtoad` VALUES (152102, 15, 21, 2, '内蒙古', '呼伦贝尔盟', '满洲里市', 0);
INSERT INTO `idtoad` VALUES (152103, 15, 21, 3, '内蒙古', '呼伦贝尔盟', '扎兰屯市', 0);
INSERT INTO `idtoad` VALUES (152104, 15, 21, 4, '内蒙古', '呼伦贝尔盟', '牙克石市', 0);
INSERT INTO `idtoad` VALUES (152105, 15, 21, 5, '内蒙古', '呼伦贝尔盟', '根河市', 0);
INSERT INTO `idtoad` VALUES (152106, 15, 21, 6, '内蒙古', '呼伦贝尔盟', '额尔古纳市', 0);
INSERT INTO `idtoad` VALUES (152122, 15, 21, 22, '内蒙古', '呼伦贝尔盟', '阿荣旗', 0);
INSERT INTO `idtoad` VALUES (152123, 15, 21, 23, '内蒙古', '呼伦贝尔盟', '莫力达瓦达斡尔族自治旗', 0);
INSERT INTO `idtoad` VALUES (152127, 15, 21, 27, '内蒙古', '呼伦贝尔盟', '鄂伦春自治旗', 0);
INSERT INTO `idtoad` VALUES (152128, 15, 21, 28, '内蒙古', '呼伦贝尔盟', '鄂温克族自治旗', 0);
INSERT INTO `idtoad` VALUES (152129, 15, 21, 29, '内蒙古', '呼伦贝尔盟', '新巴尔虎右旗', 0);
INSERT INTO `idtoad` VALUES (152130, 15, 21, 30, '内蒙古', '呼伦贝尔盟', '新巴尔虎左旗', 0);
INSERT INTO `idtoad` VALUES (152131, 15, 21, 31, '内蒙古', '呼伦贝尔盟', '陈巴尔虎旗', 0);
INSERT INTO `idtoad` VALUES (152200, 15, 22, 0, '内蒙古', '兴安盟', '', 0);
INSERT INTO `idtoad` VALUES (152201, 15, 22, 1, '内蒙古', '兴安盟', '乌兰浩特市', 1);
INSERT INTO `idtoad` VALUES (152202, 15, 22, 2, '内蒙古', '兴安盟', '阿尔山市', 1);
INSERT INTO `idtoad` VALUES (152221, 15, 22, 21, '内蒙古', '兴安盟', '科尔沁右翼前旗', 1);
INSERT INTO `idtoad` VALUES (152222, 15, 22, 22, '内蒙古', '兴安盟', '科尔沁右翼中旗', 1);
INSERT INTO `idtoad` VALUES (152223, 15, 22, 23, '内蒙古', '兴安盟', '扎赉特旗', 1);
INSERT INTO `idtoad` VALUES (152224, 15, 22, 24, '内蒙古', '兴安盟', '突泉县', 1);
INSERT INTO `idtoad` VALUES (152300, 15, 23, 0, '内蒙古', '哲里木盟', '', 0);
INSERT INTO `idtoad` VALUES (152301, 15, 23, 1, '内蒙古', '哲里木盟', '通辽市', 0);
INSERT INTO `idtoad` VALUES (152302, 15, 23, 2, '内蒙古', '哲里木盟', '霍林郭勒市', 0);
INSERT INTO `idtoad` VALUES (152322, 15, 23, 22, '内蒙古', '哲里木盟', '科尔沁左翼中旗', 0);
INSERT INTO `idtoad` VALUES (152323, 15, 23, 23, '内蒙古', '哲里木盟', '科尔沁左翼后旗', 0);
INSERT INTO `idtoad` VALUES (152324, 15, 23, 24, '内蒙古', '哲里木盟', '开鲁县', 0);
INSERT INTO `idtoad` VALUES (152325, 15, 23, 25, '内蒙古', '哲里木盟', '库伦旗', 0);
INSERT INTO `idtoad` VALUES (152326, 15, 23, 26, '内蒙古', '哲里木盟', '奈曼旗', 0);
INSERT INTO `idtoad` VALUES (152327, 15, 23, 27, '内蒙古', '哲里木盟', '扎鲁特旗', 0);
INSERT INTO `idtoad` VALUES (152500, 15, 25, 0, '内蒙古', '锡林郭勒盟', '', 0);
INSERT INTO `idtoad` VALUES (152501, 15, 25, 1, '内蒙古', '锡林郭勒盟', '二连浩特市', 1);
INSERT INTO `idtoad` VALUES (152502, 15, 25, 2, '内蒙古', '锡林郭勒盟', '锡林浩特市', 1);
INSERT INTO `idtoad` VALUES (152522, 15, 25, 22, '内蒙古', '锡林郭勒盟', '阿巴嘎旗', 1);
INSERT INTO `idtoad` VALUES (152523, 15, 25, 23, '内蒙古', '锡林郭勒盟', '苏尼特左旗', 1);
INSERT INTO `idtoad` VALUES (152524, 15, 25, 24, '内蒙古', '锡林郭勒盟', '苏尼特右旗', 1);
INSERT INTO `idtoad` VALUES (152525, 15, 25, 25, '内蒙古', '锡林郭勒盟', '东乌珠穆沁旗', 1);
INSERT INTO `idtoad` VALUES (152526, 15, 25, 26, '内蒙古', '锡林郭勒盟', '西乌珠穆沁旗', 1);
INSERT INTO `idtoad` VALUES (152527, 15, 25, 27, '内蒙古', '锡林郭勒盟', '太仆寺旗', 1);
INSERT INTO `idtoad` VALUES (152528, 15, 25, 28, '内蒙古', '锡林郭勒盟', '镶黄旗', 1);
INSERT INTO `idtoad` VALUES (152529, 15, 25, 29, '内蒙古', '锡林郭勒盟', '正镶白旗', 1);
INSERT INTO `idtoad` VALUES (152530, 15, 25, 30, '内蒙古', '锡林郭勒盟', '正蓝旗', 1);
INSERT INTO `idtoad` VALUES (152531, 15, 25, 31, '内蒙古', '锡林郭勒盟', '多伦县', 1);
INSERT INTO `idtoad` VALUES (152600, 15, 26, 0, '内蒙古', '乌兰察布盟', '', 0);
INSERT INTO `idtoad` VALUES (152601, 15, 26, 1, '内蒙古', '乌兰察布盟', '集宁市', 0);
INSERT INTO `idtoad` VALUES (152602, 15, 26, 2, '内蒙古', '乌兰察布盟', '丰镇市', 0);
INSERT INTO `idtoad` VALUES (152624, 15, 26, 24, '内蒙古', '乌兰察布盟', '卓资县', 0);
INSERT INTO `idtoad` VALUES (152625, 15, 26, 25, '内蒙古', '乌兰察布盟', '化德县', 0);
INSERT INTO `idtoad` VALUES (152626, 15, 26, 26, '内蒙古', '乌兰察布盟', '商都县', 0);
INSERT INTO `idtoad` VALUES (152627, 15, 26, 27, '内蒙古', '乌兰察布盟', '兴和县', 0);
INSERT INTO `idtoad` VALUES (152629, 15, 26, 29, '内蒙古', '乌兰察布盟', '凉城县', 0);
INSERT INTO `idtoad` VALUES (152630, 15, 26, 30, '内蒙古', '乌兰察布盟', '察哈尔右翼前旗', 0);
INSERT INTO `idtoad` VALUES (152631, 15, 26, 31, '内蒙古', '乌兰察布盟', '察哈尔右翼中旗', 0);
INSERT INTO `idtoad` VALUES (152632, 15, 26, 32, '内蒙古', '乌兰察布盟', '察哈尔右翼后旗', 0);
INSERT INTO `idtoad` VALUES (152634, 15, 26, 34, '内蒙古', '乌兰察布盟', '四子王旗', 0);
INSERT INTO `idtoad` VALUES (152700, 15, 27, 0, '内蒙古', '伊克昭盟', '', 0);
INSERT INTO `idtoad` VALUES (152701, 15, 27, 1, '内蒙古', '伊克昭盟', '东胜市', 0);
INSERT INTO `idtoad` VALUES (152722, 15, 27, 22, '内蒙古', '伊克昭盟', '达拉特旗', 0);
INSERT INTO `idtoad` VALUES (152723, 15, 27, 23, '内蒙古', '伊克昭盟', '准格尔旗', 0);
INSERT INTO `idtoad` VALUES (152724, 15, 27, 24, '内蒙古', '伊克昭盟', '鄂托克前旗', 0);
INSERT INTO `idtoad` VALUES (152725, 15, 27, 25, '内蒙古', '伊克昭盟', '鄂托克旗', 0);
INSERT INTO `idtoad` VALUES (152726, 15, 27, 26, '内蒙古', '伊克昭盟', '杭锦旗', 0);
INSERT INTO `idtoad` VALUES (152727, 15, 27, 27, '内蒙古', '伊克昭盟', '乌审旗', 0);
INSERT INTO `idtoad` VALUES (152728, 15, 27, 28, '内蒙古', '伊克昭盟', '伊金霍洛旗', 0);
INSERT INTO `idtoad` VALUES (152800, 15, 28, 0, '内蒙古', '巴彦淖尔盟', '', 0);
INSERT INTO `idtoad` VALUES (152801, 15, 28, 1, '内蒙古', '巴彦淖尔盟', '临河市', 0);
INSERT INTO `idtoad` VALUES (152822, 15, 28, 22, '内蒙古', '巴彦淖尔盟', '五原县', 0);
INSERT INTO `idtoad` VALUES (152823, 15, 28, 23, '内蒙古', '巴彦淖尔盟', '磴口县', 0);
INSERT INTO `idtoad` VALUES (152824, 15, 28, 24, '内蒙古', '巴彦淖尔盟', '乌拉特前旗', 0);
INSERT INTO `idtoad` VALUES (152825, 15, 28, 25, '内蒙古', '巴彦淖尔盟', '乌拉特中旗', 0);
INSERT INTO `idtoad` VALUES (152826, 15, 28, 26, '内蒙古', '巴彦淖尔盟', '乌拉特后旗', 0);
INSERT INTO `idtoad` VALUES (152827, 15, 28, 27, '内蒙古', '巴彦淖尔盟', '杭锦后旗', 0);
INSERT INTO `idtoad` VALUES (152900, 15, 29, 0, '内蒙古', '阿拉善盟', '', 0);
INSERT INTO `idtoad` VALUES (152921, 15, 29, 21, '内蒙古', '阿拉善盟', '阿拉善左旗', 1);
INSERT INTO `idtoad` VALUES (152922, 15, 29, 22, '内蒙古', '阿拉善盟', '阿拉善右旗', 1);
INSERT INTO `idtoad` VALUES (152923, 15, 29, 23, '内蒙古', '阿拉善盟', '额济纳旗', 1);
INSERT INTO `idtoad` VALUES (210000, 21, 0, 0, '辽宁', '', '', 0);
INSERT INTO `idtoad` VALUES (210100, 21, 1, 0, '辽宁', '沈阳', '', 0);
INSERT INTO `idtoad` VALUES (210101, 21, 1, 1, '辽宁', '沈阳', '市辖区', 0);
INSERT INTO `idtoad` VALUES (210102, 21, 1, 2, '辽宁', '沈阳', '和平区', 1);
INSERT INTO `idtoad` VALUES (210103, 21, 1, 3, '辽宁', '沈阳', '沈河区', 1);
INSERT INTO `idtoad` VALUES (210104, 21, 1, 4, '辽宁', '沈阳', '大东区', 1);
INSERT INTO `idtoad` VALUES (210105, 21, 1, 5, '辽宁', '沈阳', '皇姑区', 1);
INSERT INTO `idtoad` VALUES (210106, 21, 1, 6, '辽宁', '沈阳', '铁西区', 1);
INSERT INTO `idtoad` VALUES (210111, 21, 1, 11, '辽宁', '沈阳', '苏家屯区', 1);
INSERT INTO `idtoad` VALUES (210112, 21, 1, 12, '辽宁', '沈阳', '浑南区', 1);
INSERT INTO `idtoad` VALUES (210113, 21, 1, 13, '辽宁', '沈阳', '沈北新区', 1);
INSERT INTO `idtoad` VALUES (210114, 21, 1, 14, '辽宁', '沈阳', '于洪区', 1);
INSERT INTO `idtoad` VALUES (210115, 21, 1, 15, '辽宁', '沈阳', '辽中区', 1);
INSERT INTO `idtoad` VALUES (210122, 21, 1, 22, '辽宁', '沈阳', '辽中县', 0);
INSERT INTO `idtoad` VALUES (210123, 21, 1, 23, '辽宁', '沈阳', '康平县', 1);
INSERT INTO `idtoad` VALUES (210124, 21, 1, 24, '辽宁', '沈阳', '法库县', 1);
INSERT INTO `idtoad` VALUES (210181, 21, 1, 81, '辽宁', '沈阳', '新民市', 1);
INSERT INTO `idtoad` VALUES (210200, 21, 2, 0, '辽宁', '大连', '', 0);
INSERT INTO `idtoad` VALUES (210201, 21, 2, 1, '辽宁', '大连', '市辖区', 0);
INSERT INTO `idtoad` VALUES (210202, 21, 2, 2, '辽宁', '大连', '中山区', 1);
INSERT INTO `idtoad` VALUES (210203, 21, 2, 3, '辽宁', '大连', '西岗区', 1);
INSERT INTO `idtoad` VALUES (210204, 21, 2, 4, '辽宁', '大连', '沙河口区', 1);
INSERT INTO `idtoad` VALUES (210211, 21, 2, 11, '辽宁', '大连', '甘井子区', 1);
INSERT INTO `idtoad` VALUES (210212, 21, 2, 12, '辽宁', '大连', '旅顺口区', 1);
INSERT INTO `idtoad` VALUES (210213, 21, 2, 13, '辽宁', '大连', '金州区', 1);
INSERT INTO `idtoad` VALUES (210214, 21, 2, 14, '辽宁', '大连', '普兰店区', 1);
INSERT INTO `idtoad` VALUES (210224, 21, 2, 24, '辽宁', '大连', '长海县', 1);
INSERT INTO `idtoad` VALUES (210281, 21, 2, 81, '辽宁', '大连', '瓦房店市', 1);
INSERT INTO `idtoad` VALUES (210282, 21, 2, 82, '辽宁', '大连', '普兰店市', 0);
INSERT INTO `idtoad` VALUES (210283, 21, 2, 83, '辽宁', '大连', '庄河市', 1);
INSERT INTO `idtoad` VALUES (210300, 21, 3, 0, '辽宁', '鞍山', '', 0);
INSERT INTO `idtoad` VALUES (210301, 21, 3, 1, '辽宁', '鞍山', '市辖区', 0);
INSERT INTO `idtoad` VALUES (210302, 21, 3, 2, '辽宁', '鞍山', '铁东区', 1);
INSERT INTO `idtoad` VALUES (210303, 21, 3, 3, '辽宁', '鞍山', '铁西区', 1);
INSERT INTO `idtoad` VALUES (210304, 21, 3, 4, '辽宁', '鞍山', '立山区', 1);
INSERT INTO `idtoad` VALUES (210311, 21, 3, 11, '辽宁', '鞍山', '千山区', 1);
INSERT INTO `idtoad` VALUES (210321, 21, 3, 21, '辽宁', '鞍山', '台安县', 1);
INSERT INTO `idtoad` VALUES (210323, 21, 3, 23, '辽宁', '鞍山', '岫岩满族自治县', 1);
INSERT INTO `idtoad` VALUES (210381, 21, 3, 81, '辽宁', '鞍山', '海城市', 1);
INSERT INTO `idtoad` VALUES (210400, 21, 4, 0, '辽宁', '抚顺', '', 0);
INSERT INTO `idtoad` VALUES (210401, 21, 4, 1, '辽宁', '抚顺', '市辖区', 0);
INSERT INTO `idtoad` VALUES (210402, 21, 4, 2, '辽宁', '抚顺', '新抚区', 1);
INSERT INTO `idtoad` VALUES (210403, 21, 4, 3, '辽宁', '抚顺', '东洲区', 1);
INSERT INTO `idtoad` VALUES (210404, 21, 4, 4, '辽宁', '抚顺', '望花区', 1);
INSERT INTO `idtoad` VALUES (210411, 21, 4, 11, '辽宁', '抚顺', '顺城区', 1);
INSERT INTO `idtoad` VALUES (210421, 21, 4, 21, '辽宁', '抚顺', '抚顺县', 1);
INSERT INTO `idtoad` VALUES (210422, 21, 4, 22, '辽宁', '抚顺', '新宾满族自治县', 1);
INSERT INTO `idtoad` VALUES (210423, 21, 4, 23, '辽宁', '抚顺', '清原满族自治县', 1);
INSERT INTO `idtoad` VALUES (210500, 21, 5, 0, '辽宁', '本溪', '', 0);
INSERT INTO `idtoad` VALUES (210501, 21, 5, 1, '辽宁', '本溪', '市辖区', 0);
INSERT INTO `idtoad` VALUES (210502, 21, 5, 2, '辽宁', '本溪', '平山区', 1);
INSERT INTO `idtoad` VALUES (210503, 21, 5, 3, '辽宁', '本溪', '溪湖区', 1);
INSERT INTO `idtoad` VALUES (210504, 21, 5, 4, '辽宁', '本溪', '明山区', 1);
INSERT INTO `idtoad` VALUES (210505, 21, 5, 5, '辽宁', '本溪', '南芬区', 1);
INSERT INTO `idtoad` VALUES (210521, 21, 5, 21, '辽宁', '本溪', '本溪满族自治县', 1);
INSERT INTO `idtoad` VALUES (210522, 21, 5, 22, '辽宁', '本溪', '桓仁满族自治县', 1);
INSERT INTO `idtoad` VALUES (210600, 21, 6, 0, '辽宁', '丹东', '', 0);
INSERT INTO `idtoad` VALUES (210601, 21, 6, 1, '辽宁', '丹东', '市辖区', 0);
INSERT INTO `idtoad` VALUES (210602, 21, 6, 2, '辽宁', '丹东', '元宝区', 1);
INSERT INTO `idtoad` VALUES (210603, 21, 6, 3, '辽宁', '丹东', '振兴区', 1);
INSERT INTO `idtoad` VALUES (210604, 21, 6, 4, '辽宁', '丹东', '振安区', 1);
INSERT INTO `idtoad` VALUES (210624, 21, 6, 24, '辽宁', '丹东', '宽甸满族自治县', 1);
INSERT INTO `idtoad` VALUES (210681, 21, 6, 81, '辽宁', '丹东', '东港市', 1);
INSERT INTO `idtoad` VALUES (210682, 21, 6, 82, '辽宁', '丹东', '凤城市', 1);
INSERT INTO `idtoad` VALUES (210700, 21, 7, 0, '辽宁', '锦州', '', 0);
INSERT INTO `idtoad` VALUES (210701, 21, 7, 1, '辽宁', '锦州', '市辖区', 0);
INSERT INTO `idtoad` VALUES (210702, 21, 7, 2, '辽宁', '锦州', '古塔区', 1);
INSERT INTO `idtoad` VALUES (210703, 21, 7, 3, '辽宁', '锦州', '凌河区', 1);
INSERT INTO `idtoad` VALUES (210711, 21, 7, 11, '辽宁', '锦州', '太和区', 1);
INSERT INTO `idtoad` VALUES (210726, 21, 7, 26, '辽宁', '锦州', '黑山县', 1);
INSERT INTO `idtoad` VALUES (210727, 21, 7, 27, '辽宁', '锦州', '义县', 1);
INSERT INTO `idtoad` VALUES (210781, 21, 7, 81, '辽宁', '锦州', '凌海市', 1);
INSERT INTO `idtoad` VALUES (210782, 21, 7, 82, '辽宁', '锦州', '北镇市', 1);
INSERT INTO `idtoad` VALUES (210800, 21, 8, 0, '辽宁', '营口', '', 0);
INSERT INTO `idtoad` VALUES (210801, 21, 8, 1, '辽宁', '营口', '市辖区', 0);
INSERT INTO `idtoad` VALUES (210802, 21, 8, 2, '辽宁', '营口', '站前区', 1);
INSERT INTO `idtoad` VALUES (210803, 21, 8, 3, '辽宁', '营口', '西市区', 1);
INSERT INTO `idtoad` VALUES (210804, 21, 8, 4, '辽宁', '营口', '鲅鱼圈区', 1);
INSERT INTO `idtoad` VALUES (210811, 21, 8, 11, '辽宁', '营口', '老边区', 1);
INSERT INTO `idtoad` VALUES (210881, 21, 8, 81, '辽宁', '营口', '盖州市', 1);
INSERT INTO `idtoad` VALUES (210882, 21, 8, 82, '辽宁', '营口', '大石桥市', 1);
INSERT INTO `idtoad` VALUES (210900, 21, 9, 0, '辽宁', '阜新', '', 0);
INSERT INTO `idtoad` VALUES (210901, 21, 9, 1, '辽宁', '阜新', '市辖区', 0);
INSERT INTO `idtoad` VALUES (210902, 21, 9, 2, '辽宁', '阜新', '海州区', 1);
INSERT INTO `idtoad` VALUES (210903, 21, 9, 3, '辽宁', '阜新', '新邱区', 1);
INSERT INTO `idtoad` VALUES (210904, 21, 9, 4, '辽宁', '阜新', '太平区', 1);
INSERT INTO `idtoad` VALUES (210905, 21, 9, 5, '辽宁', '阜新', '清河门区', 1);
INSERT INTO `idtoad` VALUES (210911, 21, 9, 11, '辽宁', '阜新', '细河区', 1);
INSERT INTO `idtoad` VALUES (210921, 21, 9, 21, '辽宁', '阜新', '阜新蒙古族自治县', 1);
INSERT INTO `idtoad` VALUES (210922, 21, 9, 22, '辽宁', '阜新', '彰武县', 1);
INSERT INTO `idtoad` VALUES (211000, 21, 10, 0, '辽宁', '辽阳', '', 0);
INSERT INTO `idtoad` VALUES (211001, 21, 10, 1, '辽宁', '辽阳', '市辖区', 0);
INSERT INTO `idtoad` VALUES (211002, 21, 10, 2, '辽宁', '辽阳', '白塔区', 1);
INSERT INTO `idtoad` VALUES (211003, 21, 10, 3, '辽宁', '辽阳', '文圣区', 1);
INSERT INTO `idtoad` VALUES (211004, 21, 10, 4, '辽宁', '辽阳', '宏伟区', 1);
INSERT INTO `idtoad` VALUES (211005, 21, 10, 5, '辽宁', '辽阳', '弓长岭区', 1);
INSERT INTO `idtoad` VALUES (211011, 21, 10, 11, '辽宁', '辽阳', '太子河区', 1);
INSERT INTO `idtoad` VALUES (211021, 21, 10, 21, '辽宁', '辽阳', '辽阳县', 1);
INSERT INTO `idtoad` VALUES (211081, 21, 10, 81, '辽宁', '辽阳', '灯塔市', 1);
INSERT INTO `idtoad` VALUES (211100, 21, 11, 0, '辽宁', '盘锦', '', 0);
INSERT INTO `idtoad` VALUES (211101, 21, 11, 1, '辽宁', '盘锦', '市辖区', 0);
INSERT INTO `idtoad` VALUES (211102, 21, 11, 2, '辽宁', '盘锦', '双台子区', 1);
INSERT INTO `idtoad` VALUES (211103, 21, 11, 3, '辽宁', '盘锦', '兴隆台区', 1);
INSERT INTO `idtoad` VALUES (211104, 21, 11, 4, '辽宁', '盘锦', '大洼区', 1);
INSERT INTO `idtoad` VALUES (211121, 21, 11, 21, '辽宁', '盘锦', '大洼县', 0);
INSERT INTO `idtoad` VALUES (211122, 21, 11, 22, '辽宁', '盘锦', '盘山县', 1);
INSERT INTO `idtoad` VALUES (211200, 21, 12, 0, '辽宁', '铁岭', '', 0);
INSERT INTO `idtoad` VALUES (211201, 21, 12, 1, '辽宁', '铁岭', '市辖区', 0);
INSERT INTO `idtoad` VALUES (211202, 21, 12, 2, '辽宁', '铁岭', '银州区', 1);
INSERT INTO `idtoad` VALUES (211204, 21, 12, 4, '辽宁', '铁岭', '清河区', 1);
INSERT INTO `idtoad` VALUES (211221, 21, 12, 21, '辽宁', '铁岭', '铁岭县', 1);
INSERT INTO `idtoad` VALUES (211223, 21, 12, 23, '辽宁', '铁岭', '西丰县', 1);
INSERT INTO `idtoad` VALUES (211224, 21, 12, 24, '辽宁', '铁岭', '昌图县', 1);
INSERT INTO `idtoad` VALUES (211281, 21, 12, 81, '辽宁', '铁岭', '调兵山市', 1);
INSERT INTO `idtoad` VALUES (211282, 21, 12, 82, '辽宁', '铁岭', '开原市', 1);
INSERT INTO `idtoad` VALUES (211300, 21, 13, 0, '辽宁', '朝阳', '', 0);
INSERT INTO `idtoad` VALUES (211301, 21, 13, 1, '辽宁', '朝阳', '市辖区', 0);
INSERT INTO `idtoad` VALUES (211302, 21, 13, 2, '辽宁', '朝阳', '双塔区', 1);
INSERT INTO `idtoad` VALUES (211303, 21, 13, 3, '辽宁', '朝阳', '龙城区', 1);
INSERT INTO `idtoad` VALUES (211321, 21, 13, 21, '辽宁', '朝阳', '朝阳县', 1);
INSERT INTO `idtoad` VALUES (211322, 21, 13, 22, '辽宁', '朝阳', '建平县', 1);
INSERT INTO `idtoad` VALUES (211324, 21, 13, 24, '辽宁', '朝阳', '喀喇沁左翼蒙古族自治县', 1);
INSERT INTO `idtoad` VALUES (211381, 21, 13, 81, '辽宁', '朝阳', '北票市', 1);
INSERT INTO `idtoad` VALUES (211382, 21, 13, 82, '辽宁', '朝阳', '凌源市', 1);
INSERT INTO `idtoad` VALUES (211400, 21, 14, 0, '辽宁', '葫芦岛', '', 0);
INSERT INTO `idtoad` VALUES (211401, 21, 14, 1, '辽宁', '葫芦岛', '市辖区', 0);
INSERT INTO `idtoad` VALUES (211402, 21, 14, 2, '辽宁', '葫芦岛', '连山区', 1);
INSERT INTO `idtoad` VALUES (211403, 21, 14, 3, '辽宁', '葫芦岛', '龙港区', 1);
INSERT INTO `idtoad` VALUES (211404, 21, 14, 4, '辽宁', '葫芦岛', '南票区', 1);
INSERT INTO `idtoad` VALUES (211421, 21, 14, 21, '辽宁', '葫芦岛', '绥中县', 1);
INSERT INTO `idtoad` VALUES (211422, 21, 14, 22, '辽宁', '葫芦岛', '建昌县', 1);
INSERT INTO `idtoad` VALUES (211481, 21, 14, 81, '辽宁', '葫芦岛', '兴城市', 1);
INSERT INTO `idtoad` VALUES (220000, 22, 0, 0, '吉林', '', '', 0);
INSERT INTO `idtoad` VALUES (220100, 22, 1, 0, '吉林', '长春', '长春', 1);
INSERT INTO `idtoad` VALUES (220101, 22, 1, 1, '吉林', '长春', '市辖区', 0);
INSERT INTO `idtoad` VALUES (220102, 22, 1, 2, '吉林', '长春', '南关区', 1);
INSERT INTO `idtoad` VALUES (220103, 22, 1, 3, '吉林', '长春', '宽城区', 1);
INSERT INTO `idtoad` VALUES (220104, 22, 1, 4, '吉林', '长春', '朝阳区', 1);
INSERT INTO `idtoad` VALUES (220105, 22, 1, 5, '吉林', '长春', '二道区', 1);
INSERT INTO `idtoad` VALUES (220106, 22, 1, 6, '吉林', '长春', '绿园区', 1);
INSERT INTO `idtoad` VALUES (220112, 22, 1, 12, '吉林', '长春', '双阳区', 1);
INSERT INTO `idtoad` VALUES (220113, 22, 1, 13, '吉林', '长春', '九台区', 1);
INSERT INTO `idtoad` VALUES (220122, 22, 1, 22, '吉林', '长春', '农安县', 1);
INSERT INTO `idtoad` VALUES (220181, 22, 1, 81, '吉林', '长春', '九台市', 0);
INSERT INTO `idtoad` VALUES (220182, 22, 1, 82, '吉林', '长春', '榆树市', 1);
INSERT INTO `idtoad` VALUES (220183, 22, 1, 83, '吉林', '长春', '德惠市', 1);
INSERT INTO `idtoad` VALUES (220184, 22, 1, 84, '吉林', '长春', '公主岭市', 1);
INSERT INTO `idtoad` VALUES (220200, 22, 2, 0, '吉林', '吉林', '', 0);
INSERT INTO `idtoad` VALUES (220201, 22, 2, 1, '吉林', '吉林', '市市辖区', 0);
INSERT INTO `idtoad` VALUES (220202, 22, 2, 2, '吉林', '吉林市', '昌邑区', 1);
INSERT INTO `idtoad` VALUES (220203, 22, 2, 3, '吉林', '吉林市', '龙潭区', 1);
INSERT INTO `idtoad` VALUES (220204, 22, 2, 4, '吉林', '吉林市', '船营区', 1);
INSERT INTO `idtoad` VALUES (220211, 22, 2, 11, '吉林', '吉林市', '丰满区', 1);
INSERT INTO `idtoad` VALUES (220221, 22, 2, 21, '吉林', '吉林市', '永吉县', 1);
INSERT INTO `idtoad` VALUES (220281, 22, 2, 81, '吉林', '吉林市', '蛟河市', 1);
INSERT INTO `idtoad` VALUES (220282, 22, 2, 82, '吉林', '吉林市', '桦甸市', 1);
INSERT INTO `idtoad` VALUES (220283, 22, 2, 83, '吉林', '吉林市', '舒兰市', 1);
INSERT INTO `idtoad` VALUES (220284, 22, 2, 84, '吉林', '吉林市', '磐石市', 1);
INSERT INTO `idtoad` VALUES (220300, 22, 3, 0, '吉林', '四平', '', 0);
INSERT INTO `idtoad` VALUES (220301, 22, 3, 1, '吉林', '四平', '市辖区', 0);
INSERT INTO `idtoad` VALUES (220302, 22, 3, 2, '吉林', '四平', '铁西区', 1);
INSERT INTO `idtoad` VALUES (220303, 22, 3, 3, '吉林', '四平', '铁东区', 1);
INSERT INTO `idtoad` VALUES (220322, 22, 3, 22, '吉林', '四平', '梨树县', 1);
INSERT INTO `idtoad` VALUES (220323, 22, 3, 23, '吉林', '四平', '伊通满族自治县', 1);
INSERT INTO `idtoad` VALUES (220381, 22, 3, 81, '吉林', '四平', '公主岭市', 0);
INSERT INTO `idtoad` VALUES (220382, 22, 3, 82, '吉林', '四平', '双辽市', 1);
INSERT INTO `idtoad` VALUES (220400, 22, 4, 0, '吉林', '辽源', '', 0);
INSERT INTO `idtoad` VALUES (220401, 22, 4, 1, '吉林', '辽源', '市辖区', 0);
INSERT INTO `idtoad` VALUES (220402, 22, 4, 2, '吉林', '辽源', '龙山区', 1);
INSERT INTO `idtoad` VALUES (220403, 22, 4, 3, '吉林', '辽源', '西安区', 1);
INSERT INTO `idtoad` VALUES (220421, 22, 4, 21, '吉林', '辽源', '东丰县', 1);
INSERT INTO `idtoad` VALUES (220422, 22, 4, 22, '吉林', '辽源', '东辽县', 1);
INSERT INTO `idtoad` VALUES (220500, 22, 5, 0, '吉林', '通化', '', 0);
INSERT INTO `idtoad` VALUES (220501, 22, 5, 1, '吉林', '通化', '市辖区', 0);
INSERT INTO `idtoad` VALUES (220502, 22, 5, 2, '吉林', '通化', '东昌区', 1);
INSERT INTO `idtoad` VALUES (220503, 22, 5, 3, '吉林', '通化', '二道江区', 1);
INSERT INTO `idtoad` VALUES (220521, 22, 5, 21, '吉林', '通化', '通化县', 1);
INSERT INTO `idtoad` VALUES (220523, 22, 5, 23, '吉林', '通化', '辉南县', 1);
INSERT INTO `idtoad` VALUES (220524, 22, 5, 24, '吉林', '通化', '柳河县', 1);
INSERT INTO `idtoad` VALUES (220581, 22, 5, 81, '吉林', '通化', '梅河口市', 1);
INSERT INTO `idtoad` VALUES (220582, 22, 5, 82, '吉林', '通化', '集安市', 1);
INSERT INTO `idtoad` VALUES (220600, 22, 6, 0, '吉林', '白山', '', 0);
INSERT INTO `idtoad` VALUES (220601, 22, 6, 1, '吉林', '白山', '市辖区', 0);
INSERT INTO `idtoad` VALUES (220602, 22, 6, 2, '吉林', '白山', '浑江区', 1);
INSERT INTO `idtoad` VALUES (220605, 22, 6, 5, '吉林', '白山', '江源区', 1);
INSERT INTO `idtoad` VALUES (220621, 22, 6, 21, '吉林', '白山', '抚松县', 1);
INSERT INTO `idtoad` VALUES (220622, 22, 6, 22, '吉林', '白山', '靖宇县', 1);
INSERT INTO `idtoad` VALUES (220623, 22, 6, 23, '吉林', '白山', '长白朝鲜族自治县', 1);
INSERT INTO `idtoad` VALUES (220625, 22, 6, 25, '吉林', '白山', '江源县', 0);
INSERT INTO `idtoad` VALUES (220681, 22, 6, 81, '吉林', '白山', '临江市', 1);
INSERT INTO `idtoad` VALUES (220700, 22, 7, 0, '吉林', '松原', '', 0);
INSERT INTO `idtoad` VALUES (220701, 22, 7, 1, '吉林', '松原', '市辖区', 0);
INSERT INTO `idtoad` VALUES (220702, 22, 7, 2, '吉林', '松原', '宁江区', 1);
INSERT INTO `idtoad` VALUES (220721, 22, 7, 21, '吉林', '松原', '前郭尔罗斯蒙古族自治县', 1);
INSERT INTO `idtoad` VALUES (220722, 22, 7, 22, '吉林', '松原', '长岭县', 1);
INSERT INTO `idtoad` VALUES (220723, 22, 7, 23, '吉林', '松原', '乾安县', 1);
INSERT INTO `idtoad` VALUES (220724, 22, 7, 24, '吉林', '松原', '扶余县', 0);
INSERT INTO `idtoad` VALUES (220781, 22, 7, 81, '吉林', '松原', '扶余市', 1);
INSERT INTO `idtoad` VALUES (220800, 22, 8, 0, '吉林', '白城', '', 0);
INSERT INTO `idtoad` VALUES (220801, 22, 8, 1, '吉林', '白城', '市辖区', 0);
INSERT INTO `idtoad` VALUES (220802, 22, 8, 2, '吉林', '白城', '洮北区', 1);
INSERT INTO `idtoad` VALUES (220821, 22, 8, 21, '吉林', '白城', '镇赉县', 1);
INSERT INTO `idtoad` VALUES (220822, 22, 8, 22, '吉林', '白城', '通榆县', 1);
INSERT INTO `idtoad` VALUES (220881, 22, 8, 81, '吉林', '白城', '洮南市', 1);
INSERT INTO `idtoad` VALUES (220882, 22, 8, 82, '吉林', '白城', '大安市', 1);
INSERT INTO `idtoad` VALUES (222400, 22, 24, 0, '吉林', '延边朝鲜族自治州', '', 0);
INSERT INTO `idtoad` VALUES (222401, 22, 24, 1, '吉林', '延边朝鲜族自治州', '延吉市', 1);
INSERT INTO `idtoad` VALUES (222402, 22, 24, 2, '吉林', '延边朝鲜族自治州', '图们市', 1);
INSERT INTO `idtoad` VALUES (222403, 22, 24, 3, '吉林', '延边朝鲜族自治州', '敦化市', 1);
INSERT INTO `idtoad` VALUES (222404, 22, 24, 4, '吉林', '延边朝鲜族自治州', '珲春市', 1);
INSERT INTO `idtoad` VALUES (222405, 22, 24, 5, '吉林', '延边朝鲜族自治州', '龙井市', 1);
INSERT INTO `idtoad` VALUES (222406, 22, 24, 6, '吉林', '延边朝鲜族自治州', '和龙市', 1);
INSERT INTO `idtoad` VALUES (222424, 22, 24, 24, '吉林', '延边朝鲜族自治州', '汪清县', 1);
INSERT INTO `idtoad` VALUES (222426, 22, 24, 26, '吉林', '延边朝鲜族自治州', '安图县', 1);
INSERT INTO `idtoad` VALUES (230000, 23, 0, 0, '黑龙江', '', '', 0);
INSERT INTO `idtoad` VALUES (230100, 23, 1, 0, '黑龙江', '哈尔滨', '', 0);
INSERT INTO `idtoad` VALUES (230101, 23, 1, 1, '黑龙江', '哈尔滨', '市辖区', 0);
INSERT INTO `idtoad` VALUES (230102, 23, 1, 2, '黑龙江', '哈尔滨', '道里区', 1);
INSERT INTO `idtoad` VALUES (230103, 23, 1, 3, '黑龙江', '哈尔滨', '南岗区', 1);
INSERT INTO `idtoad` VALUES (230104, 23, 1, 4, '黑龙江', '哈尔滨', '道外区', 1);
INSERT INTO `idtoad` VALUES (230105, 23, 1, 5, '黑龙江', '哈尔滨', '太平区', 0);
INSERT INTO `idtoad` VALUES (230106, 23, 1, 6, '黑龙江', '哈尔滨', '香坊区', 0);
INSERT INTO `idtoad` VALUES (230107, 23, 1, 7, '黑龙江', '哈尔滨', '动力区', 0);
INSERT INTO `idtoad` VALUES (230108, 23, 1, 8, '黑龙江', '哈尔滨', '平房区', 1);
INSERT INTO `idtoad` VALUES (230109, 23, 1, 9, '黑龙江', '哈尔滨', '松北区', 1);
INSERT INTO `idtoad` VALUES (230110, 23, 1, 10, '黑龙江', '哈尔滨', '香坊区', 1);
INSERT INTO `idtoad` VALUES (230111, 23, 1, 11, '黑龙江', '哈尔滨', '呼兰区', 1);
INSERT INTO `idtoad` VALUES (230112, 23, 1, 12, '黑龙江', '哈尔滨', '阿城区', 1);
INSERT INTO `idtoad` VALUES (230113, 23, 1, 13, '黑龙江', '哈尔滨', '双城区', 1);
INSERT INTO `idtoad` VALUES (230121, 23, 1, 21, '黑龙江', '哈尔滨', '呼兰县', 0);
INSERT INTO `idtoad` VALUES (230123, 23, 1, 23, '黑龙江', '哈尔滨', '依兰县', 1);
INSERT INTO `idtoad` VALUES (230124, 23, 1, 24, '黑龙江', '哈尔滨', '方正县', 1);
INSERT INTO `idtoad` VALUES (230125, 23, 1, 25, '黑龙江', '哈尔滨', '宾县', 1);
INSERT INTO `idtoad` VALUES (230126, 23, 1, 26, '黑龙江', '哈尔滨', '巴彦县', 1);
INSERT INTO `idtoad` VALUES (230127, 23, 1, 27, '黑龙江', '哈尔滨', '木兰县', 1);
INSERT INTO `idtoad` VALUES (230128, 23, 1, 28, '黑龙江', '哈尔滨', '通河县', 1);
INSERT INTO `idtoad` VALUES (230129, 23, 1, 29, '黑龙江', '哈尔滨', '延寿县', 1);
INSERT INTO `idtoad` VALUES (230181, 23, 1, 81, '黑龙江', '哈尔滨', '阿城市', 0);
INSERT INTO `idtoad` VALUES (230182, 23, 1, 82, '黑龙江', '哈尔滨', '双城市', 0);
INSERT INTO `idtoad` VALUES (230183, 23, 1, 83, '黑龙江', '哈尔滨', '尚志市', 1);
INSERT INTO `idtoad` VALUES (230184, 23, 1, 84, '黑龙江', '哈尔滨', '五常市', 1);
INSERT INTO `idtoad` VALUES (230200, 23, 2, 0, '黑龙江', '齐齐哈尔', '', 0);
INSERT INTO `idtoad` VALUES (230201, 23, 2, 1, '黑龙江', '齐齐哈尔', '市辖区', 0);
INSERT INTO `idtoad` VALUES (230202, 23, 2, 2, '黑龙江', '齐齐哈尔', '龙沙区', 1);
INSERT INTO `idtoad` VALUES (230203, 23, 2, 3, '黑龙江', '齐齐哈尔', '建华区', 1);
INSERT INTO `idtoad` VALUES (230204, 23, 2, 4, '黑龙江', '齐齐哈尔', '铁锋区', 1);
INSERT INTO `idtoad` VALUES (230205, 23, 2, 5, '黑龙江', '齐齐哈尔', '昂昂溪区', 1);
INSERT INTO `idtoad` VALUES (230206, 23, 2, 6, '黑龙江', '齐齐哈尔', '富拉尔基区', 1);
INSERT INTO `idtoad` VALUES (230207, 23, 2, 7, '黑龙江', '齐齐哈尔', '碾子山区', 1);
INSERT INTO `idtoad` VALUES (230208, 23, 2, 8, '黑龙江', '齐齐哈尔', '梅里斯达斡尔族区', 1);
INSERT INTO `idtoad` VALUES (230221, 23, 2, 21, '黑龙江', '齐齐哈尔', '龙江县', 1);
INSERT INTO `idtoad` VALUES (230223, 23, 2, 23, '黑龙江', '齐齐哈尔', '依安县', 1);
INSERT INTO `idtoad` VALUES (230224, 23, 2, 24, '黑龙江', '齐齐哈尔', '泰来县', 1);
INSERT INTO `idtoad` VALUES (230225, 23, 2, 25, '黑龙江', '齐齐哈尔', '甘南县', 1);
INSERT INTO `idtoad` VALUES (230227, 23, 2, 27, '黑龙江', '齐齐哈尔', '富裕县', 1);
INSERT INTO `idtoad` VALUES (230229, 23, 2, 29, '黑龙江', '齐齐哈尔', '克山县', 1);
INSERT INTO `idtoad` VALUES (230230, 23, 2, 30, '黑龙江', '齐齐哈尔', '克东县', 1);
INSERT INTO `idtoad` VALUES (230231, 23, 2, 31, '黑龙江', '齐齐哈尔', '拜泉县', 1);
INSERT INTO `idtoad` VALUES (230281, 23, 2, 81, '黑龙江', '齐齐哈尔', '讷河市', 1);
INSERT INTO `idtoad` VALUES (230300, 23, 3, 0, '黑龙江', '鸡西', '', 0);
INSERT INTO `idtoad` VALUES (230301, 23, 3, 1, '黑龙江', '鸡西', '市辖区', 0);
INSERT INTO `idtoad` VALUES (230302, 23, 3, 2, '黑龙江', '鸡西', '鸡冠区', 1);
INSERT INTO `idtoad` VALUES (230303, 23, 3, 3, '黑龙江', '鸡西', '恒山区', 1);
INSERT INTO `idtoad` VALUES (230304, 23, 3, 4, '黑龙江', '鸡西', '滴道区', 1);
INSERT INTO `idtoad` VALUES (230305, 23, 3, 5, '黑龙江', '鸡西', '梨树区', 1);
INSERT INTO `idtoad` VALUES (230306, 23, 3, 6, '黑龙江', '鸡西', '城子河区', 1);
INSERT INTO `idtoad` VALUES (230307, 23, 3, 7, '黑龙江', '鸡西', '麻山区', 1);
INSERT INTO `idtoad` VALUES (230321, 23, 3, 21, '黑龙江', '鸡西', '鸡东县', 1);
INSERT INTO `idtoad` VALUES (230381, 23, 3, 81, '黑龙江', '鸡西', '虎林市', 1);
INSERT INTO `idtoad` VALUES (230382, 23, 3, 82, '黑龙江', '鸡西', '密山市', 1);
INSERT INTO `idtoad` VALUES (230400, 23, 4, 0, '黑龙江', '鹤岗', '', 0);
INSERT INTO `idtoad` VALUES (230401, 23, 4, 1, '黑龙江', '鹤岗', '市辖区', 0);
INSERT INTO `idtoad` VALUES (230402, 23, 4, 2, '黑龙江', '鹤岗', '向阳区', 1);
INSERT INTO `idtoad` VALUES (230403, 23, 4, 3, '黑龙江', '鹤岗', '工农区', 1);
INSERT INTO `idtoad` VALUES (230404, 23, 4, 4, '黑龙江', '鹤岗', '南山区', 1);
INSERT INTO `idtoad` VALUES (230405, 23, 4, 5, '黑龙江', '鹤岗', '兴安区', 1);
INSERT INTO `idtoad` VALUES (230406, 23, 4, 6, '黑龙江', '鹤岗', '东山区', 1);
INSERT INTO `idtoad` VALUES (230407, 23, 4, 7, '黑龙江', '鹤岗', '兴山区', 1);
INSERT INTO `idtoad` VALUES (230421, 23, 4, 21, '黑龙江', '鹤岗', '萝北县', 1);
INSERT INTO `idtoad` VALUES (230422, 23, 4, 22, '黑龙江', '鹤岗', '绥滨县', 1);
INSERT INTO `idtoad` VALUES (230500, 23, 5, 0, '黑龙江', '双鸭山', '', 0);
INSERT INTO `idtoad` VALUES (230501, 23, 5, 1, '黑龙江', '双鸭山', '市辖区', 0);
INSERT INTO `idtoad` VALUES (230502, 23, 5, 2, '黑龙江', '双鸭山', '尖山区', 1);
INSERT INTO `idtoad` VALUES (230503, 23, 5, 3, '黑龙江', '双鸭山', '岭东区', 1);
INSERT INTO `idtoad` VALUES (230505, 23, 5, 5, '黑龙江', '双鸭山', '四方台区', 1);
INSERT INTO `idtoad` VALUES (230506, 23, 5, 6, '黑龙江', '双鸭山', '宝山区', 1);
INSERT INTO `idtoad` VALUES (230521, 23, 5, 21, '黑龙江', '双鸭山', '集贤县', 1);
INSERT INTO `idtoad` VALUES (230522, 23, 5, 22, '黑龙江', '双鸭山', '友谊县', 1);
INSERT INTO `idtoad` VALUES (230523, 23, 5, 23, '黑龙江', '双鸭山', '宝清县', 1);
INSERT INTO `idtoad` VALUES (230524, 23, 5, 24, '黑龙江', '双鸭山', '饶河县', 1);
INSERT INTO `idtoad` VALUES (230600, 23, 6, 0, '黑龙江', '大庆', '', 0);
INSERT INTO `idtoad` VALUES (230601, 23, 6, 1, '黑龙江', '大庆', '市辖区', 0);
INSERT INTO `idtoad` VALUES (230602, 23, 6, 2, '黑龙江', '大庆', '萨尔图区', 1);
INSERT INTO `idtoad` VALUES (230603, 23, 6, 3, '黑龙江', '大庆', '龙凤区', 1);
INSERT INTO `idtoad` VALUES (230604, 23, 6, 4, '黑龙江', '大庆', '让胡路区', 1);
INSERT INTO `idtoad` VALUES (230605, 23, 6, 5, '黑龙江', '大庆', '红岗区', 1);
INSERT INTO `idtoad` VALUES (230606, 23, 6, 6, '黑龙江', '大庆', '大同区', 1);
INSERT INTO `idtoad` VALUES (230621, 23, 6, 21, '黑龙江', '大庆', '肇州县', 1);
INSERT INTO `idtoad` VALUES (230622, 23, 6, 22, '黑龙江', '大庆', '肇源县', 1);
INSERT INTO `idtoad` VALUES (230623, 23, 6, 23, '黑龙江', '大庆', '林甸县', 1);
INSERT INTO `idtoad` VALUES (230624, 23, 6, 24, '黑龙江', '大庆', '杜尔伯特蒙古族自治县', 1);
INSERT INTO `idtoad` VALUES (230700, 23, 7, 0, '黑龙江', '伊春', '', 0);
INSERT INTO `idtoad` VALUES (230701, 23, 7, 1, '黑龙江', '伊春', '市辖区', 0);
INSERT INTO `idtoad` VALUES (230702, 23, 7, 2, '黑龙江', '伊春', '伊春区', 0);
INSERT INTO `idtoad` VALUES (230703, 23, 7, 3, '黑龙江', '伊春', '南岔区', 0);
INSERT INTO `idtoad` VALUES (230704, 23, 7, 4, '黑龙江', '伊春', '友好区', 0);
INSERT INTO `idtoad` VALUES (230705, 23, 7, 5, '黑龙江', '伊春', '西林区', 0);
INSERT INTO `idtoad` VALUES (230706, 23, 7, 6, '黑龙江', '伊春', '翠峦区', 0);
INSERT INTO `idtoad` VALUES (230707, 23, 7, 7, '黑龙江', '伊春', '新青区', 0);
INSERT INTO `idtoad` VALUES (230708, 23, 7, 8, '黑龙江', '伊春', '美溪区', 0);
INSERT INTO `idtoad` VALUES (230709, 23, 7, 9, '黑龙江', '伊春', '金山屯区', 0);
INSERT INTO `idtoad` VALUES (230710, 23, 7, 10, '黑龙江', '伊春', '五营区', 0);
INSERT INTO `idtoad` VALUES (230711, 23, 7, 11, '黑龙江', '伊春', '乌马河区', 0);
INSERT INTO `idtoad` VALUES (230712, 23, 7, 12, '黑龙江', '伊春', '汤旺河区', 0);
INSERT INTO `idtoad` VALUES (230713, 23, 7, 13, '黑龙江', '伊春', '带岭区', 0);
INSERT INTO `idtoad` VALUES (230714, 23, 7, 14, '黑龙江', '伊春', '乌伊岭区', 0);
INSERT INTO `idtoad` VALUES (230715, 23, 7, 15, '黑龙江', '伊春', '红星区', 0);
INSERT INTO `idtoad` VALUES (230716, 23, 7, 16, '黑龙江', '伊春', '上甘岭区', 0);
INSERT INTO `idtoad` VALUES (230717, 23, 7, 17, '黑龙江', '伊春', '伊美区', 1);
INSERT INTO `idtoad` VALUES (230718, 23, 7, 18, '黑龙江', '伊春', '乌翠区', 1);
INSERT INTO `idtoad` VALUES (230719, 23, 7, 19, '黑龙江', '伊春', '友好区', 1);
INSERT INTO `idtoad` VALUES (230722, 23, 7, 22, '黑龙江', '伊春', '嘉荫县', 1);
INSERT INTO `idtoad` VALUES (230723, 23, 7, 23, '黑龙江', '伊春', '汤旺县', 1);
INSERT INTO `idtoad` VALUES (230724, 23, 7, 24, '黑龙江', '伊春', '丰林县', 1);
INSERT INTO `idtoad` VALUES (230725, 23, 7, 25, '黑龙江', '伊春', '大箐山县', 1);
INSERT INTO `idtoad` VALUES (230726, 23, 7, 26, '黑龙江', '伊春', '南岔县', 1);
INSERT INTO `idtoad` VALUES (230751, 23, 7, 51, '黑龙江', '伊春', '金林区', 1);
INSERT INTO `idtoad` VALUES (230781, 23, 7, 81, '黑龙江', '伊春', '铁力市', 1);
INSERT INTO `idtoad` VALUES (230800, 23, 8, 0, '黑龙江', '佳木斯', '', 0);
INSERT INTO `idtoad` VALUES (230801, 23, 8, 1, '黑龙江', '佳木斯', '市辖区', 0);
INSERT INTO `idtoad` VALUES (230802, 23, 8, 2, '黑龙江', '佳木斯', '永红区', 0);
INSERT INTO `idtoad` VALUES (230803, 23, 8, 3, '黑龙江', '佳木斯', '向阳区', 1);
INSERT INTO `idtoad` VALUES (230804, 23, 8, 4, '黑龙江', '佳木斯', '前进区', 1);
INSERT INTO `idtoad` VALUES (230805, 23, 8, 5, '黑龙江', '佳木斯', '东风区', 1);
INSERT INTO `idtoad` VALUES (230811, 23, 8, 11, '黑龙江', '佳木斯', '郊区', 1);
INSERT INTO `idtoad` VALUES (230822, 23, 8, 22, '黑龙江', '佳木斯', '桦南县', 1);
INSERT INTO `idtoad` VALUES (230826, 23, 8, 26, '黑龙江', '佳木斯', '桦川县', 1);
INSERT INTO `idtoad` VALUES (230828, 23, 8, 28, '黑龙江', '佳木斯', '汤原县', 1);
INSERT INTO `idtoad` VALUES (230833, 23, 8, 33, '黑龙江', '佳木斯', '抚远县', 0);
INSERT INTO `idtoad` VALUES (230881, 23, 8, 81, '黑龙江', '佳木斯', '同江市', 1);
INSERT INTO `idtoad` VALUES (230882, 23, 8, 82, '黑龙江', '佳木斯', '富锦市', 1);
INSERT INTO `idtoad` VALUES (230883, 23, 8, 83, '黑龙江', '佳木斯', '抚远市', 1);
INSERT INTO `idtoad` VALUES (230900, 23, 9, 0, '黑龙江', '七台河', '', 0);
INSERT INTO `idtoad` VALUES (230901, 23, 9, 1, '黑龙江', '七台河', '市辖区', 0);
INSERT INTO `idtoad` VALUES (230902, 23, 9, 2, '黑龙江', '七台河', '新兴区', 1);
INSERT INTO `idtoad` VALUES (230903, 23, 9, 3, '黑龙江', '七台河', '桃山区', 1);
INSERT INTO `idtoad` VALUES (230904, 23, 9, 4, '黑龙江', '七台河', '茄子河区', 1);
INSERT INTO `idtoad` VALUES (230921, 23, 9, 21, '黑龙江', '七台河', '勃利县', 1);
INSERT INTO `idtoad` VALUES (231000, 23, 10, 0, '黑龙江', '牡丹江', '', 0);
INSERT INTO `idtoad` VALUES (231001, 23, 10, 1, '黑龙江', '牡丹江', '市辖区', 0);
INSERT INTO `idtoad` VALUES (231002, 23, 10, 2, '黑龙江', '牡丹江', '东安区', 1);
INSERT INTO `idtoad` VALUES (231003, 23, 10, 3, '黑龙江', '牡丹江', '阳明区', 1);
INSERT INTO `idtoad` VALUES (231004, 23, 10, 4, '黑龙江', '牡丹江', '爱民区', 1);
INSERT INTO `idtoad` VALUES (231005, 23, 10, 5, '黑龙江', '牡丹江', '西安区', 1);
INSERT INTO `idtoad` VALUES (231024, 23, 10, 24, '黑龙江', '牡丹江', '东宁县', 0);
INSERT INTO `idtoad` VALUES (231025, 23, 10, 25, '黑龙江', '牡丹江', '林口县', 1);
INSERT INTO `idtoad` VALUES (231081, 23, 10, 81, '黑龙江', '牡丹江', '绥芬河市', 1);
INSERT INTO `idtoad` VALUES (231083, 23, 10, 83, '黑龙江', '牡丹江', '海林市', 1);
INSERT INTO `idtoad` VALUES (231084, 23, 10, 84, '黑龙江', '牡丹江', '宁安市', 1);
INSERT INTO `idtoad` VALUES (231085, 23, 10, 85, '黑龙江', '牡丹江', '穆棱市', 1);
INSERT INTO `idtoad` VALUES (231086, 23, 10, 86, '黑龙江', '牡丹江', '东宁市', 1);
INSERT INTO `idtoad` VALUES (231100, 23, 11, 0, '黑龙江', '黑河', '', 0);
INSERT INTO `idtoad` VALUES (231101, 23, 11, 1, '黑龙江', '黑河', '市辖区', 0);
INSERT INTO `idtoad` VALUES (231102, 23, 11, 2, '黑龙江', '黑河', '爱辉区', 1);
INSERT INTO `idtoad` VALUES (231121, 23, 11, 21, '黑龙江', '黑河', '嫩江县', 0);
INSERT INTO `idtoad` VALUES (231123, 23, 11, 23, '黑龙江', '黑河', '逊克县', 1);
INSERT INTO `idtoad` VALUES (231124, 23, 11, 24, '黑龙江', '黑河', '孙吴县', 1);
INSERT INTO `idtoad` VALUES (231181, 23, 11, 81, '黑龙江', '黑河', '北安市', 1);
INSERT INTO `idtoad` VALUES (231182, 23, 11, 82, '黑龙江', '黑河', '五大连池市', 1);
INSERT INTO `idtoad` VALUES (231183, 23, 11, 83, '黑龙江', '黑河', '嫩江市', 1);
INSERT INTO `idtoad` VALUES (231202, 23, 12, 2, '黑龙江', '绥化', '北林区', 1);
INSERT INTO `idtoad` VALUES (231221, 23, 12, 21, '黑龙江', '绥化', '望奎县', 1);
INSERT INTO `idtoad` VALUES (231222, 23, 12, 22, '黑龙江', '绥化', '兰西县', 1);
INSERT INTO `idtoad` VALUES (231223, 23, 12, 23, '黑龙江', '绥化', '青冈县', 1);
INSERT INTO `idtoad` VALUES (231224, 23, 12, 24, '黑龙江', '绥化', '庆安县', 1);
INSERT INTO `idtoad` VALUES (231225, 23, 12, 25, '黑龙江', '绥化', '明水县', 1);
INSERT INTO `idtoad` VALUES (231226, 23, 12, 26, '黑龙江', '绥化', '绥棱县', 1);
INSERT INTO `idtoad` VALUES (231281, 23, 12, 81, '黑龙江', '绥化', '安达市', 1);
INSERT INTO `idtoad` VALUES (231282, 23, 12, 82, '黑龙江', '绥化', '肇东市', 1);
INSERT INTO `idtoad` VALUES (231283, 23, 12, 83, '黑龙江', '绥化', '海伦市', 1);
INSERT INTO `idtoad` VALUES (232300, 23, 23, 0, '黑龙江', '绥化地区', '', 0);
INSERT INTO `idtoad` VALUES (232301, 23, 23, 1, '黑龙江', '绥化地区', '绥化市', 0);
INSERT INTO `idtoad` VALUES (232302, 23, 23, 2, '黑龙江', '绥化地区', '安达市', 0);
INSERT INTO `idtoad` VALUES (232303, 23, 23, 3, '黑龙江', '绥化地区', '肇东市', 0);
INSERT INTO `idtoad` VALUES (232304, 23, 23, 4, '黑龙江', '绥化地区', '海伦市', 0);
INSERT INTO `idtoad` VALUES (232324, 23, 23, 24, '黑龙江', '绥化地区', '望奎县', 0);
INSERT INTO `idtoad` VALUES (232325, 23, 23, 25, '黑龙江', '绥化地区', '兰西县', 0);
INSERT INTO `idtoad` VALUES (232326, 23, 23, 26, '黑龙江', '绥化地区', '青冈县', 0);
INSERT INTO `idtoad` VALUES (232330, 23, 23, 30, '黑龙江', '绥化地区', '庆安县', 0);
INSERT INTO `idtoad` VALUES (232331, 23, 23, 31, '黑龙江', '绥化地区', '明水县', 0);
INSERT INTO `idtoad` VALUES (232332, 23, 23, 32, '黑龙江', '绥化地区', '绥棱县', 0);
INSERT INTO `idtoad` VALUES (232700, 23, 27, 0, '黑龙江', '大兴安岭地区', '大兴安岭地区', 1);
INSERT INTO `idtoad` VALUES (232701, 23, 27, 1, '黑龙江', '大兴安岭地区', '漠河市', 1);
INSERT INTO `idtoad` VALUES (232721, 23, 27, 21, '黑龙江', '大兴安岭地区', '呼玛县', 1);
INSERT INTO `idtoad` VALUES (232722, 23, 27, 22, '黑龙江', '大兴安岭地区', '塔河县', 1);
INSERT INTO `idtoad` VALUES (232723, 23, 27, 23, '黑龙江', '大兴安岭地区', '漠河县', 0);
INSERT INTO `idtoad` VALUES (310000, 31, 0, 0, '上海', '', '', 0);
INSERT INTO `idtoad` VALUES (310100, 31, 1, 0, '上海', '市辖区', '', 0);
INSERT INTO `idtoad` VALUES (310101, 31, 1, 1, '上海', '上海', '黄浦区', 1);
INSERT INTO `idtoad` VALUES (310102, 31, 1, 2, '上海', '上海', '南市区', 0);
INSERT INTO `idtoad` VALUES (310103, 31, 1, 3, '上海', '上海', '卢湾区', 0);
INSERT INTO `idtoad` VALUES (310104, 31, 1, 4, '上海', '上海', '徐汇区', 1);
INSERT INTO `idtoad` VALUES (310105, 31, 1, 5, '上海', '上海', '长宁区', 1);
INSERT INTO `idtoad` VALUES (310106, 31, 1, 6, '上海', '上海', '静安区', 1);
INSERT INTO `idtoad` VALUES (310107, 31, 1, 7, '上海', '上海', '普陀区', 1);
INSERT INTO `idtoad` VALUES (310108, 31, 1, 8, '上海', '上海', '闸北区', 0);
INSERT INTO `idtoad` VALUES (310109, 31, 1, 9, '上海', '上海', '虹口区', 1);
INSERT INTO `idtoad` VALUES (310110, 31, 1, 10, '上海', '上海', '杨浦区', 1);
INSERT INTO `idtoad` VALUES (310112, 31, 1, 12, '上海', '上海', '闵行区', 1);
INSERT INTO `idtoad` VALUES (310113, 31, 1, 13, '上海', '上海', '宝山区', 1);
INSERT INTO `idtoad` VALUES (310114, 31, 1, 14, '上海', '上海', '嘉定区', 1);
INSERT INTO `idtoad` VALUES (310115, 31, 1, 15, '上海', '上海', '浦东新区', 1);
INSERT INTO `idtoad` VALUES (310116, 31, 1, 16, '上海', '上海', '金山区', 1);
INSERT INTO `idtoad` VALUES (310117, 31, 1, 17, '上海', '上海', '松江区', 1);
INSERT INTO `idtoad` VALUES (310118, 31, 1, 18, '上海', '上海', '青浦区', 1);
INSERT INTO `idtoad` VALUES (310120, 31, 1, 20, '上海', '上海', '奉贤区', 1);
INSERT INTO `idtoad` VALUES (310151, 31, 1, 51, '上海', '上海', '崇明区', 1);
INSERT INTO `idtoad` VALUES (310200, 31, 2, 0, '上海', '市县', '', 0);
INSERT INTO `idtoad` VALUES (310225, 31, 2, 25, '上海', '上海', '南汇县', 0);
INSERT INTO `idtoad` VALUES (310226, 31, 2, 26, '上海', '上海', '奉贤县', 0);
INSERT INTO `idtoad` VALUES (310229, 31, 2, 29, '上海', '上海', '青浦县', 0);
INSERT INTO `idtoad` VALUES (310230, 31, 2, 30, '上海', '上海', '崇明县', 0);
INSERT INTO `idtoad` VALUES (320000, 32, 0, 0, '江苏', '', '', 0);
INSERT INTO `idtoad` VALUES (320100, 32, 1, 0, '江苏', '南京', '', 0);
INSERT INTO `idtoad` VALUES (320101, 32, 1, 1, '江苏', '南京', '市辖区', 0);
INSERT INTO `idtoad` VALUES (320102, 32, 1, 2, '江苏', '南京', '玄武区', 1);
INSERT INTO `idtoad` VALUES (320103, 32, 1, 3, '江苏', '南京', '白下区', 0);
INSERT INTO `idtoad` VALUES (320104, 32, 1, 4, '江苏', '南京', '秦淮区', 1);
INSERT INTO `idtoad` VALUES (320105, 32, 1, 5, '江苏', '南京', '建邺区', 1);
INSERT INTO `idtoad` VALUES (320106, 32, 1, 6, '江苏', '南京', '鼓楼区', 1);
INSERT INTO `idtoad` VALUES (320107, 32, 1, 7, '江苏', '南京', '下关区', 0);
INSERT INTO `idtoad` VALUES (320111, 32, 1, 11, '江苏', '南京', '浦口区', 1);
INSERT INTO `idtoad` VALUES (320112, 32, 1, 12, '江苏', '南京', '大厂区', 0);
INSERT INTO `idtoad` VALUES (320113, 32, 1, 13, '江苏', '南京', '栖霞区', 1);
INSERT INTO `idtoad` VALUES (320114, 32, 1, 14, '江苏', '南京', '雨花台区', 1);
INSERT INTO `idtoad` VALUES (320115, 32, 1, 15, '江苏', '南京', '江宁区', 1);
INSERT INTO `idtoad` VALUES (320116, 32, 1, 16, '江苏', '南京', '六合区', 1);
INSERT INTO `idtoad` VALUES (320117, 32, 1, 17, '江苏', '南京', '溧水区', 1);
INSERT INTO `idtoad` VALUES (320118, 32, 1, 18, '江苏', '南京', '高淳区', 1);
INSERT INTO `idtoad` VALUES (320121, 32, 1, 21, '江苏', '南京', '江宁县', 0);
INSERT INTO `idtoad` VALUES (320122, 32, 1, 22, '江苏', '南京', '江浦县', 0);
INSERT INTO `idtoad` VALUES (320123, 32, 1, 23, '江苏', '南京', '六合县', 0);
INSERT INTO `idtoad` VALUES (320124, 32, 1, 24, '江苏', '南京', '溧水县', 0);
INSERT INTO `idtoad` VALUES (320125, 32, 1, 25, '江苏', '南京', '高淳县', 0);
INSERT INTO `idtoad` VALUES (320200, 32, 2, 0, '江苏', '无锡', '无锡', 1);
INSERT INTO `idtoad` VALUES (320201, 32, 2, 1, '江苏', '无锡', '市辖区', 0);
INSERT INTO `idtoad` VALUES (320202, 32, 2, 2, '江苏', '无锡', '崇安区', 0);
INSERT INTO `idtoad` VALUES (320203, 32, 2, 3, '江苏', '无锡', '南长区', 0);
INSERT INTO `idtoad` VALUES (320204, 32, 2, 4, '江苏', '无锡', '北塘区', 0);
INSERT INTO `idtoad` VALUES (320205, 32, 2, 5, '江苏', '无锡', '锡山区', 1);
INSERT INTO `idtoad` VALUES (320206, 32, 2, 6, '江苏', '无锡', '惠山区', 1);
INSERT INTO `idtoad` VALUES (320211, 32, 2, 11, '江苏', '无锡', '滨湖区', 1);
INSERT INTO `idtoad` VALUES (320213, 32, 2, 13, '江苏', '无锡', '梁溪区', 1);
INSERT INTO `idtoad` VALUES (320214, 32, 2, 14, '江苏', '无锡', '新吴区', 1);
INSERT INTO `idtoad` VALUES (320281, 32, 2, 81, '江苏', '无锡', '江阴市', 1);
INSERT INTO `idtoad` VALUES (320282, 32, 2, 82, '江苏', '无锡', '宜兴市', 1);
INSERT INTO `idtoad` VALUES (320283, 32, 2, 83, '江苏', '无锡', '锡山市', 0);
INSERT INTO `idtoad` VALUES (320300, 32, 3, 0, '江苏', '徐州', '', 0);
INSERT INTO `idtoad` VALUES (320301, 32, 3, 1, '江苏', '徐州', '市辖区', 0);
INSERT INTO `idtoad` VALUES (320302, 32, 3, 2, '江苏', '徐州', '鼓楼区', 1);
INSERT INTO `idtoad` VALUES (320303, 32, 3, 3, '江苏', '徐州', '云龙区', 1);
INSERT INTO `idtoad` VALUES (320304, 32, 3, 4, '江苏', '徐州', '九里区', 0);
INSERT INTO `idtoad` VALUES (320305, 32, 3, 5, '江苏', '徐州', '贾汪区', 1);
INSERT INTO `idtoad` VALUES (320311, 32, 3, 11, '江苏', '徐州', '泉山区', 1);
INSERT INTO `idtoad` VALUES (320312, 32, 3, 12, '江苏', '徐州', '铜山区', 1);
INSERT INTO `idtoad` VALUES (320321, 32, 3, 21, '江苏', '徐州', '丰县', 1);
INSERT INTO `idtoad` VALUES (320322, 32, 3, 22, '江苏', '徐州', '沛县', 1);
INSERT INTO `idtoad` VALUES (320323, 32, 3, 23, '江苏', '徐州', '铜山县', 0);
INSERT INTO `idtoad` VALUES (320324, 32, 3, 24, '江苏', '徐州', '睢宁县', 1);
INSERT INTO `idtoad` VALUES (320381, 32, 3, 81, '江苏', '徐州', '新沂市', 1);
INSERT INTO `idtoad` VALUES (320382, 32, 3, 82, '江苏', '徐州', '邳州市', 1);
INSERT INTO `idtoad` VALUES (320400, 32, 4, 0, '江苏', '常州', '', 0);
INSERT INTO `idtoad` VALUES (320401, 32, 4, 1, '江苏', '常州', '市辖区', 0);
INSERT INTO `idtoad` VALUES (320402, 32, 4, 2, '江苏', '常州', '天宁区', 1);
INSERT INTO `idtoad` VALUES (320403, 32, 4, 3, '江苏', '常州', '广化区', 0);
INSERT INTO `idtoad` VALUES (320404, 32, 4, 4, '江苏', '常州', '钟楼区', 1);
INSERT INTO `idtoad` VALUES (320405, 32, 4, 5, '江苏', '常州', '戚墅堰区', 0);
INSERT INTO `idtoad` VALUES (320411, 32, 4, 11, '江苏', '常州', '新北区', 1);
INSERT INTO `idtoad` VALUES (320412, 32, 4, 12, '江苏', '常州', '武进区', 1);
INSERT INTO `idtoad` VALUES (320413, 32, 4, 13, '江苏', '常州', '金坛区', 1);
INSERT INTO `idtoad` VALUES (320481, 32, 4, 81, '江苏', '常州', '溧阳市', 1);
INSERT INTO `idtoad` VALUES (320482, 32, 4, 82, '江苏', '常州', '金坛县', 0);
INSERT INTO `idtoad` VALUES (320483, 32, 4, 83, '江苏', '常州', '武进县', 0);
INSERT INTO `idtoad` VALUES (320500, 32, 5, 0, '江苏', '苏州', '苏州', 1);
INSERT INTO `idtoad` VALUES (320501, 32, 5, 1, '江苏', '苏州', '市辖区', 0);
INSERT INTO `idtoad` VALUES (320502, 32, 5, 2, '江苏', '苏州', '沧浪区', 0);
INSERT INTO `idtoad` VALUES (320503, 32, 5, 3, '江苏', '苏州', '平江区', 0);
INSERT INTO `idtoad` VALUES (320504, 32, 5, 4, '江苏', '苏州', '金阊区', 0);
INSERT INTO `idtoad` VALUES (320505, 32, 5, 5, '江苏', '苏州', '虎丘区', 1);
INSERT INTO `idtoad` VALUES (320506, 32, 5, 6, '江苏', '苏州', '吴中区', 1);
INSERT INTO `idtoad` VALUES (320507, 32, 5, 7, '江苏', '苏州', '相城区', 1);
INSERT INTO `idtoad` VALUES (320508, 32, 5, 8, '江苏', '苏州', '姑苏区', 1);
INSERT INTO `idtoad` VALUES (320509, 32, 5, 9, '江苏', '苏州', '吴江区', 1);
INSERT INTO `idtoad` VALUES (320511, 32, 5, 11, '江苏', '苏州', '郊区', 0);
INSERT INTO `idtoad` VALUES (320581, 32, 5, 81, '江苏', '苏州', '常熟市', 1);
INSERT INTO `idtoad` VALUES (320582, 32, 5, 82, '江苏', '苏州', '张家港市', 1);
INSERT INTO `idtoad` VALUES (320583, 32, 5, 83, '江苏', '苏州', '昆山市', 1);
INSERT INTO `idtoad` VALUES (320584, 32, 5, 84, '江苏', '苏州', '吴江市', 0);
INSERT INTO `idtoad` VALUES (320585, 32, 5, 85, '江苏', '苏州', '太仓市', 1);
INSERT INTO `idtoad` VALUES (320586, 32, 5, 86, '江苏', '苏州', '吴县市', 0);
INSERT INTO `idtoad` VALUES (320600, 32, 6, 0, '江苏', '南通', '南通', 1);
INSERT INTO `idtoad` VALUES (320601, 32, 6, 1, '江苏', '南通', '市辖区', 0);
INSERT INTO `idtoad` VALUES (320602, 32, 6, 2, '江苏', '南通', '崇川区', 0);
INSERT INTO `idtoad` VALUES (320611, 32, 6, 11, '江苏', '南通', '港闸区', 0);
INSERT INTO `idtoad` VALUES (320612, 32, 6, 12, '江苏', '南通', '通州区', 1);
INSERT INTO `idtoad` VALUES (320613, 32, 6, 13, '江苏', '南通', '崇川区', 1);
INSERT INTO `idtoad` VALUES (320614, 32, 6, 14, '江苏', '南通', '海门区', 1);
INSERT INTO `idtoad` VALUES (320621, 32, 6, 21, '江苏', '南通', '海安县', 0);
INSERT INTO `idtoad` VALUES (320623, 32, 6, 23, '江苏', '南通', '如东县', 1);
INSERT INTO `idtoad` VALUES (320681, 32, 6, 81, '江苏', '南通', '启东市', 1);
INSERT INTO `idtoad` VALUES (320682, 32, 6, 82, '江苏', '南通', '如皋市', 1);
INSERT INTO `idtoad` VALUES (320683, 32, 6, 83, '江苏', '南通', '通州市', 0);
INSERT INTO `idtoad` VALUES (320684, 32, 6, 84, '江苏', '南通', '海门市', 0);
INSERT INTO `idtoad` VALUES (320685, 32, 6, 85, '江苏', '南通', '海安市', 1);
INSERT INTO `idtoad` VALUES (320700, 32, 7, 0, '江苏', '连云港', '', 0);
INSERT INTO `idtoad` VALUES (320701, 32, 7, 1, '江苏', '连云港', '市辖区', 0);
INSERT INTO `idtoad` VALUES (320703, 32, 7, 3, '江苏', '连云港', '连云区', 1);
INSERT INTO `idtoad` VALUES (320704, 32, 7, 4, '江苏', '连云港', '云台区', 0);
INSERT INTO `idtoad` VALUES (320705, 32, 7, 5, '江苏', '连云港', '新浦区', 0);
INSERT INTO `idtoad` VALUES (320706, 32, 7, 6, '江苏', '连云港', '海州区', 1);
INSERT INTO `idtoad` VALUES (320707, 32, 7, 7, '江苏', '连云港', '赣榆区', 1);
INSERT INTO `idtoad` VALUES (320721, 32, 7, 21, '江苏', '连云港', '赣榆县', 0);
INSERT INTO `idtoad` VALUES (320722, 32, 7, 22, '江苏', '连云港', '东海县', 1);
INSERT INTO `idtoad` VALUES (320723, 32, 7, 23, '江苏', '连云港', '灌云县', 1);
INSERT INTO `idtoad` VALUES (320724, 32, 7, 24, '江苏', '连云港', '灌南县', 1);
INSERT INTO `idtoad` VALUES (320800, 32, 8, 0, '江苏', '淮阴', '', 0);
INSERT INTO `idtoad` VALUES (320801, 32, 8, 1, '江苏', '淮阴', '市辖区', 0);
INSERT INTO `idtoad` VALUES (320802, 32, 8, 2, '江苏', '淮阴', '清河区', 0);
INSERT INTO `idtoad` VALUES (320803, 32, 8, 3, '江苏', '淮安', '淮安区', 1);
INSERT INTO `idtoad` VALUES (320804, 32, 8, 4, '江苏', '淮安', '淮阴区', 1);
INSERT INTO `idtoad` VALUES (320811, 32, 8, 11, '江苏', '淮阴', '清浦区', 0);
INSERT INTO `idtoad` VALUES (320812, 32, 8, 12, '江苏', '淮安', '清江浦区', 1);
INSERT INTO `idtoad` VALUES (320813, 32, 8, 13, '江苏', '淮安', '洪泽区', 1);
INSERT INTO `idtoad` VALUES (320821, 32, 8, 21, '江苏', '淮阴', '县', 0);
INSERT INTO `idtoad` VALUES (320826, 32, 8, 26, '江苏', '淮安', '涟水县', 1);
INSERT INTO `idtoad` VALUES (320829, 32, 8, 29, '江苏', '淮阴', '洪泽县', 0);
INSERT INTO `idtoad` VALUES (320830, 32, 8, 30, '江苏', '淮安', '盱眙县', 1);
INSERT INTO `idtoad` VALUES (320831, 32, 8, 31, '江苏', '淮安', '金湖县', 1);
INSERT INTO `idtoad` VALUES (320882, 32, 8, 82, '江苏', '淮阴', '淮安市', 0);
INSERT INTO `idtoad` VALUES (320900, 32, 9, 0, '江苏', '盐城', '', 0);
INSERT INTO `idtoad` VALUES (320901, 32, 9, 1, '江苏', '盐城', '市辖区', 0);
INSERT INTO `idtoad` VALUES (320902, 32, 9, 2, '江苏', '盐城', '亭湖区', 1);
INSERT INTO `idtoad` VALUES (320903, 32, 9, 3, '江苏', '盐城', '盐都区', 1);
INSERT INTO `idtoad` VALUES (320904, 32, 9, 4, '江苏', '盐城', '大丰区', 1);
INSERT INTO `idtoad` VALUES (320921, 32, 9, 21, '江苏', '盐城', '响水县', 1);
INSERT INTO `idtoad` VALUES (320922, 32, 9, 22, '江苏', '盐城', '滨海县', 1);
INSERT INTO `idtoad` VALUES (320923, 32, 9, 23, '江苏', '盐城', '阜宁县', 1);
INSERT INTO `idtoad` VALUES (320924, 32, 9, 24, '江苏', '盐城', '射阳县', 1);
INSERT INTO `idtoad` VALUES (320925, 32, 9, 25, '江苏', '盐城', '建湖县', 1);
INSERT INTO `idtoad` VALUES (320928, 32, 9, 28, '江苏', '盐城', '盐都县', 0);
INSERT INTO `idtoad` VALUES (320981, 32, 9, 81, '江苏', '盐城', '东台市', 1);
INSERT INTO `idtoad` VALUES (320982, 32, 9, 82, '江苏', '盐城', '大丰市', 0);
INSERT INTO `idtoad` VALUES (321000, 32, 10, 0, '江苏', '扬州', '扬州', 1);
INSERT INTO `idtoad` VALUES (321001, 32, 10, 1, '江苏', '扬州', '市辖区', 0);
INSERT INTO `idtoad` VALUES (321002, 32, 10, 2, '江苏', '扬州', '广陵区', 1);
INSERT INTO `idtoad` VALUES (321003, 32, 10, 3, '江苏', '扬州', '邗江区', 1);
INSERT INTO `idtoad` VALUES (321011, 32, 10, 11, '江苏', '扬州', '郊区', 0);
INSERT INTO `idtoad` VALUES (321012, 32, 10, 12, '江苏', '扬州', '江都区', 1);
INSERT INTO `idtoad` VALUES (321023, 32, 10, 23, '江苏', '扬州', '宝应县', 1);
INSERT INTO `idtoad` VALUES (321027, 32, 10, 27, '江苏', '扬州', '邗江县', 0);
INSERT INTO `idtoad` VALUES (321081, 32, 10, 81, '江苏', '扬州', '仪征市', 1);
INSERT INTO `idtoad` VALUES (321084, 32, 10, 84, '江苏', '扬州', '高邮市', 1);
INSERT INTO `idtoad` VALUES (321088, 32, 10, 88, '江苏', '扬州', '江都市', 0);
INSERT INTO `idtoad` VALUES (321100, 32, 11, 0, '江苏', '镇江', '镇江', 1);
INSERT INTO `idtoad` VALUES (321101, 32, 11, 1, '江苏', '镇江', '市辖区', 0);
INSERT INTO `idtoad` VALUES (321102, 32, 11, 2, '江苏', '镇江', '京口区', 1);
INSERT INTO `idtoad` VALUES (321111, 32, 11, 11, '江苏', '镇江', '润州区', 1);
INSERT INTO `idtoad` VALUES (321112, 32, 11, 12, '江苏', '镇江', '丹徒区', 1);
INSERT INTO `idtoad` VALUES (321121, 32, 11, 21, '江苏', '镇江', '丹徒县', 0);
INSERT INTO `idtoad` VALUES (321181, 32, 11, 81, '江苏', '镇江', '丹阳市', 1);
INSERT INTO `idtoad` VALUES (321182, 32, 11, 82, '江苏', '镇江', '扬中市', 1);
INSERT INTO `idtoad` VALUES (321183, 32, 11, 83, '江苏', '镇江', '句容市', 1);
INSERT INTO `idtoad` VALUES (321200, 32, 12, 0, '江苏', '泰州', '', 0);
INSERT INTO `idtoad` VALUES (321201, 32, 12, 1, '江苏', '泰州', '市辖区', 0);
INSERT INTO `idtoad` VALUES (321202, 32, 12, 2, '江苏', '泰州', '海陵区', 1);
INSERT INTO `idtoad` VALUES (321203, 32, 12, 3, '江苏', '泰州', '高港区', 1);
INSERT INTO `idtoad` VALUES (321204, 32, 12, 4, '江苏', '泰州', '姜堰区', 1);
INSERT INTO `idtoad` VALUES (321281, 32, 12, 81, '江苏', '泰州', '兴化市', 1);
INSERT INTO `idtoad` VALUES (321282, 32, 12, 82, '江苏', '泰州', '靖江市', 1);
INSERT INTO `idtoad` VALUES (321283, 32, 12, 83, '江苏', '泰州', '泰兴市', 1);
INSERT INTO `idtoad` VALUES (321284, 32, 12, 84, '江苏', '泰州', '姜堰市', 0);
INSERT INTO `idtoad` VALUES (321300, 32, 13, 0, '江苏', '宿迁', '', 0);
INSERT INTO `idtoad` VALUES (321301, 32, 13, 1, '江苏', '宿迁', '市辖区', 0);
INSERT INTO `idtoad` VALUES (321302, 32, 13, 2, '江苏', '宿迁', '宿城区', 1);
INSERT INTO `idtoad` VALUES (321311, 32, 13, 11, '江苏', '宿迁', '宿豫区', 1);
INSERT INTO `idtoad` VALUES (321321, 32, 13, 21, '江苏', '宿迁', '宿豫县', 0);
INSERT INTO `idtoad` VALUES (321322, 32, 13, 22, '江苏', '宿迁', '沭阳县', 1);
INSERT INTO `idtoad` VALUES (321323, 32, 13, 23, '江苏', '宿迁', '泗阳县', 1);
INSERT INTO `idtoad` VALUES (321324, 32, 13, 24, '江苏', '宿迁', '泗洪县', 1);
INSERT INTO `idtoad` VALUES (330000, 33, 0, 0, '浙江', '', '', 0);
INSERT INTO `idtoad` VALUES (330100, 33, 1, 0, '浙江', '杭州', '', 0);
INSERT INTO `idtoad` VALUES (330101, 33, 1, 1, '浙江', '杭州', '市辖区', 0);
INSERT INTO `idtoad` VALUES (330102, 33, 1, 2, '浙江', '杭州', '上城区', 1);
INSERT INTO `idtoad` VALUES (330103, 33, 1, 3, '浙江', '杭州', '下城区', 1);
INSERT INTO `idtoad` VALUES (330104, 33, 1, 4, '浙江', '杭州', '江干区', 1);
INSERT INTO `idtoad` VALUES (330105, 33, 1, 5, '浙江', '杭州', '拱墅区', 1);
INSERT INTO `idtoad` VALUES (330106, 33, 1, 6, '浙江', '杭州', '西湖区', 1);
INSERT INTO `idtoad` VALUES (330108, 33, 1, 8, '浙江', '杭州', '滨江区', 1);
INSERT INTO `idtoad` VALUES (330109, 33, 1, 9, '浙江', '杭州', '萧山区', 1);
INSERT INTO `idtoad` VALUES (330110, 33, 1, 10, '浙江', '杭州', '余杭区', 1);
INSERT INTO `idtoad` VALUES (330111, 33, 1, 11, '浙江', '杭州', '富阳区', 1);
INSERT INTO `idtoad` VALUES (330112, 33, 1, 12, '浙江', '杭州', '临安区', 1);
INSERT INTO `idtoad` VALUES (330122, 33, 1, 22, '浙江', '杭州', '桐庐县', 1);
INSERT INTO `idtoad` VALUES (330127, 33, 1, 27, '浙江', '杭州', '淳安县', 1);
INSERT INTO `idtoad` VALUES (330181, 33, 1, 81, '浙江', '杭州', '萧山市', 0);
INSERT INTO `idtoad` VALUES (330182, 33, 1, 82, '浙江', '杭州', '建德市', 1);
INSERT INTO `idtoad` VALUES (330183, 33, 1, 83, '浙江', '杭州', '富阳市', 0);
INSERT INTO `idtoad` VALUES (330184, 33, 1, 84, '浙江', '杭州', '余杭市', 0);
INSERT INTO `idtoad` VALUES (330185, 33, 1, 85, '浙江', '杭州', '临安市', 0);
INSERT INTO `idtoad` VALUES (330200, 33, 2, 0, '浙江', '宁波', '', 0);
INSERT INTO `idtoad` VALUES (330201, 33, 2, 1, '浙江', '宁波', '市辖区', 0);
INSERT INTO `idtoad` VALUES (330203, 33, 2, 3, '浙江', '宁波', '海曙区', 1);
INSERT INTO `idtoad` VALUES (330204, 33, 2, 4, '浙江', '宁波', '江东区', 0);
INSERT INTO `idtoad` VALUES (330205, 33, 2, 5, '浙江', '宁波', '江北区', 1);
INSERT INTO `idtoad` VALUES (330206, 33, 2, 6, '浙江', '宁波', '北仑区', 1);
INSERT INTO `idtoad` VALUES (330211, 33, 2, 11, '浙江', '宁波', '镇海区', 1);
INSERT INTO `idtoad` VALUES (330212, 33, 2, 12, '浙江', '宁波', '鄞州区', 1);
INSERT INTO `idtoad` VALUES (330213, 33, 2, 13, '浙江', '宁波', '奉化区', 1);
INSERT INTO `idtoad` VALUES (330225, 33, 2, 25, '浙江', '宁波', '象山县', 1);
INSERT INTO `idtoad` VALUES (330226, 33, 2, 26, '浙江', '宁波', '宁海县', 1);
INSERT INTO `idtoad` VALUES (330227, 33, 2, 27, '浙江', '宁波', '鄞县', 0);
INSERT INTO `idtoad` VALUES (330281, 33, 2, 81, '浙江', '宁波', '余姚市', 1);
INSERT INTO `idtoad` VALUES (330282, 33, 2, 82, '浙江', '宁波', '慈溪市', 1);
INSERT INTO `idtoad` VALUES (330283, 33, 2, 83, '浙江', '宁波', '奉化市', 0);
INSERT INTO `idtoad` VALUES (330300, 33, 3, 0, '浙江', '温州', '', 0);
INSERT INTO `idtoad` VALUES (330301, 33, 3, 1, '浙江', '温州', '市辖区', 0);
INSERT INTO `idtoad` VALUES (330302, 33, 3, 2, '浙江', '温州', '鹿城区', 1);
INSERT INTO `idtoad` VALUES (330303, 33, 3, 3, '浙江', '温州', '龙湾区', 1);
INSERT INTO `idtoad` VALUES (330304, 33, 3, 4, '浙江', '温州', '瓯海区', 1);
INSERT INTO `idtoad` VALUES (330305, 33, 3, 5, '浙江', '温州', '洞头区', 1);
INSERT INTO `idtoad` VALUES (330322, 33, 3, 22, '浙江', '温州', '洞头县', 0);
INSERT INTO `idtoad` VALUES (330324, 33, 3, 24, '浙江', '温州', '永嘉县', 1);
INSERT INTO `idtoad` VALUES (330326, 33, 3, 26, '浙江', '温州', '平阳县', 1);
INSERT INTO `idtoad` VALUES (330327, 33, 3, 27, '浙江', '温州', '苍南县', 1);
INSERT INTO `idtoad` VALUES (330328, 33, 3, 28, '浙江', '温州', '文成县', 1);
INSERT INTO `idtoad` VALUES (330329, 33, 3, 29, '浙江', '温州', '泰顺县', 1);
INSERT INTO `idtoad` VALUES (330381, 33, 3, 81, '浙江', '温州', '瑞安市', 1);
INSERT INTO `idtoad` VALUES (330382, 33, 3, 82, '浙江', '温州', '乐清市', 1);
INSERT INTO `idtoad` VALUES (330383, 33, 3, 83, '浙江', '温州', '龙港市', 1);
INSERT INTO `idtoad` VALUES (330400, 33, 4, 0, '浙江', '嘉兴', '', 0);
INSERT INTO `idtoad` VALUES (330401, 33, 4, 1, '浙江', '嘉兴', '市辖区', 0);
INSERT INTO `idtoad` VALUES (330402, 33, 4, 2, '浙江', '嘉兴', '南湖区', 1);
INSERT INTO `idtoad` VALUES (330411, 33, 4, 11, '浙江', '嘉兴', '秀洲区', 1);
INSERT INTO `idtoad` VALUES (330421, 33, 4, 21, '浙江', '嘉兴', '嘉善县', 1);
INSERT INTO `idtoad` VALUES (330424, 33, 4, 24, '浙江', '嘉兴', '海盐县', 1);
INSERT INTO `idtoad` VALUES (330481, 33, 4, 81, '浙江', '嘉兴', '海宁市', 1);
INSERT INTO `idtoad` VALUES (330482, 33, 4, 82, '浙江', '嘉兴', '平湖市', 1);
INSERT INTO `idtoad` VALUES (330483, 33, 4, 83, '浙江', '嘉兴', '桐乡市', 1);
INSERT INTO `idtoad` VALUES (330500, 33, 5, 0, '浙江', '湖州', '', 0);
INSERT INTO `idtoad` VALUES (330501, 33, 5, 1, '浙江', '湖州', '市辖区', 0);
INSERT INTO `idtoad` VALUES (330502, 33, 5, 2, '浙江', '湖州', '吴兴区', 1);
INSERT INTO `idtoad` VALUES (330503, 33, 5, 3, '浙江', '湖州', '南浔区', 1);
INSERT INTO `idtoad` VALUES (330521, 33, 5, 21, '浙江', '湖州', '德清县', 1);
INSERT INTO `idtoad` VALUES (330522, 33, 5, 22, '浙江', '湖州', '长兴县', 1);
INSERT INTO `idtoad` VALUES (330523, 33, 5, 23, '浙江', '湖州', '安吉县', 1);
INSERT INTO `idtoad` VALUES (330600, 33, 6, 0, '浙江', '绍兴', '', 0);
INSERT INTO `idtoad` VALUES (330601, 33, 6, 1, '浙江', '绍兴', '市辖区', 0);
INSERT INTO `idtoad` VALUES (330602, 33, 6, 2, '浙江', '绍兴', '越城区', 1);
INSERT INTO `idtoad` VALUES (330603, 33, 6, 3, '浙江', '绍兴', '柯桥区', 1);
INSERT INTO `idtoad` VALUES (330604, 33, 6, 4, '浙江', '绍兴', '上虞区', 1);
INSERT INTO `idtoad` VALUES (330621, 33, 6, 21, '浙江', '绍兴', '县', 0);
INSERT INTO `idtoad` VALUES (330624, 33, 6, 24, '浙江', '绍兴', '新昌县', 1);
INSERT INTO `idtoad` VALUES (330681, 33, 6, 81, '浙江', '绍兴', '诸暨市', 1);
INSERT INTO `idtoad` VALUES (330682, 33, 6, 82, '浙江', '绍兴', '上虞市', 0);
INSERT INTO `idtoad` VALUES (330683, 33, 6, 83, '浙江', '绍兴', '嵊州市', 1);
INSERT INTO `idtoad` VALUES (330700, 33, 7, 0, '浙江', '金华', '', 0);
INSERT INTO `idtoad` VALUES (330701, 33, 7, 1, '浙江', '金华', '市辖区', 0);
INSERT INTO `idtoad` VALUES (330702, 33, 7, 2, '浙江', '金华', '婺城区', 1);
INSERT INTO `idtoad` VALUES (330703, 33, 7, 3, '浙江', '金华', '金东区', 1);
INSERT INTO `idtoad` VALUES (330721, 33, 7, 21, '浙江', '金华', '县', 0);
INSERT INTO `idtoad` VALUES (330723, 33, 7, 23, '浙江', '金华', '武义县', 1);
INSERT INTO `idtoad` VALUES (330726, 33, 7, 26, '浙江', '金华', '浦江县', 1);
INSERT INTO `idtoad` VALUES (330727, 33, 7, 27, '浙江', '金华', '磐安县', 1);
INSERT INTO `idtoad` VALUES (330781, 33, 7, 81, '浙江', '金华', '兰溪市', 1);
INSERT INTO `idtoad` VALUES (330782, 33, 7, 82, '浙江', '金华', '义乌市', 1);
INSERT INTO `idtoad` VALUES (330783, 33, 7, 83, '浙江', '金华', '东阳市', 1);
INSERT INTO `idtoad` VALUES (330784, 33, 7, 84, '浙江', '金华', '永康市', 1);
INSERT INTO `idtoad` VALUES (330800, 33, 8, 0, '浙江', '衢州', '', 0);
INSERT INTO `idtoad` VALUES (330801, 33, 8, 1, '浙江', '衢州', '市辖区', 0);
INSERT INTO `idtoad` VALUES (330802, 33, 8, 2, '浙江', '衢州', '柯城区', 1);
INSERT INTO `idtoad` VALUES (330803, 33, 8, 3, '浙江', '衢州', '衢江区', 1);
INSERT INTO `idtoad` VALUES (330821, 33, 8, 21, '浙江', '衢州', '衢县', 0);
INSERT INTO `idtoad` VALUES (330822, 33, 8, 22, '浙江', '衢州', '常山县', 1);
INSERT INTO `idtoad` VALUES (330824, 33, 8, 24, '浙江', '衢州', '开化县', 1);
INSERT INTO `idtoad` VALUES (330825, 33, 8, 25, '浙江', '衢州', '龙游县', 1);
INSERT INTO `idtoad` VALUES (330881, 33, 8, 81, '浙江', '衢州', '江山市', 1);
INSERT INTO `idtoad` VALUES (330900, 33, 9, 0, '浙江', '舟山', '', 0);
INSERT INTO `idtoad` VALUES (330901, 33, 9, 1, '浙江', '舟山', '市辖区', 0);
INSERT INTO `idtoad` VALUES (330902, 33, 9, 2, '浙江', '舟山', '定海区', 1);
INSERT INTO `idtoad` VALUES (330903, 33, 9, 3, '浙江', '舟山', '普陀区', 1);
INSERT INTO `idtoad` VALUES (330921, 33, 9, 21, '浙江', '舟山', '岱山县', 1);
INSERT INTO `idtoad` VALUES (330922, 33, 9, 22, '浙江', '舟山', '嵊泗县', 1);
INSERT INTO `idtoad` VALUES (331000, 33, 10, 0, '浙江', '台州', '', 0);
INSERT INTO `idtoad` VALUES (331001, 33, 10, 1, '浙江', '台州', '市辖区', 0);
INSERT INTO `idtoad` VALUES (331002, 33, 10, 2, '浙江', '台州', '椒江区', 1);
INSERT INTO `idtoad` VALUES (331003, 33, 10, 3, '浙江', '台州', '黄岩区', 1);
INSERT INTO `idtoad` VALUES (331004, 33, 10, 4, '浙江', '台州', '路桥区', 1);
INSERT INTO `idtoad` VALUES (331021, 33, 10, 21, '浙江', '台州', '玉环县', 0);
INSERT INTO `idtoad` VALUES (331022, 33, 10, 22, '浙江', '台州', '三门县', 1);
INSERT INTO `idtoad` VALUES (331023, 33, 10, 23, '浙江', '台州', '天台县', 1);
INSERT INTO `idtoad` VALUES (331024, 33, 10, 24, '浙江', '台州', '仙居县', 1);
INSERT INTO `idtoad` VALUES (331081, 33, 10, 81, '浙江', '台州', '温岭市', 1);
INSERT INTO `idtoad` VALUES (331082, 33, 10, 82, '浙江', '台州', '临海市', 1);
INSERT INTO `idtoad` VALUES (331083, 33, 10, 83, '浙江', '台州', '玉环市', 1);
INSERT INTO `idtoad` VALUES (331102, 33, 11, 2, '浙江', '丽水', '莲都区', 1);
INSERT INTO `idtoad` VALUES (331121, 33, 11, 21, '浙江', '丽水', '青田县', 1);
INSERT INTO `idtoad` VALUES (331122, 33, 11, 22, '浙江', '丽水', '缙云县', 1);
INSERT INTO `idtoad` VALUES (331123, 33, 11, 23, '浙江', '丽水', '遂昌县', 1);
INSERT INTO `idtoad` VALUES (331124, 33, 11, 24, '浙江', '丽水', '松阳县', 1);
INSERT INTO `idtoad` VALUES (331125, 33, 11, 25, '浙江', '丽水', '云和县', 1);
INSERT INTO `idtoad` VALUES (331126, 33, 11, 26, '浙江', '丽水', '庆元县', 1);
INSERT INTO `idtoad` VALUES (331127, 33, 11, 27, '浙江', '丽水', '景宁畲族自治县', 1);
INSERT INTO `idtoad` VALUES (331181, 33, 11, 81, '浙江', '丽水', '龙泉市', 1);
INSERT INTO `idtoad` VALUES (332500, 33, 25, 0, '浙江', '丽水地区', '', 0);
INSERT INTO `idtoad` VALUES (332501, 33, 25, 1, '浙江', '丽水地区', '市辖区', 0);
INSERT INTO `idtoad` VALUES (332502, 33, 25, 2, '浙江', '丽水地区', '龙泉市', 0);
INSERT INTO `idtoad` VALUES (332522, 33, 25, 22, '浙江', '丽水地区', '青田县', 0);
INSERT INTO `idtoad` VALUES (332523, 33, 25, 23, '浙江', '丽水地区', '云和县', 0);
INSERT INTO `idtoad` VALUES (332525, 33, 25, 25, '浙江', '丽水地区', '庆元县', 0);
INSERT INTO `idtoad` VALUES (332526, 33, 25, 26, '浙江', '丽水地区', '缙云县', 0);
INSERT INTO `idtoad` VALUES (332527, 33, 25, 27, '浙江', '丽水地区', '遂昌县', 0);
INSERT INTO `idtoad` VALUES (332528, 33, 25, 28, '浙江', '丽水地区', '松阳县', 0);
INSERT INTO `idtoad` VALUES (332529, 33, 25, 29, '浙江', '丽水地区', '景宁畲族自治县', 0);
INSERT INTO `idtoad` VALUES (340000, 34, 0, 0, '安徽', '', '', 0);
INSERT INTO `idtoad` VALUES (340100, 34, 1, 0, '安徽', '合肥', '合肥', 1);
INSERT INTO `idtoad` VALUES (340101, 34, 1, 1, '安徽', '合肥', '市辖区', 0);
INSERT INTO `idtoad` VALUES (340102, 34, 1, 2, '安徽', '合肥', '瑶海区', 1);
INSERT INTO `idtoad` VALUES (340103, 34, 1, 3, '安徽', '合肥', '庐阳区', 1);
INSERT INTO `idtoad` VALUES (340104, 34, 1, 4, '安徽', '合肥', '蜀山区', 1);
INSERT INTO `idtoad` VALUES (340111, 34, 1, 11, '安徽', '合肥', '包河区', 1);
INSERT INTO `idtoad` VALUES (340121, 34, 1, 21, '安徽', '合肥', '长丰县', 1);
INSERT INTO `idtoad` VALUES (340122, 34, 1, 22, '安徽', '合肥', '肥东县', 1);
INSERT INTO `idtoad` VALUES (340123, 34, 1, 23, '安徽', '合肥', '肥西县', 1);
INSERT INTO `idtoad` VALUES (340124, 34, 1, 24, '安徽', '合肥', '庐江县', 1);
INSERT INTO `idtoad` VALUES (340181, 34, 1, 81, '安徽', '合肥', '巢湖市', 1);
INSERT INTO `idtoad` VALUES (340200, 34, 2, 0, '安徽', '芜湖', '', 0);
INSERT INTO `idtoad` VALUES (340201, 34, 2, 1, '安徽', '芜湖', '市辖区', 0);
INSERT INTO `idtoad` VALUES (340202, 34, 2, 2, '安徽', '芜湖', '镜湖区', 1);
INSERT INTO `idtoad` VALUES (340203, 34, 2, 3, '安徽', '芜湖', '弋江区', 0);
INSERT INTO `idtoad` VALUES (340204, 34, 2, 4, '安徽', '芜湖', '新芜区', 0);
INSERT INTO `idtoad` VALUES (340207, 34, 2, 7, '安徽', '芜湖', '鸠江区', 1);
INSERT INTO `idtoad` VALUES (340208, 34, 2, 8, '安徽', '芜湖', '三山区', 0);
INSERT INTO `idtoad` VALUES (340209, 34, 2, 9, '安徽', '芜湖', '弋江区', 1);
INSERT INTO `idtoad` VALUES (340210, 34, 2, 10, '安徽', '芜湖', '湾沚区', 1);
INSERT INTO `idtoad` VALUES (340212, 34, 2, 12, '安徽', '芜湖', '繁昌区', 1);
INSERT INTO `idtoad` VALUES (340221, 34, 2, 21, '安徽', '芜湖', '芜湖县', 0);
INSERT INTO `idtoad` VALUES (340222, 34, 2, 22, '安徽', '芜湖', '繁昌县', 0);
INSERT INTO `idtoad` VALUES (340223, 34, 2, 23, '安徽', '芜湖', '南陵县', 1);
INSERT INTO `idtoad` VALUES (340225, 34, 2, 25, '安徽', '芜湖', '无为县', 0);
INSERT INTO `idtoad` VALUES (340281, 34, 2, 81, '安徽', '芜湖', '无为市', 1);
INSERT INTO `idtoad` VALUES (340300, 34, 3, 0, '安徽', '蚌埠', '', 0);
INSERT INTO `idtoad` VALUES (340301, 34, 3, 1, '安徽', '蚌埠', '市辖区', 0);
INSERT INTO `idtoad` VALUES (340302, 34, 3, 2, '安徽', '蚌埠', '龙子湖区', 1);
INSERT INTO `idtoad` VALUES (340303, 34, 3, 3, '安徽', '蚌埠', '蚌山区', 1);
INSERT INTO `idtoad` VALUES (340304, 34, 3, 4, '安徽', '蚌埠', '禹会区', 1);
INSERT INTO `idtoad` VALUES (340311, 34, 3, 11, '安徽', '蚌埠', '淮上区', 1);
INSERT INTO `idtoad` VALUES (340321, 34, 3, 21, '安徽', '蚌埠', '怀远县', 1);
INSERT INTO `idtoad` VALUES (340322, 34, 3, 22, '安徽', '蚌埠', '五河县', 1);
INSERT INTO `idtoad` VALUES (340323, 34, 3, 23, '安徽', '蚌埠', '固镇县', 1);
INSERT INTO `idtoad` VALUES (340400, 34, 4, 0, '安徽', '淮南', '', 0);
INSERT INTO `idtoad` VALUES (340401, 34, 4, 1, '安徽', '淮南', '市辖区', 0);
INSERT INTO `idtoad` VALUES (340402, 34, 4, 2, '安徽', '淮南', '大通区', 1);
INSERT INTO `idtoad` VALUES (340403, 34, 4, 3, '安徽', '淮南', '田家庵区', 1);
INSERT INTO `idtoad` VALUES (340404, 34, 4, 4, '安徽', '淮南', '谢家集区', 1);
INSERT INTO `idtoad` VALUES (340405, 34, 4, 5, '安徽', '淮南', '八公山区', 1);
INSERT INTO `idtoad` VALUES (340406, 34, 4, 6, '安徽', '淮南', '潘集区', 1);
INSERT INTO `idtoad` VALUES (340421, 34, 4, 21, '安徽', '淮南', '凤台县', 1);
INSERT INTO `idtoad` VALUES (340422, 34, 4, 22, '安徽', '淮南', '寿县', 1);
INSERT INTO `idtoad` VALUES (340500, 34, 5, 0, '安徽', '马鞍山', '', 0);
INSERT INTO `idtoad` VALUES (340501, 34, 5, 1, '安徽', '马鞍山', '市辖区', 0);
INSERT INTO `idtoad` VALUES (340502, 34, 5, 2, '安徽', '马鞍山', '金家庄区', 0);
INSERT INTO `idtoad` VALUES (340503, 34, 5, 3, '安徽', '马鞍山', '花山区', 1);
INSERT INTO `idtoad` VALUES (340504, 34, 5, 4, '安徽', '马鞍山', '雨山区', 1);
INSERT INTO `idtoad` VALUES (340505, 34, 5, 5, '安徽', '马鞍山', '向山区', 0);
INSERT INTO `idtoad` VALUES (340506, 34, 5, 6, '安徽', '马鞍山', '博望区', 1);
INSERT INTO `idtoad` VALUES (340521, 34, 5, 21, '安徽', '马鞍山', '当涂县', 1);
INSERT INTO `idtoad` VALUES (340522, 34, 5, 22, '安徽', '马鞍山', '含山县', 1);
INSERT INTO `idtoad` VALUES (340523, 34, 5, 23, '安徽', '马鞍山', '和县', 1);
INSERT INTO `idtoad` VALUES (340600, 34, 6, 0, '安徽', '淮北', '', 0);
INSERT INTO `idtoad` VALUES (340601, 34, 6, 1, '安徽', '淮北', '市辖区', 0);
INSERT INTO `idtoad` VALUES (340602, 34, 6, 2, '安徽', '淮北', '杜集区', 1);
INSERT INTO `idtoad` VALUES (340603, 34, 6, 3, '安徽', '淮北', '相山区', 1);
INSERT INTO `idtoad` VALUES (340604, 34, 6, 4, '安徽', '淮北', '烈山区', 1);
INSERT INTO `idtoad` VALUES (340621, 34, 6, 21, '安徽', '淮北', '濉溪县', 1);
INSERT INTO `idtoad` VALUES (340700, 34, 7, 0, '安徽', '铜陵', '', 0);
INSERT INTO `idtoad` VALUES (340701, 34, 7, 1, '安徽', '铜陵', '市辖区', 0);
INSERT INTO `idtoad` VALUES (340702, 34, 7, 2, '安徽', '铜陵', '铜官山区', 0);
INSERT INTO `idtoad` VALUES (340703, 34, 7, 3, '安徽', '铜陵', '狮子山区', 0);
INSERT INTO `idtoad` VALUES (340705, 34, 7, 5, '安徽', '铜陵', '铜官区', 1);
INSERT INTO `idtoad` VALUES (340706, 34, 7, 6, '安徽', '铜陵', '义安区', 1);
INSERT INTO `idtoad` VALUES (340711, 34, 7, 11, '安徽', '铜陵', '郊区', 1);
INSERT INTO `idtoad` VALUES (340721, 34, 7, 21, '安徽', '铜陵', '县', 0);
INSERT INTO `idtoad` VALUES (340722, 34, 7, 22, '安徽', '铜陵', '枞阳县', 1);
INSERT INTO `idtoad` VALUES (340800, 34, 8, 0, '安徽', '安庆', '', 0);
INSERT INTO `idtoad` VALUES (340801, 34, 8, 1, '安徽', '安庆', '市辖区', 0);
INSERT INTO `idtoad` VALUES (340802, 34, 8, 2, '安徽', '安庆', '迎江区', 1);
INSERT INTO `idtoad` VALUES (340803, 34, 8, 3, '安徽', '安庆', '大观区', 1);
INSERT INTO `idtoad` VALUES (340811, 34, 8, 11, '安徽', '安庆', '宜秀区', 1);
INSERT INTO `idtoad` VALUES (340822, 34, 8, 22, '安徽', '安庆', '怀宁县', 1);
INSERT INTO `idtoad` VALUES (340823, 34, 8, 23, '安徽', '安庆', '枞阳县', 0);
INSERT INTO `idtoad` VALUES (340824, 34, 8, 24, '安徽', '安庆', '潜山县', 0);
INSERT INTO `idtoad` VALUES (340825, 34, 8, 25, '安徽', '安庆', '太湖县', 1);
INSERT INTO `idtoad` VALUES (340826, 34, 8, 26, '安徽', '安庆', '宿松县', 1);
INSERT INTO `idtoad` VALUES (340827, 34, 8, 27, '安徽', '安庆', '望江县', 1);
INSERT INTO `idtoad` VALUES (340828, 34, 8, 28, '安徽', '安庆', '岳西县', 1);
INSERT INTO `idtoad` VALUES (340881, 34, 8, 81, '安徽', '安庆', '桐城市', 1);
INSERT INTO `idtoad` VALUES (340882, 34, 8, 82, '安徽', '安庆', '潜山市', 1);
INSERT INTO `idtoad` VALUES (341000, 34, 10, 0, '安徽', '黄山', '', 0);
INSERT INTO `idtoad` VALUES (341001, 34, 10, 1, '安徽', '黄山', '市辖区', 0);
INSERT INTO `idtoad` VALUES (341002, 34, 10, 2, '安徽', '黄山', '屯溪区', 1);
INSERT INTO `idtoad` VALUES (341003, 34, 10, 3, '安徽', '黄山', '黄山区', 1);
INSERT INTO `idtoad` VALUES (341004, 34, 10, 4, '安徽', '黄山', '徽州区', 1);
INSERT INTO `idtoad` VALUES (341021, 34, 10, 21, '安徽', '黄山', '歙县', 1);
INSERT INTO `idtoad` VALUES (341022, 34, 10, 22, '安徽', '黄山', '休宁县', 1);
INSERT INTO `idtoad` VALUES (341023, 34, 10, 23, '安徽', '黄山', '黟县', 1);
INSERT INTO `idtoad` VALUES (341024, 34, 10, 24, '安徽', '黄山', '祁门县', 1);
INSERT INTO `idtoad` VALUES (341100, 34, 11, 0, '安徽', '滁州', '', 0);
INSERT INTO `idtoad` VALUES (341101, 34, 11, 1, '安徽', '滁州', '市辖区', 0);
INSERT INTO `idtoad` VALUES (341102, 34, 11, 2, '安徽', '滁州', '琅琊区', 1);
INSERT INTO `idtoad` VALUES (341103, 34, 11, 3, '安徽', '滁州', '南谯区', 1);
INSERT INTO `idtoad` VALUES (341122, 34, 11, 22, '安徽', '滁州', '来安县', 1);
INSERT INTO `idtoad` VALUES (341124, 34, 11, 24, '安徽', '滁州', '全椒县', 1);
INSERT INTO `idtoad` VALUES (341125, 34, 11, 25, '安徽', '滁州', '定远县', 1);
INSERT INTO `idtoad` VALUES (341126, 34, 11, 26, '安徽', '滁州', '凤阳县', 1);
INSERT INTO `idtoad` VALUES (341181, 34, 11, 81, '安徽', '滁州', '天长市', 1);
INSERT INTO `idtoad` VALUES (341182, 34, 11, 82, '安徽', '滁州', '明光市', 1);
INSERT INTO `idtoad` VALUES (341200, 34, 12, 0, '安徽', '阜阳', '', 0);
INSERT INTO `idtoad` VALUES (341201, 34, 12, 1, '安徽', '阜阳', '市辖区', 0);
INSERT INTO `idtoad` VALUES (341202, 34, 12, 2, '安徽', '阜阳', '颍州区', 1);
INSERT INTO `idtoad` VALUES (341203, 34, 12, 3, '安徽', '阜阳', '颍东区', 1);
INSERT INTO `idtoad` VALUES (341204, 34, 12, 4, '安徽', '阜阳', '颍泉区', 1);
INSERT INTO `idtoad` VALUES (341221, 34, 12, 21, '安徽', '阜阳', '临泉县', 1);
INSERT INTO `idtoad` VALUES (341222, 34, 12, 22, '安徽', '阜阳', '太和县', 1);
INSERT INTO `idtoad` VALUES (341223, 34, 12, 23, '安徽', '阜阳', '涡阳县', 0);
INSERT INTO `idtoad` VALUES (341224, 34, 12, 24, '安徽', '阜阳', '蒙城县', 0);
INSERT INTO `idtoad` VALUES (341225, 34, 12, 25, '安徽', '阜阳', '阜南县', 1);
INSERT INTO `idtoad` VALUES (341226, 34, 12, 26, '安徽', '阜阳', '颍上县', 1);
INSERT INTO `idtoad` VALUES (341227, 34, 12, 27, '安徽', '阜阳', '利辛县', 0);
INSERT INTO `idtoad` VALUES (341281, 34, 12, 81, '安徽', '阜阳', '亳州市', 0);
INSERT INTO `idtoad` VALUES (341282, 34, 12, 82, '安徽', '阜阳', '界首市', 1);
INSERT INTO `idtoad` VALUES (341300, 34, 13, 0, '安徽', '宿州', '', 0);
INSERT INTO `idtoad` VALUES (341301, 34, 13, 1, '安徽', '宿州', '市辖区', 0);
INSERT INTO `idtoad` VALUES (341302, 34, 13, 2, '安徽', '宿州', '埇桥区', 1);
INSERT INTO `idtoad` VALUES (341321, 34, 13, 21, '安徽', '宿州', '砀山县', 1);
INSERT INTO `idtoad` VALUES (341322, 34, 13, 22, '安徽', '宿州', '萧县', 1);
INSERT INTO `idtoad` VALUES (341323, 34, 13, 23, '安徽', '宿州', '灵璧县', 1);
INSERT INTO `idtoad` VALUES (341324, 34, 13, 24, '安徽', '宿州', '泗县', 1);
INSERT INTO `idtoad` VALUES (341502, 34, 15, 2, '安徽', '六安', '金安区', 1);
INSERT INTO `idtoad` VALUES (341503, 34, 15, 3, '安徽', '六安', '裕安区', 1);
INSERT INTO `idtoad` VALUES (341504, 34, 15, 4, '安徽', '六安', '叶集区', 1);
INSERT INTO `idtoad` VALUES (341522, 34, 15, 22, '安徽', '六安', '霍邱县', 1);
INSERT INTO `idtoad` VALUES (341523, 34, 15, 23, '安徽', '六安', '舒城县', 1);
INSERT INTO `idtoad` VALUES (341524, 34, 15, 24, '安徽', '六安', '金寨县', 1);
INSERT INTO `idtoad` VALUES (341525, 34, 15, 25, '安徽', '六安', '霍山县', 1);
INSERT INTO `idtoad` VALUES (341602, 34, 16, 2, '安徽', '亳州', '谯城区', 1);
INSERT INTO `idtoad` VALUES (341621, 34, 16, 21, '安徽', '亳州', '涡阳县', 1);
INSERT INTO `idtoad` VALUES (341622, 34, 16, 22, '安徽', '亳州', '蒙城县', 1);
INSERT INTO `idtoad` VALUES (341623, 34, 16, 23, '安徽', '亳州', '利辛县', 1);
INSERT INTO `idtoad` VALUES (341702, 34, 17, 2, '安徽', '池州', '贵池区', 1);
INSERT INTO `idtoad` VALUES (341721, 34, 17, 21, '安徽', '池州', '东至县', 1);
INSERT INTO `idtoad` VALUES (341722, 34, 17, 22, '安徽', '池州', '石台县', 1);
INSERT INTO `idtoad` VALUES (341723, 34, 17, 23, '安徽', '池州', '青阳县', 1);
INSERT INTO `idtoad` VALUES (341802, 34, 18, 2, '安徽', '宣城', '宣州区', 1);
INSERT INTO `idtoad` VALUES (341821, 34, 18, 21, '安徽', '宣城', '郎溪县', 1);
INSERT INTO `idtoad` VALUES (341822, 34, 18, 22, '安徽', '宣城', '广德县', 0);
INSERT INTO `idtoad` VALUES (341823, 34, 18, 23, '安徽', '宣城', '泾县', 1);
INSERT INTO `idtoad` VALUES (341824, 34, 18, 24, '安徽', '宣城', '绩溪县', 1);
INSERT INTO `idtoad` VALUES (341825, 34, 18, 25, '安徽', '宣城', '旌德县', 1);
INSERT INTO `idtoad` VALUES (341881, 34, 18, 81, '安徽', '宣城', '宁国市', 1);
INSERT INTO `idtoad` VALUES (341882, 34, 18, 82, '安徽', '宣城', '广德市', 1);
INSERT INTO `idtoad` VALUES (342400, 34, 24, 0, '安徽', '六安地区', '', 0);
INSERT INTO `idtoad` VALUES (342401, 34, 24, 1, '安徽', '六安地区', '六安市', 0);
INSERT INTO `idtoad` VALUES (342422, 34, 24, 22, '安徽', '六安地区', '寿县', 0);
INSERT INTO `idtoad` VALUES (342423, 34, 24, 23, '安徽', '六安地区', '霍邱县', 0);
INSERT INTO `idtoad` VALUES (342425, 34, 24, 25, '安徽', '六安地区', '舒城县', 0);
INSERT INTO `idtoad` VALUES (342426, 34, 24, 26, '安徽', '六安地区', '金寨县', 0);
INSERT INTO `idtoad` VALUES (342427, 34, 24, 27, '安徽', '六安地区', '霍山县', 0);
INSERT INTO `idtoad` VALUES (342500, 34, 25, 0, '安徽', '宣城地区', '', 0);
INSERT INTO `idtoad` VALUES (342501, 34, 25, 1, '安徽', '宣城地区', '宣州市', 0);
INSERT INTO `idtoad` VALUES (342502, 34, 25, 2, '安徽', '宣城地区', '宁国市', 0);
INSERT INTO `idtoad` VALUES (342522, 34, 25, 22, '安徽', '宣城地区', '郎溪县', 0);
INSERT INTO `idtoad` VALUES (342523, 34, 25, 23, '安徽', '宣城地区', '广德县', 0);
INSERT INTO `idtoad` VALUES (342529, 34, 25, 29, '安徽', '宣城地区', '泾县', 0);
INSERT INTO `idtoad` VALUES (342530, 34, 25, 30, '安徽', '宣城地区', '旌德县', 0);
INSERT INTO `idtoad` VALUES (342531, 34, 25, 31, '安徽', '宣城地区', '绩溪县', 0);
INSERT INTO `idtoad` VALUES (342600, 34, 26, 0, '安徽', '巢湖地区', '', 0);
INSERT INTO `idtoad` VALUES (342601, 34, 26, 1, '安徽', '巢湖地区', '巢湖市', 0);
INSERT INTO `idtoad` VALUES (342622, 34, 26, 22, '安徽', '巢湖地区', '庐江县', 0);
INSERT INTO `idtoad` VALUES (342623, 34, 26, 23, '安徽', '巢湖地区', '无为县', 0);
INSERT INTO `idtoad` VALUES (342625, 34, 26, 25, '安徽', '巢湖地区', '含山县', 0);
INSERT INTO `idtoad` VALUES (342626, 34, 26, 26, '安徽', '巢湖地区', '和县', 0);
INSERT INTO `idtoad` VALUES (342900, 34, 29, 0, '安徽', '池州地区', '', 0);
INSERT INTO `idtoad` VALUES (342901, 34, 29, 1, '安徽', '池州地区', '贵池市', 0);
INSERT INTO `idtoad` VALUES (342921, 34, 29, 21, '安徽', '池州地区', '东至县', 0);
INSERT INTO `idtoad` VALUES (342922, 34, 29, 22, '安徽', '池州地区', '石台县', 0);
INSERT INTO `idtoad` VALUES (342923, 34, 29, 23, '安徽', '池州地区', '青阳县', 0);
INSERT INTO `idtoad` VALUES (350000, 35, 0, 0, '福建', '', '', 0);
INSERT INTO `idtoad` VALUES (350100, 35, 1, 0, '福建', '福州', '', 0);
INSERT INTO `idtoad` VALUES (350101, 35, 1, 1, '福建', '福州', '市辖区', 0);
INSERT INTO `idtoad` VALUES (350102, 35, 1, 2, '福建', '福州', '鼓楼区', 1);
INSERT INTO `idtoad` VALUES (350103, 35, 1, 3, '福建', '福州', '台江区', 1);
INSERT INTO `idtoad` VALUES (350104, 35, 1, 4, '福建', '福州', '仓山区', 1);
INSERT INTO `idtoad` VALUES (350105, 35, 1, 5, '福建', '福州', '马尾区', 1);
INSERT INTO `idtoad` VALUES (350111, 35, 1, 11, '福建', '福州', '晋安区', 1);
INSERT INTO `idtoad` VALUES (350112, 35, 1, 12, '福建', '福州', '长乐区', 1);
INSERT INTO `idtoad` VALUES (350121, 35, 1, 21, '福建', '福州', '闽侯县', 1);
INSERT INTO `idtoad` VALUES (350122, 35, 1, 22, '福建', '福州', '连江县', 1);
INSERT INTO `idtoad` VALUES (350123, 35, 1, 23, '福建', '福州', '罗源县', 1);
INSERT INTO `idtoad` VALUES (350124, 35, 1, 24, '福建', '福州', '闽清县', 1);
INSERT INTO `idtoad` VALUES (350125, 35, 1, 25, '福建', '福州', '永泰县', 1);
INSERT INTO `idtoad` VALUES (350128, 35, 1, 28, '福建', '福州', '平潭县', 1);
INSERT INTO `idtoad` VALUES (350181, 35, 1, 81, '福建', '福州', '福清市', 1);
INSERT INTO `idtoad` VALUES (350182, 35, 1, 82, '福建', '福州', '长乐市', 0);
INSERT INTO `idtoad` VALUES (350200, 35, 2, 0, '福建', '厦门', '', 0);
INSERT INTO `idtoad` VALUES (350201, 35, 2, 1, '福建', '厦门', '市辖区', 0);
INSERT INTO `idtoad` VALUES (350202, 35, 2, 2, '福建', '厦门', '鼓浪屿区', 0);
INSERT INTO `idtoad` VALUES (350203, 35, 2, 3, '福建', '厦门', '思明区', 1);
INSERT INTO `idtoad` VALUES (350204, 35, 2, 4, '福建', '厦门', '开元区', 0);
INSERT INTO `idtoad` VALUES (350205, 35, 2, 5, '福建', '厦门', '海沧区', 1);
INSERT INTO `idtoad` VALUES (350206, 35, 2, 6, '福建', '厦门', '湖里区', 1);
INSERT INTO `idtoad` VALUES (350211, 35, 2, 11, '福建', '厦门', '集美区', 1);
INSERT INTO `idtoad` VALUES (350212, 35, 2, 12, '福建', '厦门', '同安区', 1);
INSERT INTO `idtoad` VALUES (350213, 35, 2, 13, '福建', '厦门', '翔安区', 1);
INSERT INTO `idtoad` VALUES (350300, 35, 3, 0, '福建', '莆田', '', 0);
INSERT INTO `idtoad` VALUES (350301, 35, 3, 1, '福建', '莆田', '市辖区', 0);
INSERT INTO `idtoad` VALUES (350302, 35, 3, 2, '福建', '莆田', '城厢区', 1);
INSERT INTO `idtoad` VALUES (350303, 35, 3, 3, '福建', '莆田', '涵江区', 1);
INSERT INTO `idtoad` VALUES (350304, 35, 3, 4, '福建', '莆田', '荔城区', 1);
INSERT INTO `idtoad` VALUES (350305, 35, 3, 5, '福建', '莆田', '秀屿区', 1);
INSERT INTO `idtoad` VALUES (350321, 35, 3, 21, '福建', '莆田', '县', 0);
INSERT INTO `idtoad` VALUES (350322, 35, 3, 22, '福建', '莆田', '仙游县', 1);
INSERT INTO `idtoad` VALUES (350400, 35, 4, 0, '福建', '三明', '', 0);
INSERT INTO `idtoad` VALUES (350401, 35, 4, 1, '福建', '三明', '市辖区', 0);
INSERT INTO `idtoad` VALUES (350402, 35, 4, 2, '福建', '三明', '梅列区', 1);
INSERT INTO `idtoad` VALUES (350403, 35, 4, 3, '福建', '三明', '三元区', 1);
INSERT INTO `idtoad` VALUES (350421, 35, 4, 21, '福建', '三明', '明溪县', 1);
INSERT INTO `idtoad` VALUES (350423, 35, 4, 23, '福建', '三明', '清流县', 1);
INSERT INTO `idtoad` VALUES (350424, 35, 4, 24, '福建', '三明', '宁化县', 1);
INSERT INTO `idtoad` VALUES (350425, 35, 4, 25, '福建', '三明', '大田县', 1);
INSERT INTO `idtoad` VALUES (350426, 35, 4, 26, '福建', '三明', '尤溪县', 1);
INSERT INTO `idtoad` VALUES (350427, 35, 4, 27, '福建', '三明', '沙县', 1);
INSERT INTO `idtoad` VALUES (350428, 35, 4, 28, '福建', '三明', '将乐县', 1);
INSERT INTO `idtoad` VALUES (350429, 35, 4, 29, '福建', '三明', '泰宁县', 1);
INSERT INTO `idtoad` VALUES (350430, 35, 4, 30, '福建', '三明', '建宁县', 1);
INSERT INTO `idtoad` VALUES (350481, 35, 4, 81, '福建', '三明', '永安市', 1);
INSERT INTO `idtoad` VALUES (350500, 35, 5, 0, '福建', '泉州', '', 0);
INSERT INTO `idtoad` VALUES (350501, 35, 5, 1, '福建', '泉州', '市辖区', 0);
INSERT INTO `idtoad` VALUES (350502, 35, 5, 2, '福建', '泉州', '鲤城区', 1);
INSERT INTO `idtoad` VALUES (350503, 35, 5, 3, '福建', '泉州', '丰泽区', 1);
INSERT INTO `idtoad` VALUES (350504, 35, 5, 4, '福建', '泉州', '洛江区', 1);
INSERT INTO `idtoad` VALUES (350505, 35, 5, 5, '福建', '泉州', '泉港区', 1);
INSERT INTO `idtoad` VALUES (350521, 35, 5, 21, '福建', '泉州', '惠安县', 1);
INSERT INTO `idtoad` VALUES (350524, 35, 5, 24, '福建', '泉州', '安溪县', 1);
INSERT INTO `idtoad` VALUES (350525, 35, 5, 25, '福建', '泉州', '永春县', 1);
INSERT INTO `idtoad` VALUES (350526, 35, 5, 26, '福建', '泉州', '德化县', 1);
INSERT INTO `idtoad` VALUES (350527, 35, 5, 27, '福建', '泉州', '金门县', 1);
INSERT INTO `idtoad` VALUES (350581, 35, 5, 81, '福建', '泉州', '石狮市', 1);
INSERT INTO `idtoad` VALUES (350582, 35, 5, 82, '福建', '泉州', '晋江市', 1);
INSERT INTO `idtoad` VALUES (350583, 35, 5, 83, '福建', '泉州', '南安市', 1);
INSERT INTO `idtoad` VALUES (350600, 35, 6, 0, '福建', '漳州', '', 0);
INSERT INTO `idtoad` VALUES (350601, 35, 6, 1, '福建', '漳州', '市辖区', 0);
INSERT INTO `idtoad` VALUES (350602, 35, 6, 2, '福建', '漳州', '芗城区', 1);
INSERT INTO `idtoad` VALUES (350603, 35, 6, 3, '福建', '漳州', '龙文区', 1);
INSERT INTO `idtoad` VALUES (350622, 35, 6, 22, '福建', '漳州', '云霄县', 1);
INSERT INTO `idtoad` VALUES (350623, 35, 6, 23, '福建', '漳州', '漳浦县', 1);
INSERT INTO `idtoad` VALUES (350624, 35, 6, 24, '福建', '漳州', '诏安县', 1);
INSERT INTO `idtoad` VALUES (350625, 35, 6, 25, '福建', '漳州', '长泰县', 1);
INSERT INTO `idtoad` VALUES (350626, 35, 6, 26, '福建', '漳州', '东山县', 1);
INSERT INTO `idtoad` VALUES (350627, 35, 6, 27, '福建', '漳州', '南靖县', 1);
INSERT INTO `idtoad` VALUES (350628, 35, 6, 28, '福建', '漳州', '平和县', 1);
INSERT INTO `idtoad` VALUES (350629, 35, 6, 29, '福建', '漳州', '华安县', 1);
INSERT INTO `idtoad` VALUES (350681, 35, 6, 81, '福建', '漳州', '龙海市', 1);
INSERT INTO `idtoad` VALUES (350700, 35, 7, 0, '福建', '南平', '', 0);
INSERT INTO `idtoad` VALUES (350701, 35, 7, 1, '福建', '南平', '市辖区', 0);
INSERT INTO `idtoad` VALUES (350702, 35, 7, 2, '福建', '南平', '延平区', 1);
INSERT INTO `idtoad` VALUES (350703, 35, 7, 3, '福建', '南平', '建阳区', 1);
INSERT INTO `idtoad` VALUES (350721, 35, 7, 21, '福建', '南平', '顺昌县', 1);
INSERT INTO `idtoad` VALUES (350722, 35, 7, 22, '福建', '南平', '浦城县', 1);
INSERT INTO `idtoad` VALUES (350723, 35, 7, 23, '福建', '南平', '光泽县', 1);
INSERT INTO `idtoad` VALUES (350724, 35, 7, 24, '福建', '南平', '松溪县', 1);
INSERT INTO `idtoad` VALUES (350725, 35, 7, 25, '福建', '南平', '政和县', 1);
INSERT INTO `idtoad` VALUES (350781, 35, 7, 81, '福建', '南平', '邵武市', 1);
INSERT INTO `idtoad` VALUES (350782, 35, 7, 82, '福建', '南平', '武夷山市', 1);
INSERT INTO `idtoad` VALUES (350783, 35, 7, 83, '福建', '南平', '建瓯市', 1);
INSERT INTO `idtoad` VALUES (350784, 35, 7, 84, '福建', '南平', '建阳市', 0);
INSERT INTO `idtoad` VALUES (350800, 35, 8, 0, '福建', '龙岩', '', 0);
INSERT INTO `idtoad` VALUES (350801, 35, 8, 1, '福建', '龙岩', '市辖区', 0);
INSERT INTO `idtoad` VALUES (350802, 35, 8, 2, '福建', '龙岩', '新罗区', 1);
INSERT INTO `idtoad` VALUES (350803, 35, 8, 3, '福建', '龙岩', '永定区', 1);
INSERT INTO `idtoad` VALUES (350821, 35, 8, 21, '福建', '龙岩', '长汀县', 1);
INSERT INTO `idtoad` VALUES (350822, 35, 8, 22, '福建', '龙岩', '永定县', 0);
INSERT INTO `idtoad` VALUES (350823, 35, 8, 23, '福建', '龙岩', '上杭县', 1);
INSERT INTO `idtoad` VALUES (350824, 35, 8, 24, '福建', '龙岩', '武平县', 1);
INSERT INTO `idtoad` VALUES (350825, 35, 8, 25, '福建', '龙岩', '连城县', 1);
INSERT INTO `idtoad` VALUES (350881, 35, 8, 81, '福建', '龙岩', '漳平市', 1);
INSERT INTO `idtoad` VALUES (350900, 35, 9, 0, '福建', '宁德', '宁德', 1);
INSERT INTO `idtoad` VALUES (350902, 35, 9, 2, '福建', '宁德', '蕉城区', 1);
INSERT INTO `idtoad` VALUES (350921, 35, 9, 21, '福建', '宁德', '霞浦县', 1);
INSERT INTO `idtoad` VALUES (350922, 35, 9, 22, '福建', '宁德', '古田县', 1);
INSERT INTO `idtoad` VALUES (350923, 35, 9, 23, '福建', '宁德', '屏南县', 1);
INSERT INTO `idtoad` VALUES (350924, 35, 9, 24, '福建', '宁德', '寿宁县', 1);
INSERT INTO `idtoad` VALUES (350925, 35, 9, 25, '福建', '宁德', '周宁县', 1);
INSERT INTO `idtoad` VALUES (350926, 35, 9, 26, '福建', '宁德', '柘荣县', 1);
INSERT INTO `idtoad` VALUES (350981, 35, 9, 81, '福建', '宁德', '福安市', 1);
INSERT INTO `idtoad` VALUES (350982, 35, 9, 82, '福建', '宁德', '福鼎市', 1);
INSERT INTO `idtoad` VALUES (352200, 35, 22, 0, '福建', '宁德地区', '', 0);
INSERT INTO `idtoad` VALUES (352201, 35, 22, 1, '福建', '宁德地区', '宁德市', 0);
INSERT INTO `idtoad` VALUES (352202, 35, 22, 2, '福建', '宁德地区', '福安市', 0);
INSERT INTO `idtoad` VALUES (352203, 35, 22, 3, '福建', '宁德地区', '福鼎市', 0);
INSERT INTO `idtoad` VALUES (352225, 35, 22, 25, '福建', '宁德地区', '霞浦县', 0);
INSERT INTO `idtoad` VALUES (352227, 35, 22, 27, '福建', '宁德地区', '古田县', 0);
INSERT INTO `idtoad` VALUES (352228, 35, 22, 28, '福建', '宁德地区', '屏南县', 0);
INSERT INTO `idtoad` VALUES (352229, 35, 22, 29, '福建', '宁德地区', '寿宁县', 0);
INSERT INTO `idtoad` VALUES (352230, 35, 22, 30, '福建', '宁德地区', '周宁县', 0);
INSERT INTO `idtoad` VALUES (352231, 35, 22, 31, '福建', '宁德地区', '柘荣县', 0);
INSERT INTO `idtoad` VALUES (360000, 36, 0, 0, '江西', '', '', 0);
INSERT INTO `idtoad` VALUES (360100, 36, 1, 0, '江西', '南昌', '南昌', 1);
INSERT INTO `idtoad` VALUES (360101, 36, 1, 1, '江西', '南昌', '市辖区', 0);
INSERT INTO `idtoad` VALUES (360102, 36, 1, 2, '江西', '南昌', '东湖区', 1);
INSERT INTO `idtoad` VALUES (360103, 36, 1, 3, '江西', '南昌', '西湖区', 1);
INSERT INTO `idtoad` VALUES (360104, 36, 1, 4, '江西', '南昌', '青云谱区', 1);
INSERT INTO `idtoad` VALUES (360105, 36, 1, 5, '江西', '南昌', '湾里区', 0);
INSERT INTO `idtoad` VALUES (360111, 36, 1, 11, '江西', '南昌', '青山湖区', 1);
INSERT INTO `idtoad` VALUES (360112, 36, 1, 12, '江西', '南昌', '新建区', 1);
INSERT INTO `idtoad` VALUES (360113, 36, 1, 13, '江西', '南昌', '红谷滩区', 1);
INSERT INTO `idtoad` VALUES (360121, 36, 1, 21, '江西', '南昌', '南昌县', 1);
INSERT INTO `idtoad` VALUES (360122, 36, 1, 22, '江西', '南昌', '新建县', 0);
INSERT INTO `idtoad` VALUES (360123, 36, 1, 23, '江西', '南昌', '安义县', 1);
INSERT INTO `idtoad` VALUES (360124, 36, 1, 24, '江西', '南昌', '进贤县', 1);
INSERT INTO `idtoad` VALUES (360200, 36, 2, 0, '江西', '景德镇', '', 0);
INSERT INTO `idtoad` VALUES (360201, 36, 2, 1, '江西', '景德镇', '市辖区', 0);
INSERT INTO `idtoad` VALUES (360202, 36, 2, 2, '江西', '景德镇', '昌江区', 1);
INSERT INTO `idtoad` VALUES (360203, 36, 2, 3, '江西', '景德镇', '珠山区', 1);
INSERT INTO `idtoad` VALUES (360222, 36, 2, 22, '江西', '景德镇', '浮梁县', 1);
INSERT INTO `idtoad` VALUES (360281, 36, 2, 81, '江西', '景德镇', '乐平市', 1);
INSERT INTO `idtoad` VALUES (360300, 36, 3, 0, '江西', '萍乡', '', 0);
INSERT INTO `idtoad` VALUES (360301, 36, 3, 1, '江西', '萍乡', '市辖区', 0);
INSERT INTO `idtoad` VALUES (360302, 36, 3, 2, '江西', '萍乡', '安源区', 1);
INSERT INTO `idtoad` VALUES (360313, 36, 3, 13, '江西', '萍乡', '湘东区', 1);
INSERT INTO `idtoad` VALUES (360321, 36, 3, 21, '江西', '萍乡', '莲花县', 1);
INSERT INTO `idtoad` VALUES (360322, 36, 3, 22, '江西', '萍乡', '上栗县', 1);
INSERT INTO `idtoad` VALUES (360323, 36, 3, 23, '江西', '萍乡', '芦溪县', 1);
INSERT INTO `idtoad` VALUES (360400, 36, 4, 0, '江西', '九江', '九江', 1);
INSERT INTO `idtoad` VALUES (360401, 36, 4, 1, '江西', '九江', '市辖区', 0);
INSERT INTO `idtoad` VALUES (360402, 36, 4, 2, '江西', '九江', '濂溪区', 1);
INSERT INTO `idtoad` VALUES (360403, 36, 4, 3, '江西', '九江', '浔阳区', 1);
INSERT INTO `idtoad` VALUES (360404, 36, 4, 4, '江西', '九江', '柴桑区', 1);
INSERT INTO `idtoad` VALUES (360421, 36, 4, 21, '江西', '九江', '县', 0);
INSERT INTO `idtoad` VALUES (360423, 36, 4, 23, '江西', '九江', '武宁县', 1);
INSERT INTO `idtoad` VALUES (360424, 36, 4, 24, '江西', '九江', '修水县', 1);
INSERT INTO `idtoad` VALUES (360425, 36, 4, 25, '江西', '九江', '永修县', 1);
INSERT INTO `idtoad` VALUES (360426, 36, 4, 26, '江西', '九江', '德安县', 1);
INSERT INTO `idtoad` VALUES (360427, 36, 4, 27, '江西', '九江', '星子县', 0);
INSERT INTO `idtoad` VALUES (360428, 36, 4, 28, '江西', '九江', '都昌县', 1);
INSERT INTO `idtoad` VALUES (360429, 36, 4, 29, '江西', '九江', '湖口县', 1);
INSERT INTO `idtoad` VALUES (360430, 36, 4, 30, '江西', '九江', '彭泽县', 1);
INSERT INTO `idtoad` VALUES (360481, 36, 4, 81, '江西', '九江', '瑞昌市', 1);
INSERT INTO `idtoad` VALUES (360482, 36, 4, 82, '江西', '九江', '共青城市', 1);
INSERT INTO `idtoad` VALUES (360483, 36, 4, 83, '江西', '九江', '庐山市', 1);
INSERT INTO `idtoad` VALUES (360500, 36, 5, 0, '江西', '新余', '', 0);
INSERT INTO `idtoad` VALUES (360501, 36, 5, 1, '江西', '新余', '市辖区', 0);
INSERT INTO `idtoad` VALUES (360502, 36, 5, 2, '江西', '新余', '渝水区', 1);
INSERT INTO `idtoad` VALUES (360521, 36, 5, 21, '江西', '新余', '分宜县', 1);
INSERT INTO `idtoad` VALUES (360600, 36, 6, 0, '江西', '鹰潭', '', 0);
INSERT INTO `idtoad` VALUES (360601, 36, 6, 1, '江西', '鹰潭', '市辖区', 0);
INSERT INTO `idtoad` VALUES (360602, 36, 6, 2, '江西', '鹰潭', '月湖区', 1);
INSERT INTO `idtoad` VALUES (360603, 36, 6, 3, '江西', '鹰潭', '余江区', 1);
INSERT INTO `idtoad` VALUES (360622, 36, 6, 22, '江西', '鹰潭', '余江县', 0);
INSERT INTO `idtoad` VALUES (360681, 36, 6, 81, '江西', '鹰潭', '贵溪市', 1);
INSERT INTO `idtoad` VALUES (360700, 36, 7, 0, '江西', '赣州', '', 0);
INSERT INTO `idtoad` VALUES (360701, 36, 7, 1, '江西', '赣州', '市辖区', 0);
INSERT INTO `idtoad` VALUES (360702, 36, 7, 2, '江西', '赣州', '章贡区', 1);
INSERT INTO `idtoad` VALUES (360703, 36, 7, 3, '江西', '赣州', '南康区', 1);
INSERT INTO `idtoad` VALUES (360704, 36, 7, 4, '江西', '赣州', '赣县区', 1);
INSERT INTO `idtoad` VALUES (360721, 36, 7, 21, '江西', '赣州', '赣县', 0);
INSERT INTO `idtoad` VALUES (360722, 36, 7, 22, '江西', '赣州', '信丰县', 1);
INSERT INTO `idtoad` VALUES (360723, 36, 7, 23, '江西', '赣州', '大余县', 1);
INSERT INTO `idtoad` VALUES (360724, 36, 7, 24, '江西', '赣州', '上犹县', 1);
INSERT INTO `idtoad` VALUES (360725, 36, 7, 25, '江西', '赣州', '崇义县', 1);
INSERT INTO `idtoad` VALUES (360726, 36, 7, 26, '江西', '赣州', '安远县', 1);
INSERT INTO `idtoad` VALUES (360727, 36, 7, 27, '江西', '赣州', '龙南县', 0);
INSERT INTO `idtoad` VALUES (360728, 36, 7, 28, '江西', '赣州', '定南县', 1);
INSERT INTO `idtoad` VALUES (360729, 36, 7, 29, '江西', '赣州', '全南县', 1);
INSERT INTO `idtoad` VALUES (360730, 36, 7, 30, '江西', '赣州', '宁都县', 1);
INSERT INTO `idtoad` VALUES (360731, 36, 7, 31, '江西', '赣州', '于都县', 1);
INSERT INTO `idtoad` VALUES (360732, 36, 7, 32, '江西', '赣州', '兴国县', 1);
INSERT INTO `idtoad` VALUES (360733, 36, 7, 33, '江西', '赣州', '会昌县', 1);
INSERT INTO `idtoad` VALUES (360734, 36, 7, 34, '江西', '赣州', '寻乌县', 1);
INSERT INTO `idtoad` VALUES (360735, 36, 7, 35, '江西', '赣州', '石城县', 1);
INSERT INTO `idtoad` VALUES (360781, 36, 7, 81, '江西', '赣州', '瑞金市', 1);
INSERT INTO `idtoad` VALUES (360782, 36, 7, 82, '江西', '赣州', '南康市', 0);
INSERT INTO `idtoad` VALUES (360783, 36, 7, 83, '江西', '赣州', '龙南市', 1);
INSERT INTO `idtoad` VALUES (360802, 36, 8, 2, '江西', '吉安', '吉州区', 1);
INSERT INTO `idtoad` VALUES (360803, 36, 8, 3, '江西', '吉安', '青原区', 1);
INSERT INTO `idtoad` VALUES (360821, 36, 8, 21, '江西', '吉安', '吉安县', 1);
INSERT INTO `idtoad` VALUES (360822, 36, 8, 22, '江西', '吉安', '吉水县', 1);
INSERT INTO `idtoad` VALUES (360823, 36, 8, 23, '江西', '吉安', '峡江县', 1);
INSERT INTO `idtoad` VALUES (360824, 36, 8, 24, '江西', '吉安', '新干县', 1);
INSERT INTO `idtoad` VALUES (360825, 36, 8, 25, '江西', '吉安', '永丰县', 1);
INSERT INTO `idtoad` VALUES (360826, 36, 8, 26, '江西', '吉安', '泰和县', 1);
INSERT INTO `idtoad` VALUES (360827, 36, 8, 27, '江西', '吉安', '遂川县', 1);
INSERT INTO `idtoad` VALUES (360828, 36, 8, 28, '江西', '吉安', '万安县', 1);
INSERT INTO `idtoad` VALUES (360829, 36, 8, 29, '江西', '吉安', '安福县', 1);
INSERT INTO `idtoad` VALUES (360830, 36, 8, 30, '江西', '吉安', '永新县', 1);
INSERT INTO `idtoad` VALUES (360881, 36, 8, 81, '江西', '吉安', '井冈山市', 1);
INSERT INTO `idtoad` VALUES (360902, 36, 9, 2, '江西', '宜春', '袁州区', 1);
INSERT INTO `idtoad` VALUES (360921, 36, 9, 21, '江西', '宜春', '奉新县', 1);
INSERT INTO `idtoad` VALUES (360922, 36, 9, 22, '江西', '宜春', '万载县', 1);
INSERT INTO `idtoad` VALUES (360923, 36, 9, 23, '江西', '宜春', '上高县', 1);
INSERT INTO `idtoad` VALUES (360924, 36, 9, 24, '江西', '宜春', '宜丰县', 1);
INSERT INTO `idtoad` VALUES (360925, 36, 9, 25, '江西', '宜春', '靖安县', 1);
INSERT INTO `idtoad` VALUES (360926, 36, 9, 26, '江西', '宜春', '铜鼓县', 1);
INSERT INTO `idtoad` VALUES (360981, 36, 9, 81, '江西', '宜春', '丰城市', 1);
INSERT INTO `idtoad` VALUES (360982, 36, 9, 82, '江西', '宜春', '樟树市', 1);
INSERT INTO `idtoad` VALUES (360983, 36, 9, 83, '江西', '宜春', '高安市', 1);
INSERT INTO `idtoad` VALUES (361002, 36, 10, 2, '江西', '抚州', '临川区', 1);
INSERT INTO `idtoad` VALUES (361003, 36, 10, 3, '江西', '抚州', '东乡区', 1);
INSERT INTO `idtoad` VALUES (361021, 36, 10, 21, '江西', '抚州', '南城县', 1);
INSERT INTO `idtoad` VALUES (361022, 36, 10, 22, '江西', '抚州', '黎川县', 1);
INSERT INTO `idtoad` VALUES (361023, 36, 10, 23, '江西', '抚州', '南丰县', 1);
INSERT INTO `idtoad` VALUES (361024, 36, 10, 24, '江西', '抚州', '崇仁县', 1);
INSERT INTO `idtoad` VALUES (361025, 36, 10, 25, '江西', '抚州', '乐安县', 1);
INSERT INTO `idtoad` VALUES (361026, 36, 10, 26, '江西', '抚州', '宜黄县', 1);
INSERT INTO `idtoad` VALUES (361027, 36, 10, 27, '江西', '抚州', '金溪县', 1);
INSERT INTO `idtoad` VALUES (361028, 36, 10, 28, '江西', '抚州', '资溪县', 1);
INSERT INTO `idtoad` VALUES (361030, 36, 10, 30, '江西', '抚州', '广昌县', 1);
INSERT INTO `idtoad` VALUES (361102, 36, 11, 2, '江西', '上饶', '信州区', 1);
INSERT INTO `idtoad` VALUES (361103, 36, 11, 3, '江西', '上饶', '广丰区', 1);
INSERT INTO `idtoad` VALUES (361104, 36, 11, 4, '江西', '上饶', '广信区', 1);
INSERT INTO `idtoad` VALUES (361121, 36, 11, 21, '江西', '上饶', '上饶县', 0);
INSERT INTO `idtoad` VALUES (361123, 36, 11, 23, '江西', '上饶', '玉山县', 1);
INSERT INTO `idtoad` VALUES (361124, 36, 11, 24, '江西', '上饶', '铅山县', 1);
INSERT INTO `idtoad` VALUES (361125, 36, 11, 25, '江西', '上饶', '横峰县', 1);
INSERT INTO `idtoad` VALUES (361126, 36, 11, 26, '江西', '上饶', '弋阳县', 1);
INSERT INTO `idtoad` VALUES (361127, 36, 11, 27, '江西', '上饶', '余干县', 1);
INSERT INTO `idtoad` VALUES (361128, 36, 11, 28, '江西', '上饶', '鄱阳县', 1);
INSERT INTO `idtoad` VALUES (361129, 36, 11, 29, '江西', '上饶', '万年县', 1);
INSERT INTO `idtoad` VALUES (361130, 36, 11, 30, '江西', '上饶', '婺源县', 1);
INSERT INTO `idtoad` VALUES (361181, 36, 11, 81, '江西', '上饶', '德兴市', 1);
INSERT INTO `idtoad` VALUES (362200, 36, 22, 0, '江西', '宜春地区', '', 0);
INSERT INTO `idtoad` VALUES (362201, 36, 22, 1, '江西', '宜春地区', '宜春市', 0);
INSERT INTO `idtoad` VALUES (362202, 36, 22, 2, '江西', '宜春地区', '丰城市', 0);
INSERT INTO `idtoad` VALUES (362203, 36, 22, 3, '江西', '宜春地区', '樟树市', 0);
INSERT INTO `idtoad` VALUES (362204, 36, 22, 4, '江西', '宜春地区', '高安市', 0);
INSERT INTO `idtoad` VALUES (362226, 36, 22, 26, '江西', '宜春地区', '奉新县', 0);
INSERT INTO `idtoad` VALUES (362227, 36, 22, 27, '江西', '宜春地区', '万载县', 0);
INSERT INTO `idtoad` VALUES (362228, 36, 22, 28, '江西', '宜春地区', '上高县', 0);
INSERT INTO `idtoad` VALUES (362229, 36, 22, 29, '江西', '宜春地区', '宜丰县', 0);
INSERT INTO `idtoad` VALUES (362232, 36, 22, 32, '江西', '宜春地区', '靖安县', 0);
INSERT INTO `idtoad` VALUES (362233, 36, 22, 33, '江西', '宜春地区', '铜鼓县', 0);
INSERT INTO `idtoad` VALUES (362300, 36, 23, 0, '江西', '上饶地区', '', 0);
INSERT INTO `idtoad` VALUES (362301, 36, 23, 1, '江西', '上饶地区', '上饶市', 0);
INSERT INTO `idtoad` VALUES (362302, 36, 23, 2, '江西', '上饶地区', '德兴市', 0);
INSERT INTO `idtoad` VALUES (362321, 36, 23, 21, '江西', '上饶地区', '上饶县', 0);
INSERT INTO `idtoad` VALUES (362322, 36, 23, 22, '江西', '上饶地区', '广丰县', 0);
INSERT INTO `idtoad` VALUES (362323, 36, 23, 23, '江西', '上饶地区', '玉山县', 0);
INSERT INTO `idtoad` VALUES (362324, 36, 23, 24, '江西', '上饶地区', '铅山县', 0);
INSERT INTO `idtoad` VALUES (362325, 36, 23, 25, '江西', '上饶地区', '横峰县', 0);
INSERT INTO `idtoad` VALUES (362326, 36, 23, 26, '江西', '上饶地区', '弋阳县', 0);
INSERT INTO `idtoad` VALUES (362329, 36, 23, 29, '江西', '上饶地区', '余干县', 0);
INSERT INTO `idtoad` VALUES (362330, 36, 23, 30, '江西', '上饶地区', '波阳县', 0);
INSERT INTO `idtoad` VALUES (362331, 36, 23, 31, '江西', '上饶地区', '万年县', 0);
INSERT INTO `idtoad` VALUES (362334, 36, 23, 34, '江西', '上饶地区', '婺源县', 0);
INSERT INTO `idtoad` VALUES (362400, 36, 24, 0, '江西', '吉安地区', '', 0);
INSERT INTO `idtoad` VALUES (362401, 36, 24, 1, '江西', '吉安地区', '吉安市', 0);
INSERT INTO `idtoad` VALUES (362402, 36, 24, 2, '江西', '吉安地区', '井冈山市', 0);
INSERT INTO `idtoad` VALUES (362421, 36, 24, 21, '江西', '吉安地区', '吉安县', 0);
INSERT INTO `idtoad` VALUES (362422, 36, 24, 22, '江西', '吉安地区', '吉水县', 0);
INSERT INTO `idtoad` VALUES (362423, 36, 24, 23, '江西', '吉安地区', '峡江县', 0);
INSERT INTO `idtoad` VALUES (362424, 36, 24, 24, '江西', '吉安地区', '新干县', 0);
INSERT INTO `idtoad` VALUES (362425, 36, 24, 25, '江西', '吉安地区', '永丰县', 0);
INSERT INTO `idtoad` VALUES (362426, 36, 24, 26, '江西', '吉安地区', '泰和县', 0);
INSERT INTO `idtoad` VALUES (362427, 36, 24, 27, '江西', '吉安地区', '遂川县', 0);
INSERT INTO `idtoad` VALUES (362428, 36, 24, 28, '江西', '吉安地区', '万安县', 0);
INSERT INTO `idtoad` VALUES (362429, 36, 24, 29, '江西', '吉安地区', '安福县', 0);
INSERT INTO `idtoad` VALUES (362430, 36, 24, 30, '江西', '吉安地区', '永新县', 0);
INSERT INTO `idtoad` VALUES (362432, 36, 24, 32, '江西', '吉安地区', '宁冈县', 0);
INSERT INTO `idtoad` VALUES (362500, 36, 25, 0, '江西', '抚州地区', '', 0);
INSERT INTO `idtoad` VALUES (362502, 36, 25, 2, '江西', '抚州地区', '临川市', 0);
INSERT INTO `idtoad` VALUES (362522, 36, 25, 22, '江西', '抚州地区', '南城县', 0);
INSERT INTO `idtoad` VALUES (362523, 36, 25, 23, '江西', '抚州地区', '黎川县', 0);
INSERT INTO `idtoad` VALUES (362524, 36, 25, 24, '江西', '抚州地区', '南丰县', 0);
INSERT INTO `idtoad` VALUES (362525, 36, 25, 25, '江西', '抚州地区', '崇仁县', 0);
INSERT INTO `idtoad` VALUES (362526, 36, 25, 26, '江西', '抚州地区', '乐安县', 0);
INSERT INTO `idtoad` VALUES (362527, 36, 25, 27, '江西', '抚州地区', '宜黄县', 0);
INSERT INTO `idtoad` VALUES (362528, 36, 25, 28, '江西', '抚州地区', '金溪县', 0);
INSERT INTO `idtoad` VALUES (362529, 36, 25, 29, '江西', '抚州地区', '资溪县', 0);
INSERT INTO `idtoad` VALUES (362531, 36, 25, 31, '江西', '抚州地区', '东乡县', 0);
INSERT INTO `idtoad` VALUES (362532, 36, 25, 32, '江西', '抚州地区', '广昌县', 0);
INSERT INTO `idtoad` VALUES (370000, 37, 0, 0, '山东', '', '', 0);
INSERT INTO `idtoad` VALUES (370100, 37, 1, 0, '山东', '济南', '济南', 1);
INSERT INTO `idtoad` VALUES (370101, 37, 1, 1, '山东', '济南', '市辖区', 0);
INSERT INTO `idtoad` VALUES (370102, 37, 1, 2, '山东', '济南', '历下区', 1);
INSERT INTO `idtoad` VALUES (370103, 37, 1, 3, '山东', '济南', '市中区', 1);
INSERT INTO `idtoad` VALUES (370104, 37, 1, 4, '山东', '济南', '槐荫区', 1);
INSERT INTO `idtoad` VALUES (370105, 37, 1, 5, '山东', '济南', '天桥区', 1);
INSERT INTO `idtoad` VALUES (370112, 37, 1, 12, '山东', '济南', '历城区', 1);
INSERT INTO `idtoad` VALUES (370113, 37, 1, 13, '山东', '济南', '长清区', 1);
INSERT INTO `idtoad` VALUES (370114, 37, 1, 14, '山东', '济南', '章丘区', 1);
INSERT INTO `idtoad` VALUES (370115, 37, 1, 15, '山东', '济南', '济阳区', 1);
INSERT INTO `idtoad` VALUES (370116, 37, 1, 16, '山东', '济南', '莱芜区', 1);
INSERT INTO `idtoad` VALUES (370117, 37, 1, 17, '山东', '济南', '钢城区', 1);
INSERT INTO `idtoad` VALUES (370123, 37, 1, 23, '山东', '济南', '长清县', 0);
INSERT INTO `idtoad` VALUES (370124, 37, 1, 24, '山东', '济南', '平阴县', 1);
INSERT INTO `idtoad` VALUES (370125, 37, 1, 25, '山东', '济南', '济阳县', 0);
INSERT INTO `idtoad` VALUES (370126, 37, 1, 26, '山东', '济南', '商河县', 1);
INSERT INTO `idtoad` VALUES (370181, 37, 1, 81, '山东', '济南', '章丘市', 0);
INSERT INTO `idtoad` VALUES (370200, 37, 2, 0, '山东', '青岛', '', 0);
INSERT INTO `idtoad` VALUES (370201, 37, 2, 1, '山东', '青岛', '市辖区', 0);
INSERT INTO `idtoad` VALUES (370202, 37, 2, 2, '山东', '青岛', '市南区', 1);
INSERT INTO `idtoad` VALUES (370203, 37, 2, 3, '山东', '青岛', '市北区', 1);
INSERT INTO `idtoad` VALUES (370205, 37, 2, 5, '山东', '青岛', '四方区', 0);
INSERT INTO `idtoad` VALUES (370211, 37, 2, 11, '山东', '青岛', '黄岛区', 1);
INSERT INTO `idtoad` VALUES (370212, 37, 2, 12, '山东', '青岛', '崂山区', 1);
INSERT INTO `idtoad` VALUES (370213, 37, 2, 13, '山东', '青岛', '李沧区', 1);
INSERT INTO `idtoad` VALUES (370214, 37, 2, 14, '山东', '青岛', '城阳区', 1);
INSERT INTO `idtoad` VALUES (370215, 37, 2, 15, '山东', '青岛', '即墨区', 1);
INSERT INTO `idtoad` VALUES (370281, 37, 2, 81, '山东', '青岛', '胶州市', 1);
INSERT INTO `idtoad` VALUES (370282, 37, 2, 82, '山东', '青岛', '即墨市', 0);
INSERT INTO `idtoad` VALUES (370283, 37, 2, 83, '山东', '青岛', '平度市', 1);
INSERT INTO `idtoad` VALUES (370284, 37, 2, 84, '山东', '青岛', '胶南市', 0);
INSERT INTO `idtoad` VALUES (370285, 37, 2, 85, '山东', '青岛', '莱西市', 1);
INSERT INTO `idtoad` VALUES (370300, 37, 3, 0, '山东', '淄博', '', 0);
INSERT INTO `idtoad` VALUES (370301, 37, 3, 1, '山东', '淄博', '市辖区', 0);
INSERT INTO `idtoad` VALUES (370302, 37, 3, 2, '山东', '淄博', '淄川区', 1);
INSERT INTO `idtoad` VALUES (370303, 37, 3, 3, '山东', '淄博', '张店区', 1);
INSERT INTO `idtoad` VALUES (370304, 37, 3, 4, '山东', '淄博', '博山区', 1);
INSERT INTO `idtoad` VALUES (370305, 37, 3, 5, '山东', '淄博', '临淄区', 1);
INSERT INTO `idtoad` VALUES (370306, 37, 3, 6, '山东', '淄博', '周村区', 1);
INSERT INTO `idtoad` VALUES (370321, 37, 3, 21, '山东', '淄博', '桓台县', 1);
INSERT INTO `idtoad` VALUES (370322, 37, 3, 22, '山东', '淄博', '高青县', 1);
INSERT INTO `idtoad` VALUES (370323, 37, 3, 23, '山东', '淄博', '沂源县', 1);
INSERT INTO `idtoad` VALUES (370400, 37, 4, 0, '山东', '枣庄', '', 0);
INSERT INTO `idtoad` VALUES (370401, 37, 4, 1, '山东', '枣庄', '市辖区', 0);
INSERT INTO `idtoad` VALUES (370402, 37, 4, 2, '山东', '枣庄', '市中区', 1);
INSERT INTO `idtoad` VALUES (370403, 37, 4, 3, '山东', '枣庄', '薛城区', 1);
INSERT INTO `idtoad` VALUES (370404, 37, 4, 4, '山东', '枣庄', '峄城区', 1);
INSERT INTO `idtoad` VALUES (370405, 37, 4, 5, '山东', '枣庄', '台儿庄区', 1);
INSERT INTO `idtoad` VALUES (370406, 37, 4, 6, '山东', '枣庄', '山亭区', 1);
INSERT INTO `idtoad` VALUES (370481, 37, 4, 81, '山东', '枣庄', '滕州市', 1);
INSERT INTO `idtoad` VALUES (370500, 37, 5, 0, '山东', '东营', '', 0);
INSERT INTO `idtoad` VALUES (370501, 37, 5, 1, '山东', '东营', '市辖区', 0);
INSERT INTO `idtoad` VALUES (370502, 37, 5, 2, '山东', '东营', '东营区', 1);
INSERT INTO `idtoad` VALUES (370503, 37, 5, 3, '山东', '东营', '河口区', 1);
INSERT INTO `idtoad` VALUES (370505, 37, 5, 5, '山东', '东营', '垦利区', 1);
INSERT INTO `idtoad` VALUES (370521, 37, 5, 21, '山东', '东营', '垦利县', 0);
INSERT INTO `idtoad` VALUES (370522, 37, 5, 22, '山东', '东营', '利津县', 1);
INSERT INTO `idtoad` VALUES (370523, 37, 5, 23, '山东', '东营', '广饶县', 1);
INSERT INTO `idtoad` VALUES (370600, 37, 6, 0, '山东', '烟台', '烟台', 1);
INSERT INTO `idtoad` VALUES (370601, 37, 6, 1, '山东', '烟台', '市辖区', 0);
INSERT INTO `idtoad` VALUES (370602, 37, 6, 2, '山东', '烟台', '芝罘区', 1);
INSERT INTO `idtoad` VALUES (370611, 37, 6, 11, '山东', '烟台', '福山区', 1);
INSERT INTO `idtoad` VALUES (370612, 37, 6, 12, '山东', '烟台', '牟平区', 1);
INSERT INTO `idtoad` VALUES (370613, 37, 6, 13, '山东', '烟台', '莱山区', 1);
INSERT INTO `idtoad` VALUES (370614, 37, 6, 14, '山东', '烟台', '蓬莱区', 1);
INSERT INTO `idtoad` VALUES (370634, 37, 6, 34, '山东', '烟台', '长岛县', 0);
INSERT INTO `idtoad` VALUES (370681, 37, 6, 81, '山东', '烟台', '龙口市', 1);
INSERT INTO `idtoad` VALUES (370682, 37, 6, 82, '山东', '烟台', '莱阳市', 1);
INSERT INTO `idtoad` VALUES (370683, 37, 6, 83, '山东', '烟台', '莱州市', 1);
INSERT INTO `idtoad` VALUES (370684, 37, 6, 84, '山东', '烟台', '蓬莱市', 0);
INSERT INTO `idtoad` VALUES (370685, 37, 6, 85, '山东', '烟台', '招远市', 1);
INSERT INTO `idtoad` VALUES (370686, 37, 6, 86, '山东', '烟台', '栖霞市', 1);
INSERT INTO `idtoad` VALUES (370687, 37, 6, 87, '山东', '烟台', '海阳市', 1);
INSERT INTO `idtoad` VALUES (370700, 37, 7, 0, '山东', '潍坊', '潍坊', 1);
INSERT INTO `idtoad` VALUES (370701, 37, 7, 1, '山东', '潍坊', '市辖区', 0);
INSERT INTO `idtoad` VALUES (370702, 37, 7, 2, '山东', '潍坊', '潍城区', 1);
INSERT INTO `idtoad` VALUES (370703, 37, 7, 3, '山东', '潍坊', '寒亭区', 1);
INSERT INTO `idtoad` VALUES (370704, 37, 7, 4, '山东', '潍坊', '坊子区', 1);
INSERT INTO `idtoad` VALUES (370705, 37, 7, 5, '山东', '潍坊', '奎文区', 1);
INSERT INTO `idtoad` VALUES (370724, 37, 7, 24, '山东', '潍坊', '临朐县', 1);
INSERT INTO `idtoad` VALUES (370725, 37, 7, 25, '山东', '潍坊', '昌乐县', 1);
INSERT INTO `idtoad` VALUES (370781, 37, 7, 81, '山东', '潍坊', '青州市', 1);
INSERT INTO `idtoad` VALUES (370782, 37, 7, 82, '山东', '潍坊', '诸城市', 1);
INSERT INTO `idtoad` VALUES (370783, 37, 7, 83, '山东', '潍坊', '寿光市', 1);
INSERT INTO `idtoad` VALUES (370784, 37, 7, 84, '山东', '潍坊', '安丘市', 1);
INSERT INTO `idtoad` VALUES (370785, 37, 7, 85, '山东', '潍坊', '高密市', 1);
INSERT INTO `idtoad` VALUES (370786, 37, 7, 86, '山东', '潍坊', '昌邑市', 1);
INSERT INTO `idtoad` VALUES (370800, 37, 8, 0, '山东', '济宁', '', 0);
INSERT INTO `idtoad` VALUES (370801, 37, 8, 1, '山东', '济宁', '市辖区', 0);
INSERT INTO `idtoad` VALUES (370802, 37, 8, 2, '山东', '济宁', '市中区', 0);
INSERT INTO `idtoad` VALUES (370811, 37, 8, 11, '山东', '济宁', '任城区', 1);
INSERT INTO `idtoad` VALUES (370812, 37, 8, 12, '山东', '济宁', '兖州区', 1);
INSERT INTO `idtoad` VALUES (370826, 37, 8, 26, '山东', '济宁', '微山县', 1);
INSERT INTO `idtoad` VALUES (370827, 37, 8, 27, '山东', '济宁', '鱼台县', 1);
INSERT INTO `idtoad` VALUES (370828, 37, 8, 28, '山东', '济宁', '金乡县', 1);
INSERT INTO `idtoad` VALUES (370829, 37, 8, 29, '山东', '济宁', '嘉祥县', 1);
INSERT INTO `idtoad` VALUES (370830, 37, 8, 30, '山东', '济宁', '汶上县', 1);
INSERT INTO `idtoad` VALUES (370831, 37, 8, 31, '山东', '济宁', '泗水县', 1);
INSERT INTO `idtoad` VALUES (370832, 37, 8, 32, '山东', '济宁', '梁山县', 1);
INSERT INTO `idtoad` VALUES (370881, 37, 8, 81, '山东', '济宁', '曲阜市', 1);
INSERT INTO `idtoad` VALUES (370882, 37, 8, 82, '山东', '济宁', '兖州市', 0);
INSERT INTO `idtoad` VALUES (370883, 37, 8, 83, '山东', '济宁', '邹城市', 1);
INSERT INTO `idtoad` VALUES (370900, 37, 9, 0, '山东', '泰安', '', 0);
INSERT INTO `idtoad` VALUES (370901, 37, 9, 1, '山东', '泰安', '市辖区', 0);
INSERT INTO `idtoad` VALUES (370902, 37, 9, 2, '山东', '泰安', '泰山区', 1);
INSERT INTO `idtoad` VALUES (370911, 37, 9, 11, '山东', '泰安', '岱岳区', 1);
INSERT INTO `idtoad` VALUES (370921, 37, 9, 21, '山东', '泰安', '宁阳县', 1);
INSERT INTO `idtoad` VALUES (370923, 37, 9, 23, '山东', '泰安', '东平县', 1);
INSERT INTO `idtoad` VALUES (370982, 37, 9, 82, '山东', '泰安', '新泰市', 1);
INSERT INTO `idtoad` VALUES (370983, 37, 9, 83, '山东', '泰安', '肥城市', 1);
INSERT INTO `idtoad` VALUES (371000, 37, 10, 0, '山东', '威海', '威海', 1);
INSERT INTO `idtoad` VALUES (371001, 37, 10, 1, '山东', '威海', '市辖区', 0);
INSERT INTO `idtoad` VALUES (371002, 37, 10, 2, '山东', '威海', '环翠区', 1);
INSERT INTO `idtoad` VALUES (371003, 37, 10, 3, '山东', '威海', '文登区', 1);
INSERT INTO `idtoad` VALUES (371081, 37, 10, 81, '山东', '威海', '文登市', 0);
INSERT INTO `idtoad` VALUES (371082, 37, 10, 82, '山东', '威海', '荣成市', 1);
INSERT INTO `idtoad` VALUES (371083, 37, 10, 83, '山东', '威海', '乳山市', 1);
INSERT INTO `idtoad` VALUES (371100, 37, 11, 0, '山东', '日照', '', 0);
INSERT INTO `idtoad` VALUES (371101, 37, 11, 1, '山东', '日照', '市辖区', 0);
INSERT INTO `idtoad` VALUES (371102, 37, 11, 2, '山东', '日照', '东港区', 1);
INSERT INTO `idtoad` VALUES (371103, 37, 11, 3, '山东', '日照', '岚山区', 1);
INSERT INTO `idtoad` VALUES (371121, 37, 11, 21, '山东', '日照', '五莲县', 1);
INSERT INTO `idtoad` VALUES (371122, 37, 11, 22, '山东', '日照', '莒县', 1);
INSERT INTO `idtoad` VALUES (371200, 37, 12, 0, '山东', '莱芜', '', 0);
INSERT INTO `idtoad` VALUES (371201, 37, 12, 1, '山东', '莱芜', '市辖区', 0);
INSERT INTO `idtoad` VALUES (371202, 37, 12, 2, '山东', '莱芜', '莱城区', 0);
INSERT INTO `idtoad` VALUES (371203, 37, 12, 3, '山东', '莱芜', '钢城区', 0);
INSERT INTO `idtoad` VALUES (371300, 37, 13, 0, '山东', '临沂', '', 0);
INSERT INTO `idtoad` VALUES (371301, 37, 13, 1, '山东', '临沂', '市辖区', 0);
INSERT INTO `idtoad` VALUES (371302, 37, 13, 2, '山东', '临沂', '兰山区', 1);
INSERT INTO `idtoad` VALUES (371311, 37, 13, 11, '山东', '临沂', '罗庄区', 1);
INSERT INTO `idtoad` VALUES (371312, 37, 13, 12, '山东', '临沂', '河东区', 1);
INSERT INTO `idtoad` VALUES (371321, 37, 13, 21, '山东', '临沂', '沂南县', 1);
INSERT INTO `idtoad` VALUES (371322, 37, 13, 22, '山东', '临沂', '郯城县', 1);
INSERT INTO `idtoad` VALUES (371323, 37, 13, 23, '山东', '临沂', '沂水县', 1);
INSERT INTO `idtoad` VALUES (371324, 37, 13, 24, '山东', '临沂', '兰陵县', 1);
INSERT INTO `idtoad` VALUES (371325, 37, 13, 25, '山东', '临沂', '费县', 1);
INSERT INTO `idtoad` VALUES (371326, 37, 13, 26, '山东', '临沂', '平邑县', 1);
INSERT INTO `idtoad` VALUES (371327, 37, 13, 27, '山东', '临沂', '莒南县', 1);
INSERT INTO `idtoad` VALUES (371328, 37, 13, 28, '山东', '临沂', '蒙阴县', 1);
INSERT INTO `idtoad` VALUES (371329, 37, 13, 29, '山东', '临沂', '临沭县', 1);
INSERT INTO `idtoad` VALUES (371400, 37, 14, 0, '山东', '德州', '', 0);
INSERT INTO `idtoad` VALUES (371401, 37, 14, 1, '山东', '德州', '市辖区', 0);
INSERT INTO `idtoad` VALUES (371402, 37, 14, 2, '山东', '德州', '德城区', 1);
INSERT INTO `idtoad` VALUES (371403, 37, 14, 3, '山东', '德州', '陵城区', 1);
INSERT INTO `idtoad` VALUES (371421, 37, 14, 21, '山东', '德州', '陵县', 0);
INSERT INTO `idtoad` VALUES (371422, 37, 14, 22, '山东', '德州', '宁津县', 1);
INSERT INTO `idtoad` VALUES (371423, 37, 14, 23, '山东', '德州', '庆云县', 1);
INSERT INTO `idtoad` VALUES (371424, 37, 14, 24, '山东', '德州', '临邑县', 1);
INSERT INTO `idtoad` VALUES (371425, 37, 14, 25, '山东', '德州', '齐河县', 1);
INSERT INTO `idtoad` VALUES (371426, 37, 14, 26, '山东', '德州', '平原县', 1);
INSERT INTO `idtoad` VALUES (371427, 37, 14, 27, '山东', '德州', '夏津县', 1);
INSERT INTO `idtoad` VALUES (371428, 37, 14, 28, '山东', '德州', '武城县', 1);
INSERT INTO `idtoad` VALUES (371481, 37, 14, 81, '山东', '德州', '乐陵市', 1);
INSERT INTO `idtoad` VALUES (371482, 37, 14, 82, '山东', '德州', '禹城市', 1);
INSERT INTO `idtoad` VALUES (371500, 37, 15, 0, '山东', '聊城', '', 0);
INSERT INTO `idtoad` VALUES (371501, 37, 15, 1, '山东', '聊城', '市辖区', 0);
INSERT INTO `idtoad` VALUES (371502, 37, 15, 2, '山东', '聊城', '东昌府区', 1);
INSERT INTO `idtoad` VALUES (371503, 37, 15, 3, '山东', '聊城', '茌平区', 1);
INSERT INTO `idtoad` VALUES (371521, 37, 15, 21, '山东', '聊城', '阳谷县', 1);
INSERT INTO `idtoad` VALUES (371522, 37, 15, 22, '山东', '聊城', '莘县', 1);
INSERT INTO `idtoad` VALUES (371523, 37, 15, 23, '山东', '聊城', '茌平县', 0);
INSERT INTO `idtoad` VALUES (371524, 37, 15, 24, '山东', '聊城', '东阿县', 1);
INSERT INTO `idtoad` VALUES (371525, 37, 15, 25, '山东', '聊城', '冠县', 1);
INSERT INTO `idtoad` VALUES (371526, 37, 15, 26, '山东', '聊城', '高唐县', 1);
INSERT INTO `idtoad` VALUES (371581, 37, 15, 81, '山东', '聊城', '临清市', 1);
INSERT INTO `idtoad` VALUES (371602, 37, 16, 2, '山东', '滨州', '滨城区', 1);
INSERT INTO `idtoad` VALUES (371603, 37, 16, 3, '山东', '滨州', '沾化区', 1);
INSERT INTO `idtoad` VALUES (371621, 37, 16, 21, '山东', '滨州', '惠民县', 1);
INSERT INTO `idtoad` VALUES (371622, 37, 16, 22, '山东', '滨州', '阳信县', 1);
INSERT INTO `idtoad` VALUES (371623, 37, 16, 23, '山东', '滨州', '无棣县', 1);
INSERT INTO `idtoad` VALUES (371625, 37, 16, 25, '山东', '滨州', '博兴县', 1);
INSERT INTO `idtoad` VALUES (371626, 37, 16, 26, '山东', '滨州', '邹平县', 0);
INSERT INTO `idtoad` VALUES (371681, 37, 16, 81, '山东', '滨州', '邹平市', 1);
INSERT INTO `idtoad` VALUES (371702, 37, 17, 2, '山东', '菏泽', '牡丹区', 1);
INSERT INTO `idtoad` VALUES (371703, 37, 17, 3, '山东', '菏泽', '定陶区', 1);
INSERT INTO `idtoad` VALUES (371721, 37, 17, 21, '山东', '菏泽', '曹县', 1);
INSERT INTO `idtoad` VALUES (371722, 37, 17, 22, '山东', '菏泽', '单县', 1);
INSERT INTO `idtoad` VALUES (371723, 37, 17, 23, '山东', '菏泽', '成武县', 1);
INSERT INTO `idtoad` VALUES (371724, 37, 17, 24, '山东', '菏泽', '巨野县', 1);
INSERT INTO `idtoad` VALUES (371725, 37, 17, 25, '山东', '菏泽', '郓城县', 1);
INSERT INTO `idtoad` VALUES (371726, 37, 17, 26, '山东', '菏泽', '鄄城县', 1);
INSERT INTO `idtoad` VALUES (371728, 37, 17, 28, '山东', '菏泽', '东明县', 1);
INSERT INTO `idtoad` VALUES (372300, 37, 23, 0, '山东', '滨州地区', '', 0);
INSERT INTO `idtoad` VALUES (372301, 37, 23, 1, '山东', '滨州地区', '滨州市', 0);
INSERT INTO `idtoad` VALUES (372321, 37, 23, 21, '山东', '滨州地区', '惠民县', 0);
INSERT INTO `idtoad` VALUES (372323, 37, 23, 23, '山东', '滨州地区', '阳信县', 0);
INSERT INTO `idtoad` VALUES (372324, 37, 23, 24, '山东', '滨州地区', '无棣县', 0);
INSERT INTO `idtoad` VALUES (372325, 37, 23, 25, '山东', '滨州地区', '沾化县', 0);
INSERT INTO `idtoad` VALUES (372328, 37, 23, 28, '山东', '滨州地区', '博兴县', 0);
INSERT INTO `idtoad` VALUES (372330, 37, 23, 30, '山东', '滨州地区', '邹平县', 0);
INSERT INTO `idtoad` VALUES (372900, 37, 29, 0, '山东', '菏泽地区', '', 0);
INSERT INTO `idtoad` VALUES (372901, 37, 29, 1, '山东', '菏泽地区', '菏泽市', 0);
INSERT INTO `idtoad` VALUES (372922, 37, 29, 22, '山东', '菏泽地区', '曹县', 0);
INSERT INTO `idtoad` VALUES (372923, 37, 29, 23, '山东', '菏泽地区', '定陶县', 0);
INSERT INTO `idtoad` VALUES (372924, 37, 29, 24, '山东', '菏泽地区', '成武县', 0);
INSERT INTO `idtoad` VALUES (372925, 37, 29, 25, '山东', '菏泽地区', '单县', 0);
INSERT INTO `idtoad` VALUES (372926, 37, 29, 26, '山东', '菏泽地区', '巨野县', 0);
INSERT INTO `idtoad` VALUES (372928, 37, 29, 28, '山东', '菏泽地区', '郓城县', 0);
INSERT INTO `idtoad` VALUES (372929, 37, 29, 29, '山东', '菏泽地区', '鄄城县', 0);
INSERT INTO `idtoad` VALUES (372930, 37, 29, 30, '山东', '菏泽地区', '东明县', 0);
INSERT INTO `idtoad` VALUES (410000, 41, 0, 0, '河南', '', '', 0);
INSERT INTO `idtoad` VALUES (410100, 41, 1, 0, '河南', '郑州', '郑州', 1);
INSERT INTO `idtoad` VALUES (410101, 41, 1, 1, '河南', '郑州', '市辖区', 0);
INSERT INTO `idtoad` VALUES (410102, 41, 1, 2, '河南', '郑州', '中原区', 1);
INSERT INTO `idtoad` VALUES (410103, 41, 1, 3, '河南', '郑州', '二七区', 1);
INSERT INTO `idtoad` VALUES (410104, 41, 1, 4, '河南', '郑州', '管城回族区', 1);
INSERT INTO `idtoad` VALUES (410105, 41, 1, 5, '河南', '郑州', '金水区', 1);
INSERT INTO `idtoad` VALUES (410106, 41, 1, 6, '河南', '郑州', '上街区', 1);
INSERT INTO `idtoad` VALUES (410108, 41, 1, 8, '河南', '郑州', '惠济区', 1);
INSERT INTO `idtoad` VALUES (410122, 41, 1, 22, '河南', '郑州', '中牟县', 1);
INSERT INTO `idtoad` VALUES (410181, 41, 1, 81, '河南', '郑州', '巩义市', 1);
INSERT INTO `idtoad` VALUES (410182, 41, 1, 82, '河南', '郑州', '荥阳市', 1);
INSERT INTO `idtoad` VALUES (410183, 41, 1, 83, '河南', '郑州', '新密市', 1);
INSERT INTO `idtoad` VALUES (410184, 41, 1, 84, '河南', '郑州', '新郑市', 1);
INSERT INTO `idtoad` VALUES (410185, 41, 1, 85, '河南', '郑州', '登封市', 1);
INSERT INTO `idtoad` VALUES (410200, 41, 2, 0, '河南', '开封', '', 0);
INSERT INTO `idtoad` VALUES (410201, 41, 2, 1, '河南', '开封', '市辖区', 0);
INSERT INTO `idtoad` VALUES (410202, 41, 2, 2, '河南', '开封', '龙亭区', 1);
INSERT INTO `idtoad` VALUES (410203, 41, 2, 3, '河南', '开封', '顺河回族区', 1);
INSERT INTO `idtoad` VALUES (410204, 41, 2, 4, '河南', '开封', '鼓楼区', 1);
INSERT INTO `idtoad` VALUES (410205, 41, 2, 5, '河南', '开封', '禹王台区', 1);
INSERT INTO `idtoad` VALUES (410211, 41, 2, 11, '河南', '开封', '郊区', 0);
INSERT INTO `idtoad` VALUES (410212, 41, 2, 12, '河南', '开封', '祥符区', 1);
INSERT INTO `idtoad` VALUES (410221, 41, 2, 21, '河南', '开封', '杞县', 1);
INSERT INTO `idtoad` VALUES (410222, 41, 2, 22, '河南', '开封', '通许县', 1);
INSERT INTO `idtoad` VALUES (410223, 41, 2, 23, '河南', '开封', '尉氏县', 1);
INSERT INTO `idtoad` VALUES (410224, 41, 2, 24, '河南', '开封', '县', 0);
INSERT INTO `idtoad` VALUES (410225, 41, 2, 25, '河南', '开封', '兰考县', 1);
INSERT INTO `idtoad` VALUES (410300, 41, 3, 0, '河南', '洛阳', '', 0);
INSERT INTO `idtoad` VALUES (410301, 41, 3, 1, '河南', '洛阳', '市辖区', 0);
INSERT INTO `idtoad` VALUES (410302, 41, 3, 2, '河南', '洛阳', '老城区', 1);
INSERT INTO `idtoad` VALUES (410303, 41, 3, 3, '河南', '洛阳', '西工区', 1);
INSERT INTO `idtoad` VALUES (410304, 41, 3, 4, '河南', '洛阳', '瀍河回族区', 1);
INSERT INTO `idtoad` VALUES (410305, 41, 3, 5, '河南', '洛阳', '涧西区', 1);
INSERT INTO `idtoad` VALUES (410306, 41, 3, 6, '河南', '洛阳', '吉利区', 1);
INSERT INTO `idtoad` VALUES (410311, 41, 3, 11, '河南', '洛阳', '洛龙区', 1);
INSERT INTO `idtoad` VALUES (410322, 41, 3, 22, '河南', '洛阳', '孟津县', 1);
INSERT INTO `idtoad` VALUES (410323, 41, 3, 23, '河南', '洛阳', '新安县', 1);
INSERT INTO `idtoad` VALUES (410324, 41, 3, 24, '河南', '洛阳', '栾川县', 1);
INSERT INTO `idtoad` VALUES (410325, 41, 3, 25, '河南', '洛阳', '嵩县', 1);
INSERT INTO `idtoad` VALUES (410326, 41, 3, 26, '河南', '洛阳', '汝阳县', 1);
INSERT INTO `idtoad` VALUES (410327, 41, 3, 27, '河南', '洛阳', '宜阳县', 1);
INSERT INTO `idtoad` VALUES (410328, 41, 3, 28, '河南', '洛阳', '洛宁县', 1);
INSERT INTO `idtoad` VALUES (410329, 41, 3, 29, '河南', '洛阳', '伊川县', 1);
INSERT INTO `idtoad` VALUES (410381, 41, 3, 81, '河南', '洛阳', '偃师市', 1);
INSERT INTO `idtoad` VALUES (410400, 41, 4, 0, '河南', '平顶山', '', 0);
INSERT INTO `idtoad` VALUES (410401, 41, 4, 1, '河南', '平顶山', '市辖区', 0);
INSERT INTO `idtoad` VALUES (410402, 41, 4, 2, '河南', '平顶山', '新华区', 1);
INSERT INTO `idtoad` VALUES (410403, 41, 4, 3, '河南', '平顶山', '卫东区', 1);
INSERT INTO `idtoad` VALUES (410404, 41, 4, 4, '河南', '平顶山', '石龙区', 1);
INSERT INTO `idtoad` VALUES (410411, 41, 4, 11, '河南', '平顶山', '湛河区', 1);
INSERT INTO `idtoad` VALUES (410421, 41, 4, 21, '河南', '平顶山', '宝丰县', 1);
INSERT INTO `idtoad` VALUES (410422, 41, 4, 22, '河南', '平顶山', '叶县', 1);
INSERT INTO `idtoad` VALUES (410423, 41, 4, 23, '河南', '平顶山', '鲁山县', 1);
INSERT INTO `idtoad` VALUES (410425, 41, 4, 25, '河南', '平顶山', '郏县', 1);
INSERT INTO `idtoad` VALUES (410481, 41, 4, 81, '河南', '平顶山', '舞钢市', 1);
INSERT INTO `idtoad` VALUES (410482, 41, 4, 82, '河南', '平顶山', '汝州市', 1);
INSERT INTO `idtoad` VALUES (410500, 41, 5, 0, '河南', '安阳', '', 0);
INSERT INTO `idtoad` VALUES (410501, 41, 5, 1, '河南', '安阳', '市辖区', 0);
INSERT INTO `idtoad` VALUES (410502, 41, 5, 2, '河南', '安阳', '文峰区', 1);
INSERT INTO `idtoad` VALUES (410503, 41, 5, 3, '河南', '安阳', '北关区', 1);
INSERT INTO `idtoad` VALUES (410504, 41, 5, 4, '河南', '安阳', '铁西区', 0);
INSERT INTO `idtoad` VALUES (410505, 41, 5, 5, '河南', '安阳', '殷都区', 1);
INSERT INTO `idtoad` VALUES (410506, 41, 5, 6, '河南', '安阳', '龙安区', 1);
INSERT INTO `idtoad` VALUES (410511, 41, 5, 11, '河南', '安阳', '郊区', 0);
INSERT INTO `idtoad` VALUES (410522, 41, 5, 22, '河南', '安阳', '安阳县', 1);
INSERT INTO `idtoad` VALUES (410523, 41, 5, 23, '河南', '安阳', '汤阴县', 1);
INSERT INTO `idtoad` VALUES (410526, 41, 5, 26, '河南', '安阳', '滑县', 1);
INSERT INTO `idtoad` VALUES (410527, 41, 5, 27, '河南', '安阳', '内黄县', 1);
INSERT INTO `idtoad` VALUES (410581, 41, 5, 81, '河南', '安阳', '林州市', 1);
INSERT INTO `idtoad` VALUES (410600, 41, 6, 0, '河南', '鹤壁', '', 0);
INSERT INTO `idtoad` VALUES (410601, 41, 6, 1, '河南', '鹤壁', '市辖区', 0);
INSERT INTO `idtoad` VALUES (410602, 41, 6, 2, '河南', '鹤壁', '鹤山区', 1);
INSERT INTO `idtoad` VALUES (410603, 41, 6, 3, '河南', '鹤壁', '山城区', 1);
INSERT INTO `idtoad` VALUES (410611, 41, 6, 11, '河南', '鹤壁', '淇滨区', 1);
INSERT INTO `idtoad` VALUES (410621, 41, 6, 21, '河南', '鹤壁', '浚县', 1);
INSERT INTO `idtoad` VALUES (410622, 41, 6, 22, '河南', '鹤壁', '淇县', 1);
INSERT INTO `idtoad` VALUES (410700, 41, 7, 0, '河南', '新乡', '', 0);
INSERT INTO `idtoad` VALUES (410701, 41, 7, 1, '河南', '新乡', '市辖区', 0);
INSERT INTO `idtoad` VALUES (410702, 41, 7, 2, '河南', '新乡', '红旗区', 1);
INSERT INTO `idtoad` VALUES (410703, 41, 7, 3, '河南', '新乡', '卫滨区', 1);
INSERT INTO `idtoad` VALUES (410704, 41, 7, 4, '河南', '新乡', '凤泉区', 1);
INSERT INTO `idtoad` VALUES (410711, 41, 7, 11, '河南', '新乡', '牧野区', 1);
INSERT INTO `idtoad` VALUES (410721, 41, 7, 21, '河南', '新乡', '新乡县', 1);
INSERT INTO `idtoad` VALUES (410724, 41, 7, 24, '河南', '新乡', '获嘉县', 1);
INSERT INTO `idtoad` VALUES (410725, 41, 7, 25, '河南', '新乡', '原阳县', 1);
INSERT INTO `idtoad` VALUES (410726, 41, 7, 26, '河南', '新乡', '延津县', 1);
INSERT INTO `idtoad` VALUES (410727, 41, 7, 27, '河南', '新乡', '封丘县', 1);
INSERT INTO `idtoad` VALUES (410728, 41, 7, 28, '河南', '新乡', '长垣县', 0);
INSERT INTO `idtoad` VALUES (410781, 41, 7, 81, '河南', '新乡', '卫辉市', 1);
INSERT INTO `idtoad` VALUES (410782, 41, 7, 82, '河南', '新乡', '辉县市', 1);
INSERT INTO `idtoad` VALUES (410783, 41, 7, 83, '河南', '新乡', '长垣市', 1);
INSERT INTO `idtoad` VALUES (410800, 41, 8, 0, '河南', '焦作', '', 0);
INSERT INTO `idtoad` VALUES (410801, 41, 8, 1, '河南', '焦作', '市辖区', 0);
INSERT INTO `idtoad` VALUES (410802, 41, 8, 2, '河南', '焦作', '解放区', 1);
INSERT INTO `idtoad` VALUES (410803, 41, 8, 3, '河南', '焦作', '中站区', 1);
INSERT INTO `idtoad` VALUES (410804, 41, 8, 4, '河南', '焦作', '马村区', 1);
INSERT INTO `idtoad` VALUES (410811, 41, 8, 11, '河南', '焦作', '山阳区', 1);
INSERT INTO `idtoad` VALUES (410821, 41, 8, 21, '河南', '焦作', '修武县', 1);
INSERT INTO `idtoad` VALUES (410822, 41, 8, 22, '河南', '焦作', '博爱县', 1);
INSERT INTO `idtoad` VALUES (410823, 41, 8, 23, '河南', '焦作', '武陟县', 1);
INSERT INTO `idtoad` VALUES (410825, 41, 8, 25, '河南', '焦作', '温县', 1);
INSERT INTO `idtoad` VALUES (410881, 41, 8, 81, '河南', '焦作', '济源市', 0);
INSERT INTO `idtoad` VALUES (410882, 41, 8, 82, '河南', '焦作', '沁阳市', 1);
INSERT INTO `idtoad` VALUES (410883, 41, 8, 83, '河南', '焦作', '孟州市', 1);
INSERT INTO `idtoad` VALUES (410900, 41, 9, 0, '河南', '濮阳', '', 0);
INSERT INTO `idtoad` VALUES (410901, 41, 9, 1, '河南', '濮阳', '市辖区', 0);
INSERT INTO `idtoad` VALUES (410902, 41, 9, 2, '河南', '濮阳', '华龙区', 1);
INSERT INTO `idtoad` VALUES (410922, 41, 9, 22, '河南', '濮阳', '清丰县', 1);
INSERT INTO `idtoad` VALUES (410923, 41, 9, 23, '河南', '濮阳', '南乐县', 1);
INSERT INTO `idtoad` VALUES (410926, 41, 9, 26, '河南', '濮阳', '范县', 1);
INSERT INTO `idtoad` VALUES (410927, 41, 9, 27, '河南', '濮阳', '台前县', 1);
INSERT INTO `idtoad` VALUES (410928, 41, 9, 28, '河南', '濮阳', '濮阳县', 1);
INSERT INTO `idtoad` VALUES (411000, 41, 10, 0, '河南', '许昌', '', 0);
INSERT INTO `idtoad` VALUES (411001, 41, 10, 1, '河南', '许昌', '市辖区', 0);
INSERT INTO `idtoad` VALUES (411002, 41, 10, 2, '河南', '许昌', '魏都区', 1);
INSERT INTO `idtoad` VALUES (411003, 41, 10, 3, '河南', '许昌', '建安区', 1);
INSERT INTO `idtoad` VALUES (411023, 41, 10, 23, '河南', '许昌', '县', 0);
INSERT INTO `idtoad` VALUES (411024, 41, 10, 24, '河南', '许昌', '鄢陵县', 1);
INSERT INTO `idtoad` VALUES (411025, 41, 10, 25, '河南', '许昌', '襄城县', 1);
INSERT INTO `idtoad` VALUES (411081, 41, 10, 81, '河南', '许昌', '禹州市', 1);
INSERT INTO `idtoad` VALUES (411082, 41, 10, 82, '河南', '许昌', '长葛市', 1);
INSERT INTO `idtoad` VALUES (411100, 41, 11, 0, '河南', '漯河', '', 0);
INSERT INTO `idtoad` VALUES (411101, 41, 11, 1, '河南', '漯河', '市辖区', 0);
INSERT INTO `idtoad` VALUES (411102, 41, 11, 2, '河南', '漯河', '源汇区', 1);
INSERT INTO `idtoad` VALUES (411103, 41, 11, 3, '河南', '漯河', '郾城区', 1);
INSERT INTO `idtoad` VALUES (411104, 41, 11, 4, '河南', '漯河', '召陵区', 1);
INSERT INTO `idtoad` VALUES (411121, 41, 11, 21, '河南', '漯河', '舞阳县', 1);
INSERT INTO `idtoad` VALUES (411122, 41, 11, 22, '河南', '漯河', '临颍县', 1);
INSERT INTO `idtoad` VALUES (411123, 41, 11, 23, '河南', '漯河', '郾城县', 0);
INSERT INTO `idtoad` VALUES (411200, 41, 12, 0, '河南', '三门峡', '', 0);
INSERT INTO `idtoad` VALUES (411201, 41, 12, 1, '河南', '三门峡', '市辖区', 0);
INSERT INTO `idtoad` VALUES (411202, 41, 12, 2, '河南', '三门峡', '湖滨区', 1);
INSERT INTO `idtoad` VALUES (411203, 41, 12, 3, '河南', '三门峡', '陕州区', 1);
INSERT INTO `idtoad` VALUES (411221, 41, 12, 21, '河南', '三门峡', '渑池县', 1);
INSERT INTO `idtoad` VALUES (411222, 41, 12, 22, '河南', '三门峡', '陕县', 0);
INSERT INTO `idtoad` VALUES (411224, 41, 12, 24, '河南', '三门峡', '卢氏县', 1);
INSERT INTO `idtoad` VALUES (411281, 41, 12, 81, '河南', '三门峡', '义马市', 1);
INSERT INTO `idtoad` VALUES (411282, 41, 12, 82, '河南', '三门峡', '灵宝市', 1);
INSERT INTO `idtoad` VALUES (411300, 41, 13, 0, '河南', '南阳', '', 0);
INSERT INTO `idtoad` VALUES (411301, 41, 13, 1, '河南', '南阳', '市辖区', 0);
INSERT INTO `idtoad` VALUES (411302, 41, 13, 2, '河南', '南阳', '宛城区', 1);
INSERT INTO `idtoad` VALUES (411303, 41, 13, 3, '河南', '南阳', '卧龙区', 1);
INSERT INTO `idtoad` VALUES (411321, 41, 13, 21, '河南', '南阳', '南召县', 1);
INSERT INTO `idtoad` VALUES (411322, 41, 13, 22, '河南', '南阳', '方城县', 1);
INSERT INTO `idtoad` VALUES (411323, 41, 13, 23, '河南', '南阳', '西峡县', 1);
INSERT INTO `idtoad` VALUES (411324, 41, 13, 24, '河南', '南阳', '镇平县', 1);
INSERT INTO `idtoad` VALUES (411325, 41, 13, 25, '河南', '南阳', '内乡县', 1);
INSERT INTO `idtoad` VALUES (411326, 41, 13, 26, '河南', '南阳', '淅川县', 1);
INSERT INTO `idtoad` VALUES (411327, 41, 13, 27, '河南', '南阳', '社旗县', 1);
INSERT INTO `idtoad` VALUES (411328, 41, 13, 28, '河南', '南阳', '唐河县', 1);
INSERT INTO `idtoad` VALUES (411329, 41, 13, 29, '河南', '南阳', '新野县', 1);
INSERT INTO `idtoad` VALUES (411330, 41, 13, 30, '河南', '南阳', '桐柏县', 1);
INSERT INTO `idtoad` VALUES (411381, 41, 13, 81, '河南', '南阳', '邓州市', 1);
INSERT INTO `idtoad` VALUES (411400, 41, 14, 0, '河南', '商丘', '', 0);
INSERT INTO `idtoad` VALUES (411401, 41, 14, 1, '河南', '商丘', '市辖区', 0);
INSERT INTO `idtoad` VALUES (411402, 41, 14, 2, '河南', '商丘', '梁园区', 1);
INSERT INTO `idtoad` VALUES (411403, 41, 14, 3, '河南', '商丘', '睢阳区', 1);
INSERT INTO `idtoad` VALUES (411421, 41, 14, 21, '河南', '商丘', '民权县', 1);
INSERT INTO `idtoad` VALUES (411422, 41, 14, 22, '河南', '商丘', '睢县', 1);
INSERT INTO `idtoad` VALUES (411423, 41, 14, 23, '河南', '商丘', '宁陵县', 1);
INSERT INTO `idtoad` VALUES (411424, 41, 14, 24, '河南', '商丘', '柘城县', 1);
INSERT INTO `idtoad` VALUES (411425, 41, 14, 25, '河南', '商丘', '虞城县', 1);
INSERT INTO `idtoad` VALUES (411426, 41, 14, 26, '河南', '商丘', '夏邑县', 1);
INSERT INTO `idtoad` VALUES (411481, 41, 14, 81, '河南', '商丘', '永城市', 1);
INSERT INTO `idtoad` VALUES (411500, 41, 15, 0, '河南', '信阳', '', 0);
INSERT INTO `idtoad` VALUES (411501, 41, 15, 1, '河南', '信阳', '市辖区', 0);
INSERT INTO `idtoad` VALUES (411502, 41, 15, 2, '河南', '信阳', '浉河区', 1);
INSERT INTO `idtoad` VALUES (411503, 41, 15, 3, '河南', '信阳', '平桥区', 1);
INSERT INTO `idtoad` VALUES (411521, 41, 15, 21, '河南', '信阳', '罗山县', 1);
INSERT INTO `idtoad` VALUES (411522, 41, 15, 22, '河南', '信阳', '光山县', 1);
INSERT INTO `idtoad` VALUES (411523, 41, 15, 23, '河南', '信阳', '新县', 1);
INSERT INTO `idtoad` VALUES (411524, 41, 15, 24, '河南', '信阳', '商城县', 1);
INSERT INTO `idtoad` VALUES (411525, 41, 15, 25, '河南', '信阳', '固始县', 1);
INSERT INTO `idtoad` VALUES (411526, 41, 15, 26, '河南', '信阳', '潢川县', 1);
INSERT INTO `idtoad` VALUES (411527, 41, 15, 27, '河南', '信阳', '淮滨县', 1);
INSERT INTO `idtoad` VALUES (411528, 41, 15, 28, '河南', '信阳', '息县', 1);
INSERT INTO `idtoad` VALUES (411602, 41, 16, 2, '河南', '周口', '川汇区', 1);
INSERT INTO `idtoad` VALUES (411603, 41, 16, 3, '河南', '周口', '淮阳区', 1);
INSERT INTO `idtoad` VALUES (411621, 41, 16, 21, '河南', '周口', '扶沟县', 1);
INSERT INTO `idtoad` VALUES (411622, 41, 16, 22, '河南', '周口', '西华县', 1);
INSERT INTO `idtoad` VALUES (411623, 41, 16, 23, '河南', '周口', '商水县', 1);
INSERT INTO `idtoad` VALUES (411624, 41, 16, 24, '河南', '周口', '沈丘县', 1);
INSERT INTO `idtoad` VALUES (411625, 41, 16, 25, '河南', '周口', '郸城县', 1);
INSERT INTO `idtoad` VALUES (411626, 41, 16, 26, '河南', '周口', '淮阳县', 0);
INSERT INTO `idtoad` VALUES (411627, 41, 16, 27, '河南', '周口', '太康县', 1);
INSERT INTO `idtoad` VALUES (411628, 41, 16, 28, '河南', '周口', '鹿邑县', 1);
INSERT INTO `idtoad` VALUES (411681, 41, 16, 81, '河南', '周口', '项城市', 1);
INSERT INTO `idtoad` VALUES (411702, 41, 17, 2, '河南', '驻马店', '驿城区', 1);
INSERT INTO `idtoad` VALUES (411721, 41, 17, 21, '河南', '驻马店', '西平县', 1);
INSERT INTO `idtoad` VALUES (411722, 41, 17, 22, '河南', '驻马店', '上蔡县', 1);
INSERT INTO `idtoad` VALUES (411723, 41, 17, 23, '河南', '驻马店', '平舆县', 1);
INSERT INTO `idtoad` VALUES (411724, 41, 17, 24, '河南', '驻马店', '正阳县', 1);
INSERT INTO `idtoad` VALUES (411725, 41, 17, 25, '河南', '驻马店', '确山县', 1);
INSERT INTO `idtoad` VALUES (411726, 41, 17, 26, '河南', '驻马店', '泌阳县', 1);
INSERT INTO `idtoad` VALUES (411727, 41, 17, 27, '河南', '驻马店', '汝南县', 1);
INSERT INTO `idtoad` VALUES (411728, 41, 17, 28, '河南', '驻马店', '遂平县', 1);
INSERT INTO `idtoad` VALUES (411729, 41, 17, 29, '河南', '驻马店', '新蔡县', 1);
INSERT INTO `idtoad` VALUES (412700, 41, 27, 0, '河南', '周口地区', '', 0);
INSERT INTO `idtoad` VALUES (412701, 41, 27, 1, '河南', '周口地区', '周口市', 0);
INSERT INTO `idtoad` VALUES (412702, 41, 27, 2, '河南', '周口地区', '项城市', 0);
INSERT INTO `idtoad` VALUES (412721, 41, 27, 21, '河南', '周口地区', '扶沟县', 0);
INSERT INTO `idtoad` VALUES (412722, 41, 27, 22, '河南', '周口地区', '西华县', 0);
INSERT INTO `idtoad` VALUES (412723, 41, 27, 23, '河南', '周口地区', '商水县', 0);
INSERT INTO `idtoad` VALUES (412724, 41, 27, 24, '河南', '周口地区', '太康县', 0);
INSERT INTO `idtoad` VALUES (412725, 41, 27, 25, '河南', '周口地区', '鹿邑县', 0);
INSERT INTO `idtoad` VALUES (412726, 41, 27, 26, '河南', '周口地区', '郸城县', 0);
INSERT INTO `idtoad` VALUES (412727, 41, 27, 27, '河南', '周口地区', '淮阳县', 0);
INSERT INTO `idtoad` VALUES (412728, 41, 27, 28, '河南', '周口地区', '沈丘县', 0);
INSERT INTO `idtoad` VALUES (412800, 41, 28, 0, '河南', '驻马店地区', '', 0);
INSERT INTO `idtoad` VALUES (412801, 41, 28, 1, '河南', '驻马店地区', '驻马店市', 0);
INSERT INTO `idtoad` VALUES (412821, 41, 28, 21, '河南', '驻马店地区', '确山县', 0);
INSERT INTO `idtoad` VALUES (412822, 41, 28, 22, '河南', '驻马店地区', '泌阳县', 0);
INSERT INTO `idtoad` VALUES (412823, 41, 28, 23, '河南', '驻马店地区', '遂平县', 0);
INSERT INTO `idtoad` VALUES (412824, 41, 28, 24, '河南', '驻马店地区', '西平县', 0);
INSERT INTO `idtoad` VALUES (412825, 41, 28, 25, '河南', '驻马店地区', '上蔡县', 0);
INSERT INTO `idtoad` VALUES (412826, 41, 28, 26, '河南', '驻马店地区', '汝南县', 0);
INSERT INTO `idtoad` VALUES (412827, 41, 28, 27, '河南', '驻马店地区', '平舆县', 0);
INSERT INTO `idtoad` VALUES (412828, 41, 28, 28, '河南', '驻马店地区', '新蔡县', 0);
INSERT INTO `idtoad` VALUES (412829, 41, 28, 29, '河南', '驻马店地区', '正阳县', 0);
INSERT INTO `idtoad` VALUES (419001, 41, 90, 1, '河南', '济源', '济源', 1);
INSERT INTO `idtoad` VALUES (420000, 42, 0, 0, '湖北', '', '', 0);
INSERT INTO `idtoad` VALUES (420100, 42, 1, 0, '湖北', '武汉', '', 0);
INSERT INTO `idtoad` VALUES (420101, 42, 1, 1, '湖北', '武汉', '市辖区', 0);
INSERT INTO `idtoad` VALUES (420102, 42, 1, 2, '湖北', '武汉', '江岸区', 1);
INSERT INTO `idtoad` VALUES (420103, 42, 1, 3, '湖北', '武汉', '江汉区', 1);
INSERT INTO `idtoad` VALUES (420104, 42, 1, 4, '湖北', '武汉', '硚口区', 1);
INSERT INTO `idtoad` VALUES (420105, 42, 1, 5, '湖北', '武汉', '汉阳区', 1);
INSERT INTO `idtoad` VALUES (420106, 42, 1, 6, '湖北', '武汉', '武昌区', 1);
INSERT INTO `idtoad` VALUES (420107, 42, 1, 7, '湖北', '武汉', '青山区', 1);
INSERT INTO `idtoad` VALUES (420111, 42, 1, 11, '湖北', '武汉', '洪山区', 1);
INSERT INTO `idtoad` VALUES (420112, 42, 1, 12, '湖北', '武汉', '东西湖区', 1);
INSERT INTO `idtoad` VALUES (420113, 42, 1, 13, '湖北', '武汉', '汉南区', 1);
INSERT INTO `idtoad` VALUES (420114, 42, 1, 14, '湖北', '武汉', '蔡甸区', 1);
INSERT INTO `idtoad` VALUES (420115, 42, 1, 15, '湖北', '武汉', '江夏区', 1);
INSERT INTO `idtoad` VALUES (420116, 42, 1, 16, '湖北', '武汉', '黄陂区', 1);
INSERT INTO `idtoad` VALUES (420117, 42, 1, 17, '湖北', '武汉', '新洲区', 1);
INSERT INTO `idtoad` VALUES (420200, 42, 2, 0, '湖北', '黄石', '', 0);
INSERT INTO `idtoad` VALUES (420201, 42, 2, 1, '湖北', '黄石', '市辖区', 0);
INSERT INTO `idtoad` VALUES (420202, 42, 2, 2, '湖北', '黄石', '黄石港区', 1);
INSERT INTO `idtoad` VALUES (420203, 42, 2, 3, '湖北', '黄石', '西塞山区', 1);
INSERT INTO `idtoad` VALUES (420204, 42, 2, 4, '湖北', '黄石', '下陆区', 1);
INSERT INTO `idtoad` VALUES (420205, 42, 2, 5, '湖北', '黄石', '铁山区', 1);
INSERT INTO `idtoad` VALUES (420222, 42, 2, 22, '湖北', '黄石', '阳新县', 1);
INSERT INTO `idtoad` VALUES (420281, 42, 2, 81, '湖北', '黄石', '大冶市', 1);
INSERT INTO `idtoad` VALUES (420300, 42, 3, 0, '湖北', '十堰', '', 0);
INSERT INTO `idtoad` VALUES (420301, 42, 3, 1, '湖北', '十堰', '市辖区', 0);
INSERT INTO `idtoad` VALUES (420302, 42, 3, 2, '湖北', '十堰', '茅箭区', 1);
INSERT INTO `idtoad` VALUES (420303, 42, 3, 3, '湖北', '十堰', '张湾区', 1);
INSERT INTO `idtoad` VALUES (420304, 42, 3, 4, '湖北', '十堰', '郧阳区', 1);
INSERT INTO `idtoad` VALUES (420321, 42, 3, 21, '湖北', '十堰', '郧县', 0);
INSERT INTO `idtoad` VALUES (420322, 42, 3, 22, '湖北', '十堰', '郧西县', 1);
INSERT INTO `idtoad` VALUES (420323, 42, 3, 23, '湖北', '十堰', '竹山县', 1);
INSERT INTO `idtoad` VALUES (420324, 42, 3, 24, '湖北', '十堰', '竹溪县', 1);
INSERT INTO `idtoad` VALUES (420325, 42, 3, 25, '湖北', '十堰', '房县', 1);
INSERT INTO `idtoad` VALUES (420381, 42, 3, 81, '湖北', '十堰', '丹江口市', 1);
INSERT INTO `idtoad` VALUES (420500, 42, 5, 0, '湖北', '宜昌', '', 0);
INSERT INTO `idtoad` VALUES (420501, 42, 5, 1, '湖北', '宜昌', '市辖区', 0);
INSERT INTO `idtoad` VALUES (420502, 42, 5, 2, '湖北', '宜昌', '西陵区', 1);
INSERT INTO `idtoad` VALUES (420503, 42, 5, 3, '湖北', '宜昌', '伍家岗区', 1);
INSERT INTO `idtoad` VALUES (420504, 42, 5, 4, '湖北', '宜昌', '点军区', 1);
INSERT INTO `idtoad` VALUES (420505, 42, 5, 5, '湖北', '宜昌', '猇亭区', 1);
INSERT INTO `idtoad` VALUES (420506, 42, 5, 6, '湖北', '宜昌', '夷陵区', 1);
INSERT INTO `idtoad` VALUES (420521, 42, 5, 21, '湖北', '宜昌', '县', 0);
INSERT INTO `idtoad` VALUES (420525, 42, 5, 25, '湖北', '宜昌', '远安县', 1);
INSERT INTO `idtoad` VALUES (420526, 42, 5, 26, '湖北', '宜昌', '兴山县', 1);
INSERT INTO `idtoad` VALUES (420527, 42, 5, 27, '湖北', '宜昌', '秭归县', 1);
INSERT INTO `idtoad` VALUES (420528, 42, 5, 28, '湖北', '宜昌', '长阳土家族自治县', 1);
INSERT INTO `idtoad` VALUES (420529, 42, 5, 29, '湖北', '宜昌', '五峰土家族自治县', 1);
INSERT INTO `idtoad` VALUES (420581, 42, 5, 81, '湖北', '宜昌', '宜都市', 1);
INSERT INTO `idtoad` VALUES (420582, 42, 5, 82, '湖北', '宜昌', '当阳市', 1);
INSERT INTO `idtoad` VALUES (420583, 42, 5, 83, '湖北', '宜昌', '枝江市', 1);
INSERT INTO `idtoad` VALUES (420600, 42, 6, 0, '湖北', '襄樊', '', 0);
INSERT INTO `idtoad` VALUES (420601, 42, 6, 1, '湖北', '襄樊', '市辖区', 0);
INSERT INTO `idtoad` VALUES (420602, 42, 6, 2, '湖北', '襄阳', '襄城区', 1);
INSERT INTO `idtoad` VALUES (420606, 42, 6, 6, '湖北', '襄阳', '樊城区', 1);
INSERT INTO `idtoad` VALUES (420607, 42, 6, 7, '湖北', '襄阳', '襄州区', 1);
INSERT INTO `idtoad` VALUES (420621, 42, 6, 21, '湖北', '襄樊', '襄阳县', 0);
INSERT INTO `idtoad` VALUES (420624, 42, 6, 24, '湖北', '襄阳', '南漳县', 1);
INSERT INTO `idtoad` VALUES (420625, 42, 6, 25, '湖北', '襄阳', '谷城县', 1);
INSERT INTO `idtoad` VALUES (420626, 42, 6, 26, '湖北', '襄阳', '保康县', 1);
INSERT INTO `idtoad` VALUES (420682, 42, 6, 82, '湖北', '襄阳', '老河口市', 1);
INSERT INTO `idtoad` VALUES (420683, 42, 6, 83, '湖北', '襄阳', '枣阳市', 1);
INSERT INTO `idtoad` VALUES (420684, 42, 6, 84, '湖北', '襄阳', '宜城市', 1);
INSERT INTO `idtoad` VALUES (420700, 42, 7, 0, '湖北', '鄂州', '', 0);
INSERT INTO `idtoad` VALUES (420701, 42, 7, 1, '湖北', '鄂州', '市辖区', 0);
INSERT INTO `idtoad` VALUES (420702, 42, 7, 2, '湖北', '鄂州', '梁子湖区', 1);
INSERT INTO `idtoad` VALUES (420703, 42, 7, 3, '湖北', '鄂州', '华容区', 1);
INSERT INTO `idtoad` VALUES (420704, 42, 7, 4, '湖北', '鄂州', '鄂城区', 1);
INSERT INTO `idtoad` VALUES (420800, 42, 8, 0, '湖北', '荆门', '', 0);
INSERT INTO `idtoad` VALUES (420801, 42, 8, 1, '湖北', '荆门', '市辖区', 0);
INSERT INTO `idtoad` VALUES (420802, 42, 8, 2, '湖北', '荆门', '东宝区', 1);
INSERT INTO `idtoad` VALUES (420804, 42, 8, 4, '湖北', '荆门', '掇刀区', 1);
INSERT INTO `idtoad` VALUES (420821, 42, 8, 21, '湖北', '荆门', '京山县', 0);
INSERT INTO `idtoad` VALUES (420822, 42, 8, 22, '湖北', '荆门', '沙洋县', 1);
INSERT INTO `idtoad` VALUES (420881, 42, 8, 81, '湖北', '荆门', '钟祥市', 1);
INSERT INTO `idtoad` VALUES (420882, 42, 8, 82, '湖北', '荆门', '京山市', 1);
INSERT INTO `idtoad` VALUES (420900, 42, 9, 0, '湖北', '孝感', '', 0);
INSERT INTO `idtoad` VALUES (420901, 42, 9, 1, '湖北', '孝感', '市辖区', 0);
INSERT INTO `idtoad` VALUES (420902, 42, 9, 2, '湖北', '孝感', '孝南区', 1);
INSERT INTO `idtoad` VALUES (420921, 42, 9, 21, '湖北', '孝感', '孝昌县', 1);
INSERT INTO `idtoad` VALUES (420922, 42, 9, 22, '湖北', '孝感', '大悟县', 1);
INSERT INTO `idtoad` VALUES (420923, 42, 9, 23, '湖北', '孝感', '云梦县', 1);
INSERT INTO `idtoad` VALUES (420981, 42, 9, 81, '湖北', '孝感', '应城市', 1);
INSERT INTO `idtoad` VALUES (420982, 42, 9, 82, '湖北', '孝感', '安陆市', 1);
INSERT INTO `idtoad` VALUES (420983, 42, 9, 83, '湖北', '孝感', '广水市', 0);
INSERT INTO `idtoad` VALUES (420984, 42, 9, 84, '湖北', '孝感', '汉川市', 1);
INSERT INTO `idtoad` VALUES (421000, 42, 10, 0, '湖北', '荆州', '', 0);
INSERT INTO `idtoad` VALUES (421001, 42, 10, 1, '湖北', '荆州', '市辖区', 0);
INSERT INTO `idtoad` VALUES (421002, 42, 10, 2, '湖北', '荆州', '沙市区', 1);
INSERT INTO `idtoad` VALUES (421003, 42, 10, 3, '湖北', '荆州', '荆州区', 1);
INSERT INTO `idtoad` VALUES (421022, 42, 10, 22, '湖北', '荆州', '公安县', 1);
INSERT INTO `idtoad` VALUES (421023, 42, 10, 23, '湖北', '荆州', '监利县', 0);
INSERT INTO `idtoad` VALUES (421024, 42, 10, 24, '湖北', '荆州', '江陵县', 1);
INSERT INTO `idtoad` VALUES (421081, 42, 10, 81, '湖北', '荆州', '石首市', 1);
INSERT INTO `idtoad` VALUES (421083, 42, 10, 83, '湖北', '荆州', '洪湖市', 1);
INSERT INTO `idtoad` VALUES (421087, 42, 10, 87, '湖北', '荆州', '松滋市', 1);
INSERT INTO `idtoad` VALUES (421088, 42, 10, 88, '湖北', '荆州', '监利市', 1);
INSERT INTO `idtoad` VALUES (421100, 42, 11, 0, '湖北', '黄冈', '', 0);
INSERT INTO `idtoad` VALUES (421101, 42, 11, 1, '湖北', '黄冈', '市辖区', 0);
INSERT INTO `idtoad` VALUES (421102, 42, 11, 2, '湖北', '黄冈', '黄州区', 1);
INSERT INTO `idtoad` VALUES (421121, 42, 11, 21, '湖北', '黄冈', '团风县', 1);
INSERT INTO `idtoad` VALUES (421122, 42, 11, 22, '湖北', '黄冈', '红安县', 1);
INSERT INTO `idtoad` VALUES (421123, 42, 11, 23, '湖北', '黄冈', '罗田县', 1);
INSERT INTO `idtoad` VALUES (421124, 42, 11, 24, '湖北', '黄冈', '英山县', 1);
INSERT INTO `idtoad` VALUES (421125, 42, 11, 25, '湖北', '黄冈', '浠水县', 1);
INSERT INTO `idtoad` VALUES (421126, 42, 11, 26, '湖北', '黄冈', '蕲春县', 1);
INSERT INTO `idtoad` VALUES (421127, 42, 11, 27, '湖北', '黄冈', '黄梅县', 1);
INSERT INTO `idtoad` VALUES (421181, 42, 11, 81, '湖北', '黄冈', '麻城市', 1);
INSERT INTO `idtoad` VALUES (421182, 42, 11, 82, '湖北', '黄冈', '武穴市', 1);
INSERT INTO `idtoad` VALUES (421200, 42, 12, 0, '湖北', '咸宁', '', 0);
INSERT INTO `idtoad` VALUES (421201, 42, 12, 1, '湖北', '咸宁', '市辖区', 0);
INSERT INTO `idtoad` VALUES (421202, 42, 12, 2, '湖北', '咸宁', '咸安区', 1);
INSERT INTO `idtoad` VALUES (421221, 42, 12, 21, '湖北', '咸宁', '嘉鱼县', 1);
INSERT INTO `idtoad` VALUES (421222, 42, 12, 22, '湖北', '咸宁', '通城县', 1);
INSERT INTO `idtoad` VALUES (421223, 42, 12, 23, '湖北', '咸宁', '崇阳县', 1);
INSERT INTO `idtoad` VALUES (421224, 42, 12, 24, '湖北', '咸宁', '通山县', 1);
INSERT INTO `idtoad` VALUES (421281, 42, 12, 81, '湖北', '咸宁', '赤壁市', 1);
INSERT INTO `idtoad` VALUES (421303, 42, 13, 3, '湖北', '随州', '曾都区', 1);
INSERT INTO `idtoad` VALUES (421321, 42, 13, 21, '湖北', '随州', '随县', 1);
INSERT INTO `idtoad` VALUES (421381, 42, 13, 81, '湖北', '随州', '广水市', 1);
INSERT INTO `idtoad` VALUES (422800, 42, 28, 0, '湖北', '恩施土家族苗族自治州', '', 0);
INSERT INTO `idtoad` VALUES (422801, 42, 28, 1, '湖北', '恩施土家族苗族自治州', '恩施市', 1);
INSERT INTO `idtoad` VALUES (422802, 42, 28, 2, '湖北', '恩施土家族苗族自治州', '利川市', 1);
INSERT INTO `idtoad` VALUES (422822, 42, 28, 22, '湖北', '恩施土家族苗族自治州', '建始县', 1);
INSERT INTO `idtoad` VALUES (422823, 42, 28, 23, '湖北', '恩施土家族苗族自治州', '巴东县', 1);
INSERT INTO `idtoad` VALUES (422825, 42, 28, 25, '湖北', '恩施土家族苗族自治州', '宣恩县', 1);
INSERT INTO `idtoad` VALUES (422826, 42, 28, 26, '湖北', '恩施土家族苗族自治州', '咸丰县', 1);
INSERT INTO `idtoad` VALUES (422827, 42, 28, 27, '湖北', '恩施土家族苗族自治州', '来凤县', 1);
INSERT INTO `idtoad` VALUES (422828, 42, 28, 28, '湖北', '恩施土家族苗族自治州', '鹤峰县', 1);
INSERT INTO `idtoad` VALUES (429000, 42, 90, 0, '湖北', '省辖县', '', 0);
INSERT INTO `idtoad` VALUES (429001, 42, 90, 1, '湖北', '随州', '市辖区', 0);
INSERT INTO `idtoad` VALUES (429004, 42, 90, 4, '湖北', '仙桃', '仙桃', 1);
INSERT INTO `idtoad` VALUES (429005, 42, 90, 5, '湖北', '潜江', '潜江', 1);
INSERT INTO `idtoad` VALUES (429006, 42, 90, 6, '湖北', '天门', '天门', 1);
INSERT INTO `idtoad` VALUES (429021, 42, 90, 21, '湖北', '神农架林区', '神农架林区', 1);
INSERT INTO `idtoad` VALUES (430000, 43, 0, 0, '湖南', '', '', 0);
INSERT INTO `idtoad` VALUES (430100, 43, 1, 0, '湖南', '长沙', '', 0);
INSERT INTO `idtoad` VALUES (430101, 43, 1, 1, '湖南', '长沙', '市辖区', 0);
INSERT INTO `idtoad` VALUES (430102, 43, 1, 2, '湖南', '长沙', '芙蓉区', 1);
INSERT INTO `idtoad` VALUES (430103, 43, 1, 3, '湖南', '长沙', '天心区', 1);
INSERT INTO `idtoad` VALUES (430104, 43, 1, 4, '湖南', '长沙', '岳麓区', 1);
INSERT INTO `idtoad` VALUES (430105, 43, 1, 5, '湖南', '长沙', '开福区', 1);
INSERT INTO `idtoad` VALUES (430111, 43, 1, 11, '湖南', '长沙', '雨花区', 1);
INSERT INTO `idtoad` VALUES (430112, 43, 1, 12, '湖南', '长沙', '望城区', 1);
INSERT INTO `idtoad` VALUES (430121, 43, 1, 21, '湖南', '长沙', '长沙县', 1);
INSERT INTO `idtoad` VALUES (430122, 43, 1, 22, '湖南', '长沙', '望城县', 0);
INSERT INTO `idtoad` VALUES (430124, 43, 1, 24, '湖南', '长沙', '宁乡县', 0);
INSERT INTO `idtoad` VALUES (430181, 43, 1, 81, '湖南', '长沙', '浏阳市', 1);
INSERT INTO `idtoad` VALUES (430182, 43, 1, 82, '湖南', '长沙', '宁乡市', 1);
INSERT INTO `idtoad` VALUES (430200, 43, 2, 0, '湖南', '株洲', '', 0);
INSERT INTO `idtoad` VALUES (430201, 43, 2, 1, '湖南', '株洲', '市辖区', 0);
INSERT INTO `idtoad` VALUES (430202, 43, 2, 2, '湖南', '株洲', '荷塘区', 1);
INSERT INTO `idtoad` VALUES (430203, 43, 2, 3, '湖南', '株洲', '芦淞区', 1);
INSERT INTO `idtoad` VALUES (430204, 43, 2, 4, '湖南', '株洲', '石峰区', 1);
INSERT INTO `idtoad` VALUES (430211, 43, 2, 11, '湖南', '株洲', '天元区', 1);
INSERT INTO `idtoad` VALUES (430212, 43, 2, 12, '湖南', '株洲', '渌口区', 1);
INSERT INTO `idtoad` VALUES (430221, 43, 2, 21, '湖南', '株洲', '株洲县', 0);
INSERT INTO `idtoad` VALUES (430223, 43, 2, 23, '湖南', '株洲', '攸县', 1);
INSERT INTO `idtoad` VALUES (430224, 43, 2, 24, '湖南', '株洲', '茶陵县', 1);
INSERT INTO `idtoad` VALUES (430225, 43, 2, 25, '湖南', '株洲', '炎陵县', 1);
INSERT INTO `idtoad` VALUES (430281, 43, 2, 81, '湖南', '株洲', '醴陵市', 1);
INSERT INTO `idtoad` VALUES (430300, 43, 3, 0, '湖南', '湘潭', '', 0);
INSERT INTO `idtoad` VALUES (430301, 43, 3, 1, '湖南', '湘潭', '市辖区', 0);
INSERT INTO `idtoad` VALUES (430302, 43, 3, 2, '湖南', '湘潭', '雨湖区', 1);
INSERT INTO `idtoad` VALUES (430304, 43, 3, 4, '湖南', '湘潭', '岳塘区', 1);
INSERT INTO `idtoad` VALUES (430321, 43, 3, 21, '湖南', '湘潭', '湘潭县', 1);
INSERT INTO `idtoad` VALUES (430381, 43, 3, 81, '湖南', '湘潭', '湘乡市', 1);
INSERT INTO `idtoad` VALUES (430382, 43, 3, 82, '湖南', '湘潭', '韶山市', 1);
INSERT INTO `idtoad` VALUES (430400, 43, 4, 0, '湖南', '衡阳', '', 0);
INSERT INTO `idtoad` VALUES (430401, 43, 4, 1, '湖南', '衡阳', '市辖区', 0);
INSERT INTO `idtoad` VALUES (430402, 43, 4, 2, '湖南', '衡阳', '江东区', 0);
INSERT INTO `idtoad` VALUES (430403, 43, 4, 3, '湖南', '衡阳', '城南区', 0);
INSERT INTO `idtoad` VALUES (430404, 43, 4, 4, '湖南', '衡阳', '城北区', 0);
INSERT INTO `idtoad` VALUES (430405, 43, 4, 5, '湖南', '衡阳', '珠晖区', 1);
INSERT INTO `idtoad` VALUES (430406, 43, 4, 6, '湖南', '衡阳', '雁峰区', 1);
INSERT INTO `idtoad` VALUES (430407, 43, 4, 7, '湖南', '衡阳', '石鼓区', 1);
INSERT INTO `idtoad` VALUES (430408, 43, 4, 8, '湖南', '衡阳', '蒸湘区', 1);
INSERT INTO `idtoad` VALUES (430411, 43, 4, 11, '湖南', '衡阳', '郊区', 0);
INSERT INTO `idtoad` VALUES (430412, 43, 4, 12, '湖南', '衡阳', '南岳区', 1);
INSERT INTO `idtoad` VALUES (430421, 43, 4, 21, '湖南', '衡阳', '衡阳县', 1);
INSERT INTO `idtoad` VALUES (430422, 43, 4, 22, '湖南', '衡阳', '衡南县', 1);
INSERT INTO `idtoad` VALUES (430423, 43, 4, 23, '湖南', '衡阳', '衡山县', 1);
INSERT INTO `idtoad` VALUES (430424, 43, 4, 24, '湖南', '衡阳', '衡东县', 1);
INSERT INTO `idtoad` VALUES (430426, 43, 4, 26, '湖南', '衡阳', '祁东县', 1);
INSERT INTO `idtoad` VALUES (430481, 43, 4, 81, '湖南', '衡阳', '耒阳市', 1);
INSERT INTO `idtoad` VALUES (430482, 43, 4, 82, '湖南', '衡阳', '常宁市', 1);
INSERT INTO `idtoad` VALUES (430500, 43, 5, 0, '湖南', '邵阳', '', 0);
INSERT INTO `idtoad` VALUES (430501, 43, 5, 1, '湖南', '邵阳', '市辖区', 0);
INSERT INTO `idtoad` VALUES (430502, 43, 5, 2, '湖南', '邵阳', '双清区', 1);
INSERT INTO `idtoad` VALUES (430503, 43, 5, 3, '湖南', '邵阳', '大祥区', 1);
INSERT INTO `idtoad` VALUES (430511, 43, 5, 11, '湖南', '邵阳', '北塔区', 1);
INSERT INTO `idtoad` VALUES (430521, 43, 5, 21, '湖南', '邵阳', '邵东县', 0);
INSERT INTO `idtoad` VALUES (430522, 43, 5, 22, '湖南', '邵阳', '新邵县', 1);
INSERT INTO `idtoad` VALUES (430523, 43, 5, 23, '湖南', '邵阳', '邵阳县', 1);
INSERT INTO `idtoad` VALUES (430524, 43, 5, 24, '湖南', '邵阳', '隆回县', 1);
INSERT INTO `idtoad` VALUES (430525, 43, 5, 25, '湖南', '邵阳', '洞口县', 1);
INSERT INTO `idtoad` VALUES (430527, 43, 5, 27, '湖南', '邵阳', '绥宁县', 1);
INSERT INTO `idtoad` VALUES (430528, 43, 5, 28, '湖南', '邵阳', '新宁县', 1);
INSERT INTO `idtoad` VALUES (430529, 43, 5, 29, '湖南', '邵阳', '城步苗族自治县', 1);
INSERT INTO `idtoad` VALUES (430581, 43, 5, 81, '湖南', '邵阳', '武冈市', 1);
INSERT INTO `idtoad` VALUES (430582, 43, 5, 82, '湖南', '邵阳', '邵东市', 1);
INSERT INTO `idtoad` VALUES (430600, 43, 6, 0, '湖南', '岳阳', '', 0);
INSERT INTO `idtoad` VALUES (430601, 43, 6, 1, '湖南', '岳阳', '市辖区', 0);
INSERT INTO `idtoad` VALUES (430602, 43, 6, 2, '湖南', '岳阳', '岳阳楼区', 1);
INSERT INTO `idtoad` VALUES (430603, 43, 6, 3, '湖南', '岳阳', '云溪区', 1);
INSERT INTO `idtoad` VALUES (430611, 43, 6, 11, '湖南', '岳阳', '君山区', 1);
INSERT INTO `idtoad` VALUES (430621, 43, 6, 21, '湖南', '岳阳', '岳阳县', 1);
INSERT INTO `idtoad` VALUES (430623, 43, 6, 23, '湖南', '岳阳', '华容县', 1);
INSERT INTO `idtoad` VALUES (430624, 43, 6, 24, '湖南', '岳阳', '湘阴县', 1);
INSERT INTO `idtoad` VALUES (430626, 43, 6, 26, '湖南', '岳阳', '平江县', 1);
INSERT INTO `idtoad` VALUES (430681, 43, 6, 81, '湖南', '岳阳', '汨罗市', 1);
INSERT INTO `idtoad` VALUES (430682, 43, 6, 82, '湖南', '岳阳', '临湘市', 1);
INSERT INTO `idtoad` VALUES (430700, 43, 7, 0, '湖南', '常德', '', 0);
INSERT INTO `idtoad` VALUES (430701, 43, 7, 1, '湖南', '常德', '市辖区', 0);
INSERT INTO `idtoad` VALUES (430702, 43, 7, 2, '湖南', '常德', '武陵区', 1);
INSERT INTO `idtoad` VALUES (430703, 43, 7, 3, '湖南', '常德', '鼎城区', 1);
INSERT INTO `idtoad` VALUES (430721, 43, 7, 21, '湖南', '常德', '安乡县', 1);
INSERT INTO `idtoad` VALUES (430722, 43, 7, 22, '湖南', '常德', '汉寿县', 1);
INSERT INTO `idtoad` VALUES (430723, 43, 7, 23, '湖南', '常德', '澧县', 1);
INSERT INTO `idtoad` VALUES (430724, 43, 7, 24, '湖南', '常德', '临澧县', 1);
INSERT INTO `idtoad` VALUES (430725, 43, 7, 25, '湖南', '常德', '桃源县', 1);
INSERT INTO `idtoad` VALUES (430726, 43, 7, 26, '湖南', '常德', '石门县', 1);
INSERT INTO `idtoad` VALUES (430781, 43, 7, 81, '湖南', '常德', '津市市', 1);
INSERT INTO `idtoad` VALUES (430800, 43, 8, 0, '湖南', '张家界', '', 0);
INSERT INTO `idtoad` VALUES (430801, 43, 8, 1, '湖南', '张家界', '市辖区', 0);
INSERT INTO `idtoad` VALUES (430802, 43, 8, 2, '湖南', '张家界', '永定区', 1);
INSERT INTO `idtoad` VALUES (430811, 43, 8, 11, '湖南', '张家界', '武陵源区', 1);
INSERT INTO `idtoad` VALUES (430821, 43, 8, 21, '湖南', '张家界', '慈利县', 1);
INSERT INTO `idtoad` VALUES (430822, 43, 8, 22, '湖南', '张家界', '桑植县', 1);
INSERT INTO `idtoad` VALUES (430900, 43, 9, 0, '湖南', '益阳', '', 0);
INSERT INTO `idtoad` VALUES (430901, 43, 9, 1, '湖南', '益阳', '市辖区', 0);
INSERT INTO `idtoad` VALUES (430902, 43, 9, 2, '湖南', '益阳', '资阳区', 1);
INSERT INTO `idtoad` VALUES (430903, 43, 9, 3, '湖南', '益阳', '赫山区', 1);
INSERT INTO `idtoad` VALUES (430921, 43, 9, 21, '湖南', '益阳', '南县', 1);
INSERT INTO `idtoad` VALUES (430922, 43, 9, 22, '湖南', '益阳', '桃江县', 1);
INSERT INTO `idtoad` VALUES (430923, 43, 9, 23, '湖南', '益阳', '安化县', 1);
INSERT INTO `idtoad` VALUES (430981, 43, 9, 81, '湖南', '益阳', '沅江市', 1);
INSERT INTO `idtoad` VALUES (431000, 43, 10, 0, '湖南', '郴州', '', 0);
INSERT INTO `idtoad` VALUES (431001, 43, 10, 1, '湖南', '郴州', '市辖区', 0);
INSERT INTO `idtoad` VALUES (431002, 43, 10, 2, '湖南', '郴州', '北湖区', 1);
INSERT INTO `idtoad` VALUES (431003, 43, 10, 3, '湖南', '郴州', '苏仙区', 1);
INSERT INTO `idtoad` VALUES (431021, 43, 10, 21, '湖南', '郴州', '桂阳县', 1);
INSERT INTO `idtoad` VALUES (431022, 43, 10, 22, '湖南', '郴州', '宜章县', 1);
INSERT INTO `idtoad` VALUES (431023, 43, 10, 23, '湖南', '郴州', '永兴县', 1);
INSERT INTO `idtoad` VALUES (431024, 43, 10, 24, '湖南', '郴州', '嘉禾县', 1);
INSERT INTO `idtoad` VALUES (431025, 43, 10, 25, '湖南', '郴州', '临武县', 1);
INSERT INTO `idtoad` VALUES (431026, 43, 10, 26, '湖南', '郴州', '汝城县', 1);
INSERT INTO `idtoad` VALUES (431027, 43, 10, 27, '湖南', '郴州', '桂东县', 1);
INSERT INTO `idtoad` VALUES (431028, 43, 10, 28, '湖南', '郴州', '安仁县', 1);
INSERT INTO `idtoad` VALUES (431081, 43, 10, 81, '湖南', '郴州', '资兴市', 1);
INSERT INTO `idtoad` VALUES (431100, 43, 11, 0, '湖南', '永州', '', 0);
INSERT INTO `idtoad` VALUES (431101, 43, 11, 1, '湖南', '永州', '市辖区', 0);
INSERT INTO `idtoad` VALUES (431102, 43, 11, 2, '湖南', '永州', '零陵区', 1);
INSERT INTO `idtoad` VALUES (431103, 43, 11, 3, '湖南', '永州', '冷水滩区', 1);
INSERT INTO `idtoad` VALUES (431121, 43, 11, 21, '湖南', '永州', '祁阳县', 1);
INSERT INTO `idtoad` VALUES (431122, 43, 11, 22, '湖南', '永州', '东安县', 1);
INSERT INTO `idtoad` VALUES (431123, 43, 11, 23, '湖南', '永州', '双牌县', 1);
INSERT INTO `idtoad` VALUES (431124, 43, 11, 24, '湖南', '永州', '道县', 1);
INSERT INTO `idtoad` VALUES (431125, 43, 11, 25, '湖南', '永州', '江永县', 1);
INSERT INTO `idtoad` VALUES (431126, 43, 11, 26, '湖南', '永州', '宁远县', 1);
INSERT INTO `idtoad` VALUES (431127, 43, 11, 27, '湖南', '永州', '蓝山县', 1);
INSERT INTO `idtoad` VALUES (431128, 43, 11, 28, '湖南', '永州', '新田县', 1);
INSERT INTO `idtoad` VALUES (431129, 43, 11, 29, '湖南', '永州', '江华瑶族自治县', 1);
INSERT INTO `idtoad` VALUES (431200, 43, 12, 0, '湖南', '怀化', '', 0);
INSERT INTO `idtoad` VALUES (431201, 43, 12, 1, '湖南', '怀化', '市辖区', 0);
INSERT INTO `idtoad` VALUES (431202, 43, 12, 2, '湖南', '怀化', '鹤城区', 1);
INSERT INTO `idtoad` VALUES (431221, 43, 12, 21, '湖南', '怀化', '中方县', 1);
INSERT INTO `idtoad` VALUES (431222, 43, 12, 22, '湖南', '怀化', '沅陵县', 1);
INSERT INTO `idtoad` VALUES (431223, 43, 12, 23, '湖南', '怀化', '辰溪县', 1);
INSERT INTO `idtoad` VALUES (431224, 43, 12, 24, '湖南', '怀化', '溆浦县', 1);
INSERT INTO `idtoad` VALUES (431225, 43, 12, 25, '湖南', '怀化', '会同县', 1);
INSERT INTO `idtoad` VALUES (431226, 43, 12, 26, '湖南', '怀化', '麻阳苗族自治县', 1);
INSERT INTO `idtoad` VALUES (431227, 43, 12, 27, '湖南', '怀化', '新晃侗族自治县', 1);
INSERT INTO `idtoad` VALUES (431228, 43, 12, 28, '湖南', '怀化', '芷江侗族自治县', 1);
INSERT INTO `idtoad` VALUES (431229, 43, 12, 29, '湖南', '怀化', '靖州苗族侗族自治县', 1);
INSERT INTO `idtoad` VALUES (431230, 43, 12, 30, '湖南', '怀化', '通道侗族自治县', 1);
INSERT INTO `idtoad` VALUES (431281, 43, 12, 81, '湖南', '怀化', '洪江市', 1);
INSERT INTO `idtoad` VALUES (431302, 43, 13, 2, '湖南', '娄底', '娄星区', 1);
INSERT INTO `idtoad` VALUES (431321, 43, 13, 21, '湖南', '娄底', '双峰县', 1);
INSERT INTO `idtoad` VALUES (431322, 43, 13, 22, '湖南', '娄底', '新化县', 1);
INSERT INTO `idtoad` VALUES (431381, 43, 13, 81, '湖南', '娄底', '冷水江市', 1);
INSERT INTO `idtoad` VALUES (431382, 43, 13, 82, '湖南', '娄底', '涟源市', 1);
INSERT INTO `idtoad` VALUES (432500, 43, 25, 0, '湖南', '娄底地区', '', 0);
INSERT INTO `idtoad` VALUES (432501, 43, 25, 1, '湖南', '娄底地区', '娄底市', 0);
INSERT INTO `idtoad` VALUES (432502, 43, 25, 2, '湖南', '娄底地区', '冷水江市', 0);
INSERT INTO `idtoad` VALUES (432503, 43, 25, 3, '湖南', '娄底地区', '涟源市', 0);
INSERT INTO `idtoad` VALUES (432522, 43, 25, 22, '湖南', '娄底地区', '双峰县', 0);
INSERT INTO `idtoad` VALUES (432524, 43, 25, 24, '湖南', '娄底地区', '新化县', 0);
INSERT INTO `idtoad` VALUES (433000, 43, 30, 0, '湖南', '怀化', '', 0);
INSERT INTO `idtoad` VALUES (433001, 43, 30, 1, '湖南', '怀化', '', 0);
INSERT INTO `idtoad` VALUES (433100, 43, 31, 0, '湖南', '湘西土家族苗族自治州', '', 0);
INSERT INTO `idtoad` VALUES (433101, 43, 31, 1, '湖南', '湘西土家族苗族自治州', '吉首市', 1);
INSERT INTO `idtoad` VALUES (433122, 43, 31, 22, '湖南', '湘西土家族苗族自治州', '泸溪县', 1);
INSERT INTO `idtoad` VALUES (433123, 43, 31, 23, '湖南', '湘西土家族苗族自治州', '凤凰县', 1);
INSERT INTO `idtoad` VALUES (433124, 43, 31, 24, '湖南', '湘西土家族苗族自治州', '花垣县', 1);
INSERT INTO `idtoad` VALUES (433125, 43, 31, 25, '湖南', '湘西土家族苗族自治州', '保靖县', 1);
INSERT INTO `idtoad` VALUES (433126, 43, 31, 26, '湖南', '湘西土家族苗族自治州', '古丈县', 1);
INSERT INTO `idtoad` VALUES (433127, 43, 31, 27, '湖南', '湘西土家族苗族自治州', '永顺县', 1);
INSERT INTO `idtoad` VALUES (433130, 43, 31, 30, '湖南', '湘西土家族苗族自治州', '龙山县', 1);
INSERT INTO `idtoad` VALUES (440000, 44, 0, 0, '广东', '', '', 0);
INSERT INTO `idtoad` VALUES (440100, 44, 1, 0, '广东', '广州', '', 0);
INSERT INTO `idtoad` VALUES (440101, 44, 1, 1, '广东', '广州', '市辖区', 0);
INSERT INTO `idtoad` VALUES (440102, 44, 1, 2, '广东', '广州', '东山区', 0);
INSERT INTO `idtoad` VALUES (440103, 44, 1, 3, '广东', '广州', '荔湾区', 1);
INSERT INTO `idtoad` VALUES (440104, 44, 1, 4, '广东', '广州', '越秀区', 1);
INSERT INTO `idtoad` VALUES (440105, 44, 1, 5, '广东', '广州', '海珠区', 1);
INSERT INTO `idtoad` VALUES (440106, 44, 1, 6, '广东', '广州', '天河区', 1);
INSERT INTO `idtoad` VALUES (440107, 44, 1, 7, '广东', '广州', '芳村区', 0);
INSERT INTO `idtoad` VALUES (440111, 44, 1, 11, '广东', '广州', '白云区', 1);
INSERT INTO `idtoad` VALUES (440112, 44, 1, 12, '广东', '广州', '黄埔区', 1);
INSERT INTO `idtoad` VALUES (440113, 44, 1, 13, '广东', '广州', '番禺区', 1);
INSERT INTO `idtoad` VALUES (440114, 44, 1, 14, '广东', '广州', '花都区', 1);
INSERT INTO `idtoad` VALUES (440115, 44, 1, 15, '广东', '广州', '南沙区', 1);
INSERT INTO `idtoad` VALUES (440117, 44, 1, 17, '广东', '广州', '从化区', 1);
INSERT INTO `idtoad` VALUES (440118, 44, 1, 18, '广东', '广州', '增城区', 1);
INSERT INTO `idtoad` VALUES (440181, 44, 1, 81, '广东', '广州', '番禺市', 0);
INSERT INTO `idtoad` VALUES (440182, 44, 1, 82, '广东', '广州', '花都市', 0);
INSERT INTO `idtoad` VALUES (440183, 44, 1, 83, '广东', '广州', '增城市', 0);
INSERT INTO `idtoad` VALUES (440184, 44, 1, 84, '广东', '广州', '从化市', 0);
INSERT INTO `idtoad` VALUES (440200, 44, 2, 0, '广东', '韶关', '', 0);
INSERT INTO `idtoad` VALUES (440201, 44, 2, 1, '广东', '韶关', '市辖区', 0);
INSERT INTO `idtoad` VALUES (440202, 44, 2, 2, '广东', '韶关', '北江区', 0);
INSERT INTO `idtoad` VALUES (440203, 44, 2, 3, '广东', '韶关', '武江区', 1);
INSERT INTO `idtoad` VALUES (440204, 44, 2, 4, '广东', '韶关', '浈江区', 1);
INSERT INTO `idtoad` VALUES (440205, 44, 2, 5, '广东', '韶关', '曲江区', 1);
INSERT INTO `idtoad` VALUES (440221, 44, 2, 21, '广东', '韶关', '曲江县', 0);
INSERT INTO `idtoad` VALUES (440222, 44, 2, 22, '广东', '韶关', '始兴县', 1);
INSERT INTO `idtoad` VALUES (440224, 44, 2, 24, '广东', '韶关', '仁化县', 1);
INSERT INTO `idtoad` VALUES (440229, 44, 2, 29, '广东', '韶关', '翁源县', 1);
INSERT INTO `idtoad` VALUES (440232, 44, 2, 32, '广东', '韶关', '乳源瑶族自治县', 1);
INSERT INTO `idtoad` VALUES (440233, 44, 2, 33, '广东', '韶关', '新丰县', 1);
INSERT INTO `idtoad` VALUES (440281, 44, 2, 81, '广东', '韶关', '乐昌市', 1);
INSERT INTO `idtoad` VALUES (440282, 44, 2, 82, '广东', '韶关', '南雄市', 1);
INSERT INTO `idtoad` VALUES (440300, 44, 3, 0, '广东', '深圳', '深圳', 1);
INSERT INTO `idtoad` VALUES (440301, 44, 3, 1, '广东', '深圳', '市辖区', 0);
INSERT INTO `idtoad` VALUES (440303, 44, 3, 3, '广东', '深圳', '罗湖区', 1);
INSERT INTO `idtoad` VALUES (440304, 44, 3, 4, '广东', '深圳', '福田区', 1);
INSERT INTO `idtoad` VALUES (440305, 44, 3, 5, '广东', '深圳', '南山区', 1);
INSERT INTO `idtoad` VALUES (440306, 44, 3, 6, '广东', '深圳', '宝安区', 1);
INSERT INTO `idtoad` VALUES (440307, 44, 3, 7, '广东', '深圳', '龙岗区', 1);
INSERT INTO `idtoad` VALUES (440308, 44, 3, 8, '广东', '深圳', '盐田区', 1);
INSERT INTO `idtoad` VALUES (440309, 44, 3, 9, '广东', '深圳', '龙华区', 1);
INSERT INTO `idtoad` VALUES (440310, 44, 3, 10, '广东', '深圳', '坪山区', 1);
INSERT INTO `idtoad` VALUES (440311, 44, 3, 11, '广东', '深圳', '光明区', 1);
INSERT INTO `idtoad` VALUES (440400, 44, 4, 0, '广东', '珠海', '', 0);
INSERT INTO `idtoad` VALUES (440401, 44, 4, 1, '广东', '珠海', '市辖区', 0);
INSERT INTO `idtoad` VALUES (440402, 44, 4, 2, '广东', '珠海', '香洲区', 1);
INSERT INTO `idtoad` VALUES (440403, 44, 4, 3, '广东', '珠海', '斗门区', 1);
INSERT INTO `idtoad` VALUES (440404, 44, 4, 4, '广东', '珠海', '金湾区', 1);
INSERT INTO `idtoad` VALUES (440421, 44, 4, 21, '广东', '珠海', '斗门县', 0);
INSERT INTO `idtoad` VALUES (440500, 44, 5, 0, '广东', '汕头', '', 0);
INSERT INTO `idtoad` VALUES (440501, 44, 5, 1, '广东', '汕头', '市辖区', 0);
INSERT INTO `idtoad` VALUES (440506, 44, 5, 6, '广东', '汕头', '达濠区', 0);
INSERT INTO `idtoad` VALUES (440507, 44, 5, 7, '广东', '汕头', '龙湖区', 1);
INSERT INTO `idtoad` VALUES (440508, 44, 5, 8, '广东', '汕头', '金园区', 0);
INSERT INTO `idtoad` VALUES (440509, 44, 5, 9, '广东', '汕头', '升平区', 0);
INSERT INTO `idtoad` VALUES (440510, 44, 5, 10, '广东', '汕头', '河浦区', 0);
INSERT INTO `idtoad` VALUES (440511, 44, 5, 11, '广东', '汕头', '金平区', 1);
INSERT INTO `idtoad` VALUES (440512, 44, 5, 12, '广东', '汕头', '濠江区', 1);
INSERT INTO `idtoad` VALUES (440513, 44, 5, 13, '广东', '汕头', '潮阳区', 1);
INSERT INTO `idtoad` VALUES (440514, 44, 5, 14, '广东', '汕头', '潮南区', 1);
INSERT INTO `idtoad` VALUES (440515, 44, 5, 15, '广东', '汕头', '澄海区', 1);
INSERT INTO `idtoad` VALUES (440523, 44, 5, 23, '广东', '汕头', '南澳县', 1);
INSERT INTO `idtoad` VALUES (440582, 44, 5, 82, '广东', '汕头', '潮阳市', 0);
INSERT INTO `idtoad` VALUES (440583, 44, 5, 83, '广东', '汕头', '澄海市', 0);
INSERT INTO `idtoad` VALUES (440600, 44, 6, 0, '广东', '佛山', '', 0);
INSERT INTO `idtoad` VALUES (440601, 44, 6, 1, '广东', '佛山', '市辖区', 0);
INSERT INTO `idtoad` VALUES (440602, 44, 6, 2, '广东', '佛山', '城区', 0);
INSERT INTO `idtoad` VALUES (440603, 44, 6, 3, '广东', '佛山', '石湾区', 0);
INSERT INTO `idtoad` VALUES (440604, 44, 6, 4, '广东', '佛山', '禅城区', 1);
INSERT INTO `idtoad` VALUES (440605, 44, 6, 5, '广东', '佛山', '南海区', 1);
INSERT INTO `idtoad` VALUES (440606, 44, 6, 6, '广东', '佛山', '顺德区', 1);
INSERT INTO `idtoad` VALUES (440607, 44, 6, 7, '广东', '佛山', '三水区', 1);
INSERT INTO `idtoad` VALUES (440608, 44, 6, 8, '广东', '佛山', '高明区', 1);
INSERT INTO `idtoad` VALUES (440681, 44, 6, 81, '广东', '佛山', '顺德市', 0);
INSERT INTO `idtoad` VALUES (440682, 44, 6, 82, '广东', '佛山', '南海市', 0);
INSERT INTO `idtoad` VALUES (440683, 44, 6, 83, '广东', '佛山', '三水市', 0);
INSERT INTO `idtoad` VALUES (440684, 44, 6, 84, '广东', '佛山', '高明市', 0);
INSERT INTO `idtoad` VALUES (440700, 44, 7, 0, '广东', '江门', '', 0);
INSERT INTO `idtoad` VALUES (440701, 44, 7, 1, '广东', '江门', '市辖区', 0);
INSERT INTO `idtoad` VALUES (440703, 44, 7, 3, '广东', '江门', '蓬江区', 1);
INSERT INTO `idtoad` VALUES (440704, 44, 7, 4, '广东', '江门', '江海区', 1);
INSERT INTO `idtoad` VALUES (440705, 44, 7, 5, '广东', '江门', '新会区', 1);
INSERT INTO `idtoad` VALUES (440781, 44, 7, 81, '广东', '江门', '台山市', 1);
INSERT INTO `idtoad` VALUES (440782, 44, 7, 82, '广东', '江门', '新会市', 0);
INSERT INTO `idtoad` VALUES (440783, 44, 7, 83, '广东', '江门', '开平市', 1);
INSERT INTO `idtoad` VALUES (440784, 44, 7, 84, '广东', '江门', '鹤山市', 1);
INSERT INTO `idtoad` VALUES (440785, 44, 7, 85, '广东', '江门', '恩平市', 1);
INSERT INTO `idtoad` VALUES (440800, 44, 8, 0, '广东', '湛江', '湛江', 1);
INSERT INTO `idtoad` VALUES (440801, 44, 8, 1, '广东', '湛江', '市辖区', 0);
INSERT INTO `idtoad` VALUES (440802, 44, 8, 2, '广东', '湛江', '赤坎区', 1);
INSERT INTO `idtoad` VALUES (440803, 44, 8, 3, '广东', '湛江', '霞山区', 1);
INSERT INTO `idtoad` VALUES (440804, 44, 8, 4, '广东', '湛江', '坡头区', 1);
INSERT INTO `idtoad` VALUES (440811, 44, 8, 11, '广东', '湛江', '麻章区', 1);
INSERT INTO `idtoad` VALUES (440823, 44, 8, 23, '广东', '湛江', '遂溪县', 1);
INSERT INTO `idtoad` VALUES (440825, 44, 8, 25, '广东', '湛江', '徐闻县', 1);
INSERT INTO `idtoad` VALUES (440881, 44, 8, 81, '广东', '湛江', '廉江市', 1);
INSERT INTO `idtoad` VALUES (440882, 44, 8, 82, '广东', '湛江', '雷州市', 1);
INSERT INTO `idtoad` VALUES (440883, 44, 8, 83, '广东', '湛江', '吴川市', 1);
INSERT INTO `idtoad` VALUES (440900, 44, 9, 0, '广东', '茂名', '', 0);
INSERT INTO `idtoad` VALUES (440901, 44, 9, 1, '广东', '茂名', '市辖区', 0);
INSERT INTO `idtoad` VALUES (440902, 44, 9, 2, '广东', '茂名', '茂南区', 1);
INSERT INTO `idtoad` VALUES (440904, 44, 9, 4, '广东', '茂名', '电白区', 1);
INSERT INTO `idtoad` VALUES (440923, 44, 9, 23, '广东', '茂名', '电白县', 0);
INSERT INTO `idtoad` VALUES (440981, 44, 9, 81, '广东', '茂名', '高州市', 1);
INSERT INTO `idtoad` VALUES (440982, 44, 9, 82, '广东', '茂名', '化州市', 1);
INSERT INTO `idtoad` VALUES (440983, 44, 9, 83, '广东', '茂名', '信宜市', 1);
INSERT INTO `idtoad` VALUES (441200, 44, 12, 0, '广东', '肇庆', '', 0);
INSERT INTO `idtoad` VALUES (441201, 44, 12, 1, '广东', '肇庆', '市辖区', 0);
INSERT INTO `idtoad` VALUES (441202, 44, 12, 2, '广东', '肇庆', '端州区', 1);
INSERT INTO `idtoad` VALUES (441203, 44, 12, 3, '广东', '肇庆', '鼎湖区', 1);
INSERT INTO `idtoad` VALUES (441204, 44, 12, 4, '广东', '肇庆', '高要区', 1);
INSERT INTO `idtoad` VALUES (441223, 44, 12, 23, '广东', '肇庆', '广宁县', 1);
INSERT INTO `idtoad` VALUES (441224, 44, 12, 24, '广东', '肇庆', '怀集县', 1);
INSERT INTO `idtoad` VALUES (441225, 44, 12, 25, '广东', '肇庆', '封开县', 1);
INSERT INTO `idtoad` VALUES (441226, 44, 12, 26, '广东', '肇庆', '德庆县', 1);
INSERT INTO `idtoad` VALUES (441283, 44, 12, 83, '广东', '肇庆', '高要市', 0);
INSERT INTO `idtoad` VALUES (441284, 44, 12, 84, '广东', '肇庆', '四会市', 1);
INSERT INTO `idtoad` VALUES (441300, 44, 13, 0, '广东', '惠州', '', 0);
INSERT INTO `idtoad` VALUES (441301, 44, 13, 1, '广东', '惠州', '市辖区', 0);
INSERT INTO `idtoad` VALUES (441302, 44, 13, 2, '广东', '惠州', '惠城区', 1);
INSERT INTO `idtoad` VALUES (441303, 44, 13, 3, '广东', '惠州', '惠阳区', 1);
INSERT INTO `idtoad` VALUES (441322, 44, 13, 22, '广东', '惠州', '博罗县', 1);
INSERT INTO `idtoad` VALUES (441323, 44, 13, 23, '广东', '惠州', '惠东县', 1);
INSERT INTO `idtoad` VALUES (441324, 44, 13, 24, '广东', '惠州', '龙门县', 1);
INSERT INTO `idtoad` VALUES (441381, 44, 13, 81, '广东', '惠州', '惠阳市', 0);
INSERT INTO `idtoad` VALUES (441400, 44, 14, 0, '广东', '梅州', '', 0);
INSERT INTO `idtoad` VALUES (441401, 44, 14, 1, '广东', '梅州', '市辖区', 0);
INSERT INTO `idtoad` VALUES (441402, 44, 14, 2, '广东', '梅州', '梅江区', 1);
INSERT INTO `idtoad` VALUES (441403, 44, 14, 3, '广东', '梅州', '梅县区', 1);
INSERT INTO `idtoad` VALUES (441421, 44, 14, 21, '广东', '梅州', '梅县', 0);
INSERT INTO `idtoad` VALUES (441422, 44, 14, 22, '广东', '梅州', '大埔县', 1);
INSERT INTO `idtoad` VALUES (441423, 44, 14, 23, '广东', '梅州', '丰顺县', 1);
INSERT INTO `idtoad` VALUES (441424, 44, 14, 24, '广东', '梅州', '五华县', 1);
INSERT INTO `idtoad` VALUES (441426, 44, 14, 26, '广东', '梅州', '平远县', 1);
INSERT INTO `idtoad` VALUES (441427, 44, 14, 27, '广东', '梅州', '蕉岭县', 1);
INSERT INTO `idtoad` VALUES (441481, 44, 14, 81, '广东', '梅州', '兴宁市', 1);
INSERT INTO `idtoad` VALUES (441500, 44, 15, 0, '广东', '汕尾', '', 0);
INSERT INTO `idtoad` VALUES (441501, 44, 15, 1, '广东', '汕尾', '市辖区', 0);
INSERT INTO `idtoad` VALUES (441502, 44, 15, 2, '广东', '汕尾', '城区', 1);
INSERT INTO `idtoad` VALUES (441521, 44, 15, 21, '广东', '汕尾', '海丰县', 1);
INSERT INTO `idtoad` VALUES (441523, 44, 15, 23, '广东', '汕尾', '陆河县', 1);
INSERT INTO `idtoad` VALUES (441581, 44, 15, 81, '广东', '汕尾', '陆丰市', 1);
INSERT INTO `idtoad` VALUES (441600, 44, 16, 0, '广东', '河源', '', 0);
INSERT INTO `idtoad` VALUES (441601, 44, 16, 1, '广东', '河源', '市辖区', 0);
INSERT INTO `idtoad` VALUES (441602, 44, 16, 2, '广东', '河源', '源城区', 1);
INSERT INTO `idtoad` VALUES (441621, 44, 16, 21, '广东', '河源', '紫金县', 1);
INSERT INTO `idtoad` VALUES (441622, 44, 16, 22, '广东', '河源', '龙川县', 1);
INSERT INTO `idtoad` VALUES (441623, 44, 16, 23, '广东', '河源', '连平县', 1);
INSERT INTO `idtoad` VALUES (441624, 44, 16, 24, '广东', '河源', '和平县', 1);
INSERT INTO `idtoad` VALUES (441625, 44, 16, 25, '广东', '河源', '东源县', 1);
INSERT INTO `idtoad` VALUES (441700, 44, 17, 0, '广东', '阳江', '', 0);
INSERT INTO `idtoad` VALUES (441701, 44, 17, 1, '广东', '阳江', '市辖区', 0);
INSERT INTO `idtoad` VALUES (441702, 44, 17, 2, '广东', '阳江', '江城区', 1);
INSERT INTO `idtoad` VALUES (441704, 44, 17, 4, '广东', '阳江', '阳东区', 1);
INSERT INTO `idtoad` VALUES (441721, 44, 17, 21, '广东', '阳江', '阳西县', 1);
INSERT INTO `idtoad` VALUES (441723, 44, 17, 23, '广东', '阳江', '阳东县', 0);
INSERT INTO `idtoad` VALUES (441781, 44, 17, 81, '广东', '阳江', '阳春市', 1);
INSERT INTO `idtoad` VALUES (441800, 44, 18, 0, '广东', '清远', '', 0);
INSERT INTO `idtoad` VALUES (441801, 44, 18, 1, '广东', '清远', '市辖区', 0);
INSERT INTO `idtoad` VALUES (441802, 44, 18, 2, '广东', '清远', '清城区', 1);
INSERT INTO `idtoad` VALUES (441803, 44, 18, 3, '广东', '清远', '清新区', 1);
INSERT INTO `idtoad` VALUES (441821, 44, 18, 21, '广东', '清远', '佛冈县', 1);
INSERT INTO `idtoad` VALUES (441823, 44, 18, 23, '广东', '清远', '阳山县', 1);
INSERT INTO `idtoad` VALUES (441825, 44, 18, 25, '广东', '清远', '连山壮族瑶族自治县', 1);
INSERT INTO `idtoad` VALUES (441826, 44, 18, 26, '广东', '清远', '连南瑶族自治县', 1);
INSERT INTO `idtoad` VALUES (441827, 44, 18, 27, '广东', '清远', '清新县', 0);
INSERT INTO `idtoad` VALUES (441881, 44, 18, 81, '广东', '清远', '英德市', 1);
INSERT INTO `idtoad` VALUES (441882, 44, 18, 82, '广东', '清远', '连州市', 1);
INSERT INTO `idtoad` VALUES (441900, 44, 19, 0, '广东', '东莞', '东莞', 1);
INSERT INTO `idtoad` VALUES (441901, 44, 19, 1, '广东', '东莞', '市辖区', 0);
INSERT INTO `idtoad` VALUES (442000, 44, 20, 0, '广东', '中山', '中山', 1);
INSERT INTO `idtoad` VALUES (442001, 44, 20, 1, '广东', '中山', '市辖区', 0);
INSERT INTO `idtoad` VALUES (445100, 44, 51, 0, '广东', '潮州', '', 0);
INSERT INTO `idtoad` VALUES (445101, 44, 51, 1, '广东', '潮州', '市辖区', 0);
INSERT INTO `idtoad` VALUES (445102, 44, 51, 2, '广东', '潮州', '湘桥区', 1);
INSERT INTO `idtoad` VALUES (445103, 44, 51, 3, '广东', '潮州', '潮安区', 1);
INSERT INTO `idtoad` VALUES (445121, 44, 51, 21, '广东', '潮州', '潮安县', 0);
INSERT INTO `idtoad` VALUES (445122, 44, 51, 22, '广东', '潮州', '饶平县', 1);
INSERT INTO `idtoad` VALUES (445200, 44, 52, 0, '广东', '揭阳', '', 0);
INSERT INTO `idtoad` VALUES (445201, 44, 52, 1, '广东', '揭阳', '市辖区', 0);
INSERT INTO `idtoad` VALUES (445202, 44, 52, 2, '广东', '揭阳', '榕城区', 1);
INSERT INTO `idtoad` VALUES (445203, 44, 52, 3, '广东', '揭阳', '揭东区', 1);
INSERT INTO `idtoad` VALUES (445221, 44, 52, 21, '广东', '揭阳', '揭东县', 0);
INSERT INTO `idtoad` VALUES (445222, 44, 52, 22, '广东', '揭阳', '揭西县', 1);
INSERT INTO `idtoad` VALUES (445224, 44, 52, 24, '广东', '揭阳', '惠来县', 1);
INSERT INTO `idtoad` VALUES (445281, 44, 52, 81, '广东', '揭阳', '普宁市', 1);
INSERT INTO `idtoad` VALUES (445300, 44, 53, 0, '广东', '云浮', '', 0);
INSERT INTO `idtoad` VALUES (445301, 44, 53, 1, '广东', '云浮', '市辖区', 0);
INSERT INTO `idtoad` VALUES (445302, 44, 53, 2, '广东', '云浮', '云城区', 1);
INSERT INTO `idtoad` VALUES (445303, 44, 53, 3, '广东', '云浮', '云安区', 1);
INSERT INTO `idtoad` VALUES (445321, 44, 53, 21, '广东', '云浮', '新兴县', 1);
INSERT INTO `idtoad` VALUES (445322, 44, 53, 22, '广东', '云浮', '郁南县', 1);
INSERT INTO `idtoad` VALUES (445323, 44, 53, 23, '广东', '云浮', '云安县', 0);
INSERT INTO `idtoad` VALUES (445381, 44, 53, 81, '广东', '云浮', '罗定市', 1);
INSERT INTO `idtoad` VALUES (450000, 45, 0, 0, '广西', '', '', 0);
INSERT INTO `idtoad` VALUES (450100, 45, 1, 0, '广西', '南宁市', '', 0);
INSERT INTO `idtoad` VALUES (450101, 45, 1, 1, '广西', '南宁市', '辖区', 0);
INSERT INTO `idtoad` VALUES (450102, 45, 1, 2, '广西', '南宁', '兴宁区', 1);
INSERT INTO `idtoad` VALUES (450103, 45, 1, 3, '广西', '南宁', '青秀区', 1);
INSERT INTO `idtoad` VALUES (450104, 45, 1, 4, '广西', '南宁市', '城北区', 0);
INSERT INTO `idtoad` VALUES (450105, 45, 1, 5, '广西', '南宁', '江南区', 1);
INSERT INTO `idtoad` VALUES (450106, 45, 1, 6, '广西', '南宁市', '永新区', 0);
INSERT INTO `idtoad` VALUES (450107, 45, 1, 7, '广西', '南宁', '西乡塘区', 1);
INSERT INTO `idtoad` VALUES (450108, 45, 1, 8, '广西', '南宁', '良庆区', 1);
INSERT INTO `idtoad` VALUES (450109, 45, 1, 9, '广西', '南宁', '邕宁区', 1);
INSERT INTO `idtoad` VALUES (450110, 45, 1, 10, '广西', '南宁', '武鸣区', 1);
INSERT INTO `idtoad` VALUES (450111, 45, 1, 11, '广西', '南宁市', '郊区', 0);
INSERT INTO `idtoad` VALUES (450121, 45, 1, 21, '广西', '南宁市', '邕宁县', 0);
INSERT INTO `idtoad` VALUES (450122, 45, 1, 22, '广西', '南宁市', '武鸣县', 0);
INSERT INTO `idtoad` VALUES (450123, 45, 1, 23, '广西', '南宁', '隆安县', 1);
INSERT INTO `idtoad` VALUES (450124, 45, 1, 24, '广西', '南宁', '马山县', 1);
INSERT INTO `idtoad` VALUES (450125, 45, 1, 25, '广西', '南宁', '上林县', 1);
INSERT INTO `idtoad` VALUES (450126, 45, 1, 26, '广西', '南宁', '宾阳县', 1);
INSERT INTO `idtoad` VALUES (450127, 45, 1, 27, '广西', '南宁', '横县', 1);
INSERT INTO `idtoad` VALUES (450200, 45, 2, 0, '广西', '柳州市', '', 0);
INSERT INTO `idtoad` VALUES (450201, 45, 2, 1, '广西', '柳州市', '辖区', 0);
INSERT INTO `idtoad` VALUES (450202, 45, 2, 2, '广西', '柳州', '城中区', 1);
INSERT INTO `idtoad` VALUES (450203, 45, 2, 3, '广西', '柳州', '鱼峰区', 1);
INSERT INTO `idtoad` VALUES (450204, 45, 2, 4, '广西', '柳州', '柳南区', 1);
INSERT INTO `idtoad` VALUES (450205, 45, 2, 5, '广西', '柳州', '柳北区', 1);
INSERT INTO `idtoad` VALUES (450206, 45, 2, 6, '广西', '柳州', '柳江区', 1);
INSERT INTO `idtoad` VALUES (450211, 45, 2, 11, '广西', '柳州市', '郊区', 0);
INSERT INTO `idtoad` VALUES (450221, 45, 2, 21, '广西', '柳州市', '柳江县', 0);
INSERT INTO `idtoad` VALUES (450222, 45, 2, 22, '广西', '柳州', '柳城县', 1);
INSERT INTO `idtoad` VALUES (450223, 45, 2, 23, '广西', '柳州', '鹿寨县', 1);
INSERT INTO `idtoad` VALUES (450224, 45, 2, 24, '广西', '柳州', '融安县', 1);
INSERT INTO `idtoad` VALUES (450225, 45, 2, 25, '广西', '柳州', '融水苗族自治县', 1);
INSERT INTO `idtoad` VALUES (450226, 45, 2, 26, '广西', '柳州', '三江侗族自治县', 1);
INSERT INTO `idtoad` VALUES (450300, 45, 3, 0, '广西', '桂林市', '', 0);
INSERT INTO `idtoad` VALUES (450301, 45, 3, 1, '广西', '桂林市', '辖区', 0);
INSERT INTO `idtoad` VALUES (450302, 45, 3, 2, '广西', '桂林', '秀峰区', 1);
INSERT INTO `idtoad` VALUES (450303, 45, 3, 3, '广西', '桂林', '叠彩区', 1);
INSERT INTO `idtoad` VALUES (450304, 45, 3, 4, '广西', '桂林', '象山区', 1);
INSERT INTO `idtoad` VALUES (450305, 45, 3, 5, '广西', '桂林', '七星区', 1);
INSERT INTO `idtoad` VALUES (450311, 45, 3, 11, '广西', '桂林', '雁山区', 1);
INSERT INTO `idtoad` VALUES (450312, 45, 3, 12, '广西', '桂林', '临桂区', 1);
INSERT INTO `idtoad` VALUES (450321, 45, 3, 21, '广西', '桂林', '阳朔县', 1);
INSERT INTO `idtoad` VALUES (450322, 45, 3, 22, '广西', '桂林市', '临桂县', 0);
INSERT INTO `idtoad` VALUES (450323, 45, 3, 23, '广西', '桂林', '灵川县', 1);
INSERT INTO `idtoad` VALUES (450324, 45, 3, 24, '广西', '桂林', '全州县', 1);
INSERT INTO `idtoad` VALUES (450325, 45, 3, 25, '广西', '桂林', '兴安县', 1);
INSERT INTO `idtoad` VALUES (450326, 45, 3, 26, '广西', '桂林', '永福县', 1);
INSERT INTO `idtoad` VALUES (450327, 45, 3, 27, '广西', '桂林', '灌阳县', 1);
INSERT INTO `idtoad` VALUES (450328, 45, 3, 28, '广西', '桂林', '龙胜各族自治县', 1);
INSERT INTO `idtoad` VALUES (450329, 45, 3, 29, '广西', '桂林', '资源县', 1);
INSERT INTO `idtoad` VALUES (450330, 45, 3, 30, '广西', '桂林', '平乐县', 1);
INSERT INTO `idtoad` VALUES (450331, 45, 3, 31, '广西', '桂林', '荔浦县', 0);
INSERT INTO `idtoad` VALUES (450332, 45, 3, 32, '广西', '桂林', '恭城瑶族自治县', 1);
INSERT INTO `idtoad` VALUES (450381, 45, 3, 81, '广西', '桂林', '荔浦市', 1);
INSERT INTO `idtoad` VALUES (450400, 45, 4, 0, '广西', '梧州市', '', 0);
INSERT INTO `idtoad` VALUES (450401, 45, 4, 1, '广西', '梧州市', '辖区', 0);
INSERT INTO `idtoad` VALUES (450403, 45, 4, 3, '广西', '梧州', '万秀区', 1);
INSERT INTO `idtoad` VALUES (450404, 45, 4, 4, '广西', '梧州市', '蝶山区', 0);
INSERT INTO `idtoad` VALUES (450405, 45, 4, 5, '广西', '梧州', '长洲区', 1);
INSERT INTO `idtoad` VALUES (450406, 45, 4, 6, '广西', '梧州', '龙圩区', 1);
INSERT INTO `idtoad` VALUES (450411, 45, 4, 11, '广西', '梧州市', '市郊区', 0);
INSERT INTO `idtoad` VALUES (450421, 45, 4, 21, '广西', '梧州', '苍梧县', 1);
INSERT INTO `idtoad` VALUES (450422, 45, 4, 22, '广西', '梧州', '藤县', 1);
INSERT INTO `idtoad` VALUES (450423, 45, 4, 23, '广西', '梧州', '蒙山县', 1);
INSERT INTO `idtoad` VALUES (450481, 45, 4, 81, '广西', '梧州', '岑溪市', 1);
INSERT INTO `idtoad` VALUES (450500, 45, 5, 0, '广西', '北海市', '', 0);
INSERT INTO `idtoad` VALUES (450501, 45, 5, 1, '广西', '北海市', '辖区', 0);
INSERT INTO `idtoad` VALUES (450502, 45, 5, 2, '广西', '北海', '海城区', 1);
INSERT INTO `idtoad` VALUES (450503, 45, 5, 3, '广西', '北海', '银海区', 1);
INSERT INTO `idtoad` VALUES (450512, 45, 5, 12, '广西', '北海', '铁山港区', 1);
INSERT INTO `idtoad` VALUES (450521, 45, 5, 21, '广西', '北海', '合浦县', 1);
INSERT INTO `idtoad` VALUES (450600, 45, 6, 0, '广西', '防城港市', '', 0);
INSERT INTO `idtoad` VALUES (450601, 45, 6, 1, '广西', '防城港市', '辖区', 0);
INSERT INTO `idtoad` VALUES (450602, 45, 6, 2, '广西', '防城港', '港口区', 1);
INSERT INTO `idtoad` VALUES (450603, 45, 6, 3, '广西', '防城港', '防城区', 1);
INSERT INTO `idtoad` VALUES (450621, 45, 6, 21, '广西', '防城港', '上思县', 1);
INSERT INTO `idtoad` VALUES (450681, 45, 6, 81, '广西', '防城港', '东兴市', 1);
INSERT INTO `idtoad` VALUES (450700, 45, 7, 0, '广西', '钦州市', '', 0);
INSERT INTO `idtoad` VALUES (450701, 45, 7, 1, '广西', '钦州市', '辖区', 0);
INSERT INTO `idtoad` VALUES (450702, 45, 7, 2, '广西', '钦州', '钦南区', 1);
INSERT INTO `idtoad` VALUES (450703, 45, 7, 3, '广西', '钦州', '钦北区', 1);
INSERT INTO `idtoad` VALUES (450721, 45, 7, 21, '广西', '钦州', '灵山县', 1);
INSERT INTO `idtoad` VALUES (450722, 45, 7, 22, '广西', '钦州', '浦北县', 1);
INSERT INTO `idtoad` VALUES (450800, 45, 8, 0, '广西', '贵港市', '', 0);
INSERT INTO `idtoad` VALUES (450801, 45, 8, 1, '广西', '贵港市', '辖区', 0);
INSERT INTO `idtoad` VALUES (450802, 45, 8, 2, '广西', '贵港', '港北区', 1);
INSERT INTO `idtoad` VALUES (450803, 45, 8, 3, '广西', '贵港', '港南区', 1);
INSERT INTO `idtoad` VALUES (450804, 45, 8, 4, '广西', '贵港', '覃塘区', 1);
INSERT INTO `idtoad` VALUES (450821, 45, 8, 21, '广西', '贵港', '平南县', 1);
INSERT INTO `idtoad` VALUES (450881, 45, 8, 81, '广西', '贵港', '桂平市', 1);
INSERT INTO `idtoad` VALUES (450900, 45, 9, 0, '广西', '玉林市', '', 0);
INSERT INTO `idtoad` VALUES (450901, 45, 9, 1, '广西', '玉林市', '辖区', 0);
INSERT INTO `idtoad` VALUES (450902, 45, 9, 2, '广西', '玉林', '玉州区', 1);
INSERT INTO `idtoad` VALUES (450903, 45, 9, 3, '广西', '玉林', '福绵区', 1);
INSERT INTO `idtoad` VALUES (450921, 45, 9, 21, '广西', '玉林', '容县', 1);
INSERT INTO `idtoad` VALUES (450922, 45, 9, 22, '广西', '玉林', '陆川县', 1);
INSERT INTO `idtoad` VALUES (450923, 45, 9, 23, '广西', '玉林', '博白县', 1);
INSERT INTO `idtoad` VALUES (450924, 45, 9, 24, '广西', '玉林', '兴业县', 1);
INSERT INTO `idtoad` VALUES (450981, 45, 9, 81, '广西', '玉林', '北流市', 1);
INSERT INTO `idtoad` VALUES (451002, 45, 10, 2, '广西', '百色', '右江区', 1);
INSERT INTO `idtoad` VALUES (451003, 45, 10, 3, '广西', '百色', '田阳区', 1);
INSERT INTO `idtoad` VALUES (451021, 45, 10, 21, '广西', '百色', '田阳县', 0);
INSERT INTO `idtoad` VALUES (451022, 45, 10, 22, '广西', '百色', '田东县', 1);
INSERT INTO `idtoad` VALUES (451023, 45, 10, 23, '广西', '百色', '平果县', 0);
INSERT INTO `idtoad` VALUES (451024, 45, 10, 24, '广西', '百色', '德保县', 1);
INSERT INTO `idtoad` VALUES (451026, 45, 10, 26, '广西', '百色', '那坡县', 1);
INSERT INTO `idtoad` VALUES (451027, 45, 10, 27, '广西', '百色', '凌云县', 1);
INSERT INTO `idtoad` VALUES (451028, 45, 10, 28, '广西', '百色', '乐业县', 1);
INSERT INTO `idtoad` VALUES (451029, 45, 10, 29, '广西', '百色', '田林县', 1);
INSERT INTO `idtoad` VALUES (451030, 45, 10, 30, '广西', '百色', '西林县', 1);
INSERT INTO `idtoad` VALUES (451031, 45, 10, 31, '广西', '百色', '隆林各族自治县', 1);
INSERT INTO `idtoad` VALUES (451081, 45, 10, 81, '广西', '百色', '靖西市', 1);
INSERT INTO `idtoad` VALUES (451082, 45, 10, 82, '广西', '百色', '平果市', 1);
INSERT INTO `idtoad` VALUES (451102, 45, 11, 2, '广西', '贺州', '八步区', 1);
INSERT INTO `idtoad` VALUES (451103, 45, 11, 3, '广西', '贺州', '平桂区', 1);
INSERT INTO `idtoad` VALUES (451121, 45, 11, 21, '广西', '贺州', '昭平县', 1);
INSERT INTO `idtoad` VALUES (451122, 45, 11, 22, '广西', '贺州', '钟山县', 1);
INSERT INTO `idtoad` VALUES (451123, 45, 11, 23, '广西', '贺州', '富川瑶族自治县', 1);
INSERT INTO `idtoad` VALUES (451202, 45, 12, 2, '广西', '河池', '金城江区', 1);
INSERT INTO `idtoad` VALUES (451203, 45, 12, 3, '广西', '河池', '宜州区', 1);
INSERT INTO `idtoad` VALUES (451221, 45, 12, 21, '广西', '河池', '南丹县', 1);
INSERT INTO `idtoad` VALUES (451222, 45, 12, 22, '广西', '河池', '天峨县', 1);
INSERT INTO `idtoad` VALUES (451223, 45, 12, 23, '广西', '河池', '凤山县', 1);
INSERT INTO `idtoad` VALUES (451224, 45, 12, 24, '广西', '河池', '东兰县', 1);
INSERT INTO `idtoad` VALUES (451225, 45, 12, 25, '广西', '河池', '罗城仫佬族自治县', 1);
INSERT INTO `idtoad` VALUES (451226, 45, 12, 26, '广西', '河池', '环江毛南族自治县', 1);
INSERT INTO `idtoad` VALUES (451227, 45, 12, 27, '广西', '河池', '巴马瑶族自治县', 1);
INSERT INTO `idtoad` VALUES (451228, 45, 12, 28, '广西', '河池', '都安瑶族自治县', 1);
INSERT INTO `idtoad` VALUES (451229, 45, 12, 29, '广西', '河池', '大化瑶族自治县', 1);
INSERT INTO `idtoad` VALUES (451302, 45, 13, 2, '广西', '来宾', '兴宾区', 1);
INSERT INTO `idtoad` VALUES (451321, 45, 13, 21, '广西', '来宾', '忻城县', 1);
INSERT INTO `idtoad` VALUES (451322, 45, 13, 22, '广西', '来宾', '象州县', 1);
INSERT INTO `idtoad` VALUES (451323, 45, 13, 23, '广西', '来宾', '武宣县', 1);
INSERT INTO `idtoad` VALUES (451324, 45, 13, 24, '广西', '来宾', '金秀瑶族自治县', 1);
INSERT INTO `idtoad` VALUES (451381, 45, 13, 81, '广西', '来宾', '合山市', 1);
INSERT INTO `idtoad` VALUES (451402, 45, 14, 2, '广西', '崇左', '江州区', 1);
INSERT INTO `idtoad` VALUES (451421, 45, 14, 21, '广西', '崇左', '扶绥县', 1);
INSERT INTO `idtoad` VALUES (451422, 45, 14, 22, '广西', '崇左', '宁明县', 1);
INSERT INTO `idtoad` VALUES (451423, 45, 14, 23, '广西', '崇左', '龙州县', 1);
INSERT INTO `idtoad` VALUES (451424, 45, 14, 24, '广西', '崇左', '大新县', 1);
INSERT INTO `idtoad` VALUES (451425, 45, 14, 25, '广西', '崇左', '天等县', 1);
INSERT INTO `idtoad` VALUES (451481, 45, 14, 81, '广西', '崇左', '凭祥市', 1);
INSERT INTO `idtoad` VALUES (452100, 45, 21, 0, '广西', '南宁地区', '', 0);
INSERT INTO `idtoad` VALUES (452101, 45, 21, 1, '广西', '南宁地区', '凭祥市', 0);
INSERT INTO `idtoad` VALUES (452122, 45, 21, 22, '广西', '南宁地区', '横县', 0);
INSERT INTO `idtoad` VALUES (452123, 45, 21, 23, '广西', '南宁地区', '宾阳县', 0);
INSERT INTO `idtoad` VALUES (452124, 45, 21, 24, '广西', '南宁地区', '上林县', 0);
INSERT INTO `idtoad` VALUES (452126, 45, 21, 26, '广西', '南宁地区', '隆安县', 0);
INSERT INTO `idtoad` VALUES (452127, 45, 21, 27, '广西', '南宁地区', '马山县', 0);
INSERT INTO `idtoad` VALUES (452128, 45, 21, 28, '广西', '南宁地区', '扶绥县', 0);
INSERT INTO `idtoad` VALUES (452129, 45, 21, 29, '广西', '南宁地区', '崇左县', 0);
INSERT INTO `idtoad` VALUES (452130, 45, 21, 30, '广西', '南宁地区', '大新县', 0);
INSERT INTO `idtoad` VALUES (452131, 45, 21, 31, '广西', '南宁地区', '天等县', 0);
INSERT INTO `idtoad` VALUES (452132, 45, 21, 32, '广西', '南宁地区', '宁明县', 0);
INSERT INTO `idtoad` VALUES (452133, 45, 21, 33, '广西', '南宁地区', '龙州县', 0);
INSERT INTO `idtoad` VALUES (452200, 45, 22, 0, '广西', '柳州地区', '', 0);
INSERT INTO `idtoad` VALUES (452201, 45, 22, 1, '广西', '柳州地区', '合山市', 0);
INSERT INTO `idtoad` VALUES (452223, 45, 22, 23, '广西', '柳州地区', '鹿寨县', 0);
INSERT INTO `idtoad` VALUES (452224, 45, 22, 24, '广西', '柳州地区', '象州县', 0);
INSERT INTO `idtoad` VALUES (452225, 45, 22, 25, '广西', '柳州地区', '武宣县', 0);
INSERT INTO `idtoad` VALUES (452226, 45, 22, 26, '广西', '柳州地区', '来宾县', 0);
INSERT INTO `idtoad` VALUES (452227, 45, 22, 27, '广西', '柳州地区', '融安县', 0);
INSERT INTO `idtoad` VALUES (452228, 45, 22, 28, '广西', '柳州地区', '三江侗族自治县', 0);
INSERT INTO `idtoad` VALUES (452229, 45, 22, 29, '广西', '柳州地区', '融水苗族自治县', 0);
INSERT INTO `idtoad` VALUES (452230, 45, 22, 30, '广西', '柳州地区', '金秀瑶族自治县', 0);
INSERT INTO `idtoad` VALUES (452231, 45, 22, 31, '广西', '柳州地区', '忻城县', 0);
INSERT INTO `idtoad` VALUES (452400, 45, 24, 0, '广西', '贺州地区', '', 0);
INSERT INTO `idtoad` VALUES (452402, 45, 24, 2, '广西', '贺州地区', '贺州市', 0);
INSERT INTO `idtoad` VALUES (452424, 45, 24, 24, '广西', '贺州地区', '昭平县', 0);
INSERT INTO `idtoad` VALUES (452427, 45, 24, 27, '广西', '贺州地区', '钟山县', 0);
INSERT INTO `idtoad` VALUES (452428, 45, 24, 28, '广西', '贺州地区', '富川瑶族自治县', 0);
INSERT INTO `idtoad` VALUES (452600, 45, 26, 0, '广西', '百色地区', '', 0);
INSERT INTO `idtoad` VALUES (452601, 45, 26, 1, '广西', '百色地区', '百色市', 0);
INSERT INTO `idtoad` VALUES (452622, 45, 26, 22, '广西', '百色地区', '田阳县', 0);
INSERT INTO `idtoad` VALUES (452623, 45, 26, 23, '广西', '百色地区', '田东县', 0);
INSERT INTO `idtoad` VALUES (452624, 45, 26, 24, '广西', '百色地区', '平果县', 0);
INSERT INTO `idtoad` VALUES (452625, 45, 26, 25, '广西', '百色地区', '德保县', 0);
INSERT INTO `idtoad` VALUES (452626, 45, 26, 26, '广西', '百色地区', '靖西县', 0);
INSERT INTO `idtoad` VALUES (452627, 45, 26, 27, '广西', '百色地区', '那坡县', 0);
INSERT INTO `idtoad` VALUES (452628, 45, 26, 28, '广西', '百色地区', '凌云县', 0);
INSERT INTO `idtoad` VALUES (452629, 45, 26, 29, '广西', '百色地区', '乐业县', 0);
INSERT INTO `idtoad` VALUES (452630, 45, 26, 30, '广西', '百色地区', '田林县', 0);
INSERT INTO `idtoad` VALUES (452631, 45, 26, 31, '广西', '百色地区', '隆林各族自治县', 0);
INSERT INTO `idtoad` VALUES (452632, 45, 26, 32, '广西', '百色地区', '西林县', 0);
INSERT INTO `idtoad` VALUES (452700, 45, 27, 0, '广西', '河池地区', '', 0);
INSERT INTO `idtoad` VALUES (452701, 45, 27, 1, '广西', '河池地区', '河池市', 0);
INSERT INTO `idtoad` VALUES (452702, 45, 27, 2, '广西', '河池地区', '宜州市', 0);
INSERT INTO `idtoad` VALUES (452723, 45, 27, 23, '广西', '河池地区', '罗城仫佬族自治县', 0);
INSERT INTO `idtoad` VALUES (452724, 45, 27, 24, '广西', '河池地区', '环江毛南族自治县', 0);
INSERT INTO `idtoad` VALUES (452725, 45, 27, 25, '广西', '河池地区', '南丹县', 0);
INSERT INTO `idtoad` VALUES (452726, 45, 27, 26, '广西', '河池地区', '天峨县', 0);
INSERT INTO `idtoad` VALUES (452727, 45, 27, 27, '广西', '河池地区', '凤山县', 0);
INSERT INTO `idtoad` VALUES (452728, 45, 27, 28, '广西', '河池地区', '东兰县', 0);
INSERT INTO `idtoad` VALUES (452729, 45, 27, 29, '广西', '河池地区', '巴马瑶族自治县', 0);
INSERT INTO `idtoad` VALUES (452730, 45, 27, 30, '广西', '河池地区', '都安瑶族自治县', 0);
INSERT INTO `idtoad` VALUES (452731, 45, 27, 31, '广西', '河池地区', '大化瑶族自治县', 0);
INSERT INTO `idtoad` VALUES (460000, 46, 0, 0, '海南', '', '', 0);
INSERT INTO `idtoad` VALUES (460001, 46, 0, 1, '海南', '三亚', '通什市', 0);
INSERT INTO `idtoad` VALUES (460002, 46, 0, 2, '海南', '三亚', '琼海市', 0);
INSERT INTO `idtoad` VALUES (460003, 46, 0, 3, '海南', '三亚', '儋州市', 0);
INSERT INTO `idtoad` VALUES (460004, 46, 0, 4, '海南', '三亚', '琼山市', 0);
INSERT INTO `idtoad` VALUES (460005, 46, 0, 5, '海南', '三亚', '文昌市', 0);
INSERT INTO `idtoad` VALUES (460006, 46, 0, 6, '海南', '三亚', '万宁市', 0);
INSERT INTO `idtoad` VALUES (460007, 46, 0, 7, '海南', '三亚', '东方市', 0);
INSERT INTO `idtoad` VALUES (460025, 46, 0, 25, '海南', '三亚', '定安县', 0);
INSERT INTO `idtoad` VALUES (460026, 46, 0, 26, '海南', '三亚', '屯昌县', 0);
INSERT INTO `idtoad` VALUES (460027, 46, 0, 27, '海南', '三亚', '澄迈县', 0);
INSERT INTO `idtoad` VALUES (460028, 46, 0, 28, '海南', '三亚', '临高县', 0);
INSERT INTO `idtoad` VALUES (460030, 46, 0, 30, '海南', '三亚', '白沙黎族自治县', 0);
INSERT INTO `idtoad` VALUES (460031, 46, 0, 31, '海南', '三亚', '昌江黎族自治县', 0);
INSERT INTO `idtoad` VALUES (460033, 46, 0, 33, '海南', '三亚', '乐东黎族自治县', 0);
INSERT INTO `idtoad` VALUES (460034, 46, 0, 34, '海南', '三亚', '陵水黎族自治县', 0);
INSERT INTO `idtoad` VALUES (460035, 46, 0, 35, '海南', '三亚', '保亭黎族苗族自治县', 0);
INSERT INTO `idtoad` VALUES (460036, 46, 0, 36, '海南', '三亚', '琼中黎族苗族自治县', 0);
INSERT INTO `idtoad` VALUES (460037, 46, 0, 37, '海南', '西沙群岛', '西沙群岛', 0);
INSERT INTO `idtoad` VALUES (460038, 46, 0, 38, '海南', '南沙群岛', '南沙群岛', 0);
INSERT INTO `idtoad` VALUES (460039, 46, 0, 39, '海南', '中沙群岛的岛礁及其海域', '中沙群岛的岛礁及其海域', 0);
INSERT INTO `idtoad` VALUES (460100, 46, 1, 0, '海南', '海口', '', 0);
INSERT INTO `idtoad` VALUES (460101, 46, 1, 1, '海南', '海口', '市辖区', 0);
INSERT INTO `idtoad` VALUES (460102, 46, 1, 2, '海南', '海口', '振东区', 0);
INSERT INTO `idtoad` VALUES (460103, 46, 1, 3, '海南', '海口', '新华区', 0);
INSERT INTO `idtoad` VALUES (460104, 46, 1, 4, '海南', '海口', '秀英区', 0);
INSERT INTO `idtoad` VALUES (460105, 46, 1, 5, '海南', '海口', '秀英区', 1);
INSERT INTO `idtoad` VALUES (460106, 46, 1, 6, '海南', '海口', '龙华区', 1);
INSERT INTO `idtoad` VALUES (460107, 46, 1, 7, '海南', '海口', '琼山区', 1);
INSERT INTO `idtoad` VALUES (460108, 46, 1, 8, '海南', '海口', '美兰区', 1);
INSERT INTO `idtoad` VALUES (460200, 46, 2, 0, '海南', '三亚', '三亚', 1);
INSERT INTO `idtoad` VALUES (460201, 46, 2, 1, '海南', '三亚', '市辖区', 0);
INSERT INTO `idtoad` VALUES (460202, 46, 2, 2, '海南', '三亚', '海棠区', 1);
INSERT INTO `idtoad` VALUES (460203, 46, 2, 3, '海南', '三亚', '吉阳区', 1);
INSERT INTO `idtoad` VALUES (460204, 46, 2, 4, '海南', '三亚', '天涯区', 1);
INSERT INTO `idtoad` VALUES (460205, 46, 2, 5, '海南', '三亚', '崖州区', 1);
INSERT INTO `idtoad` VALUES (460300, 46, 3, 0, '海南', '三沙', '三沙', 1);
INSERT INTO `idtoad` VALUES (460400, 46, 4, 0, '海南', '儋州', '儋州', 1);
INSERT INTO `idtoad` VALUES (469001, 46, 90, 1, '海南', '五指山', '五指山', 1);
INSERT INTO `idtoad` VALUES (469002, 46, 90, 2, '海南', '琼海', '琼海', 1);
INSERT INTO `idtoad` VALUES (469005, 46, 90, 5, '海南', '文昌', '文昌', 1);
INSERT INTO `idtoad` VALUES (469006, 46, 90, 6, '海南', '万宁', '万宁', 1);
INSERT INTO `idtoad` VALUES (469007, 46, 90, 7, '海南', '东方', '东方', 1);
INSERT INTO `idtoad` VALUES (469021, 46, 90, 21, '海南', '定安县', '定安县', 1);
INSERT INTO `idtoad` VALUES (469022, 46, 90, 22, '海南', '屯昌县', '屯昌县', 1);
INSERT INTO `idtoad` VALUES (469023, 46, 90, 23, '海南', '澄迈县', '澄迈县', 1);
INSERT INTO `idtoad` VALUES (469024, 46, 90, 24, '海南', '临高县', '临高县', 1);
INSERT INTO `idtoad` VALUES (469025, 46, 90, 25, '海南', '白沙黎族自治县', '白沙黎族自治县', 1);
INSERT INTO `idtoad` VALUES (469026, 46, 90, 26, '海南', '昌江黎族自治县', '昌江黎族自治县', 1);
INSERT INTO `idtoad` VALUES (469027, 46, 90, 27, '海南', '乐东黎族自治县', '乐东黎族自治县', 1);
INSERT INTO `idtoad` VALUES (469028, 46, 90, 28, '海南', '陵水黎族自治县', '陵水黎族自治县', 1);
INSERT INTO `idtoad` VALUES (469029, 46, 90, 29, '海南', '保亭黎族苗族自治县', '保亭黎族苗族自治县', 1);
INSERT INTO `idtoad` VALUES (469030, 46, 90, 30, '海南', '琼中黎族苗族自治县', '琼中黎族苗族自治县', 1);
INSERT INTO `idtoad` VALUES (500000, 50, 0, 0, '重庆', '', '', 0);
INSERT INTO `idtoad` VALUES (500100, 50, 1, 0, '重庆', '市辖区', '', 0);
INSERT INTO `idtoad` VALUES (500101, 50, 1, 1, '重庆', '重庆', '万州区', 1);
INSERT INTO `idtoad` VALUES (500102, 50, 1, 2, '重庆', '重庆', '涪陵区', 1);
INSERT INTO `idtoad` VALUES (500103, 50, 1, 3, '重庆', '重庆', '渝中区', 1);
INSERT INTO `idtoad` VALUES (500104, 50, 1, 4, '重庆', '重庆', '大渡口区', 1);
INSERT INTO `idtoad` VALUES (500105, 50, 1, 5, '重庆', '重庆', '江北区', 1);
INSERT INTO `idtoad` VALUES (500106, 50, 1, 6, '重庆', '重庆', '沙坪坝区', 1);
INSERT INTO `idtoad` VALUES (500107, 50, 1, 7, '重庆', '重庆', '九龙坡区', 1);
INSERT INTO `idtoad` VALUES (500108, 50, 1, 8, '重庆', '重庆', '南岸区', 1);
INSERT INTO `idtoad` VALUES (500109, 50, 1, 9, '重庆', '重庆', '北碚区', 1);
INSERT INTO `idtoad` VALUES (500110, 50, 1, 10, '重庆', '重庆', '綦江区', 1);
INSERT INTO `idtoad` VALUES (500111, 50, 1, 11, '重庆', '重庆', '大足区', 1);
INSERT INTO `idtoad` VALUES (500112, 50, 1, 12, '重庆', '重庆', '渝北区', 1);
INSERT INTO `idtoad` VALUES (500113, 50, 1, 13, '重庆', '重庆', '巴南区', 1);
INSERT INTO `idtoad` VALUES (500114, 50, 1, 14, '重庆', '重庆', '黔江区', 1);
INSERT INTO `idtoad` VALUES (500115, 50, 1, 15, '重庆', '重庆', '长寿区', 1);
INSERT INTO `idtoad` VALUES (500116, 50, 1, 16, '重庆', '重庆', '江津区', 1);
INSERT INTO `idtoad` VALUES (500117, 50, 1, 17, '重庆', '重庆', '合川区', 1);
INSERT INTO `idtoad` VALUES (500118, 50, 1, 18, '重庆', '重庆', '永川区', 1);
INSERT INTO `idtoad` VALUES (500119, 50, 1, 19, '重庆', '重庆', '南川区', 1);
INSERT INTO `idtoad` VALUES (500120, 50, 1, 20, '重庆', '重庆', '璧山区', 1);
INSERT INTO `idtoad` VALUES (500151, 50, 1, 51, '重庆', '重庆', '铜梁区', 1);
INSERT INTO `idtoad` VALUES (500152, 50, 1, 52, '重庆', '重庆', '潼南区', 1);
INSERT INTO `idtoad` VALUES (500153, 50, 1, 53, '重庆', '重庆', '荣昌区', 1);
INSERT INTO `idtoad` VALUES (500154, 50, 1, 54, '重庆', '重庆', '开州区', 1);
INSERT INTO `idtoad` VALUES (500155, 50, 1, 55, '重庆', '重庆', '梁平区', 1);
INSERT INTO `idtoad` VALUES (500156, 50, 1, 56, '重庆', '重庆', '武隆区', 1);
INSERT INTO `idtoad` VALUES (500200, 50, 2, 0, '重庆', '市县', '', 0);
INSERT INTO `idtoad` VALUES (500221, 50, 2, 21, '重庆', '重庆', '长寿县', 0);
INSERT INTO `idtoad` VALUES (500222, 50, 2, 22, '重庆', '重庆', '綦江县', 0);
INSERT INTO `idtoad` VALUES (500223, 50, 2, 23, '重庆', '重庆', '潼南县', 0);
INSERT INTO `idtoad` VALUES (500224, 50, 2, 24, '重庆', '重庆', '铜梁县', 0);
INSERT INTO `idtoad` VALUES (500225, 50, 2, 25, '重庆', '重庆', '大足县', 0);
INSERT INTO `idtoad` VALUES (500226, 50, 2, 26, '重庆', '重庆', '荣昌县', 0);
INSERT INTO `idtoad` VALUES (500227, 50, 2, 27, '重庆', '重庆', '璧山县', 0);
INSERT INTO `idtoad` VALUES (500228, 50, 2, 28, '重庆', '重庆', '梁平县', 0);
INSERT INTO `idtoad` VALUES (500229, 50, 2, 29, '重庆', '重庆', '城口县', 1);
INSERT INTO `idtoad` VALUES (500230, 50, 2, 30, '重庆', '重庆', '丰都县', 1);
INSERT INTO `idtoad` VALUES (500231, 50, 2, 31, '重庆', '重庆', '垫江县', 1);
INSERT INTO `idtoad` VALUES (500232, 50, 2, 32, '重庆', '重庆', '武隆县', 0);
INSERT INTO `idtoad` VALUES (500233, 50, 2, 33, '重庆', '重庆', '忠县', 1);
INSERT INTO `idtoad` VALUES (500234, 50, 2, 34, '重庆', '重庆', '开县', 0);
INSERT INTO `idtoad` VALUES (500235, 50, 2, 35, '重庆', '重庆', '云阳县', 1);
INSERT INTO `idtoad` VALUES (500236, 50, 2, 36, '重庆', '重庆', '奉节县', 1);
INSERT INTO `idtoad` VALUES (500237, 50, 2, 37, '重庆', '重庆', '巫山县', 1);
INSERT INTO `idtoad` VALUES (500238, 50, 2, 38, '重庆', '重庆', '巫溪县', 1);
INSERT INTO `idtoad` VALUES (500239, 50, 2, 39, '重庆', '重庆', '黔江土家族苗族自治县', 0);
INSERT INTO `idtoad` VALUES (500240, 50, 2, 40, '重庆', '重庆', '石柱土家族自治县', 1);
INSERT INTO `idtoad` VALUES (500241, 50, 2, 41, '重庆', '重庆', '秀山土家族苗族自治县', 1);
INSERT INTO `idtoad` VALUES (500242, 50, 2, 42, '重庆', '重庆', '酉阳土家族苗族自治县', 1);
INSERT INTO `idtoad` VALUES (500243, 50, 2, 43, '重庆', '重庆', '彭水苗族土家族自治县', 1);
INSERT INTO `idtoad` VALUES (500300, 50, 3, 0, '重庆', '市', '', 0);
INSERT INTO `idtoad` VALUES (500381, 50, 3, 81, '重庆', '重庆', '江津市', 0);
INSERT INTO `idtoad` VALUES (500382, 50, 3, 82, '重庆', '重庆', '合川市', 0);
INSERT INTO `idtoad` VALUES (500383, 50, 3, 83, '重庆', '重庆', '永川市', 0);
INSERT INTO `idtoad` VALUES (500384, 50, 3, 84, '重庆', '重庆', '南川市', 0);
INSERT INTO `idtoad` VALUES (510000, 51, 0, 0, '四川', '', '', 0);
INSERT INTO `idtoad` VALUES (510100, 51, 1, 0, '四川', '成都', '', 0);
INSERT INTO `idtoad` VALUES (510101, 51, 1, 1, '四川', '成都', '市辖区', 0);
INSERT INTO `idtoad` VALUES (510104, 51, 1, 4, '四川', '成都', '锦江区', 1);
INSERT INTO `idtoad` VALUES (510105, 51, 1, 5, '四川', '成都', '青羊区', 1);
INSERT INTO `idtoad` VALUES (510106, 51, 1, 6, '四川', '成都', '金牛区', 1);
INSERT INTO `idtoad` VALUES (510107, 51, 1, 7, '四川', '成都', '武侯区', 1);
INSERT INTO `idtoad` VALUES (510108, 51, 1, 8, '四川', '成都', '成华区', 1);
INSERT INTO `idtoad` VALUES (510112, 51, 1, 12, '四川', '成都', '龙泉驿区', 1);
INSERT INTO `idtoad` VALUES (510113, 51, 1, 13, '四川', '成都', '青白江区', 1);
INSERT INTO `idtoad` VALUES (510114, 51, 1, 14, '四川', '成都', '新都区', 1);
INSERT INTO `idtoad` VALUES (510115, 51, 1, 15, '四川', '成都', '温江区', 1);
INSERT INTO `idtoad` VALUES (510116, 51, 1, 16, '四川', '成都', '双流区', 1);
INSERT INTO `idtoad` VALUES (510117, 51, 1, 17, '四川', '成都', '郫都区', 1);
INSERT INTO `idtoad` VALUES (510118, 51, 1, 18, '四川', '成都', '新津区', 1);
INSERT INTO `idtoad` VALUES (510121, 51, 1, 21, '四川', '成都', '金堂县', 1);
INSERT INTO `idtoad` VALUES (510122, 51, 1, 22, '四川', '成都', '双流县', 0);
INSERT INTO `idtoad` VALUES (510123, 51, 1, 23, '四川', '成都', '温江县', 0);
INSERT INTO `idtoad` VALUES (510124, 51, 1, 24, '四川', '成都', '郫县', 0);
INSERT INTO `idtoad` VALUES (510125, 51, 1, 25, '四川', '成都', '新都县', 0);
INSERT INTO `idtoad` VALUES (510129, 51, 1, 29, '四川', '成都', '大邑县', 1);
INSERT INTO `idtoad` VALUES (510131, 51, 1, 31, '四川', '成都', '蒲江县', 1);
INSERT INTO `idtoad` VALUES (510132, 51, 1, 32, '四川', '成都', '新津县', 0);
INSERT INTO `idtoad` VALUES (510181, 51, 1, 81, '四川', '成都', '都江堰市', 1);
INSERT INTO `idtoad` VALUES (510182, 51, 1, 82, '四川', '成都', '彭州市', 1);
INSERT INTO `idtoad` VALUES (510183, 51, 1, 83, '四川', '成都', '邛崃市', 1);
INSERT INTO `idtoad` VALUES (510184, 51, 1, 84, '四川', '成都', '崇州市', 1);
INSERT INTO `idtoad` VALUES (510185, 51, 1, 85, '四川', '成都', '简阳市', 1);
INSERT INTO `idtoad` VALUES (510300, 51, 3, 0, '四川', '自贡', '', 0);
INSERT INTO `idtoad` VALUES (510301, 51, 3, 1, '四川', '自贡', '市辖区', 0);
INSERT INTO `idtoad` VALUES (510302, 51, 3, 2, '四川', '自贡', '自流井区', 1);
INSERT INTO `idtoad` VALUES (510303, 51, 3, 3, '四川', '自贡', '贡井区', 1);
INSERT INTO `idtoad` VALUES (510304, 51, 3, 4, '四川', '自贡', '大安区', 1);
INSERT INTO `idtoad` VALUES (510311, 51, 3, 11, '四川', '自贡', '沿滩区', 1);
INSERT INTO `idtoad` VALUES (510321, 51, 3, 21, '四川', '自贡', '荣县', 1);
INSERT INTO `idtoad` VALUES (510322, 51, 3, 22, '四川', '自贡', '富顺县', 1);
INSERT INTO `idtoad` VALUES (510400, 51, 4, 0, '四川', '攀枝花', '', 0);
INSERT INTO `idtoad` VALUES (510401, 51, 4, 1, '四川', '攀枝花', '市辖区', 0);
INSERT INTO `idtoad` VALUES (510402, 51, 4, 2, '四川', '攀枝花', '东区', 1);
INSERT INTO `idtoad` VALUES (510403, 51, 4, 3, '四川', '攀枝花', '西区', 1);
INSERT INTO `idtoad` VALUES (510411, 51, 4, 11, '四川', '攀枝花', '仁和区', 1);
INSERT INTO `idtoad` VALUES (510421, 51, 4, 21, '四川', '攀枝花', '米易县', 1);
INSERT INTO `idtoad` VALUES (510422, 51, 4, 22, '四川', '攀枝花', '盐边县', 1);
INSERT INTO `idtoad` VALUES (510500, 51, 5, 0, '四川', '泸州', '', 0);
INSERT INTO `idtoad` VALUES (510501, 51, 5, 1, '四川', '泸州', '市辖区', 0);
INSERT INTO `idtoad` VALUES (510502, 51, 5, 2, '四川', '泸州', '江阳区', 1);
INSERT INTO `idtoad` VALUES (510503, 51, 5, 3, '四川', '泸州', '纳溪区', 1);
INSERT INTO `idtoad` VALUES (510504, 51, 5, 4, '四川', '泸州', '龙马潭区', 1);
INSERT INTO `idtoad` VALUES (510521, 51, 5, 21, '四川', '泸州', '泸县', 1);
INSERT INTO `idtoad` VALUES (510522, 51, 5, 22, '四川', '泸州', '合江县', 1);
INSERT INTO `idtoad` VALUES (510524, 51, 5, 24, '四川', '泸州', '叙永县', 1);
INSERT INTO `idtoad` VALUES (510525, 51, 5, 25, '四川', '泸州', '古蔺县', 1);
INSERT INTO `idtoad` VALUES (510600, 51, 6, 0, '四川', '德阳', '', 0);
INSERT INTO `idtoad` VALUES (510601, 51, 6, 1, '四川', '德阳', '市辖区', 0);
INSERT INTO `idtoad` VALUES (510603, 51, 6, 3, '四川', '德阳', '旌阳区', 1);
INSERT INTO `idtoad` VALUES (510604, 51, 6, 4, '四川', '德阳', '罗江区', 1);
INSERT INTO `idtoad` VALUES (510623, 51, 6, 23, '四川', '德阳', '中江县', 1);
INSERT INTO `idtoad` VALUES (510626, 51, 6, 26, '四川', '德阳', '罗江区', 0);
INSERT INTO `idtoad` VALUES (510681, 51, 6, 81, '四川', '德阳', '广汉市', 1);
INSERT INTO `idtoad` VALUES (510682, 51, 6, 82, '四川', '德阳', '什邡市', 1);
INSERT INTO `idtoad` VALUES (510683, 51, 6, 83, '四川', '德阳', '绵竹市', 1);
INSERT INTO `idtoad` VALUES (510700, 51, 7, 0, '四川', '绵阳', '绵阳', 1);
INSERT INTO `idtoad` VALUES (510701, 51, 7, 1, '四川', '绵阳', '市辖区', 0);
INSERT INTO `idtoad` VALUES (510703, 51, 7, 3, '四川', '绵阳', '涪城区', 1);
INSERT INTO `idtoad` VALUES (510704, 51, 7, 4, '四川', '绵阳', '游仙区', 1);
INSERT INTO `idtoad` VALUES (510705, 51, 7, 5, '四川', '绵阳', '安州区', 1);
INSERT INTO `idtoad` VALUES (510722, 51, 7, 22, '四川', '绵阳', '三台县', 1);
INSERT INTO `idtoad` VALUES (510723, 51, 7, 23, '四川', '绵阳', '盐亭县', 1);
INSERT INTO `idtoad` VALUES (510724, 51, 7, 24, '四川', '绵阳', '安县', 0);
INSERT INTO `idtoad` VALUES (510725, 51, 7, 25, '四川', '绵阳', '梓潼县', 1);
INSERT INTO `idtoad` VALUES (510726, 51, 7, 26, '四川', '绵阳', '北川羌族自治县', 1);
INSERT INTO `idtoad` VALUES (510727, 51, 7, 27, '四川', '绵阳', '平武县', 1);
INSERT INTO `idtoad` VALUES (510781, 51, 7, 81, '四川', '绵阳', '江油市', 1);
INSERT INTO `idtoad` VALUES (510800, 51, 8, 0, '四川', '广元', '', 0);
INSERT INTO `idtoad` VALUES (510801, 51, 8, 1, '四川', '广元', '市辖区', 0);
INSERT INTO `idtoad` VALUES (510802, 51, 8, 2, '四川', '广元', '利州区', 1);
INSERT INTO `idtoad` VALUES (510811, 51, 8, 11, '四川', '广元', '昭化区', 1);
INSERT INTO `idtoad` VALUES (510812, 51, 8, 12, '四川', '广元', '朝天区', 1);
INSERT INTO `idtoad` VALUES (510821, 51, 8, 21, '四川', '广元', '旺苍县', 1);
INSERT INTO `idtoad` VALUES (510822, 51, 8, 22, '四川', '广元', '青川县', 1);
INSERT INTO `idtoad` VALUES (510823, 51, 8, 23, '四川', '广元', '剑阁县', 1);
INSERT INTO `idtoad` VALUES (510824, 51, 8, 24, '四川', '广元', '苍溪县', 1);
INSERT INTO `idtoad` VALUES (510900, 51, 9, 0, '四川', '遂宁', '', 0);
INSERT INTO `idtoad` VALUES (510901, 51, 9, 1, '四川', '遂宁', '市辖区', 0);
INSERT INTO `idtoad` VALUES (510902, 51, 9, 2, '四川', '遂宁', '市中区', 0);
INSERT INTO `idtoad` VALUES (510903, 51, 9, 3, '四川', '遂宁', '船山区', 1);
INSERT INTO `idtoad` VALUES (510904, 51, 9, 4, '四川', '遂宁', '安居区', 1);
INSERT INTO `idtoad` VALUES (510921, 51, 9, 21, '四川', '遂宁', '蓬溪县', 1);
INSERT INTO `idtoad` VALUES (510922, 51, 9, 22, '四川', '遂宁', '射洪县', 0);
INSERT INTO `idtoad` VALUES (510923, 51, 9, 23, '四川', '遂宁', '大英县', 1);
INSERT INTO `idtoad` VALUES (510981, 51, 9, 81, '四川', '遂宁', '射洪市', 1);
INSERT INTO `idtoad` VALUES (511000, 51, 10, 0, '四川', '内江', '', 0);
INSERT INTO `idtoad` VALUES (511001, 51, 10, 1, '四川', '内江', '市辖区', 0);
INSERT INTO `idtoad` VALUES (511002, 51, 10, 2, '四川', '内江', '市中区', 1);
INSERT INTO `idtoad` VALUES (511011, 51, 10, 11, '四川', '内江', '东兴区', 1);
INSERT INTO `idtoad` VALUES (511024, 51, 10, 24, '四川', '内江', '威远县', 1);
INSERT INTO `idtoad` VALUES (511025, 51, 10, 25, '四川', '内江', '资中县', 1);
INSERT INTO `idtoad` VALUES (511028, 51, 10, 28, '四川', '内江', '隆昌县', 0);
INSERT INTO `idtoad` VALUES (511083, 51, 10, 83, '四川', '内江', '隆昌市', 1);
INSERT INTO `idtoad` VALUES (511100, 51, 11, 0, '四川', '乐山', '', 0);
INSERT INTO `idtoad` VALUES (511101, 51, 11, 1, '四川', '乐山', '市辖区', 0);
INSERT INTO `idtoad` VALUES (511102, 51, 11, 2, '四川', '乐山', '市中区', 1);
INSERT INTO `idtoad` VALUES (511111, 51, 11, 11, '四川', '乐山', '沙湾区', 1);
INSERT INTO `idtoad` VALUES (511112, 51, 11, 12, '四川', '乐山', '五通桥区', 1);
INSERT INTO `idtoad` VALUES (511113, 51, 11, 13, '四川', '乐山', '金口河区', 1);
INSERT INTO `idtoad` VALUES (511123, 51, 11, 23, '四川', '乐山', '犍为县', 1);
INSERT INTO `idtoad` VALUES (511124, 51, 11, 24, '四川', '乐山', '井研县', 1);
INSERT INTO `idtoad` VALUES (511126, 51, 11, 26, '四川', '乐山', '夹江县', 1);
INSERT INTO `idtoad` VALUES (511129, 51, 11, 29, '四川', '乐山', '沐川县', 1);
INSERT INTO `idtoad` VALUES (511132, 51, 11, 32, '四川', '乐山', '峨边彝族自治县', 1);
INSERT INTO `idtoad` VALUES (511133, 51, 11, 33, '四川', '乐山', '马边彝族自治县', 1);
INSERT INTO `idtoad` VALUES (511181, 51, 11, 81, '四川', '乐山', '峨眉山市', 1);
INSERT INTO `idtoad` VALUES (511300, 51, 13, 0, '四川', '南充', '', 0);
INSERT INTO `idtoad` VALUES (511301, 51, 13, 1, '四川', '南充', '市辖区', 0);
INSERT INTO `idtoad` VALUES (511302, 51, 13, 2, '四川', '南充', '顺庆区', 1);
INSERT INTO `idtoad` VALUES (511303, 51, 13, 3, '四川', '南充', '高坪区', 1);
INSERT INTO `idtoad` VALUES (511304, 51, 13, 4, '四川', '南充', '嘉陵区', 1);
INSERT INTO `idtoad` VALUES (511321, 51, 13, 21, '四川', '南充', '南部县', 1);
INSERT INTO `idtoad` VALUES (511322, 51, 13, 22, '四川', '南充', '营山县', 1);
INSERT INTO `idtoad` VALUES (511323, 51, 13, 23, '四川', '南充', '蓬安县', 1);
INSERT INTO `idtoad` VALUES (511324, 51, 13, 24, '四川', '南充', '仪陇县', 1);
INSERT INTO `idtoad` VALUES (511325, 51, 13, 25, '四川', '南充', '西充县', 1);
INSERT INTO `idtoad` VALUES (511381, 51, 13, 81, '四川', '南充', '阆中市', 1);
INSERT INTO `idtoad` VALUES (511402, 51, 14, 2, '四川', '眉山', '东坡区', 1);
INSERT INTO `idtoad` VALUES (511403, 51, 14, 3, '四川', '眉山', '彭山区', 1);
INSERT INTO `idtoad` VALUES (511421, 51, 14, 21, '四川', '眉山', '仁寿县', 1);
INSERT INTO `idtoad` VALUES (511423, 51, 14, 23, '四川', '眉山', '洪雅县', 1);
INSERT INTO `idtoad` VALUES (511424, 51, 14, 24, '四川', '眉山', '丹棱县', 1);
INSERT INTO `idtoad` VALUES (511425, 51, 14, 25, '四川', '眉山', '青神县', 1);
INSERT INTO `idtoad` VALUES (511500, 51, 15, 0, '四川', '宜宾', '', 0);
INSERT INTO `idtoad` VALUES (511501, 51, 15, 1, '四川', '宜宾', '市辖区', 0);
INSERT INTO `idtoad` VALUES (511502, 51, 15, 2, '四川', '宜宾', '翠屏区', 1);
INSERT INTO `idtoad` VALUES (511503, 51, 15, 3, '四川', '宜宾', '南溪区', 1);
INSERT INTO `idtoad` VALUES (511504, 51, 15, 4, '四川', '宜宾', '叙州区', 1);
INSERT INTO `idtoad` VALUES (511521, 51, 15, 21, '四川', '宜宾', '宜宾县', 0);
INSERT INTO `idtoad` VALUES (511522, 51, 15, 22, '四川', '宜宾', '南溪县', 0);
INSERT INTO `idtoad` VALUES (511523, 51, 15, 23, '四川', '宜宾', '江安县', 1);
INSERT INTO `idtoad` VALUES (511524, 51, 15, 24, '四川', '宜宾', '长宁县', 1);
INSERT INTO `idtoad` VALUES (511525, 51, 15, 25, '四川', '宜宾', '高县', 1);
INSERT INTO `idtoad` VALUES (511526, 51, 15, 26, '四川', '宜宾', '珙县', 1);
INSERT INTO `idtoad` VALUES (511527, 51, 15, 27, '四川', '宜宾', '筠连县', 1);
INSERT INTO `idtoad` VALUES (511528, 51, 15, 28, '四川', '宜宾', '兴文县', 1);
INSERT INTO `idtoad` VALUES (511529, 51, 15, 29, '四川', '宜宾', '屏山县', 1);
INSERT INTO `idtoad` VALUES (511600, 51, 16, 0, '四川', '广安', '', 0);
INSERT INTO `idtoad` VALUES (511601, 51, 16, 1, '四川', '广安', '市辖区', 0);
INSERT INTO `idtoad` VALUES (511602, 51, 16, 2, '四川', '广安', '广安区', 1);
INSERT INTO `idtoad` VALUES (511603, 51, 16, 3, '四川', '广安', '前锋区', 1);
INSERT INTO `idtoad` VALUES (511621, 51, 16, 21, '四川', '广安', '岳池县', 1);
INSERT INTO `idtoad` VALUES (511622, 51, 16, 22, '四川', '广安', '武胜县', 1);
INSERT INTO `idtoad` VALUES (511623, 51, 16, 23, '四川', '广安', '邻水县', 1);
INSERT INTO `idtoad` VALUES (511681, 51, 16, 81, '四川', '广安', '华蓥市', 1);
INSERT INTO `idtoad` VALUES (511702, 51, 17, 2, '四川', '达州', '通川区', 1);
INSERT INTO `idtoad` VALUES (511703, 51, 17, 3, '四川', '达州', '达川区', 1);
INSERT INTO `idtoad` VALUES (511722, 51, 17, 22, '四川', '达州', '宣汉县', 1);
INSERT INTO `idtoad` VALUES (511723, 51, 17, 23, '四川', '达州', '开江县', 1);
INSERT INTO `idtoad` VALUES (511724, 51, 17, 24, '四川', '达州', '大竹县', 1);
INSERT INTO `idtoad` VALUES (511725, 51, 17, 25, '四川', '达州', '渠县', 1);
INSERT INTO `idtoad` VALUES (511781, 51, 17, 81, '四川', '达州', '万源市', 1);
INSERT INTO `idtoad` VALUES (511802, 51, 18, 2, '四川', '雅安', '雨城区', 1);
INSERT INTO `idtoad` VALUES (511803, 51, 18, 3, '四川', '雅安', '名山区', 1);
INSERT INTO `idtoad` VALUES (511822, 51, 18, 22, '四川', '雅安', '荥经县', 1);
INSERT INTO `idtoad` VALUES (511823, 51, 18, 23, '四川', '雅安', '汉源县', 1);
INSERT INTO `idtoad` VALUES (511824, 51, 18, 24, '四川', '雅安', '石棉县', 1);
INSERT INTO `idtoad` VALUES (511825, 51, 18, 25, '四川', '雅安', '天全县', 1);
INSERT INTO `idtoad` VALUES (511826, 51, 18, 26, '四川', '雅安', '芦山县', 1);
INSERT INTO `idtoad` VALUES (511827, 51, 18, 27, '四川', '雅安', '宝兴县', 1);
INSERT INTO `idtoad` VALUES (511902, 51, 19, 2, '四川', '巴中', '巴州区', 1);
INSERT INTO `idtoad` VALUES (511903, 51, 19, 3, '四川', '巴中', '恩阳区', 1);
INSERT INTO `idtoad` VALUES (511921, 51, 19, 21, '四川', '巴中', '通江县', 1);
INSERT INTO `idtoad` VALUES (511922, 51, 19, 22, '四川', '巴中', '南江县', 1);
INSERT INTO `idtoad` VALUES (511923, 51, 19, 23, '四川', '巴中', '平昌县', 1);
INSERT INTO `idtoad` VALUES (512002, 51, 20, 2, '四川', '资阳', '雁江区', 1);
INSERT INTO `idtoad` VALUES (512021, 51, 20, 21, '四川', '资阳', '安岳县', 1);
INSERT INTO `idtoad` VALUES (512022, 51, 20, 22, '四川', '资阳', '乐至县', 1);
INSERT INTO `idtoad` VALUES (513000, 51, 30, 0, '四川', '达川地区', '', 0);
INSERT INTO `idtoad` VALUES (513001, 51, 30, 1, '四川', '达川地区', '达川市', 0);
INSERT INTO `idtoad` VALUES (513002, 51, 30, 2, '四川', '达川地区', '万源市', 0);
INSERT INTO `idtoad` VALUES (513021, 51, 30, 21, '四川', '达川地区', '达县', 0);
INSERT INTO `idtoad` VALUES (513022, 51, 30, 22, '四川', '达川地区', '宣汉县', 0);
INSERT INTO `idtoad` VALUES (513023, 51, 30, 23, '四川', '达川地区', '开江县', 0);
INSERT INTO `idtoad` VALUES (513029, 51, 30, 29, '四川', '达川地区', '大竹县', 0);
INSERT INTO `idtoad` VALUES (513030, 51, 30, 30, '四川', '达川地区', '渠县', 0);
INSERT INTO `idtoad` VALUES (513100, 51, 31, 0, '四川', '雅安地区', '', 0);
INSERT INTO `idtoad` VALUES (513101, 51, 31, 1, '四川', '雅安地区', '雅安市', 0);
INSERT INTO `idtoad` VALUES (513122, 51, 31, 22, '四川', '雅安地区', '名山县', 0);
INSERT INTO `idtoad` VALUES (513123, 51, 31, 23, '四川', '雅安地区', '荥经县', 0);
INSERT INTO `idtoad` VALUES (513124, 51, 31, 24, '四川', '雅安地区', '汉源县', 0);
INSERT INTO `idtoad` VALUES (513125, 51, 31, 25, '四川', '雅安地区', '石棉县', 0);
INSERT INTO `idtoad` VALUES (513126, 51, 31, 26, '四川', '雅安地区', '天全县', 0);
INSERT INTO `idtoad` VALUES (513127, 51, 31, 27, '四川', '雅安地区', '芦山县', 0);
INSERT INTO `idtoad` VALUES (513128, 51, 31, 28, '四川', '雅安地区', '宝兴县', 0);
INSERT INTO `idtoad` VALUES (513200, 51, 32, 0, '四川', '阿坝藏族羌族自治州', '', 0);
INSERT INTO `idtoad` VALUES (513201, 51, 32, 1, '四川', '阿坝藏族羌族自治州', '马尔康市', 1);
INSERT INTO `idtoad` VALUES (513221, 51, 32, 21, '四川', '阿坝藏族羌族自治州', '汶川县', 1);
INSERT INTO `idtoad` VALUES (513222, 51, 32, 22, '四川', '阿坝藏族羌族自治州', '理县', 1);
INSERT INTO `idtoad` VALUES (513223, 51, 32, 23, '四川', '阿坝藏族羌族自治州', '茂县', 1);
INSERT INTO `idtoad` VALUES (513224, 51, 32, 24, '四川', '阿坝藏族羌族自治州', '松潘县', 1);
INSERT INTO `idtoad` VALUES (513225, 51, 32, 25, '四川', '阿坝藏族羌族自治州', '九寨沟县', 1);
INSERT INTO `idtoad` VALUES (513226, 51, 32, 26, '四川', '阿坝藏族羌族自治州', '金川县', 1);
INSERT INTO `idtoad` VALUES (513227, 51, 32, 27, '四川', '阿坝藏族羌族自治州', '小金县', 1);
INSERT INTO `idtoad` VALUES (513228, 51, 32, 28, '四川', '阿坝藏族羌族自治州', '黑水县', 1);
INSERT INTO `idtoad` VALUES (513229, 51, 32, 29, '四川', '阿坝藏族羌族自治州', '马尔康县', 0);
INSERT INTO `idtoad` VALUES (513230, 51, 32, 30, '四川', '阿坝藏族羌族自治州', '壤塘县', 1);
INSERT INTO `idtoad` VALUES (513231, 51, 32, 31, '四川', '阿坝藏族羌族自治州', '阿坝县', 1);
INSERT INTO `idtoad` VALUES (513232, 51, 32, 32, '四川', '阿坝藏族羌族自治州', '若尔盖县', 1);
INSERT INTO `idtoad` VALUES (513233, 51, 32, 33, '四川', '阿坝藏族羌族自治州', '红原县', 1);
INSERT INTO `idtoad` VALUES (513300, 51, 33, 0, '四川', '甘孜藏族自治州', '', 0);
INSERT INTO `idtoad` VALUES (513301, 51, 33, 1, '四川', '甘孜藏族自治州', '康定市', 1);
INSERT INTO `idtoad` VALUES (513321, 51, 33, 21, '四川', '甘孜藏族自治州', '康定县', 0);
INSERT INTO `idtoad` VALUES (513322, 51, 33, 22, '四川', '甘孜藏族自治州', '泸定县', 1);
INSERT INTO `idtoad` VALUES (513323, 51, 33, 23, '四川', '甘孜藏族自治州', '丹巴县', 1);
INSERT INTO `idtoad` VALUES (513324, 51, 33, 24, '四川', '甘孜藏族自治州', '九龙县', 1);
INSERT INTO `idtoad` VALUES (513325, 51, 33, 25, '四川', '甘孜藏族自治州', '雅江县', 1);
INSERT INTO `idtoad` VALUES (513326, 51, 33, 26, '四川', '甘孜藏族自治州', '道孚县', 1);
INSERT INTO `idtoad` VALUES (513327, 51, 33, 27, '四川', '甘孜藏族自治州', '炉霍县', 1);
INSERT INTO `idtoad` VALUES (513328, 51, 33, 28, '四川', '甘孜藏族自治州', '甘孜县', 1);
INSERT INTO `idtoad` VALUES (513329, 51, 33, 29, '四川', '甘孜藏族自治州', '新龙县', 1);
INSERT INTO `idtoad` VALUES (513330, 51, 33, 30, '四川', '甘孜藏族自治州', '德格县', 1);
INSERT INTO `idtoad` VALUES (513331, 51, 33, 31, '四川', '甘孜藏族自治州', '白玉县', 1);
INSERT INTO `idtoad` VALUES (513332, 51, 33, 32, '四川', '甘孜藏族自治州', '石渠县', 1);
INSERT INTO `idtoad` VALUES (513333, 51, 33, 33, '四川', '甘孜藏族自治州', '色达县', 1);
INSERT INTO `idtoad` VALUES (513334, 51, 33, 34, '四川', '甘孜藏族自治州', '理塘县', 1);
INSERT INTO `idtoad` VALUES (513335, 51, 33, 35, '四川', '甘孜藏族自治州', '巴塘县', 1);
INSERT INTO `idtoad` VALUES (513336, 51, 33, 36, '四川', '甘孜藏族自治州', '乡城县', 1);
INSERT INTO `idtoad` VALUES (513337, 51, 33, 37, '四川', '甘孜藏族自治州', '稻城县', 1);
INSERT INTO `idtoad` VALUES (513338, 51, 33, 38, '四川', '甘孜藏族自治州', '得荣县', 1);
INSERT INTO `idtoad` VALUES (513400, 51, 34, 0, '四川', '凉山彝族自治州', '', 0);
INSERT INTO `idtoad` VALUES (513401, 51, 34, 1, '四川', '凉山彝族自治州', '西昌市', 1);
INSERT INTO `idtoad` VALUES (513422, 51, 34, 22, '四川', '凉山彝族自治州', '木里藏族自治县', 1);
INSERT INTO `idtoad` VALUES (513423, 51, 34, 23, '四川', '凉山彝族自治州', '盐源县', 1);
INSERT INTO `idtoad` VALUES (513424, 51, 34, 24, '四川', '凉山彝族自治州', '德昌县', 1);
INSERT INTO `idtoad` VALUES (513425, 51, 34, 25, '四川', '凉山彝族自治州', '会理县', 1);
INSERT INTO `idtoad` VALUES (513426, 51, 34, 26, '四川', '凉山彝族自治州', '会东县', 1);
INSERT INTO `idtoad` VALUES (513427, 51, 34, 27, '四川', '凉山彝族自治州', '宁南县', 1);
INSERT INTO `idtoad` VALUES (513428, 51, 34, 28, '四川', '凉山彝族自治州', '普格县', 1);
INSERT INTO `idtoad` VALUES (513429, 51, 34, 29, '四川', '凉山彝族自治州', '布拖县', 1);
INSERT INTO `idtoad` VALUES (513430, 51, 34, 30, '四川', '凉山彝族自治州', '金阳县', 1);
INSERT INTO `idtoad` VALUES (513431, 51, 34, 31, '四川', '凉山彝族自治州', '昭觉县', 1);
INSERT INTO `idtoad` VALUES (513432, 51, 34, 32, '四川', '凉山彝族自治州', '喜德县', 1);
INSERT INTO `idtoad` VALUES (513433, 51, 34, 33, '四川', '凉山彝族自治州', '冕宁县', 1);
INSERT INTO `idtoad` VALUES (513434, 51, 34, 34, '四川', '凉山彝族自治州', '越西县', 1);
INSERT INTO `idtoad` VALUES (513435, 51, 34, 35, '四川', '凉山彝族自治州', '甘洛县', 1);
INSERT INTO `idtoad` VALUES (513436, 51, 34, 36, '四川', '凉山彝族自治州', '美姑县', 1);
INSERT INTO `idtoad` VALUES (513437, 51, 34, 37, '四川', '凉山彝族自治州', '雷波县', 1);
INSERT INTO `idtoad` VALUES (513700, 51, 37, 0, '四川', '巴中地区', '', 0);
INSERT INTO `idtoad` VALUES (513701, 51, 37, 1, '四川', '巴中地区', '巴中市', 0);
INSERT INTO `idtoad` VALUES (513721, 51, 37, 21, '四川', '巴中地区', '通江县', 0);
INSERT INTO `idtoad` VALUES (513722, 51, 37, 22, '四川', '巴中地区', '南江县', 0);
INSERT INTO `idtoad` VALUES (513723, 51, 37, 23, '四川', '巴中地区', '平昌县', 0);
INSERT INTO `idtoad` VALUES (513800, 51, 38, 0, '四川', '眉山地区', '', 0);
INSERT INTO `idtoad` VALUES (513821, 51, 38, 21, '四川', '眉山地区', '眉山县', 0);
INSERT INTO `idtoad` VALUES (513822, 51, 38, 22, '四川', '眉山地区', '仁寿县', 0);
INSERT INTO `idtoad` VALUES (513823, 51, 38, 23, '四川', '眉山地区', '彭山县', 0);
INSERT INTO `idtoad` VALUES (513824, 51, 38, 24, '四川', '眉山地区', '洪雅县', 0);
INSERT INTO `idtoad` VALUES (513825, 51, 38, 25, '四川', '眉山地区', '丹棱县', 0);
INSERT INTO `idtoad` VALUES (513826, 51, 38, 26, '四川', '眉山地区', '青神县', 0);
INSERT INTO `idtoad` VALUES (513900, 51, 39, 0, '四川', '眉山地区资阳地区', '', 0);
INSERT INTO `idtoad` VALUES (513901, 51, 39, 1, '四川', '眉山地区资阳地区', '眉山地区资阳市', 0);
INSERT INTO `idtoad` VALUES (513902, 51, 39, 2, '四川', '眉山地区资阳地区', '眉山地区简阳市', 0);
INSERT INTO `idtoad` VALUES (513921, 51, 39, 21, '四川', '眉山地区资阳地区', '眉山地区安岳县', 0);
INSERT INTO `idtoad` VALUES (513922, 51, 39, 22, '四川', '眉山地区资阳地区', '眉山地区乐至县', 0);
INSERT INTO `idtoad` VALUES (520000, 52, 0, 0, '贵州', '', '', 0);
INSERT INTO `idtoad` VALUES (520100, 52, 1, 0, '贵州', '贵阳', '', 0);
INSERT INTO `idtoad` VALUES (520101, 52, 1, 1, '贵州', '贵阳', '市辖区', 0);
INSERT INTO `idtoad` VALUES (520102, 52, 1, 2, '贵州', '贵阳', '南明区', 1);
INSERT INTO `idtoad` VALUES (520103, 52, 1, 3, '贵州', '贵阳', '云岩区', 1);
INSERT INTO `idtoad` VALUES (520111, 52, 1, 11, '贵州', '贵阳', '花溪区', 1);
INSERT INTO `idtoad` VALUES (520112, 52, 1, 12, '贵州', '贵阳', '乌当区', 1);
INSERT INTO `idtoad` VALUES (520113, 52, 1, 13, '贵州', '贵阳', '白云区', 1);
INSERT INTO `idtoad` VALUES (520115, 52, 1, 15, '贵州', '贵阳', '观山湖区', 1);
INSERT INTO `idtoad` VALUES (520121, 52, 1, 21, '贵州', '贵阳', '开阳县', 1);
INSERT INTO `idtoad` VALUES (520122, 52, 1, 22, '贵州', '贵阳', '息烽县', 1);
INSERT INTO `idtoad` VALUES (520123, 52, 1, 23, '贵州', '贵阳', '修文县', 1);
INSERT INTO `idtoad` VALUES (520181, 52, 1, 81, '贵州', '贵阳', '清镇市', 1);
INSERT INTO `idtoad` VALUES (520200, 52, 2, 0, '贵州', '六盘水', '', 0);
INSERT INTO `idtoad` VALUES (520201, 52, 2, 1, '贵州', '六盘水', '钟山区', 1);
INSERT INTO `idtoad` VALUES (520202, 52, 2, 2, '贵州', '六盘水', '盘县特区', 0);
INSERT INTO `idtoad` VALUES (520203, 52, 2, 3, '贵州', '六盘水', '六枝特区', 1);
INSERT INTO `idtoad` VALUES (520204, 52, 2, 4, '贵州', '六盘水', '水城区', 1);
INSERT INTO `idtoad` VALUES (520221, 52, 2, 21, '贵州', '六盘水', '水城县', 0);
INSERT INTO `idtoad` VALUES (520281, 52, 2, 81, '贵州', '六盘水', '盘州市', 1);
INSERT INTO `idtoad` VALUES (520300, 52, 3, 0, '贵州', '遵义', '', 0);
INSERT INTO `idtoad` VALUES (520301, 52, 3, 1, '贵州', '遵义', '市辖区', 0);
INSERT INTO `idtoad` VALUES (520302, 52, 3, 2, '贵州', '遵义', '红花岗区', 1);
INSERT INTO `idtoad` VALUES (520303, 52, 3, 3, '贵州', '遵义', '汇川区', 1);
INSERT INTO `idtoad` VALUES (520304, 52, 3, 4, '贵州', '遵义', '播州区', 1);
INSERT INTO `idtoad` VALUES (520321, 52, 3, 21, '贵州', '遵义', '县', 0);
INSERT INTO `idtoad` VALUES (520322, 52, 3, 22, '贵州', '遵义', '桐梓县', 1);
INSERT INTO `idtoad` VALUES (520323, 52, 3, 23, '贵州', '遵义', '绥阳县', 1);
INSERT INTO `idtoad` VALUES (520324, 52, 3, 24, '贵州', '遵义', '正安县', 1);
INSERT INTO `idtoad` VALUES (520325, 52, 3, 25, '贵州', '遵义', '道真仡佬族苗族自治县', 1);
INSERT INTO `idtoad` VALUES (520326, 52, 3, 26, '贵州', '遵义', '务川仡佬族苗族自治县', 1);
INSERT INTO `idtoad` VALUES (520327, 52, 3, 27, '贵州', '遵义', '凤冈县', 1);
INSERT INTO `idtoad` VALUES (520328, 52, 3, 28, '贵州', '遵义', '湄潭县', 1);
INSERT INTO `idtoad` VALUES (520329, 52, 3, 29, '贵州', '遵义', '余庆县', 1);
INSERT INTO `idtoad` VALUES (520330, 52, 3, 30, '贵州', '遵义', '习水县', 1);
INSERT INTO `idtoad` VALUES (520381, 52, 3, 81, '贵州', '遵义', '赤水市', 1);
INSERT INTO `idtoad` VALUES (520382, 52, 3, 82, '贵州', '遵义', '仁怀市', 1);
INSERT INTO `idtoad` VALUES (520402, 52, 4, 2, '贵州', '安顺', '西秀区', 1);
INSERT INTO `idtoad` VALUES (520403, 52, 4, 3, '贵州', '安顺', '平坝区', 1);
INSERT INTO `idtoad` VALUES (520422, 52, 4, 22, '贵州', '安顺', '普定县', 1);
INSERT INTO `idtoad` VALUES (520423, 52, 4, 23, '贵州', '安顺', '镇宁布依族苗族自治县', 1);
INSERT INTO `idtoad` VALUES (520424, 52, 4, 24, '贵州', '安顺', '关岭布依族苗族自治县', 1);
INSERT INTO `idtoad` VALUES (520425, 52, 4, 25, '贵州', '安顺', '紫云苗族布依族自治县', 1);
INSERT INTO `idtoad` VALUES (520502, 52, 5, 2, '贵州', '毕节', '七星关区', 1);
INSERT INTO `idtoad` VALUES (520521, 52, 5, 21, '贵州', '毕节', '大方县', 1);
INSERT INTO `idtoad` VALUES (520522, 52, 5, 22, '贵州', '毕节', '黔西县', 1);
INSERT INTO `idtoad` VALUES (520523, 52, 5, 23, '贵州', '毕节', '金沙县', 1);
INSERT INTO `idtoad` VALUES (520524, 52, 5, 24, '贵州', '毕节', '织金县', 1);
INSERT INTO `idtoad` VALUES (520525, 52, 5, 25, '贵州', '毕节', '纳雍县', 1);
INSERT INTO `idtoad` VALUES (520526, 52, 5, 26, '贵州', '毕节', '威宁彝族回族苗族自治县', 1);
INSERT INTO `idtoad` VALUES (520527, 52, 5, 27, '贵州', '毕节', '赫章县', 1);
INSERT INTO `idtoad` VALUES (520602, 52, 6, 2, '贵州', '铜仁', '碧江区', 1);
INSERT INTO `idtoad` VALUES (520603, 52, 6, 3, '贵州', '铜仁', '万山区', 1);
INSERT INTO `idtoad` VALUES (520621, 52, 6, 21, '贵州', '铜仁', '江口县', 1);
INSERT INTO `idtoad` VALUES (520622, 52, 6, 22, '贵州', '铜仁', '玉屏侗族自治县', 1);
INSERT INTO `idtoad` VALUES (520623, 52, 6, 23, '贵州', '铜仁', '石阡县', 1);
INSERT INTO `idtoad` VALUES (520624, 52, 6, 24, '贵州', '铜仁', '思南县', 1);
INSERT INTO `idtoad` VALUES (520625, 52, 6, 25, '贵州', '铜仁', '印江土家族苗族自治县', 1);
INSERT INTO `idtoad` VALUES (520626, 52, 6, 26, '贵州', '铜仁', '德江县', 1);
INSERT INTO `idtoad` VALUES (520627, 52, 6, 27, '贵州', '铜仁', '沿河土家族自治县', 1);
INSERT INTO `idtoad` VALUES (520628, 52, 6, 28, '贵州', '铜仁', '松桃苗族自治县', 1);
INSERT INTO `idtoad` VALUES (522200, 52, 22, 0, '贵州', '铜仁地区', '', 0);
INSERT INTO `idtoad` VALUES (522201, 52, 22, 1, '贵州', '铜仁地区', '铜仁市', 0);
INSERT INTO `idtoad` VALUES (522222, 52, 22, 22, '贵州', '铜仁地区', '江口县', 0);
INSERT INTO `idtoad` VALUES (522223, 52, 22, 23, '贵州', '铜仁地区', '玉屏侗族自治县', 0);
INSERT INTO `idtoad` VALUES (522224, 52, 22, 24, '贵州', '铜仁地区', '石阡县', 0);
INSERT INTO `idtoad` VALUES (522225, 52, 22, 25, '贵州', '铜仁地区', '思南县', 0);
INSERT INTO `idtoad` VALUES (522226, 52, 22, 26, '贵州', '铜仁地区', '印江土家族苗族自治县', 0);
INSERT INTO `idtoad` VALUES (522227, 52, 22, 27, '贵州', '铜仁地区', '德江县', 0);
INSERT INTO `idtoad` VALUES (522228, 52, 22, 28, '贵州', '铜仁地区', '沿河土家族自治县', 0);
INSERT INTO `idtoad` VALUES (522229, 52, 22, 29, '贵州', '铜仁地区', '松桃苗族自治县', 0);
INSERT INTO `idtoad` VALUES (522230, 52, 22, 30, '贵州', '铜仁地区', '万山特区', 0);
INSERT INTO `idtoad` VALUES (522300, 52, 23, 0, '贵州', '黔西南布依族苗族自治州', '', 0);
INSERT INTO `idtoad` VALUES (522301, 52, 23, 1, '贵州', '黔西南布依族苗族自治州', '兴义市', 1);
INSERT INTO `idtoad` VALUES (522302, 52, 23, 2, '贵州', '黔西南布依族苗族自治州', '兴仁市', 1);
INSERT INTO `idtoad` VALUES (522322, 52, 23, 22, '贵州', '黔西南布依族苗族自治州', '兴仁县', 0);
INSERT INTO `idtoad` VALUES (522323, 52, 23, 23, '贵州', '黔西南布依族苗族自治州', '普安县', 1);
INSERT INTO `idtoad` VALUES (522324, 52, 23, 24, '贵州', '黔西南布依族苗族自治州', '晴隆县', 1);
INSERT INTO `idtoad` VALUES (522325, 52, 23, 25, '贵州', '黔西南布依族苗族自治州', '贞丰县', 1);
INSERT INTO `idtoad` VALUES (522326, 52, 23, 26, '贵州', '黔西南布依族苗族自治州', '望谟县', 1);
INSERT INTO `idtoad` VALUES (522327, 52, 23, 27, '贵州', '黔西南布依族苗族自治州', '册亨县', 1);
INSERT INTO `idtoad` VALUES (522328, 52, 23, 28, '贵州', '黔西南布依族苗族自治州', '安龙县', 1);
INSERT INTO `idtoad` VALUES (522400, 52, 24, 0, '贵州', '毕节地区', '', 0);
INSERT INTO `idtoad` VALUES (522401, 52, 24, 1, '贵州', '毕节地区', '毕节市', 0);
INSERT INTO `idtoad` VALUES (522422, 52, 24, 22, '贵州', '毕节地区', '大方县', 0);
INSERT INTO `idtoad` VALUES (522423, 52, 24, 23, '贵州', '毕节地区', '黔西县', 0);
INSERT INTO `idtoad` VALUES (522424, 52, 24, 24, '贵州', '毕节地区', '金沙县', 0);
INSERT INTO `idtoad` VALUES (522425, 52, 24, 25, '贵州', '毕节地区', '织金县', 0);
INSERT INTO `idtoad` VALUES (522426, 52, 24, 26, '贵州', '毕节地区', '纳雍县', 0);
INSERT INTO `idtoad` VALUES (522427, 52, 24, 27, '贵州', '毕节地区', '威宁彝族回族苗族自治县', 0);
INSERT INTO `idtoad` VALUES (522428, 52, 24, 28, '贵州', '毕节地区', '赫章县', 0);
INSERT INTO `idtoad` VALUES (522500, 52, 25, 0, '贵州', '安顺地区', '', 0);
INSERT INTO `idtoad` VALUES (522501, 52, 25, 1, '贵州', '安顺地区', '安顺市', 0);
INSERT INTO `idtoad` VALUES (522526, 52, 25, 26, '贵州', '安顺地区', '平坝县', 0);
INSERT INTO `idtoad` VALUES (522527, 52, 25, 27, '贵州', '安顺地区', '普定县', 0);
INSERT INTO `idtoad` VALUES (522528, 52, 25, 28, '贵州', '安顺地区', '关岭布依族苗族自治县', 0);
INSERT INTO `idtoad` VALUES (522529, 52, 25, 29, '贵州', '安顺地区', '镇宁布依族苗族自治县', 0);
INSERT INTO `idtoad` VALUES (522530, 52, 25, 30, '贵州', '安顺地区', '紫云苗族布依族自治县', 0);
INSERT INTO `idtoad` VALUES (522600, 52, 26, 0, '贵州', '黔东南苗族侗族自治州', '', 0);
INSERT INTO `idtoad` VALUES (522601, 52, 26, 1, '贵州', '黔东南苗族侗族自治州', '凯里市', 1);
INSERT INTO `idtoad` VALUES (522622, 52, 26, 22, '贵州', '黔东南苗族侗族自治州', '黄平县', 1);
INSERT INTO `idtoad` VALUES (522623, 52, 26, 23, '贵州', '黔东南苗族侗族自治州', '施秉县', 1);
INSERT INTO `idtoad` VALUES (522624, 52, 26, 24, '贵州', '黔东南苗族侗族自治州', '三穗县', 1);
INSERT INTO `idtoad` VALUES (522625, 52, 26, 25, '贵州', '黔东南苗族侗族自治州', '镇远县', 1);
INSERT INTO `idtoad` VALUES (522626, 52, 26, 26, '贵州', '黔东南苗族侗族自治州', '岑巩县', 1);
INSERT INTO `idtoad` VALUES (522627, 52, 26, 27, '贵州', '黔东南苗族侗族自治州', '天柱县', 1);
INSERT INTO `idtoad` VALUES (522628, 52, 26, 28, '贵州', '黔东南苗族侗族自治州', '锦屏县', 1);
INSERT INTO `idtoad` VALUES (522629, 52, 26, 29, '贵州', '黔东南苗族侗族自治州', '剑河县', 1);
INSERT INTO `idtoad` VALUES (522630, 52, 26, 30, '贵州', '黔东南苗族侗族自治州', '台江县', 1);
INSERT INTO `idtoad` VALUES (522631, 52, 26, 31, '贵州', '黔东南苗族侗族自治州', '黎平县', 1);
INSERT INTO `idtoad` VALUES (522632, 52, 26, 32, '贵州', '黔东南苗族侗族自治州', '榕江县', 1);
INSERT INTO `idtoad` VALUES (522633, 52, 26, 33, '贵州', '黔东南苗族侗族自治州', '从江县', 1);
INSERT INTO `idtoad` VALUES (522634, 52, 26, 34, '贵州', '黔东南苗族侗族自治州', '雷山县', 1);
INSERT INTO `idtoad` VALUES (522635, 52, 26, 35, '贵州', '黔东南苗族侗族自治州', '麻江县', 1);
INSERT INTO `idtoad` VALUES (522636, 52, 26, 36, '贵州', '黔东南苗族侗族自治州', '丹寨县', 1);
INSERT INTO `idtoad` VALUES (522700, 52, 27, 0, '贵州', '黔南布依族苗族自治州', '', 0);
INSERT INTO `idtoad` VALUES (522701, 52, 27, 1, '贵州', '黔南布依族苗族自治州', '都匀市', 1);
INSERT INTO `idtoad` VALUES (522702, 52, 27, 2, '贵州', '黔南布依族苗族自治州', '福泉市', 1);
INSERT INTO `idtoad` VALUES (522722, 52, 27, 22, '贵州', '黔南布依族苗族自治州', '荔波县', 1);
INSERT INTO `idtoad` VALUES (522723, 52, 27, 23, '贵州', '黔南布依族苗族自治州', '贵定县', 1);
INSERT INTO `idtoad` VALUES (522725, 52, 27, 25, '贵州', '黔南布依族苗族自治州', '瓮安县', 1);
INSERT INTO `idtoad` VALUES (522726, 52, 27, 26, '贵州', '黔南布依族苗族自治州', '独山县', 1);
INSERT INTO `idtoad` VALUES (522727, 52, 27, 27, '贵州', '黔南布依族苗族自治州', '平塘县', 1);
INSERT INTO `idtoad` VALUES (522728, 52, 27, 28, '贵州', '黔南布依族苗族自治州', '罗甸县', 1);
INSERT INTO `idtoad` VALUES (522729, 52, 27, 29, '贵州', '黔南布依族苗族自治州', '长顺县', 1);
INSERT INTO `idtoad` VALUES (522730, 52, 27, 30, '贵州', '黔南布依族苗族自治州', '龙里县', 1);
INSERT INTO `idtoad` VALUES (522731, 52, 27, 31, '贵州', '黔南布依族苗族自治州', '惠水县', 1);
INSERT INTO `idtoad` VALUES (522732, 52, 27, 32, '贵州', '黔南布依族苗族自治州', '三都水族自治县', 1);
INSERT INTO `idtoad` VALUES (530000, 53, 0, 0, '云南', '', '', 0);
INSERT INTO `idtoad` VALUES (530100, 53, 1, 0, '云南', '昆明', '', 0);
INSERT INTO `idtoad` VALUES (530101, 53, 1, 1, '云南', '昆明', '市辖区', 0);
INSERT INTO `idtoad` VALUES (530102, 53, 1, 2, '云南', '昆明', '五华区', 1);
INSERT INTO `idtoad` VALUES (530103, 53, 1, 3, '云南', '昆明', '盘龙区', 1);
INSERT INTO `idtoad` VALUES (530111, 53, 1, 11, '云南', '昆明', '官渡区', 1);
INSERT INTO `idtoad` VALUES (530112, 53, 1, 12, '云南', '昆明', '西山区', 1);
INSERT INTO `idtoad` VALUES (530113, 53, 1, 13, '云南', '昆明', '东川区', 1);
INSERT INTO `idtoad` VALUES (530114, 53, 1, 14, '云南', '昆明', '呈贡区', 1);
INSERT INTO `idtoad` VALUES (530115, 53, 1, 15, '云南', '昆明', '晋宁区', 1);
INSERT INTO `idtoad` VALUES (530121, 53, 1, 21, '云南', '昆明', '呈贡县', 0);
INSERT INTO `idtoad` VALUES (530122, 53, 1, 22, '云南', '昆明', '晋宁县', 0);
INSERT INTO `idtoad` VALUES (530124, 53, 1, 24, '云南', '昆明', '富民县', 1);
INSERT INTO `idtoad` VALUES (530125, 53, 1, 25, '云南', '昆明', '宜良县', 1);
INSERT INTO `idtoad` VALUES (530126, 53, 1, 26, '云南', '昆明', '石林彝族自治县', 1);
INSERT INTO `idtoad` VALUES (530127, 53, 1, 27, '云南', '昆明', '嵩明县', 1);
INSERT INTO `idtoad` VALUES (530128, 53, 1, 28, '云南', '昆明', '禄劝彝族苗族自治县', 1);
INSERT INTO `idtoad` VALUES (530129, 53, 1, 29, '云南', '昆明', '寻甸回族彝族自治县', 1);
INSERT INTO `idtoad` VALUES (530181, 53, 1, 81, '云南', '昆明', '安宁市', 1);
INSERT INTO `idtoad` VALUES (530300, 53, 3, 0, '云南', '曲靖', '', 0);
INSERT INTO `idtoad` VALUES (530301, 53, 3, 1, '云南', '曲靖', '市辖区', 0);
INSERT INTO `idtoad` VALUES (530302, 53, 3, 2, '云南', '曲靖', '麒麟区', 1);
INSERT INTO `idtoad` VALUES (530303, 53, 3, 3, '云南', '曲靖', '沾益区', 1);
INSERT INTO `idtoad` VALUES (530304, 53, 3, 4, '云南', '曲靖', '马龙区', 1);
INSERT INTO `idtoad` VALUES (530321, 53, 3, 21, '云南', '曲靖', '马龙县', 0);
INSERT INTO `idtoad` VALUES (530322, 53, 3, 22, '云南', '曲靖', '陆良县', 1);
INSERT INTO `idtoad` VALUES (530323, 53, 3, 23, '云南', '曲靖', '师宗县', 1);
INSERT INTO `idtoad` VALUES (530324, 53, 3, 24, '云南', '曲靖', '罗平县', 1);
INSERT INTO `idtoad` VALUES (530325, 53, 3, 25, '云南', '曲靖', '富源县', 1);
INSERT INTO `idtoad` VALUES (530326, 53, 3, 26, '云南', '曲靖', '会泽县', 1);
INSERT INTO `idtoad` VALUES (530328, 53, 3, 28, '云南', '曲靖', '沾益县', 0);
INSERT INTO `idtoad` VALUES (530381, 53, 3, 81, '云南', '曲靖', '宣威市', 1);
INSERT INTO `idtoad` VALUES (530400, 53, 4, 0, '云南', '玉溪', '', 0);
INSERT INTO `idtoad` VALUES (530401, 53, 4, 1, '云南', '玉溪', '市辖区', 0);
INSERT INTO `idtoad` VALUES (530402, 53, 4, 2, '云南', '玉溪', '红塔区', 1);
INSERT INTO `idtoad` VALUES (530403, 53, 4, 3, '云南', '玉溪', '江川区', 1);
INSERT INTO `idtoad` VALUES (530421, 53, 4, 21, '云南', '玉溪', '江川县', 0);
INSERT INTO `idtoad` VALUES (530422, 53, 4, 22, '云南', '玉溪', '澄江县', 0);
INSERT INTO `idtoad` VALUES (530423, 53, 4, 23, '云南', '玉溪', '通海县', 1);
INSERT INTO `idtoad` VALUES (530424, 53, 4, 24, '云南', '玉溪', '华宁县', 1);
INSERT INTO `idtoad` VALUES (530425, 53, 4, 25, '云南', '玉溪', '易门县', 1);
INSERT INTO `idtoad` VALUES (530426, 53, 4, 26, '云南', '玉溪', '峨山彝族自治县', 1);
INSERT INTO `idtoad` VALUES (530427, 53, 4, 27, '云南', '玉溪', '新平彝族傣族自治县', 1);
INSERT INTO `idtoad` VALUES (530428, 53, 4, 28, '云南', '玉溪', '元江哈尼族彝族傣族自治县', 1);
INSERT INTO `idtoad` VALUES (530481, 53, 4, 81, '云南', '玉溪', '澄江市', 1);
INSERT INTO `idtoad` VALUES (530502, 53, 5, 2, '云南', '保山', '隆阳区', 1);
INSERT INTO `idtoad` VALUES (530521, 53, 5, 21, '云南', '保山', '施甸县', 1);
INSERT INTO `idtoad` VALUES (530523, 53, 5, 23, '云南', '保山', '龙陵县', 1);
INSERT INTO `idtoad` VALUES (530524, 53, 5, 24, '云南', '保山', '昌宁县', 1);
INSERT INTO `idtoad` VALUES (530581, 53, 5, 81, '云南', '保山', '腾冲市', 1);
INSERT INTO `idtoad` VALUES (530602, 53, 6, 2, '云南', '昭通', '昭阳区', 1);
INSERT INTO `idtoad` VALUES (530621, 53, 6, 21, '云南', '昭通', '鲁甸县', 1);
INSERT INTO `idtoad` VALUES (530622, 53, 6, 22, '云南', '昭通', '巧家县', 1);
INSERT INTO `idtoad` VALUES (530623, 53, 6, 23, '云南', '昭通', '盐津县', 1);
INSERT INTO `idtoad` VALUES (530624, 53, 6, 24, '云南', '昭通', '大关县', 1);
INSERT INTO `idtoad` VALUES (530625, 53, 6, 25, '云南', '昭通', '永善县', 1);
INSERT INTO `idtoad` VALUES (530626, 53, 6, 26, '云南', '昭通', '绥江县', 1);
INSERT INTO `idtoad` VALUES (530627, 53, 6, 27, '云南', '昭通', '镇雄县', 1);
INSERT INTO `idtoad` VALUES (530628, 53, 6, 28, '云南', '昭通', '彝良县', 1);
INSERT INTO `idtoad` VALUES (530629, 53, 6, 29, '云南', '昭通', '威信县', 1);
INSERT INTO `idtoad` VALUES (530630, 53, 6, 30, '云南', '昭通', '水富县', 0);
INSERT INTO `idtoad` VALUES (530681, 53, 6, 81, '云南', '昭通', '水富市', 1);
INSERT INTO `idtoad` VALUES (530702, 53, 7, 2, '云南', '丽江', '古城区', 1);
INSERT INTO `idtoad` VALUES (530721, 53, 7, 21, '云南', '丽江', '玉龙纳西族自治县', 1);
INSERT INTO `idtoad` VALUES (530722, 53, 7, 22, '云南', '丽江', '永胜县', 1);
INSERT INTO `idtoad` VALUES (530723, 53, 7, 23, '云南', '丽江', '华坪县', 1);
INSERT INTO `idtoad` VALUES (530724, 53, 7, 24, '云南', '丽江', '宁蒗彝族自治县', 1);
INSERT INTO `idtoad` VALUES (530802, 53, 8, 2, '云南', '普洱', '思茅区', 1);
INSERT INTO `idtoad` VALUES (530821, 53, 8, 21, '云南', '普洱', '宁洱哈尼族彝族自治县', 1);
INSERT INTO `idtoad` VALUES (530822, 53, 8, 22, '云南', '普洱', '墨江哈尼族自治县', 1);
INSERT INTO `idtoad` VALUES (530823, 53, 8, 23, '云南', '普洱', '景东彝族自治县', 1);
INSERT INTO `idtoad` VALUES (530824, 53, 8, 24, '云南', '普洱', '景谷傣族彝族自治县', 1);
INSERT INTO `idtoad` VALUES (530825, 53, 8, 25, '云南', '普洱', '镇沅彝族哈尼族拉祜族自治县', 1);
INSERT INTO `idtoad` VALUES (530826, 53, 8, 26, '云南', '普洱', '江城哈尼族彝族自治县', 1);
INSERT INTO `idtoad` VALUES (530827, 53, 8, 27, '云南', '普洱', '孟连傣族拉祜族佤族自治县', 1);
INSERT INTO `idtoad` VALUES (530828, 53, 8, 28, '云南', '普洱', '澜沧拉祜族自治县', 1);
INSERT INTO `idtoad` VALUES (530829, 53, 8, 29, '云南', '普洱', '西盟佤族自治县', 1);
INSERT INTO `idtoad` VALUES (530902, 53, 9, 2, '云南', '临沧', '临翔区', 1);
INSERT INTO `idtoad` VALUES (530921, 53, 9, 21, '云南', '临沧', '凤庆县', 1);
INSERT INTO `idtoad` VALUES (530922, 53, 9, 22, '云南', '临沧', '云县', 1);
INSERT INTO `idtoad` VALUES (530923, 53, 9, 23, '云南', '临沧', '永德县', 1);
INSERT INTO `idtoad` VALUES (530924, 53, 9, 24, '云南', '临沧', '镇康县', 1);
INSERT INTO `idtoad` VALUES (530925, 53, 9, 25, '云南', '临沧', '双江拉祜族佤族布朗族傣族自治县', 1);
INSERT INTO `idtoad` VALUES (530926, 53, 9, 26, '云南', '临沧', '耿马傣族佤族自治县', 1);
INSERT INTO `idtoad` VALUES (530927, 53, 9, 27, '云南', '临沧', '沧源佤族自治县', 1);
INSERT INTO `idtoad` VALUES (532100, 53, 21, 0, '云南', '昭通地区', '', 0);
INSERT INTO `idtoad` VALUES (532101, 53, 21, 1, '云南', '昭通地区', '昭通市', 0);
INSERT INTO `idtoad` VALUES (532122, 53, 21, 22, '云南', '昭通地区', '鲁甸县', 0);
INSERT INTO `idtoad` VALUES (532123, 53, 21, 23, '云南', '昭通地区', '巧家县', 0);
INSERT INTO `idtoad` VALUES (532124, 53, 21, 24, '云南', '昭通地区', '盐津县', 0);
INSERT INTO `idtoad` VALUES (532125, 53, 21, 25, '云南', '昭通地区', '大关县', 0);
INSERT INTO `idtoad` VALUES (532126, 53, 21, 26, '云南', '昭通地区', '永善县', 0);
INSERT INTO `idtoad` VALUES (532127, 53, 21, 27, '云南', '昭通地区', '绥江县', 0);
INSERT INTO `idtoad` VALUES (532128, 53, 21, 28, '云南', '昭通地区', '镇雄县', 0);
INSERT INTO `idtoad` VALUES (532129, 53, 21, 29, '云南', '昭通地区', '彝良县', 0);
INSERT INTO `idtoad` VALUES (532130, 53, 21, 30, '云南', '昭通地区', '威信县', 0);
INSERT INTO `idtoad` VALUES (532131, 53, 21, 31, '云南', '昭通地区', '水富县', 0);
INSERT INTO `idtoad` VALUES (532300, 53, 23, 0, '云南', '楚雄彝族自治州', '', 0);
INSERT INTO `idtoad` VALUES (532301, 53, 23, 1, '云南', '楚雄彝族自治州', '楚雄市', 1);
INSERT INTO `idtoad` VALUES (532322, 53, 23, 22, '云南', '楚雄彝族自治州', '双柏县', 1);
INSERT INTO `idtoad` VALUES (532323, 53, 23, 23, '云南', '楚雄彝族自治州', '牟定县', 1);
INSERT INTO `idtoad` VALUES (532324, 53, 23, 24, '云南', '楚雄彝族自治州', '南华县', 1);
INSERT INTO `idtoad` VALUES (532325, 53, 23, 25, '云南', '楚雄彝族自治州', '姚安县', 1);
INSERT INTO `idtoad` VALUES (532326, 53, 23, 26, '云南', '楚雄彝族自治州', '大姚县', 1);
INSERT INTO `idtoad` VALUES (532327, 53, 23, 27, '云南', '楚雄彝族自治州', '永仁县', 1);
INSERT INTO `idtoad` VALUES (532328, 53, 23, 28, '云南', '楚雄彝族自治州', '元谋县', 1);
INSERT INTO `idtoad` VALUES (532329, 53, 23, 29, '云南', '楚雄彝族自治州', '武定县', 1);
INSERT INTO `idtoad` VALUES (532331, 53, 23, 31, '云南', '楚雄彝族自治州', '禄丰县', 1);
INSERT INTO `idtoad` VALUES (532500, 53, 25, 0, '云南', '红河哈尼族彝族自治州', '', 0);
INSERT INTO `idtoad` VALUES (532501, 53, 25, 1, '云南', '红河哈尼族彝族自治州', '个旧市', 1);
INSERT INTO `idtoad` VALUES (532502, 53, 25, 2, '云南', '红河哈尼族彝族自治州', '开远市', 1);
INSERT INTO `idtoad` VALUES (532503, 53, 25, 3, '云南', '红河哈尼族彝族自治州', '蒙自市', 1);
INSERT INTO `idtoad` VALUES (532504, 53, 25, 4, '云南', '红河哈尼族彝族自治州', '弥勒市', 1);
INSERT INTO `idtoad` VALUES (532522, 53, 25, 22, '云南', '红河哈尼族彝族自治州', '蒙自县', 0);
INSERT INTO `idtoad` VALUES (532523, 53, 25, 23, '云南', '红河哈尼族彝族自治州', '屏边苗族自治县', 1);
INSERT INTO `idtoad` VALUES (532524, 53, 25, 24, '云南', '红河哈尼族彝族自治州', '建水县', 1);
INSERT INTO `idtoad` VALUES (532525, 53, 25, 25, '云南', '红河哈尼族彝族自治州', '石屏县', 1);
INSERT INTO `idtoad` VALUES (532526, 53, 25, 26, '云南', '红河哈尼族彝族自治州', '弥勒县', 0);
INSERT INTO `idtoad` VALUES (532527, 53, 25, 27, '云南', '红河哈尼族彝族自治州', '泸西县', 1);
INSERT INTO `idtoad` VALUES (532528, 53, 25, 28, '云南', '红河哈尼族彝族自治州', '元阳县', 1);
INSERT INTO `idtoad` VALUES (532529, 53, 25, 29, '云南', '红河哈尼族彝族自治州', '红河县', 1);
INSERT INTO `idtoad` VALUES (532530, 53, 25, 30, '云南', '红河哈尼族彝族自治州', '金平苗族瑶族傣族自治县', 1);
INSERT INTO `idtoad` VALUES (532531, 53, 25, 31, '云南', '红河哈尼族彝族自治州', '绿春县', 1);
INSERT INTO `idtoad` VALUES (532532, 53, 25, 32, '云南', '红河哈尼族彝族自治州', '河口瑶族自治县', 1);
INSERT INTO `idtoad` VALUES (532600, 53, 26, 0, '云南', '文山壮族苗族自治州', '', 0);
INSERT INTO `idtoad` VALUES (532601, 53, 26, 1, '云南', '文山壮族苗族自治州', '文山市', 1);
INSERT INTO `idtoad` VALUES (532621, 53, 26, 21, '云南', '文山壮族苗族自治州', '文山县', 0);
INSERT INTO `idtoad` VALUES (532622, 53, 26, 22, '云南', '文山壮族苗族自治州', '砚山县', 1);
INSERT INTO `idtoad` VALUES (532623, 53, 26, 23, '云南', '文山壮族苗族自治州', '西畴县', 1);
INSERT INTO `idtoad` VALUES (532624, 53, 26, 24, '云南', '文山壮族苗族自治州', '麻栗坡县', 1);
INSERT INTO `idtoad` VALUES (532625, 53, 26, 25, '云南', '文山壮族苗族自治州', '马关县', 1);
INSERT INTO `idtoad` VALUES (532626, 53, 26, 26, '云南', '文山壮族苗族自治州', '丘北县', 1);
INSERT INTO `idtoad` VALUES (532627, 53, 26, 27, '云南', '文山壮族苗族自治州', '广南县', 1);
INSERT INTO `idtoad` VALUES (532628, 53, 26, 28, '云南', '文山壮族苗族自治州', '富宁县', 1);
INSERT INTO `idtoad` VALUES (532700, 53, 27, 0, '云南', '思茅地区', '', 0);
INSERT INTO `idtoad` VALUES (532701, 53, 27, 1, '云南', '思茅地区', '思茅市', 0);
INSERT INTO `idtoad` VALUES (532722, 53, 27, 22, '云南', '思茅地区', '普洱哈尼族彝族自治县', 0);
INSERT INTO `idtoad` VALUES (532723, 53, 27, 23, '云南', '思茅地区', '墨江哈尼族自治县', 0);
INSERT INTO `idtoad` VALUES (532724, 53, 27, 24, '云南', '思茅地区', '景东彝族自治县', 0);
INSERT INTO `idtoad` VALUES (532725, 53, 27, 25, '云南', '思茅地区', '景谷傣族彝族自治县', 0);
INSERT INTO `idtoad` VALUES (532726, 53, 27, 26, '云南', '思茅地区', '镇沅彝族哈尼族拉祜族自治县', 0);
INSERT INTO `idtoad` VALUES (532727, 53, 27, 27, '云南', '思茅地区', '江城哈尼族彝族自治县', 0);
INSERT INTO `idtoad` VALUES (532728, 53, 27, 28, '云南', '思茅地区', '孟连傣族拉祜族佤族自治县', 0);
INSERT INTO `idtoad` VALUES (532729, 53, 27, 29, '云南', '思茅地区', '澜沧拉祜族自治县', 0);
INSERT INTO `idtoad` VALUES (532730, 53, 27, 30, '云南', '思茅地区', '西盟佤族自治县', 0);
INSERT INTO `idtoad` VALUES (532800, 53, 28, 0, '云南', '西双版纳傣族自治州', '', 0);
INSERT INTO `idtoad` VALUES (532801, 53, 28, 1, '云南', '西双版纳傣族自治州', '景洪市', 1);
INSERT INTO `idtoad` VALUES (532822, 53, 28, 22, '云南', '西双版纳傣族自治州', '勐海县', 1);
INSERT INTO `idtoad` VALUES (532823, 53, 28, 23, '云南', '西双版纳傣族自治州', '勐腊县', 1);
INSERT INTO `idtoad` VALUES (532900, 53, 29, 0, '云南', '大理白族自治州', '', 0);
INSERT INTO `idtoad` VALUES (532901, 53, 29, 1, '云南', '大理白族自治州', '大理市', 1);
INSERT INTO `idtoad` VALUES (532922, 53, 29, 22, '云南', '大理白族自治州', '漾濞彝族自治县', 1);
INSERT INTO `idtoad` VALUES (532923, 53, 29, 23, '云南', '大理白族自治州', '祥云县', 1);
INSERT INTO `idtoad` VALUES (532924, 53, 29, 24, '云南', '大理白族自治州', '宾川县', 1);
INSERT INTO `idtoad` VALUES (532925, 53, 29, 25, '云南', '大理白族自治州', '弥渡县', 1);
INSERT INTO `idtoad` VALUES (532926, 53, 29, 26, '云南', '大理白族自治州', '南涧彝族自治县', 1);
INSERT INTO `idtoad` VALUES (532927, 53, 29, 27, '云南', '大理白族自治州', '巍山彝族回族自治县', 1);
INSERT INTO `idtoad` VALUES (532928, 53, 29, 28, '云南', '大理白族自治州', '永平县', 1);
INSERT INTO `idtoad` VALUES (532929, 53, 29, 29, '云南', '大理白族自治州', '云龙县', 1);
INSERT INTO `idtoad` VALUES (532930, 53, 29, 30, '云南', '大理白族自治州', '洱源县', 1);
INSERT INTO `idtoad` VALUES (532931, 53, 29, 31, '云南', '大理白族自治州', '剑川县', 1);
INSERT INTO `idtoad` VALUES (532932, 53, 29, 32, '云南', '大理白族自治州', '鹤庆县', 1);
INSERT INTO `idtoad` VALUES (533000, 53, 30, 0, '云南', '保山地区', '', 0);
INSERT INTO `idtoad` VALUES (533001, 53, 30, 1, '云南', '保山地区', '保山市', 0);
INSERT INTO `idtoad` VALUES (533022, 53, 30, 22, '云南', '保山地区', '施甸县', 0);
INSERT INTO `idtoad` VALUES (533023, 53, 30, 23, '云南', '保山地区', '腾冲县', 0);
INSERT INTO `idtoad` VALUES (533024, 53, 30, 24, '云南', '保山地区', '龙陵县', 0);
INSERT INTO `idtoad` VALUES (533025, 53, 30, 25, '云南', '保山地区', '昌宁县', 0);
INSERT INTO `idtoad` VALUES (533100, 53, 31, 0, '云南', '德宏傣族景颇族自治州', '', 0);
INSERT INTO `idtoad` VALUES (533101, 53, 31, 1, '云南', '德宏傣族景颇族自治州', '畹町市', 0);
INSERT INTO `idtoad` VALUES (533102, 53, 31, 2, '云南', '德宏傣族景颇族自治州', '瑞丽市', 1);
INSERT INTO `idtoad` VALUES (533103, 53, 31, 3, '云南', '德宏傣族景颇族自治州', '芒市', 1);
INSERT INTO `idtoad` VALUES (533122, 53, 31, 22, '云南', '德宏傣族景颇族自治州', '梁河县', 1);
INSERT INTO `idtoad` VALUES (533123, 53, 31, 23, '云南', '德宏傣族景颇族自治州', '盈江县', 1);
INSERT INTO `idtoad` VALUES (533124, 53, 31, 24, '云南', '德宏傣族景颇族自治州', '陇川县', 1);
INSERT INTO `idtoad` VALUES (533200, 53, 32, 0, '云南', '丽江地区', '', 0);
INSERT INTO `idtoad` VALUES (533221, 53, 32, 21, '云南', '丽江地区', '丽江纳西族自治县', 0);
INSERT INTO `idtoad` VALUES (533222, 53, 32, 22, '云南', '丽江地区', '永胜县', 0);
INSERT INTO `idtoad` VALUES (533223, 53, 32, 23, '云南', '丽江地区', '华坪县', 0);
INSERT INTO `idtoad` VALUES (533224, 53, 32, 24, '云南', '丽江地区', '宁蒗彝族自治县', 0);
INSERT INTO `idtoad` VALUES (533300, 53, 33, 0, '云南', '怒江傈僳族自治州', '', 0);
INSERT INTO `idtoad` VALUES (533301, 53, 33, 1, '云南', '怒江傈僳族自治州', '泸水市', 1);
INSERT INTO `idtoad` VALUES (533321, 53, 33, 21, '云南', '怒江傈僳族自治州', '泸水县', 0);
INSERT INTO `idtoad` VALUES (533323, 53, 33, 23, '云南', '怒江傈僳族自治州', '福贡县', 1);
INSERT INTO `idtoad` VALUES (533324, 53, 33, 24, '云南', '怒江傈僳族自治州', '贡山独龙族怒族自治县', 1);
INSERT INTO `idtoad` VALUES (533325, 53, 33, 25, '云南', '怒江傈僳族自治州', '兰坪白族普米族自治县', 1);
INSERT INTO `idtoad` VALUES (533400, 53, 34, 0, '云南', '迪庆藏族自治州', '', 0);
INSERT INTO `idtoad` VALUES (533401, 53, 34, 1, '云南', '迪庆藏族自治州', '香格里拉市', 1);
INSERT INTO `idtoad` VALUES (533421, 53, 34, 21, '云南', '迪庆藏族自治州', '中甸县', 0);
INSERT INTO `idtoad` VALUES (533422, 53, 34, 22, '云南', '迪庆藏族自治州', '德钦县', 1);
INSERT INTO `idtoad` VALUES (533423, 53, 34, 23, '云南', '迪庆藏族自治州', '维西傈僳族自治县', 1);
INSERT INTO `idtoad` VALUES (533500, 53, 35, 0, '云南', '临沧地区', '', 0);
INSERT INTO `idtoad` VALUES (533521, 53, 35, 21, '云南', '临沧地区', '临沧县', 0);
INSERT INTO `idtoad` VALUES (533522, 53, 35, 22, '云南', '临沧地区', '凤庆县', 0);
INSERT INTO `idtoad` VALUES (533523, 53, 35, 23, '云南', '临沧地区', '云县', 0);
INSERT INTO `idtoad` VALUES (533524, 53, 35, 24, '云南', '临沧地区', '永德县', 0);
INSERT INTO `idtoad` VALUES (533525, 53, 35, 25, '云南', '临沧地区', '镇康县', 0);
INSERT INTO `idtoad` VALUES (533526, 53, 35, 26, '云南', '临沧地区', '双江拉祜族佤族布朗族傣族自治县', 0);
INSERT INTO `idtoad` VALUES (533527, 53, 35, 27, '云南', '临沧地区', '耿马傣族佤族自治县', 0);
INSERT INTO `idtoad` VALUES (533528, 53, 35, 28, '云南', '临沧地区', '沧源佤族自治县', 0);
INSERT INTO `idtoad` VALUES (540000, 54, 0, 0, '西藏', '', '', 0);
INSERT INTO `idtoad` VALUES (540100, 54, 1, 0, '西藏', '拉萨', '', 0);
INSERT INTO `idtoad` VALUES (540101, 54, 1, 1, '西藏', '拉萨', '市辖区', 0);
INSERT INTO `idtoad` VALUES (540102, 54, 1, 2, '西藏', '拉萨', '城关区', 1);
INSERT INTO `idtoad` VALUES (540103, 54, 1, 3, '西藏', '拉萨', '堆龙德庆区', 1);
INSERT INTO `idtoad` VALUES (540104, 54, 1, 4, '西藏', '拉萨', '达孜区', 1);
INSERT INTO `idtoad` VALUES (540121, 54, 1, 21, '西藏', '拉萨', '林周县', 1);
INSERT INTO `idtoad` VALUES (540122, 54, 1, 22, '西藏', '拉萨', '当雄县', 1);
INSERT INTO `idtoad` VALUES (540123, 54, 1, 23, '西藏', '拉萨', '尼木县', 1);
INSERT INTO `idtoad` VALUES (540124, 54, 1, 24, '西藏', '拉萨', '曲水县', 1);
INSERT INTO `idtoad` VALUES (540125, 54, 1, 25, '西藏', '拉萨', '堆龙德庆县', 0);
INSERT INTO `idtoad` VALUES (540126, 54, 1, 26, '西藏', '拉萨', '达孜县', 0);
INSERT INTO `idtoad` VALUES (540127, 54, 1, 27, '西藏', '拉萨', '墨竹工卡县', 1);
INSERT INTO `idtoad` VALUES (540202, 54, 2, 2, '西藏', '日喀则', '桑珠孜区', 1);
INSERT INTO `idtoad` VALUES (540221, 54, 2, 21, '西藏', '日喀则', '南木林县', 1);
INSERT INTO `idtoad` VALUES (540222, 54, 2, 22, '西藏', '日喀则', '江孜县', 1);
INSERT INTO `idtoad` VALUES (540223, 54, 2, 23, '西藏', '日喀则', '定日县', 1);
INSERT INTO `idtoad` VALUES (540224, 54, 2, 24, '西藏', '日喀则', '萨迦县', 1);
INSERT INTO `idtoad` VALUES (540225, 54, 2, 25, '西藏', '日喀则', '拉孜县', 1);
INSERT INTO `idtoad` VALUES (540226, 54, 2, 26, '西藏', '日喀则', '昂仁县', 1);
INSERT INTO `idtoad` VALUES (540227, 54, 2, 27, '西藏', '日喀则', '谢通门县', 1);
INSERT INTO `idtoad` VALUES (540228, 54, 2, 28, '西藏', '日喀则', '白朗县', 1);
INSERT INTO `idtoad` VALUES (540229, 54, 2, 29, '西藏', '日喀则', '仁布县', 1);
INSERT INTO `idtoad` VALUES (540230, 54, 2, 30, '西藏', '日喀则', '康马县', 1);
INSERT INTO `idtoad` VALUES (540231, 54, 2, 31, '西藏', '日喀则', '定结县', 1);
INSERT INTO `idtoad` VALUES (540232, 54, 2, 32, '西藏', '日喀则', '仲巴县', 1);
INSERT INTO `idtoad` VALUES (540233, 54, 2, 33, '西藏', '日喀则', '亚东县', 1);
INSERT INTO `idtoad` VALUES (540234, 54, 2, 34, '西藏', '日喀则', '吉隆县', 1);
INSERT INTO `idtoad` VALUES (540235, 54, 2, 35, '西藏', '日喀则', '聂拉木县', 1);
INSERT INTO `idtoad` VALUES (540236, 54, 2, 36, '西藏', '日喀则', '萨嘎县', 1);
INSERT INTO `idtoad` VALUES (540237, 54, 2, 37, '西藏', '日喀则', '岗巴县', 1);
INSERT INTO `idtoad` VALUES (540302, 54, 3, 2, '西藏', '昌都', '卡若区', 1);
INSERT INTO `idtoad` VALUES (540321, 54, 3, 21, '西藏', '昌都', '江达县', 1);
INSERT INTO `idtoad` VALUES (540322, 54, 3, 22, '西藏', '昌都', '贡觉县', 1);
INSERT INTO `idtoad` VALUES (540323, 54, 3, 23, '西藏', '昌都', '类乌齐县', 1);
INSERT INTO `idtoad` VALUES (540324, 54, 3, 24, '西藏', '昌都', '丁青县', 1);
INSERT INTO `idtoad` VALUES (540325, 54, 3, 25, '西藏', '昌都', '察雅县', 1);
INSERT INTO `idtoad` VALUES (540326, 54, 3, 26, '西藏', '昌都', '八宿县', 1);
INSERT INTO `idtoad` VALUES (540327, 54, 3, 27, '西藏', '昌都', '左贡县', 1);
INSERT INTO `idtoad` VALUES (540328, 54, 3, 28, '西藏', '昌都', '芒康县', 1);
INSERT INTO `idtoad` VALUES (540329, 54, 3, 29, '西藏', '昌都', '洛隆县', 1);
INSERT INTO `idtoad` VALUES (540330, 54, 3, 30, '西藏', '昌都', '边坝县', 1);
INSERT INTO `idtoad` VALUES (540402, 54, 4, 2, '西藏', '林芝', '巴宜区', 1);
INSERT INTO `idtoad` VALUES (540421, 54, 4, 21, '西藏', '林芝', '工布江达县', 1);
INSERT INTO `idtoad` VALUES (540422, 54, 4, 22, '西藏', '林芝', '米林县', 1);
INSERT INTO `idtoad` VALUES (540423, 54, 4, 23, '西藏', '林芝', '墨脱县', 1);
INSERT INTO `idtoad` VALUES (540424, 54, 4, 24, '西藏', '林芝', '波密县', 1);
INSERT INTO `idtoad` VALUES (540425, 54, 4, 25, '西藏', '林芝', '察隅县', 1);
INSERT INTO `idtoad` VALUES (540426, 54, 4, 26, '西藏', '林芝', '朗县', 1);
INSERT INTO `idtoad` VALUES (540502, 54, 5, 2, '西藏', '山南', '乃东区', 1);
INSERT INTO `idtoad` VALUES (540521, 54, 5, 21, '西藏', '山南', '扎囊县', 1);
INSERT INTO `idtoad` VALUES (540522, 54, 5, 22, '西藏', '山南', '贡嘎县', 1);
INSERT INTO `idtoad` VALUES (540523, 54, 5, 23, '西藏', '山南', '桑日县', 1);
INSERT INTO `idtoad` VALUES (540524, 54, 5, 24, '西藏', '山南', '琼结县', 1);
INSERT INTO `idtoad` VALUES (540525, 54, 5, 25, '西藏', '山南', '曲松县', 1);
INSERT INTO `idtoad` VALUES (540526, 54, 5, 26, '西藏', '山南', '措美县', 1);
INSERT INTO `idtoad` VALUES (540527, 54, 5, 27, '西藏', '山南', '洛扎县', 1);
INSERT INTO `idtoad` VALUES (540528, 54, 5, 28, '西藏', '山南', '加查县', 1);
INSERT INTO `idtoad` VALUES (540529, 54, 5, 29, '西藏', '山南', '隆子县', 1);
INSERT INTO `idtoad` VALUES (540530, 54, 5, 30, '西藏', '山南', '错那县', 1);
INSERT INTO `idtoad` VALUES (540531, 54, 5, 31, '西藏', '山南', '浪卡子县', 1);
INSERT INTO `idtoad` VALUES (540602, 54, 6, 2, '西藏', '那曲', '色尼区', 1);
INSERT INTO `idtoad` VALUES (540621, 54, 6, 21, '西藏', '那曲', '嘉黎县', 1);
INSERT INTO `idtoad` VALUES (540622, 54, 6, 22, '西藏', '那曲', '比如县', 1);
INSERT INTO `idtoad` VALUES (540623, 54, 6, 23, '西藏', '那曲', '聂荣县', 1);
INSERT INTO `idtoad` VALUES (540624, 54, 6, 24, '西藏', '那曲', '安多县', 1);
INSERT INTO `idtoad` VALUES (540625, 54, 6, 25, '西藏', '那曲', '申扎县', 1);
INSERT INTO `idtoad` VALUES (540626, 54, 6, 26, '西藏', '那曲', '索县', 1);
INSERT INTO `idtoad` VALUES (540627, 54, 6, 27, '西藏', '那曲', '班戈县', 1);
INSERT INTO `idtoad` VALUES (540628, 54, 6, 28, '西藏', '那曲', '巴青县', 1);
INSERT INTO `idtoad` VALUES (540629, 54, 6, 29, '西藏', '那曲', '尼玛县', 1);
INSERT INTO `idtoad` VALUES (540630, 54, 6, 30, '西藏', '那曲', '双湖县', 1);
INSERT INTO `idtoad` VALUES (542100, 54, 21, 0, '西藏', '昌都地区', '', 0);
INSERT INTO `idtoad` VALUES (542121, 54, 21, 21, '西藏', '昌都地区', '昌都县', 0);
INSERT INTO `idtoad` VALUES (542122, 54, 21, 22, '西藏', '昌都地区', '江达县', 0);
INSERT INTO `idtoad` VALUES (542123, 54, 21, 23, '西藏', '昌都地区', '贡觉县', 0);
INSERT INTO `idtoad` VALUES (542124, 54, 21, 24, '西藏', '昌都地区', '类乌齐县', 0);
INSERT INTO `idtoad` VALUES (542125, 54, 21, 25, '西藏', '昌都地区', '丁青县', 0);
INSERT INTO `idtoad` VALUES (542126, 54, 21, 26, '西藏', '昌都地区', '察雅县', 0);
INSERT INTO `idtoad` VALUES (542127, 54, 21, 27, '西藏', '昌都地区', '八宿县', 0);
INSERT INTO `idtoad` VALUES (542128, 54, 21, 28, '西藏', '昌都地区', '左贡县', 0);
INSERT INTO `idtoad` VALUES (542129, 54, 21, 29, '西藏', '昌都地区', '芒康县', 0);
INSERT INTO `idtoad` VALUES (542132, 54, 21, 32, '西藏', '昌都地区', '洛隆县', 0);
INSERT INTO `idtoad` VALUES (542133, 54, 21, 33, '西藏', '昌都地区', '边坝县', 0);
INSERT INTO `idtoad` VALUES (542134, 54, 21, 34, '西藏', '昌都地区', '盐井县', 0);
INSERT INTO `idtoad` VALUES (542135, 54, 21, 35, '西藏', '昌都地区', '碧土县', 0);
INSERT INTO `idtoad` VALUES (542136, 54, 21, 36, '西藏', '昌都地区', '妥坝县', 0);
INSERT INTO `idtoad` VALUES (542137, 54, 21, 37, '西藏', '昌都地区', '生达县', 0);
INSERT INTO `idtoad` VALUES (542200, 54, 22, 0, '西藏', '山南地区', '', 0);
INSERT INTO `idtoad` VALUES (542221, 54, 22, 21, '西藏', '山南地区', '乃东县', 0);
INSERT INTO `idtoad` VALUES (542222, 54, 22, 22, '西藏', '山南地区', '扎囊县', 0);
INSERT INTO `idtoad` VALUES (542223, 54, 22, 23, '西藏', '山南地区', '贡嘎县', 0);
INSERT INTO `idtoad` VALUES (542224, 54, 22, 24, '西藏', '山南地区', '桑日县', 0);
INSERT INTO `idtoad` VALUES (542225, 54, 22, 25, '西藏', '山南地区', '琼结县', 0);
INSERT INTO `idtoad` VALUES (542226, 54, 22, 26, '西藏', '山南地区', '曲松县', 0);
INSERT INTO `idtoad` VALUES (542227, 54, 22, 27, '西藏', '山南地区', '措美县', 0);
INSERT INTO `idtoad` VALUES (542228, 54, 22, 28, '西藏', '山南地区', '洛扎县', 0);
INSERT INTO `idtoad` VALUES (542229, 54, 22, 29, '西藏', '山南地区', '加查县', 0);
INSERT INTO `idtoad` VALUES (542231, 54, 22, 31, '西藏', '山南地区', '隆子县', 0);
INSERT INTO `idtoad` VALUES (542232, 54, 22, 32, '西藏', '山南地区', '错那县', 0);
INSERT INTO `idtoad` VALUES (542233, 54, 22, 33, '西藏', '山南地区', '浪卡子县', 0);
INSERT INTO `idtoad` VALUES (542300, 54, 23, 0, '西藏', '日喀则地区', '', 0);
INSERT INTO `idtoad` VALUES (542301, 54, 23, 1, '西藏', '日喀则地区', '日喀则市', 0);
INSERT INTO `idtoad` VALUES (542322, 54, 23, 22, '西藏', '日喀则地区', '南木林县', 0);
INSERT INTO `idtoad` VALUES (542323, 54, 23, 23, '西藏', '日喀则地区', '江孜县', 0);
INSERT INTO `idtoad` VALUES (542324, 54, 23, 24, '西藏', '日喀则地区', '定日县', 0);
INSERT INTO `idtoad` VALUES (542325, 54, 23, 25, '西藏', '日喀则地区', '萨迦县', 0);
INSERT INTO `idtoad` VALUES (542326, 54, 23, 26, '西藏', '日喀则地区', '拉孜县', 0);
INSERT INTO `idtoad` VALUES (542327, 54, 23, 27, '西藏', '日喀则地区', '昂仁县', 0);
INSERT INTO `idtoad` VALUES (542328, 54, 23, 28, '西藏', '日喀则地区', '谢通门县', 0);
INSERT INTO `idtoad` VALUES (542329, 54, 23, 29, '西藏', '日喀则地区', '白朗县', 0);
INSERT INTO `idtoad` VALUES (542330, 54, 23, 30, '西藏', '日喀则地区', '仁布县', 0);
INSERT INTO `idtoad` VALUES (542331, 54, 23, 31, '西藏', '日喀则地区', '康马县', 0);
INSERT INTO `idtoad` VALUES (542332, 54, 23, 32, '西藏', '日喀则地区', '定结县', 0);
INSERT INTO `idtoad` VALUES (542333, 54, 23, 33, '西藏', '日喀则地区', '仲巴县', 0);
INSERT INTO `idtoad` VALUES (542334, 54, 23, 34, '西藏', '日喀则地区', '亚东县', 0);
INSERT INTO `idtoad` VALUES (542335, 54, 23, 35, '西藏', '日喀则地区', '吉隆县', 0);
INSERT INTO `idtoad` VALUES (542336, 54, 23, 36, '西藏', '日喀则地区', '聂拉木县', 0);
INSERT INTO `idtoad` VALUES (542337, 54, 23, 37, '西藏', '日喀则地区', '萨嘎县', 0);
INSERT INTO `idtoad` VALUES (542338, 54, 23, 38, '西藏', '日喀则地区', '岗巴县', 0);
INSERT INTO `idtoad` VALUES (542400, 54, 24, 0, '西藏', '那曲地区', '', 0);
INSERT INTO `idtoad` VALUES (542421, 54, 24, 21, '西藏', '那曲地区', '那曲县', 0);
INSERT INTO `idtoad` VALUES (542422, 54, 24, 22, '西藏', '那曲地区', '嘉黎县', 0);
INSERT INTO `idtoad` VALUES (542423, 54, 24, 23, '西藏', '那曲地区', '比如县', 0);
INSERT INTO `idtoad` VALUES (542424, 54, 24, 24, '西藏', '那曲地区', '聂荣县', 0);
INSERT INTO `idtoad` VALUES (542425, 54, 24, 25, '西藏', '那曲地区', '安多县', 0);
INSERT INTO `idtoad` VALUES (542426, 54, 24, 26, '西藏', '那曲地区', '申扎县', 0);
INSERT INTO `idtoad` VALUES (542427, 54, 24, 27, '西藏', '那曲地区', '索县', 0);
INSERT INTO `idtoad` VALUES (542428, 54, 24, 28, '西藏', '那曲地区', '班戈县', 0);
INSERT INTO `idtoad` VALUES (542429, 54, 24, 29, '西藏', '那曲地区', '巴青县', 0);
INSERT INTO `idtoad` VALUES (542430, 54, 24, 30, '西藏', '那曲地区', '尼玛县', 0);
INSERT INTO `idtoad` VALUES (542500, 54, 25, 0, '西藏', '阿里地区', '', 0);
INSERT INTO `idtoad` VALUES (542521, 54, 25, 21, '西藏', '阿里地区', '普兰县', 1);
INSERT INTO `idtoad` VALUES (542522, 54, 25, 22, '西藏', '阿里地区', '札达县', 1);
INSERT INTO `idtoad` VALUES (542523, 54, 25, 23, '西藏', '阿里地区', '噶尔县', 1);
INSERT INTO `idtoad` VALUES (542524, 54, 25, 24, '西藏', '阿里地区', '日土县', 1);
INSERT INTO `idtoad` VALUES (542525, 54, 25, 25, '西藏', '阿里地区', '革吉县', 1);
INSERT INTO `idtoad` VALUES (542526, 54, 25, 26, '西藏', '阿里地区', '改则县', 1);
INSERT INTO `idtoad` VALUES (542527, 54, 25, 27, '西藏', '阿里地区', '措勤县', 1);
INSERT INTO `idtoad` VALUES (542528, 54, 25, 28, '西藏', '阿里地区', '隆格尔县', 0);
INSERT INTO `idtoad` VALUES (542600, 54, 26, 0, '西藏', '林芝地区', '', 0);
INSERT INTO `idtoad` VALUES (542621, 54, 26, 21, '西藏', '林芝地区', '林芝县', 0);
INSERT INTO `idtoad` VALUES (542622, 54, 26, 22, '西藏', '林芝地区', '工布江达县', 0);
INSERT INTO `idtoad` VALUES (542623, 54, 26, 23, '西藏', '林芝地区', '米林县', 0);
INSERT INTO `idtoad` VALUES (542624, 54, 26, 24, '西藏', '林芝地区', '墨脱县', 0);
INSERT INTO `idtoad` VALUES (542625, 54, 26, 25, '西藏', '林芝地区', '波密县', 0);
INSERT INTO `idtoad` VALUES (542626, 54, 26, 26, '西藏', '林芝地区', '察隅县', 0);
INSERT INTO `idtoad` VALUES (542627, 54, 26, 27, '西藏', '林芝地区', '朗县', 0);
INSERT INTO `idtoad` VALUES (610000, 61, 0, 0, '陕西', '', '', 0);
INSERT INTO `idtoad` VALUES (610100, 61, 1, 0, '陕西', '西安', '西安', 1);
INSERT INTO `idtoad` VALUES (610101, 61, 1, 1, '陕西', '西安', '市辖区', 0);
INSERT INTO `idtoad` VALUES (610102, 61, 1, 2, '陕西', '西安', '新城区', 1);
INSERT INTO `idtoad` VALUES (610103, 61, 1, 3, '陕西', '西安', '碑林区', 1);
INSERT INTO `idtoad` VALUES (610104, 61, 1, 4, '陕西', '西安', '莲湖区', 1);
INSERT INTO `idtoad` VALUES (610111, 61, 1, 11, '陕西', '西安', '灞桥区', 1);
INSERT INTO `idtoad` VALUES (610112, 61, 1, 12, '陕西', '西安', '未央区', 1);
INSERT INTO `idtoad` VALUES (610113, 61, 1, 13, '陕西', '西安', '雁塔区', 1);
INSERT INTO `idtoad` VALUES (610114, 61, 1, 14, '陕西', '西安', '阎良区', 1);
INSERT INTO `idtoad` VALUES (610115, 61, 1, 15, '陕西', '西安', '临潼区', 1);
INSERT INTO `idtoad` VALUES (610116, 61, 1, 16, '陕西', '西安', '长安区', 1);
INSERT INTO `idtoad` VALUES (610117, 61, 1, 17, '陕西', '西安', '高陵区', 1);
INSERT INTO `idtoad` VALUES (610118, 61, 1, 18, '陕西', '西安', '鄠邑区', 1);
INSERT INTO `idtoad` VALUES (610121, 61, 1, 21, '陕西', '西安', '长安县', 0);
INSERT INTO `idtoad` VALUES (610122, 61, 1, 22, '陕西', '西安', '蓝田县', 1);
INSERT INTO `idtoad` VALUES (610124, 61, 1, 24, '陕西', '西安', '周至县', 1);
INSERT INTO `idtoad` VALUES (610125, 61, 1, 25, '陕西', '西安', '户县', 0);
INSERT INTO `idtoad` VALUES (610126, 61, 1, 26, '陕西', '西安', '高陵县', 0);
INSERT INTO `idtoad` VALUES (610200, 61, 2, 0, '陕西', '铜川', '', 0);
INSERT INTO `idtoad` VALUES (610201, 61, 2, 1, '陕西', '铜川', '市辖区', 0);
INSERT INTO `idtoad` VALUES (610202, 61, 2, 2, '陕西', '铜川', '王益区', 1);
INSERT INTO `idtoad` VALUES (610203, 61, 2, 3, '陕西', '铜川', '印台区', 1);
INSERT INTO `idtoad` VALUES (610204, 61, 2, 4, '陕西', '铜川', '耀州区', 1);
INSERT INTO `idtoad` VALUES (610221, 61, 2, 21, '陕西', '铜川', '耀县', 0);
INSERT INTO `idtoad` VALUES (610222, 61, 2, 22, '陕西', '铜川', '宜君县', 1);
INSERT INTO `idtoad` VALUES (610300, 61, 3, 0, '陕西', '宝鸡', '', 0);
INSERT INTO `idtoad` VALUES (610301, 61, 3, 1, '陕西', '宝鸡', '市辖区', 0);
INSERT INTO `idtoad` VALUES (610302, 61, 3, 2, '陕西', '宝鸡', '渭滨区', 1);
INSERT INTO `idtoad` VALUES (610303, 61, 3, 3, '陕西', '宝鸡', '金台区', 1);
INSERT INTO `idtoad` VALUES (610304, 61, 3, 4, '陕西', '宝鸡', '陈仓区', 1);
INSERT INTO `idtoad` VALUES (610321, 61, 3, 21, '陕西', '宝鸡', '市县', 0);
INSERT INTO `idtoad` VALUES (610322, 61, 3, 22, '陕西', '宝鸡', '凤翔县', 1);
INSERT INTO `idtoad` VALUES (610323, 61, 3, 23, '陕西', '宝鸡', '岐山县', 1);
INSERT INTO `idtoad` VALUES (610324, 61, 3, 24, '陕西', '宝鸡', '扶风县', 1);
INSERT INTO `idtoad` VALUES (610326, 61, 3, 26, '陕西', '宝鸡', '眉县', 1);
INSERT INTO `idtoad` VALUES (610327, 61, 3, 27, '陕西', '宝鸡', '陇县', 1);
INSERT INTO `idtoad` VALUES (610328, 61, 3, 28, '陕西', '宝鸡', '千阳县', 1);
INSERT INTO `idtoad` VALUES (610329, 61, 3, 29, '陕西', '宝鸡', '麟游县', 1);
INSERT INTO `idtoad` VALUES (610330, 61, 3, 30, '陕西', '宝鸡', '凤县', 1);
INSERT INTO `idtoad` VALUES (610331, 61, 3, 31, '陕西', '宝鸡', '太白县', 1);
INSERT INTO `idtoad` VALUES (610400, 61, 4, 0, '陕西', '咸阳', '', 0);
INSERT INTO `idtoad` VALUES (610401, 61, 4, 1, '陕西', '咸阳', '市辖区', 0);
INSERT INTO `idtoad` VALUES (610402, 61, 4, 2, '陕西', '咸阳', '秦都区', 1);
INSERT INTO `idtoad` VALUES (610403, 61, 4, 3, '陕西', '咸阳', '杨陵区', 1);
INSERT INTO `idtoad` VALUES (610404, 61, 4, 4, '陕西', '咸阳', '渭城区', 1);
INSERT INTO `idtoad` VALUES (610422, 61, 4, 22, '陕西', '咸阳', '三原县', 1);
INSERT INTO `idtoad` VALUES (610423, 61, 4, 23, '陕西', '咸阳', '泾阳县', 1);
INSERT INTO `idtoad` VALUES (610424, 61, 4, 24, '陕西', '咸阳', '乾县', 1);
INSERT INTO `idtoad` VALUES (610425, 61, 4, 25, '陕西', '咸阳', '礼泉县', 1);
INSERT INTO `idtoad` VALUES (610426, 61, 4, 26, '陕西', '咸阳', '永寿县', 1);
INSERT INTO `idtoad` VALUES (610427, 61, 4, 27, '陕西', '咸阳', '彬县', 0);
INSERT INTO `idtoad` VALUES (610428, 61, 4, 28, '陕西', '咸阳', '长武县', 1);
INSERT INTO `idtoad` VALUES (610429, 61, 4, 29, '陕西', '咸阳', '旬邑县', 1);
INSERT INTO `idtoad` VALUES (610430, 61, 4, 30, '陕西', '咸阳', '淳化县', 1);
INSERT INTO `idtoad` VALUES (610431, 61, 4, 31, '陕西', '咸阳', '武功县', 1);
INSERT INTO `idtoad` VALUES (610481, 61, 4, 81, '陕西', '咸阳', '兴平市', 1);
INSERT INTO `idtoad` VALUES (610482, 61, 4, 82, '陕西', '咸阳', '彬州市', 1);
INSERT INTO `idtoad` VALUES (610500, 61, 5, 0, '陕西', '渭南', '', 0);
INSERT INTO `idtoad` VALUES (610501, 61, 5, 1, '陕西', '渭南', '市辖区', 0);
INSERT INTO `idtoad` VALUES (610502, 61, 5, 2, '陕西', '渭南', '临渭区', 1);
INSERT INTO `idtoad` VALUES (610503, 61, 5, 3, '陕西', '渭南', '华州区', 1);
INSERT INTO `idtoad` VALUES (610521, 61, 5, 21, '陕西', '渭南', '华县', 0);
INSERT INTO `idtoad` VALUES (610522, 61, 5, 22, '陕西', '渭南', '潼关县', 1);
INSERT INTO `idtoad` VALUES (610523, 61, 5, 23, '陕西', '渭南', '大荔县', 1);
INSERT INTO `idtoad` VALUES (610524, 61, 5, 24, '陕西', '渭南', '合阳县', 1);
INSERT INTO `idtoad` VALUES (610525, 61, 5, 25, '陕西', '渭南', '澄城县', 1);
INSERT INTO `idtoad` VALUES (610526, 61, 5, 26, '陕西', '渭南', '蒲城县', 1);
INSERT INTO `idtoad` VALUES (610527, 61, 5, 27, '陕西', '渭南', '白水县', 1);
INSERT INTO `idtoad` VALUES (610528, 61, 5, 28, '陕西', '渭南', '富平县', 1);
INSERT INTO `idtoad` VALUES (610581, 61, 5, 81, '陕西', '渭南', '韩城市', 1);
INSERT INTO `idtoad` VALUES (610582, 61, 5, 82, '陕西', '渭南', '华阴市', 1);
INSERT INTO `idtoad` VALUES (610600, 61, 6, 0, '陕西', '延安', '', 0);
INSERT INTO `idtoad` VALUES (610601, 61, 6, 1, '陕西', '延安', '市辖区', 0);
INSERT INTO `idtoad` VALUES (610602, 61, 6, 2, '陕西', '延安', '宝塔区', 1);
INSERT INTO `idtoad` VALUES (610603, 61, 6, 3, '陕西', '延安', '安塞区', 1);
INSERT INTO `idtoad` VALUES (610621, 61, 6, 21, '陕西', '延安', '延长县', 1);
INSERT INTO `idtoad` VALUES (610622, 61, 6, 22, '陕西', '延安', '延川县', 1);
INSERT INTO `idtoad` VALUES (610623, 61, 6, 23, '陕西', '延安', '子长县', 0);
INSERT INTO `idtoad` VALUES (610624, 61, 6, 24, '陕西', '延安', '安塞县', 0);
INSERT INTO `idtoad` VALUES (610625, 61, 6, 25, '陕西', '延安', '志丹县', 1);
INSERT INTO `idtoad` VALUES (610626, 61, 6, 26, '陕西', '延安', '吴起县', 1);
INSERT INTO `idtoad` VALUES (610627, 61, 6, 27, '陕西', '延安', '甘泉县', 1);
INSERT INTO `idtoad` VALUES (610628, 61, 6, 28, '陕西', '延安', '富县', 1);
INSERT INTO `idtoad` VALUES (610629, 61, 6, 29, '陕西', '延安', '洛川县', 1);
INSERT INTO `idtoad` VALUES (610630, 61, 6, 30, '陕西', '延安', '宜川县', 1);
INSERT INTO `idtoad` VALUES (610631, 61, 6, 31, '陕西', '延安', '黄龙县', 1);
INSERT INTO `idtoad` VALUES (610632, 61, 6, 32, '陕西', '延安', '黄陵县', 1);
INSERT INTO `idtoad` VALUES (610681, 61, 6, 81, '陕西', '延安', '子长市', 1);
INSERT INTO `idtoad` VALUES (610700, 61, 7, 0, '陕西', '汉中', '', 0);
INSERT INTO `idtoad` VALUES (610701, 61, 7, 1, '陕西', '汉中', '市辖区', 0);
INSERT INTO `idtoad` VALUES (610702, 61, 7, 2, '陕西', '汉中', '汉台区', 1);
INSERT INTO `idtoad` VALUES (610703, 61, 7, 3, '陕西', '汉中', '南郑区', 1);
INSERT INTO `idtoad` VALUES (610721, 61, 7, 21, '陕西', '汉中', '南郑县', 0);
INSERT INTO `idtoad` VALUES (610722, 61, 7, 22, '陕西', '汉中', '城固县', 1);
INSERT INTO `idtoad` VALUES (610723, 61, 7, 23, '陕西', '汉中', '洋县', 1);
INSERT INTO `idtoad` VALUES (610724, 61, 7, 24, '陕西', '汉中', '西乡县', 1);
INSERT INTO `idtoad` VALUES (610725, 61, 7, 25, '陕西', '汉中', '勉县', 1);
INSERT INTO `idtoad` VALUES (610726, 61, 7, 26, '陕西', '汉中', '宁强县', 1);
INSERT INTO `idtoad` VALUES (610727, 61, 7, 27, '陕西', '汉中', '略阳县', 1);
INSERT INTO `idtoad` VALUES (610728, 61, 7, 28, '陕西', '汉中', '镇巴县', 1);
INSERT INTO `idtoad` VALUES (610729, 61, 7, 29, '陕西', '汉中', '留坝县', 1);
INSERT INTO `idtoad` VALUES (610730, 61, 7, 30, '陕西', '汉中', '佛坪县', 1);
INSERT INTO `idtoad` VALUES (610802, 61, 8, 2, '陕西', '榆林', '榆阳区', 1);
INSERT INTO `idtoad` VALUES (610803, 61, 8, 3, '陕西', '榆林', '横山区', 1);
INSERT INTO `idtoad` VALUES (610822, 61, 8, 22, '陕西', '榆林', '府谷县', 1);
INSERT INTO `idtoad` VALUES (610824, 61, 8, 24, '陕西', '榆林', '靖边县', 1);
INSERT INTO `idtoad` VALUES (610825, 61, 8, 25, '陕西', '榆林', '定边县', 1);
INSERT INTO `idtoad` VALUES (610826, 61, 8, 26, '陕西', '榆林', '绥德县', 1);
INSERT INTO `idtoad` VALUES (610827, 61, 8, 27, '陕西', '榆林', '米脂县', 1);
INSERT INTO `idtoad` VALUES (610828, 61, 8, 28, '陕西', '榆林', '佳县', 1);
INSERT INTO `idtoad` VALUES (610829, 61, 8, 29, '陕西', '榆林', '吴堡县', 1);
INSERT INTO `idtoad` VALUES (610830, 61, 8, 30, '陕西', '榆林', '清涧县', 1);
INSERT INTO `idtoad` VALUES (610831, 61, 8, 31, '陕西', '榆林', '子洲县', 1);
INSERT INTO `idtoad` VALUES (610881, 61, 8, 81, '陕西', '榆林', '神木市', 1);
INSERT INTO `idtoad` VALUES (610902, 61, 9, 2, '陕西', '安康', '汉滨区', 1);
INSERT INTO `idtoad` VALUES (610921, 61, 9, 21, '陕西', '安康', '汉阴县', 1);
INSERT INTO `idtoad` VALUES (610922, 61, 9, 22, '陕西', '安康', '石泉县', 1);
INSERT INTO `idtoad` VALUES (610923, 61, 9, 23, '陕西', '安康', '宁陕县', 1);
INSERT INTO `idtoad` VALUES (610924, 61, 9, 24, '陕西', '安康', '紫阳县', 1);
INSERT INTO `idtoad` VALUES (610925, 61, 9, 25, '陕西', '安康', '岚皋县', 1);
INSERT INTO `idtoad` VALUES (610926, 61, 9, 26, '陕西', '安康', '平利县', 1);
INSERT INTO `idtoad` VALUES (610927, 61, 9, 27, '陕西', '安康', '镇坪县', 1);
INSERT INTO `idtoad` VALUES (610928, 61, 9, 28, '陕西', '安康', '旬阳县', 1);
INSERT INTO `idtoad` VALUES (610929, 61, 9, 29, '陕西', '安康', '白河县', 1);
INSERT INTO `idtoad` VALUES (611002, 61, 10, 2, '陕西', '商洛', '商州区', 1);
INSERT INTO `idtoad` VALUES (611021, 61, 10, 21, '陕西', '商洛', '洛南县', 1);
INSERT INTO `idtoad` VALUES (611022, 61, 10, 22, '陕西', '商洛', '丹凤县', 1);
INSERT INTO `idtoad` VALUES (611023, 61, 10, 23, '陕西', '商洛', '商南县', 1);
INSERT INTO `idtoad` VALUES (611024, 61, 10, 24, '陕西', '商洛', '山阳县', 1);
INSERT INTO `idtoad` VALUES (611025, 61, 10, 25, '陕西', '商洛', '镇安县', 1);
INSERT INTO `idtoad` VALUES (611026, 61, 10, 26, '陕西', '商洛', '柞水县', 1);
INSERT INTO `idtoad` VALUES (612400, 61, 24, 0, '陕西', '安康地区', '', 0);
INSERT INTO `idtoad` VALUES (612401, 61, 24, 1, '陕西', '安康地区', '安康市', 0);
INSERT INTO `idtoad` VALUES (612422, 61, 24, 22, '陕西', '安康地区', '汉阴县', 0);
INSERT INTO `idtoad` VALUES (612423, 61, 24, 23, '陕西', '安康地区', '石泉县', 0);
INSERT INTO `idtoad` VALUES (612424, 61, 24, 24, '陕西', '安康地区', '宁陕县', 0);
INSERT INTO `idtoad` VALUES (612425, 61, 24, 25, '陕西', '安康地区', '紫阳县', 0);
INSERT INTO `idtoad` VALUES (612426, 61, 24, 26, '陕西', '安康地区', '岚皋县', 0);
INSERT INTO `idtoad` VALUES (612427, 61, 24, 27, '陕西', '安康地区', '平利县', 0);
INSERT INTO `idtoad` VALUES (612428, 61, 24, 28, '陕西', '安康地区', '镇坪县', 0);
INSERT INTO `idtoad` VALUES (612429, 61, 24, 29, '陕西', '安康地区', '旬阳县', 0);
INSERT INTO `idtoad` VALUES (612430, 61, 24, 30, '陕西', '安康地区', '白河县', 0);
INSERT INTO `idtoad` VALUES (612500, 61, 25, 0, '陕西', '商洛地区', '', 0);
INSERT INTO `idtoad` VALUES (612501, 61, 25, 1, '陕西', '商洛地区', '商州市', 0);
INSERT INTO `idtoad` VALUES (612522, 61, 25, 22, '陕西', '商洛地区', '洛南县', 0);
INSERT INTO `idtoad` VALUES (612523, 61, 25, 23, '陕西', '商洛地区', '丹凤县', 0);
INSERT INTO `idtoad` VALUES (612524, 61, 25, 24, '陕西', '商洛地区', '商南县', 0);
INSERT INTO `idtoad` VALUES (612525, 61, 25, 25, '陕西', '商洛地区', '山阳县', 0);
INSERT INTO `idtoad` VALUES (612526, 61, 25, 26, '陕西', '商洛地区', '镇安县', 0);
INSERT INTO `idtoad` VALUES (612527, 61, 25, 27, '陕西', '商洛地区', '柞水县', 0);
INSERT INTO `idtoad` VALUES (612700, 61, 27, 0, '陕西', '榆林地区', '', 0);
INSERT INTO `idtoad` VALUES (612701, 61, 27, 1, '陕西', '榆林地区', '榆林市', 0);
INSERT INTO `idtoad` VALUES (612722, 61, 27, 22, '陕西', '榆林地区', '神木县', 0);
INSERT INTO `idtoad` VALUES (612723, 61, 27, 23, '陕西', '榆林地区', '府谷县', 0);
INSERT INTO `idtoad` VALUES (612724, 61, 27, 24, '陕西', '榆林地区', '横山县', 0);
INSERT INTO `idtoad` VALUES (612725, 61, 27, 25, '陕西', '榆林地区', '靖边县', 0);
INSERT INTO `idtoad` VALUES (612726, 61, 27, 26, '陕西', '榆林地区', '定边县', 0);
INSERT INTO `idtoad` VALUES (612727, 61, 27, 27, '陕西', '榆林地区', '绥德县', 0);
INSERT INTO `idtoad` VALUES (612728, 61, 27, 28, '陕西', '榆林地区', '米脂县', 0);
INSERT INTO `idtoad` VALUES (612729, 61, 27, 29, '陕西', '榆林地区', '佳县', 0);
INSERT INTO `idtoad` VALUES (612730, 61, 27, 30, '陕西', '榆林地区', '吴堡县', 0);
INSERT INTO `idtoad` VALUES (612731, 61, 27, 31, '陕西', '榆林地区', '清涧县', 0);
INSERT INTO `idtoad` VALUES (612732, 61, 27, 32, '陕西', '榆林地区', '子洲县', 0);
INSERT INTO `idtoad` VALUES (620000, 62, 0, 0, '甘肃', '', '', 0);
INSERT INTO `idtoad` VALUES (620100, 62, 1, 0, '甘肃', '兰州', '', 0);
INSERT INTO `idtoad` VALUES (620101, 62, 1, 1, '甘肃', '兰州', '市辖区', 0);
INSERT INTO `idtoad` VALUES (620102, 62, 1, 2, '甘肃', '兰州', '城关区', 1);
INSERT INTO `idtoad` VALUES (620103, 62, 1, 3, '甘肃', '兰州', '七里河区', 1);
INSERT INTO `idtoad` VALUES (620104, 62, 1, 4, '甘肃', '兰州', '西固区', 1);
INSERT INTO `idtoad` VALUES (620105, 62, 1, 5, '甘肃', '兰州', '安宁区', 1);
INSERT INTO `idtoad` VALUES (620111, 62, 1, 11, '甘肃', '兰州', '红古区', 1);
INSERT INTO `idtoad` VALUES (620121, 62, 1, 21, '甘肃', '兰州', '永登县', 1);
INSERT INTO `idtoad` VALUES (620122, 62, 1, 22, '甘肃', '兰州', '皋兰县', 1);
INSERT INTO `idtoad` VALUES (620123, 62, 1, 23, '甘肃', '兰州', '榆中县', 1);
INSERT INTO `idtoad` VALUES (620200, 62, 2, 0, '甘肃', '嘉峪关', '嘉峪关', 1);
INSERT INTO `idtoad` VALUES (620201, 62, 2, 1, '甘肃', '嘉峪关', '市辖区', 0);
INSERT INTO `idtoad` VALUES (620300, 62, 3, 0, '甘肃', '金昌', '', 0);
INSERT INTO `idtoad` VALUES (620301, 62, 3, 1, '甘肃', '嘉峪关', '市辖区', 0);
INSERT INTO `idtoad` VALUES (620302, 62, 3, 2, '甘肃', '金昌', '金川区', 1);
INSERT INTO `idtoad` VALUES (620321, 62, 3, 21, '甘肃', '金昌', '永昌县', 1);
INSERT INTO `idtoad` VALUES (620400, 62, 4, 0, '甘肃', '白银', '', 0);
INSERT INTO `idtoad` VALUES (620401, 62, 4, 1, '甘肃', '白银', '市辖区', 0);
INSERT INTO `idtoad` VALUES (620402, 62, 4, 2, '甘肃', '白银', '白银区', 1);
INSERT INTO `idtoad` VALUES (620403, 62, 4, 3, '甘肃', '白银', '平川区', 1);
INSERT INTO `idtoad` VALUES (620421, 62, 4, 21, '甘肃', '白银', '靖远县', 1);
INSERT INTO `idtoad` VALUES (620422, 62, 4, 22, '甘肃', '白银', '会宁县', 1);
INSERT INTO `idtoad` VALUES (620423, 62, 4, 23, '甘肃', '白银', '景泰县', 1);
INSERT INTO `idtoad` VALUES (620500, 62, 5, 0, '甘肃', '天水', '', 0);
INSERT INTO `idtoad` VALUES (620501, 62, 5, 1, '甘肃', '天水', '市辖区', 0);
INSERT INTO `idtoad` VALUES (620502, 62, 5, 2, '甘肃', '天水', '秦州区', 1);
INSERT INTO `idtoad` VALUES (620503, 62, 5, 3, '甘肃', '天水', '麦积区', 1);
INSERT INTO `idtoad` VALUES (620521, 62, 5, 21, '甘肃', '天水', '清水县', 1);
INSERT INTO `idtoad` VALUES (620522, 62, 5, 22, '甘肃', '天水', '秦安县', 1);
INSERT INTO `idtoad` VALUES (620523, 62, 5, 23, '甘肃', '天水', '甘谷县', 1);
INSERT INTO `idtoad` VALUES (620524, 62, 5, 24, '甘肃', '天水', '武山县', 1);
INSERT INTO `idtoad` VALUES (620525, 62, 5, 25, '甘肃', '天水', '张家川回族自治县', 1);
INSERT INTO `idtoad` VALUES (620602, 62, 6, 2, '甘肃', '武威', '凉州区', 1);
INSERT INTO `idtoad` VALUES (620621, 62, 6, 21, '甘肃', '武威', '民勤县', 1);
INSERT INTO `idtoad` VALUES (620622, 62, 6, 22, '甘肃', '武威', '古浪县', 1);
INSERT INTO `idtoad` VALUES (620623, 62, 6, 23, '甘肃', '武威', '天祝藏族自治县', 1);
INSERT INTO `idtoad` VALUES (620702, 62, 7, 2, '甘肃', '张掖', '甘州区', 1);
INSERT INTO `idtoad` VALUES (620721, 62, 7, 21, '甘肃', '张掖', '肃南裕固族自治县', 1);
INSERT INTO `idtoad` VALUES (620722, 62, 7, 22, '甘肃', '张掖', '民乐县', 1);
INSERT INTO `idtoad` VALUES (620723, 62, 7, 23, '甘肃', '张掖', '临泽县', 1);
INSERT INTO `idtoad` VALUES (620724, 62, 7, 24, '甘肃', '张掖', '高台县', 1);
INSERT INTO `idtoad` VALUES (620725, 62, 7, 25, '甘肃', '张掖', '山丹县', 1);
INSERT INTO `idtoad` VALUES (620802, 62, 8, 2, '甘肃', '平凉', '崆峒区', 1);
INSERT INTO `idtoad` VALUES (620821, 62, 8, 21, '甘肃', '平凉', '泾川县', 1);
INSERT INTO `idtoad` VALUES (620822, 62, 8, 22, '甘肃', '平凉', '灵台县', 1);
INSERT INTO `idtoad` VALUES (620823, 62, 8, 23, '甘肃', '平凉', '崇信县', 1);
INSERT INTO `idtoad` VALUES (620824, 62, 8, 24, '甘肃', '平凉', '华亭县', 0);
INSERT INTO `idtoad` VALUES (620825, 62, 8, 25, '甘肃', '平凉', '庄浪县', 1);
INSERT INTO `idtoad` VALUES (620826, 62, 8, 26, '甘肃', '平凉', '静宁县', 1);
INSERT INTO `idtoad` VALUES (620881, 62, 8, 81, '甘肃', '平凉', '华亭市', 1);
INSERT INTO `idtoad` VALUES (620902, 62, 9, 2, '甘肃', '酒泉', '肃州区', 1);
INSERT INTO `idtoad` VALUES (620921, 62, 9, 21, '甘肃', '酒泉', '金塔县', 1);
INSERT INTO `idtoad` VALUES (620922, 62, 9, 22, '甘肃', '酒泉', '瓜州县', 1);
INSERT INTO `idtoad` VALUES (620923, 62, 9, 23, '甘肃', '酒泉', '肃北蒙古族自治县', 1);
INSERT INTO `idtoad` VALUES (620924, 62, 9, 24, '甘肃', '酒泉', '阿克塞哈萨克族自治县', 1);
INSERT INTO `idtoad` VALUES (620981, 62, 9, 81, '甘肃', '酒泉', '玉门市', 1);
INSERT INTO `idtoad` VALUES (620982, 62, 9, 82, '甘肃', '酒泉', '敦煌市', 1);
INSERT INTO `idtoad` VALUES (621002, 62, 10, 2, '甘肃', '庆阳', '西峰区', 1);
INSERT INTO `idtoad` VALUES (621021, 62, 10, 21, '甘肃', '庆阳', '庆城县', 1);
INSERT INTO `idtoad` VALUES (621022, 62, 10, 22, '甘肃', '庆阳', '环县', 1);
INSERT INTO `idtoad` VALUES (621023, 62, 10, 23, '甘肃', '庆阳', '华池县', 1);
INSERT INTO `idtoad` VALUES (621024, 62, 10, 24, '甘肃', '庆阳', '合水县', 1);
INSERT INTO `idtoad` VALUES (621025, 62, 10, 25, '甘肃', '庆阳', '正宁县', 1);
INSERT INTO `idtoad` VALUES (621026, 62, 10, 26, '甘肃', '庆阳', '宁县', 1);
INSERT INTO `idtoad` VALUES (621027, 62, 10, 27, '甘肃', '庆阳', '镇原县', 1);
INSERT INTO `idtoad` VALUES (621102, 62, 11, 2, '甘肃', '定西', '安定区', 1);
INSERT INTO `idtoad` VALUES (621121, 62, 11, 21, '甘肃', '定西', '通渭县', 1);
INSERT INTO `idtoad` VALUES (621122, 62, 11, 22, '甘肃', '定西', '陇西县', 1);
INSERT INTO `idtoad` VALUES (621123, 62, 11, 23, '甘肃', '定西', '渭源县', 1);
INSERT INTO `idtoad` VALUES (621124, 62, 11, 24, '甘肃', '定西', '临洮县', 1);
INSERT INTO `idtoad` VALUES (621125, 62, 11, 25, '甘肃', '定西', '漳县', 1);
INSERT INTO `idtoad` VALUES (621126, 62, 11, 26, '甘肃', '定西', '岷县', 1);
INSERT INTO `idtoad` VALUES (621202, 62, 12, 2, '甘肃', '陇南', '武都区', 1);
INSERT INTO `idtoad` VALUES (621221, 62, 12, 21, '甘肃', '陇南', '成县', 1);
INSERT INTO `idtoad` VALUES (621222, 62, 12, 22, '甘肃', '陇南', '文县', 1);
INSERT INTO `idtoad` VALUES (621223, 62, 12, 23, '甘肃', '陇南', '宕昌县', 1);
INSERT INTO `idtoad` VALUES (621224, 62, 12, 24, '甘肃', '陇南', '康县', 1);
INSERT INTO `idtoad` VALUES (621225, 62, 12, 25, '甘肃', '陇南', '西和县', 1);
INSERT INTO `idtoad` VALUES (621226, 62, 12, 26, '甘肃', '陇南', '礼县', 1);
INSERT INTO `idtoad` VALUES (621227, 62, 12, 27, '甘肃', '陇南', '徽县', 1);
INSERT INTO `idtoad` VALUES (621228, 62, 12, 28, '甘肃', '陇南', '两当县', 1);
INSERT INTO `idtoad` VALUES (622100, 62, 21, 0, '甘肃', '酒泉地区', '', 0);
INSERT INTO `idtoad` VALUES (622101, 62, 21, 1, '甘肃', '酒泉地区', '玉门市', 0);
INSERT INTO `idtoad` VALUES (622102, 62, 21, 2, '甘肃', '酒泉地区', '酒泉市', 0);
INSERT INTO `idtoad` VALUES (622103, 62, 21, 3, '甘肃', '酒泉地区', '敦煌市', 0);
INSERT INTO `idtoad` VALUES (622123, 62, 21, 23, '甘肃', '酒泉地区', '金塔县', 0);
INSERT INTO `idtoad` VALUES (622124, 62, 21, 24, '甘肃', '酒泉地区', '肃北蒙古族自治县', 0);
INSERT INTO `idtoad` VALUES (622125, 62, 21, 25, '甘肃', '酒泉地区', '阿克塞哈萨克族自治县', 0);
INSERT INTO `idtoad` VALUES (622126, 62, 21, 26, '甘肃', '酒泉地区', '安西县', 0);
INSERT INTO `idtoad` VALUES (622200, 62, 22, 0, '甘肃', '张掖地区', '', 0);
INSERT INTO `idtoad` VALUES (622201, 62, 22, 1, '甘肃', '张掖地区', '张掖市', 0);
INSERT INTO `idtoad` VALUES (622222, 62, 22, 22, '甘肃', '张掖地区', '肃南裕固族自治县', 0);
INSERT INTO `idtoad` VALUES (622223, 62, 22, 23, '甘肃', '张掖地区', '民乐县', 0);
INSERT INTO `idtoad` VALUES (622224, 62, 22, 24, '甘肃', '张掖地区', '临泽县', 0);
INSERT INTO `idtoad` VALUES (622225, 62, 22, 25, '甘肃', '张掖地区', '高台县', 0);
INSERT INTO `idtoad` VALUES (622226, 62, 22, 26, '甘肃', '张掖地区', '山丹县', 0);
INSERT INTO `idtoad` VALUES (622300, 62, 23, 0, '甘肃', '武威地区', '', 0);
INSERT INTO `idtoad` VALUES (622301, 62, 23, 1, '甘肃', '武威地区', '武威市', 0);
INSERT INTO `idtoad` VALUES (622322, 62, 23, 22, '甘肃', '武威地区', '民勤县', 0);
INSERT INTO `idtoad` VALUES (622323, 62, 23, 23, '甘肃', '武威地区', '古浪县', 0);
INSERT INTO `idtoad` VALUES (622326, 62, 23, 26, '甘肃', '武威地区', '天祝藏族自治县', 0);
INSERT INTO `idtoad` VALUES (622400, 62, 24, 0, '甘肃', '定西地区', '', 0);
INSERT INTO `idtoad` VALUES (622421, 62, 24, 21, '甘肃', '定西地区', '定西县', 0);
INSERT INTO `idtoad` VALUES (622424, 62, 24, 24, '甘肃', '定西地区', '通渭县', 0);
INSERT INTO `idtoad` VALUES (622425, 62, 24, 25, '甘肃', '定西地区', '陇西县', 0);
INSERT INTO `idtoad` VALUES (622426, 62, 24, 26, '甘肃', '定西地区', '渭源县', 0);
INSERT INTO `idtoad` VALUES (622427, 62, 24, 27, '甘肃', '定西地区', '临洮县', 0);
INSERT INTO `idtoad` VALUES (622428, 62, 24, 28, '甘肃', '定西地区', '漳县', 0);
INSERT INTO `idtoad` VALUES (622429, 62, 24, 29, '甘肃', '定西地区', '岷县', 0);
INSERT INTO `idtoad` VALUES (622600, 62, 26, 0, '甘肃', '陇南地区', '', 0);
INSERT INTO `idtoad` VALUES (622621, 62, 26, 21, '甘肃', '陇南地区', '武都县', 0);
INSERT INTO `idtoad` VALUES (622623, 62, 26, 23, '甘肃', '陇南地区', '宕昌县', 0);
INSERT INTO `idtoad` VALUES (622624, 62, 26, 24, '甘肃', '陇南地区', '成县', 0);
INSERT INTO `idtoad` VALUES (622625, 62, 26, 25, '甘肃', '陇南地区', '康县', 0);
INSERT INTO `idtoad` VALUES (622626, 62, 26, 26, '甘肃', '陇南地区', '文县', 0);
INSERT INTO `idtoad` VALUES (622627, 62, 26, 27, '甘肃', '陇南地区', '西和县', 0);
INSERT INTO `idtoad` VALUES (622628, 62, 26, 28, '甘肃', '陇南地区', '礼县', 0);
INSERT INTO `idtoad` VALUES (622629, 62, 26, 29, '甘肃', '陇南地区', '两当县', 0);
INSERT INTO `idtoad` VALUES (622630, 62, 26, 30, '甘肃', '陇南地区', '徽县', 0);
INSERT INTO `idtoad` VALUES (622700, 62, 27, 0, '甘肃', '平凉地区', '', 0);
INSERT INTO `idtoad` VALUES (622701, 62, 27, 1, '甘肃', '平凉地区', '平凉市', 0);
INSERT INTO `idtoad` VALUES (622722, 62, 27, 22, '甘肃', '平凉地区', '泾川县', 0);
INSERT INTO `idtoad` VALUES (622723, 62, 27, 23, '甘肃', '平凉地区', '灵台县', 0);
INSERT INTO `idtoad` VALUES (622724, 62, 27, 24, '甘肃', '平凉地区', '崇信县', 0);
INSERT INTO `idtoad` VALUES (622725, 62, 27, 25, '甘肃', '平凉地区', '华亭县', 0);
INSERT INTO `idtoad` VALUES (622726, 62, 27, 26, '甘肃', '平凉地区', '庄浪县', 0);
INSERT INTO `idtoad` VALUES (622727, 62, 27, 27, '甘肃', '平凉地区', '静宁县', 0);
INSERT INTO `idtoad` VALUES (622800, 62, 28, 0, '甘肃', '庆阳地区', '', 0);
INSERT INTO `idtoad` VALUES (622801, 62, 28, 1, '甘肃', '庆阳地区', '西峰市', 0);
INSERT INTO `idtoad` VALUES (622821, 62, 28, 21, '甘肃', '庆阳地区', '庆阳县', 0);
INSERT INTO `idtoad` VALUES (622822, 62, 28, 22, '甘肃', '庆阳地区', '环县', 0);
INSERT INTO `idtoad` VALUES (622823, 62, 28, 23, '甘肃', '庆阳地区', '华池县', 0);
INSERT INTO `idtoad` VALUES (622824, 62, 28, 24, '甘肃', '庆阳地区', '合水县', 0);
INSERT INTO `idtoad` VALUES (622825, 62, 28, 25, '甘肃', '庆阳地区', '正宁县', 0);
INSERT INTO `idtoad` VALUES (622826, 62, 28, 26, '甘肃', '庆阳地区', '宁县', 0);
INSERT INTO `idtoad` VALUES (622827, 62, 28, 27, '甘肃', '庆阳地区', '镇原县', 0);
INSERT INTO `idtoad` VALUES (622900, 62, 29, 0, '甘肃', '临夏回族自治州', '', 0);
INSERT INTO `idtoad` VALUES (622901, 62, 29, 1, '甘肃', '临夏回族自治州', '临夏市', 1);
INSERT INTO `idtoad` VALUES (622921, 62, 29, 21, '甘肃', '临夏回族自治州', '临夏县', 1);
INSERT INTO `idtoad` VALUES (622922, 62, 29, 22, '甘肃', '临夏回族自治州', '康乐县', 1);
INSERT INTO `idtoad` VALUES (622923, 62, 29, 23, '甘肃', '临夏回族自治州', '永靖县', 1);
INSERT INTO `idtoad` VALUES (622924, 62, 29, 24, '甘肃', '临夏回族自治州', '广河县', 1);
INSERT INTO `idtoad` VALUES (622925, 62, 29, 25, '甘肃', '临夏回族自治州', '和政县', 1);
INSERT INTO `idtoad` VALUES (622926, 62, 29, 26, '甘肃', '临夏回族自治州', '东乡族自治县', 1);
INSERT INTO `idtoad` VALUES (622927, 62, 29, 27, '甘肃', '临夏回族自治州', '积石山保安族东乡族撒拉族自治县', 1);
INSERT INTO `idtoad` VALUES (623000, 62, 30, 0, '甘肃', '甘南藏族自治州', '', 0);
INSERT INTO `idtoad` VALUES (623001, 62, 30, 1, '甘肃', '甘南藏族自治州', '合作市', 1);
INSERT INTO `idtoad` VALUES (623021, 62, 30, 21, '甘肃', '甘南藏族自治州', '临潭县', 1);
INSERT INTO `idtoad` VALUES (623022, 62, 30, 22, '甘肃', '甘南藏族自治州', '卓尼县', 1);
INSERT INTO `idtoad` VALUES (623023, 62, 30, 23, '甘肃', '甘南藏族自治州', '舟曲县', 1);
INSERT INTO `idtoad` VALUES (623024, 62, 30, 24, '甘肃', '甘南藏族自治州', '迭部县', 1);
INSERT INTO `idtoad` VALUES (623025, 62, 30, 25, '甘肃', '甘南藏族自治州', '玛曲县', 1);
INSERT INTO `idtoad` VALUES (623026, 62, 30, 26, '甘肃', '甘南藏族自治州', '碌曲县', 1);
INSERT INTO `idtoad` VALUES (623027, 62, 30, 27, '甘肃', '甘南藏族自治州', '夏河县', 1);
INSERT INTO `idtoad` VALUES (630000, 63, 0, 0, '青海', '', '', 0);
INSERT INTO `idtoad` VALUES (630100, 63, 1, 0, '青海', '西宁', '', 0);
INSERT INTO `idtoad` VALUES (630101, 63, 1, 1, '青海', '西宁', '市辖区', 0);
INSERT INTO `idtoad` VALUES (630102, 63, 1, 2, '青海', '西宁', '城东区', 1);
INSERT INTO `idtoad` VALUES (630103, 63, 1, 3, '青海', '西宁', '城中区', 1);
INSERT INTO `idtoad` VALUES (630104, 63, 1, 4, '青海', '西宁', '城西区', 1);
INSERT INTO `idtoad` VALUES (630105, 63, 1, 5, '青海', '西宁', '城北区', 1);
INSERT INTO `idtoad` VALUES (630106, 63, 1, 6, '青海', '西宁', '湟中区', 1);
INSERT INTO `idtoad` VALUES (630121, 63, 1, 21, '青海', '西宁', '大通回族土族自治县', 1);
INSERT INTO `idtoad` VALUES (630122, 63, 1, 22, '青海', '西宁', '湟中县', 0);
INSERT INTO `idtoad` VALUES (630123, 63, 1, 23, '青海', '西宁', '湟源县', 1);
INSERT INTO `idtoad` VALUES (630202, 63, 2, 2, '青海', '海东', '乐都区', 1);
INSERT INTO `idtoad` VALUES (630203, 63, 2, 3, '青海', '海东', '平安区', 1);
INSERT INTO `idtoad` VALUES (630222, 63, 2, 22, '青海', '海东', '民和回族土族自治县', 1);
INSERT INTO `idtoad` VALUES (630223, 63, 2, 23, '青海', '海东', '互助土族自治县', 1);
INSERT INTO `idtoad` VALUES (630224, 63, 2, 24, '青海', '海东', '化隆回族自治县', 1);
INSERT INTO `idtoad` VALUES (630225, 63, 2, 25, '青海', '海东', '循化撒拉族自治县', 1);
INSERT INTO `idtoad` VALUES (632100, 63, 21, 0, '青海', '海东地区', '', 0);
INSERT INTO `idtoad` VALUES (632121, 63, 21, 21, '青海', '海东地区', '平安县', 0);
INSERT INTO `idtoad` VALUES (632122, 63, 21, 22, '青海', '海东地区', '民和回族土族自治县', 0);
INSERT INTO `idtoad` VALUES (632123, 63, 21, 23, '青海', '海东地区', '乐都县', 0);
INSERT INTO `idtoad` VALUES (632124, 63, 21, 24, '青海', '海东地区', '湟中县', 0);
INSERT INTO `idtoad` VALUES (632125, 63, 21, 25, '青海', '海东地区', '湟源县', 0);
INSERT INTO `idtoad` VALUES (632126, 63, 21, 26, '青海', '海东地区', '互助土族自治县', 0);
INSERT INTO `idtoad` VALUES (632127, 63, 21, 27, '青海', '海东地区', '化隆回族自治县', 0);
INSERT INTO `idtoad` VALUES (632128, 63, 21, 28, '青海', '海东地区', '循化撒拉族自治县', 0);
INSERT INTO `idtoad` VALUES (632200, 63, 22, 0, '青海', '海北藏族自治州', '', 0);
INSERT INTO `idtoad` VALUES (632221, 63, 22, 21, '青海', '海北藏族自治州', '门源回族自治县', 1);
INSERT INTO `idtoad` VALUES (632222, 63, 22, 22, '青海', '海北藏族自治州', '祁连县', 1);
INSERT INTO `idtoad` VALUES (632223, 63, 22, 23, '青海', '海北藏族自治州', '海晏县', 1);
INSERT INTO `idtoad` VALUES (632224, 63, 22, 24, '青海', '海北藏族自治州', '刚察县', 1);
INSERT INTO `idtoad` VALUES (632300, 63, 23, 0, '青海', '黄南藏族自治州', '', 0);
INSERT INTO `idtoad` VALUES (632301, 63, 23, 1, '青海', '黄南藏族自治州', '同仁市', 1);
INSERT INTO `idtoad` VALUES (632321, 63, 23, 21, '青海', '黄南藏族自治州', '同仁县', 0);
INSERT INTO `idtoad` VALUES (632322, 63, 23, 22, '青海', '黄南藏族自治州', '尖扎县', 1);
INSERT INTO `idtoad` VALUES (632323, 63, 23, 23, '青海', '黄南藏族自治州', '泽库县', 1);
INSERT INTO `idtoad` VALUES (632324, 63, 23, 24, '青海', '黄南藏族自治州', '河南蒙古族自治县', 1);
INSERT INTO `idtoad` VALUES (632500, 63, 25, 0, '青海', '海南藏族自治州', '', 0);
INSERT INTO `idtoad` VALUES (632521, 63, 25, 21, '青海', '海南藏族自治州', '共和县', 1);
INSERT INTO `idtoad` VALUES (632522, 63, 25, 22, '青海', '海南藏族自治州', '同德县', 1);
INSERT INTO `idtoad` VALUES (632523, 63, 25, 23, '青海', '海南藏族自治州', '贵德县', 1);
INSERT INTO `idtoad` VALUES (632524, 63, 25, 24, '青海', '海南藏族自治州', '兴海县', 1);
INSERT INTO `idtoad` VALUES (632525, 63, 25, 25, '青海', '海南藏族自治州', '贵南县', 1);
INSERT INTO `idtoad` VALUES (632600, 63, 26, 0, '青海', '果洛藏族自治州', '', 0);
INSERT INTO `idtoad` VALUES (632621, 63, 26, 21, '青海', '果洛藏族自治州', '玛沁县', 1);
INSERT INTO `idtoad` VALUES (632622, 63, 26, 22, '青海', '果洛藏族自治州', '班玛县', 1);
INSERT INTO `idtoad` VALUES (632623, 63, 26, 23, '青海', '果洛藏族自治州', '甘德县', 1);
INSERT INTO `idtoad` VALUES (632624, 63, 26, 24, '青海', '果洛藏族自治州', '达日县', 1);
INSERT INTO `idtoad` VALUES (632625, 63, 26, 25, '青海', '果洛藏族自治州', '久治县', 1);
INSERT INTO `idtoad` VALUES (632626, 63, 26, 26, '青海', '果洛藏族自治州', '玛多县', 1);
INSERT INTO `idtoad` VALUES (632700, 63, 27, 0, '青海', '玉树藏族自治州', '', 0);
INSERT INTO `idtoad` VALUES (632701, 63, 27, 1, '青海', '玉树藏族自治州', '玉树市', 1);
INSERT INTO `idtoad` VALUES (632721, 63, 27, 21, '青海', '玉树藏族自治州', '玉树县', 0);
INSERT INTO `idtoad` VALUES (632722, 63, 27, 22, '青海', '玉树藏族自治州', '杂多县', 1);
INSERT INTO `idtoad` VALUES (632723, 63, 27, 23, '青海', '玉树藏族自治州', '称多县', 1);
INSERT INTO `idtoad` VALUES (632724, 63, 27, 24, '青海', '玉树藏族自治州', '治多县', 1);
INSERT INTO `idtoad` VALUES (632725, 63, 27, 25, '青海', '玉树藏族自治州', '囊谦县', 1);
INSERT INTO `idtoad` VALUES (632726, 63, 27, 26, '青海', '玉树藏族自治州', '曲麻莱县', 1);
INSERT INTO `idtoad` VALUES (632800, 63, 28, 0, '青海', '海西蒙古族藏族自治州', '', 0);
INSERT INTO `idtoad` VALUES (632801, 63, 28, 1, '青海', '海西蒙古族藏族自治州', '格尔木市', 1);
INSERT INTO `idtoad` VALUES (632802, 63, 28, 2, '青海', '海西蒙古族藏族自治州', '德令哈市', 1);
INSERT INTO `idtoad` VALUES (632803, 63, 28, 3, '青海', '海西蒙古族藏族自治州', '茫崖市', 1);
INSERT INTO `idtoad` VALUES (632821, 63, 28, 21, '青海', '海西蒙古族藏族自治州', '乌兰县', 1);
INSERT INTO `idtoad` VALUES (632822, 63, 28, 22, '青海', '海西蒙古族藏族自治州', '都兰县', 1);
INSERT INTO `idtoad` VALUES (632823, 63, 28, 23, '青海', '海西蒙古族藏族自治州', '天峻县', 1);
INSERT INTO `idtoad` VALUES (640000, 64, 0, 0, '宁夏回族自治区', '', '', 0);
INSERT INTO `idtoad` VALUES (640100, 64, 1, 0, '宁夏回族自治区', '银川市', '', 0);
INSERT INTO `idtoad` VALUES (640101, 64, 1, 1, '宁夏回族自治区', '银川市', '辖区', 0);
INSERT INTO `idtoad` VALUES (640102, 64, 1, 2, '宁夏回族自治区', '银川市', '城区', 0);
INSERT INTO `idtoad` VALUES (640103, 64, 1, 3, '宁夏回族自治区', '银川市', '新城区', 0);
INSERT INTO `idtoad` VALUES (640104, 64, 1, 4, '宁夏', '银川', '兴庆区', 1);
INSERT INTO `idtoad` VALUES (640105, 64, 1, 5, '宁夏', '银川', '西夏区', 1);
INSERT INTO `idtoad` VALUES (640106, 64, 1, 6, '宁夏', '银川', '金凤区', 1);
INSERT INTO `idtoad` VALUES (640111, 64, 1, 11, '宁夏回族自治区', '银川市', '郊区', 0);
INSERT INTO `idtoad` VALUES (640121, 64, 1, 21, '宁夏', '银川', '永宁县', 1);
INSERT INTO `idtoad` VALUES (640122, 64, 1, 22, '宁夏', '银川', '贺兰县', 1);
INSERT INTO `idtoad` VALUES (640181, 64, 1, 81, '宁夏', '银川', '灵武市', 1);
INSERT INTO `idtoad` VALUES (640200, 64, 2, 0, '宁夏回族自治区', '石嘴山市', '', 0);
INSERT INTO `idtoad` VALUES (640201, 64, 2, 1, '宁夏回族自治区', '石嘴山市', '市辖区', 0);
INSERT INTO `idtoad` VALUES (640202, 64, 2, 2, '宁夏', '石嘴山', '大武口区', 1);
INSERT INTO `idtoad` VALUES (640203, 64, 2, 3, '宁夏回族自治区', '石嘴山市', '石嘴山区', 0);
INSERT INTO `idtoad` VALUES (640204, 64, 2, 4, '宁夏回族自治区', '石嘴山市', '石炭井区', 0);
INSERT INTO `idtoad` VALUES (640205, 64, 2, 5, '宁夏', '石嘴山', '惠农区', 1);
INSERT INTO `idtoad` VALUES (640221, 64, 2, 21, '宁夏', '石嘴山', '平罗县', 1);
INSERT INTO `idtoad` VALUES (640222, 64, 2, 22, '宁夏回族自治区', '石嘴山市', '陶乐县', 0);
INSERT INTO `idtoad` VALUES (640223, 64, 2, 23, '宁夏回族自治区', '石嘴山市', '惠农县', 0);
INSERT INTO `idtoad` VALUES (640300, 64, 3, 0, '宁夏回族自治区', '吴忠市', '', 0);
INSERT INTO `idtoad` VALUES (640301, 64, 3, 1, '宁夏回族自治区', '吴忠市', '市辖区', 0);
INSERT INTO `idtoad` VALUES (640302, 64, 3, 2, '宁夏', '吴忠', '利通区', 1);
INSERT INTO `idtoad` VALUES (640303, 64, 3, 3, '宁夏', '吴忠', '红寺堡区', 1);
INSERT INTO `idtoad` VALUES (640321, 64, 3, 21, '宁夏回族自治区', '吴忠市', '中卫县', 0);
INSERT INTO `idtoad` VALUES (640322, 64, 3, 22, '宁夏回族自治区', '吴忠市', '中宁县', 0);
INSERT INTO `idtoad` VALUES (640323, 64, 3, 23, '宁夏', '吴忠', '盐池县', 1);
INSERT INTO `idtoad` VALUES (640324, 64, 3, 24, '宁夏', '吴忠', '同心县', 1);
INSERT INTO `idtoad` VALUES (640381, 64, 3, 81, '宁夏', '吴忠', '青铜峡市', 1);
INSERT INTO `idtoad` VALUES (640382, 64, 3, 82, '宁夏回族自治区', '吴忠市', '灵武市', 0);
INSERT INTO `idtoad` VALUES (640402, 64, 4, 2, '宁夏', '固原', '原州区', 1);
INSERT INTO `idtoad` VALUES (640422, 64, 4, 22, '宁夏', '固原', '西吉县', 1);
INSERT INTO `idtoad` VALUES (640423, 64, 4, 23, '宁夏', '固原', '隆德县', 1);
INSERT INTO `idtoad` VALUES (640424, 64, 4, 24, '宁夏', '固原', '泾源县', 1);
INSERT INTO `idtoad` VALUES (640425, 64, 4, 25, '宁夏', '固原', '彭阳县', 1);
INSERT INTO `idtoad` VALUES (640502, 64, 5, 2, '宁夏', '中卫', '沙坡头区', 1);
INSERT INTO `idtoad` VALUES (640521, 64, 5, 21, '宁夏', '中卫', '中宁县', 1);
INSERT INTO `idtoad` VALUES (640522, 64, 5, 22, '宁夏', '中卫', '海原县', 1);
INSERT INTO `idtoad` VALUES (642200, 64, 22, 0, '宁夏回族自治区', '固原地区', '', 0);
INSERT INTO `idtoad` VALUES (642221, 64, 22, 21, '宁夏回族自治区', '固原地区', '固原县', 0);
INSERT INTO `idtoad` VALUES (642222, 64, 22, 22, '宁夏回族自治区', '固原地区', '海原县', 0);
INSERT INTO `idtoad` VALUES (642223, 64, 22, 23, '宁夏回族自治区', '固原地区', '西吉县', 0);
INSERT INTO `idtoad` VALUES (642224, 64, 22, 24, '宁夏回族自治区', '固原地区', '隆德县', 0);
INSERT INTO `idtoad` VALUES (642225, 64, 22, 25, '宁夏回族自治区', '固原地区', '泾源县', 0);
INSERT INTO `idtoad` VALUES (642226, 64, 22, 26, '宁夏回族自治区', '固原地区', '彭阳县', 0);
INSERT INTO `idtoad` VALUES (650000, 65, 0, 0, '新疆', '', '', 0);
INSERT INTO `idtoad` VALUES (650100, 65, 1, 0, '新疆', '乌鲁木齐市', '', 0);
INSERT INTO `idtoad` VALUES (650101, 65, 1, 1, '新疆', '乌鲁木齐市', '市辖区', 0);
INSERT INTO `idtoad` VALUES (650102, 65, 1, 2, '新疆', '乌鲁木齐', '天山区', 1);
INSERT INTO `idtoad` VALUES (650103, 65, 1, 3, '新疆', '乌鲁木齐', '沙依巴克区', 1);
INSERT INTO `idtoad` VALUES (650104, 65, 1, 4, '新疆', '乌鲁木齐', '新市区', 1);
INSERT INTO `idtoad` VALUES (650105, 65, 1, 5, '新疆', '乌鲁木齐', '水磨沟区', 1);
INSERT INTO `idtoad` VALUES (650106, 65, 1, 6, '新疆', '乌鲁木齐', '头屯河区', 1);
INSERT INTO `idtoad` VALUES (650107, 65, 1, 7, '新疆', '乌鲁木齐', '达坂城区', 1);
INSERT INTO `idtoad` VALUES (650108, 65, 1, 8, '新疆', '乌鲁木齐市', '东山区', 0);
INSERT INTO `idtoad` VALUES (650109, 65, 1, 9, '新疆', '乌鲁木齐', '米东区', 1);
INSERT INTO `idtoad` VALUES (650121, 65, 1, 21, '新疆', '乌鲁木齐', '乌鲁木齐县', 1);
INSERT INTO `idtoad` VALUES (650200, 65, 2, 0, '新疆', '克拉玛依', '', 0);
INSERT INTO `idtoad` VALUES (650201, 65, 2, 1, '新疆', '克拉玛依', '市辖区', 0);
INSERT INTO `idtoad` VALUES (650202, 65, 2, 2, '新疆', '克拉玛依', '独山子区', 1);
INSERT INTO `idtoad` VALUES (650203, 65, 2, 3, '新疆', '克拉玛依', '克拉玛依区', 1);
INSERT INTO `idtoad` VALUES (650204, 65, 2, 4, '新疆', '克拉玛依', '白碱滩区', 1);
INSERT INTO `idtoad` VALUES (650205, 65, 2, 5, '新疆', '克拉玛依', '乌尔禾区', 1);
INSERT INTO `idtoad` VALUES (650402, 65, 4, 2, '新疆', '吐鲁番', '高昌区', 1);
INSERT INTO `idtoad` VALUES (650421, 65, 4, 21, '新疆', '吐鲁番', '鄯善县', 1);
INSERT INTO `idtoad` VALUES (650422, 65, 4, 22, '新疆', '吐鲁番', '托克逊县', 1);
INSERT INTO `idtoad` VALUES (650502, 65, 5, 2, '新疆', '哈密', '伊州区', 1);
INSERT INTO `idtoad` VALUES (650521, 65, 5, 21, '新疆', '哈密', '巴里坤哈萨克自治县', 1);
INSERT INTO `idtoad` VALUES (650522, 65, 5, 22, '新疆', '哈密', '伊吾县', 1);
INSERT INTO `idtoad` VALUES (652100, 65, 21, 0, '新疆', '吐鲁番地区', '', 0);
INSERT INTO `idtoad` VALUES (652101, 65, 21, 1, '新疆', '吐鲁番地区', '吐鲁番市', 0);
INSERT INTO `idtoad` VALUES (652122, 65, 21, 22, '新疆', '吐鲁番地区', '鄯善县', 0);
INSERT INTO `idtoad` VALUES (652123, 65, 21, 23, '新疆', '吐鲁番地区', '托克逊县', 0);
INSERT INTO `idtoad` VALUES (652200, 65, 22, 0, '新疆', '哈密地区', '', 0);
INSERT INTO `idtoad` VALUES (652201, 65, 22, 1, '新疆', '哈密地区', '哈密市', 0);
INSERT INTO `idtoad` VALUES (652222, 65, 22, 22, '新疆', '哈密地区', '巴里坤哈萨克自治县', 0);
INSERT INTO `idtoad` VALUES (652223, 65, 22, 23, '新疆', '哈密地区', '伊吾县', 0);
INSERT INTO `idtoad` VALUES (652300, 65, 23, 0, '新疆', '昌吉回族自治州', '', 0);
INSERT INTO `idtoad` VALUES (652301, 65, 23, 1, '新疆', '昌吉回族自治州', '昌吉市', 1);
INSERT INTO `idtoad` VALUES (652302, 65, 23, 2, '新疆', '昌吉回族自治州', '阜康市', 1);
INSERT INTO `idtoad` VALUES (652303, 65, 23, 3, '新疆', '昌吉回族自治州', '米泉市', 0);
INSERT INTO `idtoad` VALUES (652323, 65, 23, 23, '新疆', '昌吉回族自治州', '呼图壁县', 1);
INSERT INTO `idtoad` VALUES (652324, 65, 23, 24, '新疆', '昌吉回族自治州', '玛纳斯县', 1);
INSERT INTO `idtoad` VALUES (652325, 65, 23, 25, '新疆', '昌吉回族自治州', '奇台县', 1);
INSERT INTO `idtoad` VALUES (652327, 65, 23, 27, '新疆', '昌吉回族自治州', '吉木萨尔县', 1);
INSERT INTO `idtoad` VALUES (652328, 65, 23, 28, '新疆', '昌吉回族自治州', '木垒哈萨克自治县', 1);
INSERT INTO `idtoad` VALUES (652700, 65, 27, 0, '新疆', '博尔塔拉蒙古自治州', '', 0);
INSERT INTO `idtoad` VALUES (652701, 65, 27, 1, '新疆', '博尔塔拉蒙古自治州', '博乐市', 1);
INSERT INTO `idtoad` VALUES (652702, 65, 27, 2, '新疆', '博尔塔拉蒙古自治州', '阿拉山口市', 1);
INSERT INTO `idtoad` VALUES (652722, 65, 27, 22, '新疆', '博尔塔拉蒙古自治州', '精河县', 1);
INSERT INTO `idtoad` VALUES (652723, 65, 27, 23, '新疆', '博尔塔拉蒙古自治州', '温泉县', 1);
INSERT INTO `idtoad` VALUES (652800, 65, 28, 0, '新疆', '巴音郭楞蒙古自治州', '', 0);
INSERT INTO `idtoad` VALUES (652801, 65, 28, 1, '新疆', '巴音郭楞蒙古自治州', '库尔勒市', 1);
INSERT INTO `idtoad` VALUES (652822, 65, 28, 22, '新疆', '巴音郭楞蒙古自治州', '轮台县', 1);
INSERT INTO `idtoad` VALUES (652823, 65, 28, 23, '新疆', '巴音郭楞蒙古自治州', '尉犁县', 1);
INSERT INTO `idtoad` VALUES (652824, 65, 28, 24, '新疆', '巴音郭楞蒙古自治州', '若羌县', 1);
INSERT INTO `idtoad` VALUES (652825, 65, 28, 25, '新疆', '巴音郭楞蒙古自治州', '且末县', 1);
INSERT INTO `idtoad` VALUES (652826, 65, 28, 26, '新疆', '巴音郭楞蒙古自治州', '焉耆回族自治县', 1);
INSERT INTO `idtoad` VALUES (652827, 65, 28, 27, '新疆', '巴音郭楞蒙古自治州', '和静县', 1);
INSERT INTO `idtoad` VALUES (652828, 65, 28, 28, '新疆', '巴音郭楞蒙古自治州', '和硕县', 1);
INSERT INTO `idtoad` VALUES (652829, 65, 28, 29, '新疆', '巴音郭楞蒙古自治州', '博湖县', 1);
INSERT INTO `idtoad` VALUES (652900, 65, 29, 0, '新疆', '阿克苏地区', '', 0);
INSERT INTO `idtoad` VALUES (652901, 65, 29, 1, '新疆', '阿克苏地区', '阿克苏市', 1);
INSERT INTO `idtoad` VALUES (652902, 65, 29, 2, '新疆', '阿克苏地区', '库车市', 1);
INSERT INTO `idtoad` VALUES (652922, 65, 29, 22, '新疆', '阿克苏地区', '温宿县', 1);
INSERT INTO `idtoad` VALUES (652923, 65, 29, 23, '新疆', '阿克苏地区', '库车县', 0);
INSERT INTO `idtoad` VALUES (652924, 65, 29, 24, '新疆', '阿克苏地区', '沙雅县', 1);
INSERT INTO `idtoad` VALUES (652925, 65, 29, 25, '新疆', '阿克苏地区', '新和县', 1);
INSERT INTO `idtoad` VALUES (652926, 65, 29, 26, '新疆', '阿克苏地区', '拜城县', 1);
INSERT INTO `idtoad` VALUES (652927, 65, 29, 27, '新疆', '阿克苏地区', '乌什县', 1);
INSERT INTO `idtoad` VALUES (652928, 65, 29, 28, '新疆', '阿克苏地区', '阿瓦提县', 1);
INSERT INTO `idtoad` VALUES (652929, 65, 29, 29, '新疆', '阿克苏地区', '柯坪县', 1);
INSERT INTO `idtoad` VALUES (653000, 65, 30, 0, '新疆', '克孜勒苏柯尔克孜自治州', '', 0);
INSERT INTO `idtoad` VALUES (653001, 65, 30, 1, '新疆', '克孜勒苏柯尔克孜自治州', '阿图什市', 1);
INSERT INTO `idtoad` VALUES (653022, 65, 30, 22, '新疆', '克孜勒苏柯尔克孜自治州', '阿克陶县', 1);
INSERT INTO `idtoad` VALUES (653023, 65, 30, 23, '新疆', '克孜勒苏柯尔克孜自治州', '阿合奇县', 1);
INSERT INTO `idtoad` VALUES (653024, 65, 30, 24, '新疆', '克孜勒苏柯尔克孜自治州', '乌恰县', 1);
INSERT INTO `idtoad` VALUES (653100, 65, 31, 0, '新疆', '喀什地区', '', 0);
INSERT INTO `idtoad` VALUES (653101, 65, 31, 1, '新疆', '喀什地区', '喀什市', 1);
INSERT INTO `idtoad` VALUES (653121, 65, 31, 21, '新疆', '喀什地区', '疏附县', 1);
INSERT INTO `idtoad` VALUES (653122, 65, 31, 22, '新疆', '喀什地区', '疏勒县', 1);
INSERT INTO `idtoad` VALUES (653123, 65, 31, 23, '新疆', '喀什地区', '英吉沙县', 1);
INSERT INTO `idtoad` VALUES (653124, 65, 31, 24, '新疆', '喀什地区', '泽普县', 1);
INSERT INTO `idtoad` VALUES (653125, 65, 31, 25, '新疆', '喀什地区', '莎车县', 1);
INSERT INTO `idtoad` VALUES (653126, 65, 31, 26, '新疆', '喀什地区', '叶城县', 1);
INSERT INTO `idtoad` VALUES (653127, 65, 31, 27, '新疆', '喀什地区', '麦盖提县', 1);
INSERT INTO `idtoad` VALUES (653128, 65, 31, 28, '新疆', '喀什地区', '岳普湖县', 1);
INSERT INTO `idtoad` VALUES (653129, 65, 31, 29, '新疆', '喀什地区', '伽师县', 1);
INSERT INTO `idtoad` VALUES (653130, 65, 31, 30, '新疆', '喀什地区', '巴楚县', 1);
INSERT INTO `idtoad` VALUES (653131, 65, 31, 31, '新疆', '喀什地区', '塔什库尔干塔吉克自治县', 1);
INSERT INTO `idtoad` VALUES (653200, 65, 32, 0, '新疆', '和田地区', '', 0);
INSERT INTO `idtoad` VALUES (653201, 65, 32, 1, '新疆', '和田地区', '和田市', 1);
INSERT INTO `idtoad` VALUES (653221, 65, 32, 21, '新疆', '和田地区', '和田县', 1);
INSERT INTO `idtoad` VALUES (653222, 65, 32, 22, '新疆', '和田地区', '墨玉县', 1);
INSERT INTO `idtoad` VALUES (653223, 65, 32, 23, '新疆', '和田地区', '皮山县', 1);
INSERT INTO `idtoad` VALUES (653224, 65, 32, 24, '新疆', '和田地区', '洛浦县', 1);
INSERT INTO `idtoad` VALUES (653225, 65, 32, 25, '新疆', '和田地区', '策勒县', 1);
INSERT INTO `idtoad` VALUES (653226, 65, 32, 26, '新疆', '和田地区', '于田县', 1);
INSERT INTO `idtoad` VALUES (653227, 65, 32, 27, '新疆', '和田地区', '民丰县', 1);
INSERT INTO `idtoad` VALUES (654000, 65, 40, 0, '新疆', '伊犁哈萨克自治州', '', 0);
INSERT INTO `idtoad` VALUES (654001, 65, 40, 1, '新疆', '伊犁哈萨克自治州', '奎屯市', 0);
INSERT INTO `idtoad` VALUES (654002, 65, 40, 2, '新疆', '伊犁哈萨克自治州', '伊宁市', 1);
INSERT INTO `idtoad` VALUES (654003, 65, 40, 3, '新疆', '伊犁哈萨克自治州', '奎屯市', 1);
INSERT INTO `idtoad` VALUES (654004, 65, 40, 4, '新疆', '伊犁哈萨克自治州', '霍尔果斯市', 1);
INSERT INTO `idtoad` VALUES (654021, 65, 40, 21, '新疆', '伊犁哈萨克自治州', '伊宁县', 1);
INSERT INTO `idtoad` VALUES (654022, 65, 40, 22, '新疆', '伊犁哈萨克自治州', '察布查尔锡伯自治县', 1);
INSERT INTO `idtoad` VALUES (654023, 65, 40, 23, '新疆', '伊犁哈萨克自治州', '霍城县', 1);
INSERT INTO `idtoad` VALUES (654024, 65, 40, 24, '新疆', '伊犁哈萨克自治州', '巩留县', 1);
INSERT INTO `idtoad` VALUES (654025, 65, 40, 25, '新疆', '伊犁哈萨克自治州', '新源县', 1);
INSERT INTO `idtoad` VALUES (654026, 65, 40, 26, '新疆', '伊犁哈萨克自治州', '昭苏县', 1);
INSERT INTO `idtoad` VALUES (654027, 65, 40, 27, '新疆', '伊犁哈萨克自治州', '特克斯县', 1);
INSERT INTO `idtoad` VALUES (654028, 65, 40, 28, '新疆', '伊犁哈萨克自治州', '尼勒克县', 1);
INSERT INTO `idtoad` VALUES (654100, 65, 41, 0, '新疆', '伊犁哈萨克自治州', '', 0);
INSERT INTO `idtoad` VALUES (654101, 65, 41, 1, '新疆', '伊犁哈萨克自治州', '伊宁市', 0);
INSERT INTO `idtoad` VALUES (654121, 65, 41, 21, '新疆', '伊犁哈萨克自治州', '伊宁县', 0);
INSERT INTO `idtoad` VALUES (654122, 65, 41, 22, '新疆', '伊犁哈萨克自治州', '新疆自治区察布查尔锡伯自治县', 0);
INSERT INTO `idtoad` VALUES (654123, 65, 41, 23, '新疆', '伊犁哈萨克自治州', '霍城县', 0);
INSERT INTO `idtoad` VALUES (654124, 65, 41, 24, '新疆', '伊犁哈萨克自治州', '巩留县', 0);
INSERT INTO `idtoad` VALUES (654125, 65, 41, 25, '新疆', '伊犁哈萨克自治州', '新源县', 0);
INSERT INTO `idtoad` VALUES (654126, 65, 41, 26, '新疆', '伊犁哈萨克自治州', '昭苏县', 0);
INSERT INTO `idtoad` VALUES (654127, 65, 41, 27, '新疆', '伊犁哈萨克自治州', '特克斯县', 0);
INSERT INTO `idtoad` VALUES (654128, 65, 41, 28, '新疆', '伊犁哈萨克自治州', '尼勒克县', 0);
INSERT INTO `idtoad` VALUES (654200, 65, 42, 0, '新疆', '塔城地区', '', 0);
INSERT INTO `idtoad` VALUES (654201, 65, 42, 1, '新疆', '塔城地区', '塔城市', 1);
INSERT INTO `idtoad` VALUES (654202, 65, 42, 2, '新疆', '塔城地区', '乌苏市', 1);
INSERT INTO `idtoad` VALUES (654221, 65, 42, 21, '新疆', '塔城地区', '额敏县', 1);
INSERT INTO `idtoad` VALUES (654223, 65, 42, 23, '新疆', '塔城地区', '沙湾县', 1);
INSERT INTO `idtoad` VALUES (654224, 65, 42, 24, '新疆', '塔城地区', '托里县', 1);
INSERT INTO `idtoad` VALUES (654225, 65, 42, 25, '新疆', '塔城地区', '裕民县', 1);
INSERT INTO `idtoad` VALUES (654226, 65, 42, 26, '新疆', '塔城地区', '和布克赛尔蒙古自治县', 1);
INSERT INTO `idtoad` VALUES (654300, 65, 43, 0, '新疆', '阿勒泰地区', '', 0);
INSERT INTO `idtoad` VALUES (654301, 65, 43, 1, '新疆', '阿勒泰地区', '阿勒泰市', 1);
INSERT INTO `idtoad` VALUES (654321, 65, 43, 21, '新疆', '阿勒泰地区', '布尔津县', 1);
INSERT INTO `idtoad` VALUES (654322, 65, 43, 22, '新疆', '阿勒泰地区', '富蕴县', 1);
INSERT INTO `idtoad` VALUES (654323, 65, 43, 23, '新疆', '阿勒泰地区', '福海县', 1);
INSERT INTO `idtoad` VALUES (654324, 65, 43, 24, '新疆', '阿勒泰地区', '哈巴河县', 1);
INSERT INTO `idtoad` VALUES (654325, 65, 43, 25, '新疆', '阿勒泰地区', '青河县', 1);
INSERT INTO `idtoad` VALUES (654326, 65, 43, 26, '新疆', '阿勒泰地区', '吉木乃县', 1);
INSERT INTO `idtoad` VALUES (659000, 65, 90, 0, '新疆', '直辖县', '', 0);
INSERT INTO `idtoad` VALUES (659001, 65, 90, 1, '新疆', '石河子', '石河子', 1);
INSERT INTO `idtoad` VALUES (659002, 65, 90, 2, '新疆', '阿拉尔', '阿拉尔', 1);
INSERT INTO `idtoad` VALUES (659003, 65, 90, 3, '新疆', '图木舒克', '图木舒克', 1);
INSERT INTO `idtoad` VALUES (659004, 65, 90, 4, '新疆', '五家渠', '五家渠', 1);
INSERT INTO `idtoad` VALUES (659005, 65, 90, 5, '新疆', '北屯', '北屯', 1);
INSERT INTO `idtoad` VALUES (659006, 65, 90, 6, '新疆', '铁门关', '铁门关', 1);
INSERT INTO `idtoad` VALUES (659007, 65, 90, 7, '新疆', '双河', '双河', 1);
INSERT INTO `idtoad` VALUES (659008, 65, 90, 8, '新疆', '可克达拉', '可克达拉', 1);
INSERT INTO `idtoad` VALUES (659009, 65, 90, 9, '新疆', '昆玉', '昆玉', 1);
INSERT INTO `idtoad` VALUES (659010, 65, 90, 10, '新疆', '胡杨河', '胡杨河', 1);
INSERT INTO `idtoad` VALUES (710101, 71, 1, 1, '台湾', '新北市', '板桥区', 1);
INSERT INTO `idtoad` VALUES (710102, 71, 1, 2, '台湾', '新北市', '新庄区', 1);
INSERT INTO `idtoad` VALUES (710103, 71, 1, 3, '台湾', '新北市', '中和区', 1);
INSERT INTO `idtoad` VALUES (710104, 71, 1, 4, '台湾', '新北市', '永和区', 1);
INSERT INTO `idtoad` VALUES (710105, 71, 1, 5, '台湾', '新北市', '土城区', 1);
INSERT INTO `idtoad` VALUES (710106, 71, 1, 6, '台湾', '新北市', '树林区', 1);
INSERT INTO `idtoad` VALUES (710107, 71, 1, 7, '台湾', '新北市', '三峡区', 1);
INSERT INTO `idtoad` VALUES (710108, 71, 1, 8, '台湾', '新北市', '莺歌区', 1);
INSERT INTO `idtoad` VALUES (710109, 71, 1, 9, '台湾', '新北市', '三重区', 1);
INSERT INTO `idtoad` VALUES (710110, 71, 1, 10, '台湾', '新北市', '芦洲区', 1);
INSERT INTO `idtoad` VALUES (710111, 71, 1, 11, '台湾', '新北市', '五股区', 1);
INSERT INTO `idtoad` VALUES (710112, 71, 1, 12, '台湾', '新北市', '泰山区', 1);
INSERT INTO `idtoad` VALUES (710113, 71, 1, 13, '台湾', '新北市', '林口区', 1);
INSERT INTO `idtoad` VALUES (710114, 71, 1, 14, '台湾', '新北市', '淡水区', 1);
INSERT INTO `idtoad` VALUES (710115, 71, 1, 15, '台湾', '新北市', '金山区', 1);
INSERT INTO `idtoad` VALUES (710116, 71, 1, 16, '台湾', '新北市', '八里区', 1);
INSERT INTO `idtoad` VALUES (710117, 71, 1, 17, '台湾', '新北市', '万里区', 1);
INSERT INTO `idtoad` VALUES (710118, 71, 1, 18, '台湾', '新北市', '石门区', 1);
INSERT INTO `idtoad` VALUES (710119, 71, 1, 19, '台湾', '新北市', '三芝区', 1);
INSERT INTO `idtoad` VALUES (710120, 71, 1, 20, '台湾', '新北市', '瑞芳区', 1);
INSERT INTO `idtoad` VALUES (710121, 71, 1, 21, '台湾', '新北市', '汐止区', 1);
INSERT INTO `idtoad` VALUES (710122, 71, 1, 22, '台湾', '新北市', '平溪区', 1);
INSERT INTO `idtoad` VALUES (710123, 71, 1, 23, '台湾', '新北市', '贡寮区', 1);
INSERT INTO `idtoad` VALUES (710124, 71, 1, 24, '台湾', '新北市', '双溪区', 1);
INSERT INTO `idtoad` VALUES (710125, 71, 1, 25, '台湾', '新北市', '深坑区', 1);
INSERT INTO `idtoad` VALUES (710126, 71, 1, 26, '台湾', '新北市', '石碇区', 1);
INSERT INTO `idtoad` VALUES (710127, 71, 1, 27, '台湾', '新北市', '新店区', 1);
INSERT INTO `idtoad` VALUES (710128, 71, 1, 28, '台湾', '新北市', '坪林区', 1);
INSERT INTO `idtoad` VALUES (710129, 71, 1, 29, '台湾', '新北市', '乌来区', 1);
INSERT INTO `idtoad` VALUES (710201, 71, 2, 1, '台湾', '高雄市', '楠梓区', 1);
INSERT INTO `idtoad` VALUES (710202, 71, 2, 2, '台湾', '高雄市', '左营区', 1);
INSERT INTO `idtoad` VALUES (710203, 71, 2, 3, '台湾', '高雄市', '鼓山区', 1);
INSERT INTO `idtoad` VALUES (710204, 71, 2, 4, '台湾', '高雄市', '三民区', 1);
INSERT INTO `idtoad` VALUES (710205, 71, 2, 5, '台湾', '高雄市', '盐埕区', 1);
INSERT INTO `idtoad` VALUES (710206, 71, 2, 6, '台湾', '高雄市', '前金区', 1);
INSERT INTO `idtoad` VALUES (710207, 71, 2, 7, '台湾', '高雄市', '新兴区', 1);
INSERT INTO `idtoad` VALUES (710208, 71, 2, 8, '台湾', '高雄市', '苓雅区', 1);
INSERT INTO `idtoad` VALUES (710209, 71, 2, 9, '台湾', '高雄市', '前镇区', 1);
INSERT INTO `idtoad` VALUES (710210, 71, 2, 10, '台湾', '高雄市', '旗津区', 1);
INSERT INTO `idtoad` VALUES (710211, 71, 2, 11, '台湾', '高雄市', '小港区', 1);
INSERT INTO `idtoad` VALUES (710212, 71, 2, 12, '台湾', '高雄市', '凤山区', 1);
INSERT INTO `idtoad` VALUES (710213, 71, 2, 13, '台湾', '高雄市', '大寮区', 1);
INSERT INTO `idtoad` VALUES (710214, 71, 2, 14, '台湾', '高雄市', '鸟松区', 1);
INSERT INTO `idtoad` VALUES (710215, 71, 2, 15, '台湾', '高雄市', '林园区', 1);
INSERT INTO `idtoad` VALUES (710216, 71, 2, 16, '台湾', '高雄市', '仁武区', 1);
INSERT INTO `idtoad` VALUES (710217, 71, 2, 17, '台湾', '高雄市', '大树区', 1);
INSERT INTO `idtoad` VALUES (710218, 71, 2, 18, '台湾', '高雄市', '大社区', 1);
INSERT INTO `idtoad` VALUES (710219, 71, 2, 19, '台湾', '高雄市', '冈山区', 1);
INSERT INTO `idtoad` VALUES (710220, 71, 2, 20, '台湾', '高雄市', '路竹区', 1);
INSERT INTO `idtoad` VALUES (710221, 71, 2, 21, '台湾', '高雄市', '桥头区', 1);
INSERT INTO `idtoad` VALUES (710222, 71, 2, 22, '台湾', '高雄市', '梓官区', 1);
INSERT INTO `idtoad` VALUES (710223, 71, 2, 23, '台湾', '高雄市', '弥陀区', 1);
INSERT INTO `idtoad` VALUES (710224, 71, 2, 24, '台湾', '高雄市', '永安区', 1);
INSERT INTO `idtoad` VALUES (710225, 71, 2, 25, '台湾', '高雄市', '燕巢区', 1);
INSERT INTO `idtoad` VALUES (710226, 71, 2, 26, '台湾', '高雄市', '田寮区', 1);
INSERT INTO `idtoad` VALUES (710227, 71, 2, 27, '台湾', '高雄市', '阿莲区', 1);
INSERT INTO `idtoad` VALUES (710228, 71, 2, 28, '台湾', '高雄市', '茄萣区', 1);
INSERT INTO `idtoad` VALUES (710229, 71, 2, 29, '台湾', '高雄市', '湖内区', 1);
INSERT INTO `idtoad` VALUES (710230, 71, 2, 30, '台湾', '高雄市', '旗山区', 1);
INSERT INTO `idtoad` VALUES (710231, 71, 2, 31, '台湾', '高雄市', '美浓区', 1);
INSERT INTO `idtoad` VALUES (710232, 71, 2, 32, '台湾', '高雄市', '内门区', 1);
INSERT INTO `idtoad` VALUES (710233, 71, 2, 33, '台湾', '高雄市', '杉林区', 1);
INSERT INTO `idtoad` VALUES (710234, 71, 2, 34, '台湾', '高雄市', '甲仙区', 1);
INSERT INTO `idtoad` VALUES (710235, 71, 2, 35, '台湾', '高雄市', '六龟区', 1);
INSERT INTO `idtoad` VALUES (710236, 71, 2, 36, '台湾', '高雄市', '茂林区', 1);
INSERT INTO `idtoad` VALUES (710237, 71, 2, 37, '台湾', '高雄市', '桃源区', 1);
INSERT INTO `idtoad` VALUES (710238, 71, 2, 38, '台湾', '高雄市', '那玛夏区', 1);
INSERT INTO `idtoad` VALUES (710301, 71, 3, 1, '台湾', '台中市', '中区', 1);
INSERT INTO `idtoad` VALUES (710302, 71, 3, 2, '台湾', '台中市', '东区', 1);
INSERT INTO `idtoad` VALUES (710303, 71, 3, 3, '台湾', '台中市', '南区', 1);
INSERT INTO `idtoad` VALUES (710304, 71, 3, 4, '台湾', '台中市', '西区', 1);
INSERT INTO `idtoad` VALUES (710305, 71, 3, 5, '台湾', '台中市', '北区', 1);
INSERT INTO `idtoad` VALUES (710306, 71, 3, 6, '台湾', '台中市', '北屯区', 1);
INSERT INTO `idtoad` VALUES (710307, 71, 3, 7, '台湾', '台中市', '西屯区', 1);
INSERT INTO `idtoad` VALUES (710308, 71, 3, 8, '台湾', '台中市', '南屯区', 1);
INSERT INTO `idtoad` VALUES (710309, 71, 3, 9, '台湾', '台中市', '太平区', 1);
INSERT INTO `idtoad` VALUES (710310, 71, 3, 10, '台湾', '台中市', '大里区', 1);
INSERT INTO `idtoad` VALUES (710311, 71, 3, 11, '台湾', '台中市', '雾峰区', 1);
INSERT INTO `idtoad` VALUES (710312, 71, 3, 12, '台湾', '台中市', '乌日区', 1);
INSERT INTO `idtoad` VALUES (710313, 71, 3, 13, '台湾', '台中市', '丰原区', 1);
INSERT INTO `idtoad` VALUES (710314, 71, 3, 14, '台湾', '台中市', '后里区', 1);
INSERT INTO `idtoad` VALUES (710315, 71, 3, 15, '台湾', '台中市', '石冈区', 1);
INSERT INTO `idtoad` VALUES (710316, 71, 3, 16, '台湾', '台中市', '东势区', 1);
INSERT INTO `idtoad` VALUES (710317, 71, 3, 17, '台湾', '台中市', '和平区', 1);
INSERT INTO `idtoad` VALUES (710318, 71, 3, 18, '台湾', '台中市', '新社区', 1);
INSERT INTO `idtoad` VALUES (710319, 71, 3, 19, '台湾', '台中市', '潭子区', 1);
INSERT INTO `idtoad` VALUES (710320, 71, 3, 20, '台湾', '台中市', '大雅区', 1);
INSERT INTO `idtoad` VALUES (710321, 71, 3, 21, '台湾', '台中市', '神冈区', 1);
INSERT INTO `idtoad` VALUES (710322, 71, 3, 22, '台湾', '台中市', '大肚区', 1);
INSERT INTO `idtoad` VALUES (710323, 71, 3, 23, '台湾', '台中市', '沙鹿区', 1);
INSERT INTO `idtoad` VALUES (710324, 71, 3, 24, '台湾', '台中市', '龙井区', 1);
INSERT INTO `idtoad` VALUES (710325, 71, 3, 25, '台湾', '台中市', '梧栖区', 1);
INSERT INTO `idtoad` VALUES (710326, 71, 3, 26, '台湾', '台中市', '清水区', 1);
INSERT INTO `idtoad` VALUES (710327, 71, 3, 27, '台湾', '台中市', '大甲区', 1);
INSERT INTO `idtoad` VALUES (710328, 71, 3, 28, '台湾', '台中市', '外埔区', 1);
INSERT INTO `idtoad` VALUES (710329, 71, 3, 29, '台湾', '台中市', '大安区', 1);
INSERT INTO `idtoad` VALUES (710401, 71, 4, 1, '台湾', '台北市', '中正区', 1);
INSERT INTO `idtoad` VALUES (710402, 71, 4, 2, '台湾', '台北市', '大同区', 1);
INSERT INTO `idtoad` VALUES (710403, 71, 4, 3, '台湾', '台北市', '中山区', 1);
INSERT INTO `idtoad` VALUES (710404, 71, 4, 4, '台湾', '台北市', '松山区', 1);
INSERT INTO `idtoad` VALUES (710405, 71, 4, 5, '台湾', '台北市', '大安区', 1);
INSERT INTO `idtoad` VALUES (710406, 71, 4, 6, '台湾', '台北市', '万华区', 1);
INSERT INTO `idtoad` VALUES (710407, 71, 4, 7, '台湾', '台北市', '信义区', 1);
INSERT INTO `idtoad` VALUES (710408, 71, 4, 8, '台湾', '台北市', '士林区', 1);
INSERT INTO `idtoad` VALUES (710409, 71, 4, 9, '台湾', '台北市', '北投区', 1);
INSERT INTO `idtoad` VALUES (710410, 71, 4, 10, '台湾', '台北市', '内湖区', 1);
INSERT INTO `idtoad` VALUES (710411, 71, 4, 11, '台湾', '台北市', '南港区', 1);
INSERT INTO `idtoad` VALUES (710412, 71, 4, 12, '台湾', '台北市', '文山区', 1);
INSERT INTO `idtoad` VALUES (710501, 71, 5, 1, '台湾', '桃园市', '桃园区', 1);
INSERT INTO `idtoad` VALUES (710502, 71, 5, 2, '台湾', '桃园市', '中坜区', 1);
INSERT INTO `idtoad` VALUES (710503, 71, 5, 3, '台湾', '桃园市', '平镇区', 1);
INSERT INTO `idtoad` VALUES (710504, 71, 5, 4, '台湾', '桃园市', '八德区', 1);
INSERT INTO `idtoad` VALUES (710505, 71, 5, 5, '台湾', '桃园市', '杨梅区', 1);
INSERT INTO `idtoad` VALUES (710506, 71, 5, 6, '台湾', '桃园市', '芦竹区', 1);
INSERT INTO `idtoad` VALUES (710507, 71, 5, 7, '台湾', '桃园市', '大溪区', 1);
INSERT INTO `idtoad` VALUES (710508, 71, 5, 8, '台湾', '桃园市', '龙潭区', 1);
INSERT INTO `idtoad` VALUES (710509, 71, 5, 9, '台湾', '桃园市', '龟山区', 1);
INSERT INTO `idtoad` VALUES (710510, 71, 5, 10, '台湾', '桃园市', '大园区', 1);
INSERT INTO `idtoad` VALUES (710511, 71, 5, 11, '台湾', '桃园市', '观音区', 1);
INSERT INTO `idtoad` VALUES (710512, 71, 5, 12, '台湾', '桃园市', '新屋区', 1);
INSERT INTO `idtoad` VALUES (710513, 71, 5, 13, '台湾', '桃园市', '复兴区', 1);
INSERT INTO `idtoad` VALUES (710601, 71, 6, 1, '台湾', '台南市', '中西区', 1);
INSERT INTO `idtoad` VALUES (710602, 71, 6, 2, '台湾', '台南市', '东区', 1);
INSERT INTO `idtoad` VALUES (710603, 71, 6, 3, '台湾', '台南市', '南区', 1);
INSERT INTO `idtoad` VALUES (710604, 71, 6, 4, '台湾', '台南市', '北区', 1);
INSERT INTO `idtoad` VALUES (710605, 71, 6, 5, '台湾', '台南市', '安平区', 1);
INSERT INTO `idtoad` VALUES (710606, 71, 6, 6, '台湾', '台南市', '安南区', 1);
INSERT INTO `idtoad` VALUES (710607, 71, 6, 7, '台湾', '台南市', '永康区', 1);
INSERT INTO `idtoad` VALUES (710608, 71, 6, 8, '台湾', '台南市', '归仁区', 1);
INSERT INTO `idtoad` VALUES (710609, 71, 6, 9, '台湾', '台南市', '新化区', 1);
INSERT INTO `idtoad` VALUES (710610, 71, 6, 10, '台湾', '台南市', '左镇区', 1);
INSERT INTO `idtoad` VALUES (710611, 71, 6, 11, '台湾', '台南市', '玉井区', 1);
INSERT INTO `idtoad` VALUES (710612, 71, 6, 12, '台湾', '台南市', '楠西区', 1);
INSERT INTO `idtoad` VALUES (710613, 71, 6, 13, '台湾', '台南市', '南化区', 1);
INSERT INTO `idtoad` VALUES (710614, 71, 6, 14, '台湾', '台南市', '仁德区', 1);
INSERT INTO `idtoad` VALUES (710615, 71, 6, 15, '台湾', '台南市', '关庙区', 1);
INSERT INTO `idtoad` VALUES (710616, 71, 6, 16, '台湾', '台南市', '龙崎区', 1);
INSERT INTO `idtoad` VALUES (710617, 71, 6, 17, '台湾', '台南市', '官田区', 1);
INSERT INTO `idtoad` VALUES (710618, 71, 6, 18, '台湾', '台南市', '麻豆区', 1);
INSERT INTO `idtoad` VALUES (710619, 71, 6, 19, '台湾', '台南市', '佳里区', 1);
INSERT INTO `idtoad` VALUES (710620, 71, 6, 20, '台湾', '台南市', '西港区', 1);
INSERT INTO `idtoad` VALUES (710621, 71, 6, 21, '台湾', '台南市', '七股区', 1);
INSERT INTO `idtoad` VALUES (710622, 71, 6, 22, '台湾', '台南市', '将军区', 1);
INSERT INTO `idtoad` VALUES (710623, 71, 6, 23, '台湾', '台南市', '学甲区', 1);
INSERT INTO `idtoad` VALUES (710624, 71, 6, 24, '台湾', '台南市', '北门区', 1);
INSERT INTO `idtoad` VALUES (710625, 71, 6, 25, '台湾', '台南市', '新营区', 1);
INSERT INTO `idtoad` VALUES (710626, 71, 6, 26, '台湾', '台南市', '后壁区', 1);
INSERT INTO `idtoad` VALUES (710627, 71, 6, 27, '台湾', '台南市', '白河区', 1);
INSERT INTO `idtoad` VALUES (710628, 71, 6, 28, '台湾', '台南市', '东山区', 1);
INSERT INTO `idtoad` VALUES (710629, 71, 6, 29, '台湾', '台南市', '六甲区', 1);
INSERT INTO `idtoad` VALUES (710630, 71, 6, 30, '台湾', '台南市', '下营区', 1);
INSERT INTO `idtoad` VALUES (710631, 71, 6, 31, '台湾', '台南市', '柳营区', 1);
INSERT INTO `idtoad` VALUES (710632, 71, 6, 32, '台湾', '台南市', '盐水区', 1);
INSERT INTO `idtoad` VALUES (710633, 71, 6, 33, '台湾', '台南市', '善化区', 1);
INSERT INTO `idtoad` VALUES (710634, 71, 6, 34, '台湾', '台南市', '大内区', 1);
INSERT INTO `idtoad` VALUES (710635, 71, 6, 35, '台湾', '台南市', '山上区', 1);
INSERT INTO `idtoad` VALUES (710636, 71, 6, 36, '台湾', '台南市', '新市区', 1);
INSERT INTO `idtoad` VALUES (710637, 71, 6, 37, '台湾', '台南市', '安定区', 1);
INSERT INTO `idtoad` VALUES (710701, 71, 7, 1, '台湾', '彰化县', '彰化市', 1);
INSERT INTO `idtoad` VALUES (710702, 71, 7, 2, '台湾', '彰化县', '员林市', 1);
INSERT INTO `idtoad` VALUES (710703, 71, 7, 3, '台湾', '彰化县', '和美镇', 1);
INSERT INTO `idtoad` VALUES (710704, 71, 7, 4, '台湾', '彰化县', '鹿港镇', 1);
INSERT INTO `idtoad` VALUES (710705, 71, 7, 5, '台湾', '彰化县', '溪湖镇', 1);
INSERT INTO `idtoad` VALUES (710706, 71, 7, 6, '台湾', '彰化县', '二林镇', 1);
INSERT INTO `idtoad` VALUES (710707, 71, 7, 7, '台湾', '彰化县', '田中镇', 1);
INSERT INTO `idtoad` VALUES (710708, 71, 7, 8, '台湾', '彰化县', '北斗镇', 1);
INSERT INTO `idtoad` VALUES (710709, 71, 7, 9, '台湾', '彰化县', '花坛乡', 1);
INSERT INTO `idtoad` VALUES (710710, 71, 7, 10, '台湾', '彰化县', '芬园乡', 1);
INSERT INTO `idtoad` VALUES (710711, 71, 7, 11, '台湾', '彰化县', '大村乡', 1);
INSERT INTO `idtoad` VALUES (710712, 71, 7, 12, '台湾', '彰化县', '永靖乡', 1);
INSERT INTO `idtoad` VALUES (710713, 71, 7, 13, '台湾', '彰化县', '伸港乡', 1);
INSERT INTO `idtoad` VALUES (710714, 71, 7, 14, '台湾', '彰化县', '线西乡', 1);
INSERT INTO `idtoad` VALUES (710715, 71, 7, 15, '台湾', '彰化县', '福兴乡', 1);
INSERT INTO `idtoad` VALUES (710716, 71, 7, 16, '台湾', '彰化县', '秀水乡', 1);
INSERT INTO `idtoad` VALUES (710717, 71, 7, 17, '台湾', '彰化县', '埔心乡', 1);
INSERT INTO `idtoad` VALUES (710718, 71, 7, 18, '台湾', '彰化县', '埔盐乡', 1);
INSERT INTO `idtoad` VALUES (710719, 71, 7, 19, '台湾', '彰化县', '大城乡', 1);
INSERT INTO `idtoad` VALUES (710720, 71, 7, 20, '台湾', '彰化县', '芳苑乡', 1);
INSERT INTO `idtoad` VALUES (710721, 71, 7, 21, '台湾', '彰化县', '竹塘乡', 1);
INSERT INTO `idtoad` VALUES (710722, 71, 7, 22, '台湾', '彰化县', '社头乡', 1);
INSERT INTO `idtoad` VALUES (710723, 71, 7, 23, '台湾', '彰化县', '二水乡', 1);
INSERT INTO `idtoad` VALUES (710724, 71, 7, 24, '台湾', '彰化县', '田尾乡', 1);
INSERT INTO `idtoad` VALUES (710725, 71, 7, 25, '台湾', '彰化县', '埤头乡', 1);
INSERT INTO `idtoad` VALUES (710726, 71, 7, 26, '台湾', '彰化县', '溪州乡', 1);
INSERT INTO `idtoad` VALUES (710801, 71, 8, 1, '台湾', '屏东县', '屏东市', 1);
INSERT INTO `idtoad` VALUES (710802, 71, 8, 2, '台湾', '屏东县', '潮州镇', 1);
INSERT INTO `idtoad` VALUES (710803, 71, 8, 3, '台湾', '屏东县', '东港镇', 1);
INSERT INTO `idtoad` VALUES (710804, 71, 8, 4, '台湾', '屏东县', '恒春镇', 1);
INSERT INTO `idtoad` VALUES (710805, 71, 8, 5, '台湾', '屏东县', '万丹乡', 1);
INSERT INTO `idtoad` VALUES (710806, 71, 8, 6, '台湾', '屏东县', '崁顶乡', 1);
INSERT INTO `idtoad` VALUES (710807, 71, 8, 7, '台湾', '屏东县', '新园乡', 1);
INSERT INTO `idtoad` VALUES (710808, 71, 8, 8, '台湾', '屏东县', '林边乡', 1);
INSERT INTO `idtoad` VALUES (710809, 71, 8, 9, '台湾', '屏东县', '南州乡', 1);
INSERT INTO `idtoad` VALUES (710810, 71, 8, 10, '台湾', '屏东县', '琉球乡', 1);
INSERT INTO `idtoad` VALUES (710811, 71, 8, 11, '台湾', '屏东县', '枋寮乡', 1);
INSERT INTO `idtoad` VALUES (710812, 71, 8, 12, '台湾', '屏东县', '枋山乡', 1);
INSERT INTO `idtoad` VALUES (710813, 71, 8, 13, '台湾', '屏东县', '车城乡', 1);
INSERT INTO `idtoad` VALUES (710814, 71, 8, 14, '台湾', '屏东县', '满州乡', 1);
INSERT INTO `idtoad` VALUES (710815, 71, 8, 15, '台湾', '屏东县', '高树乡', 1);
INSERT INTO `idtoad` VALUES (710816, 71, 8, 16, '台湾', '屏东县', '九如乡', 1);
INSERT INTO `idtoad` VALUES (710817, 71, 8, 17, '台湾', '屏东县', '盐埔乡', 1);
INSERT INTO `idtoad` VALUES (710818, 71, 8, 18, '台湾', '屏东县', '里港乡', 1);
INSERT INTO `idtoad` VALUES (710819, 71, 8, 19, '台湾', '屏东县', '内埔乡', 1);
INSERT INTO `idtoad` VALUES (710820, 71, 8, 20, '台湾', '屏东县', '竹田乡', 1);
INSERT INTO `idtoad` VALUES (710821, 71, 8, 21, '台湾', '屏东县', '长治乡', 1);
INSERT INTO `idtoad` VALUES (710822, 71, 8, 22, '台湾', '屏东县', '麟洛乡', 1);
INSERT INTO `idtoad` VALUES (710823, 71, 8, 23, '台湾', '屏东县', '万峦乡', 1);
INSERT INTO `idtoad` VALUES (710824, 71, 8, 24, '台湾', '屏东县', '新埤乡', 1);
INSERT INTO `idtoad` VALUES (710825, 71, 8, 25, '台湾', '屏东县', '佳冬乡', 1);
INSERT INTO `idtoad` VALUES (710826, 71, 8, 26, '台湾', '屏东县', '雾台乡', 1);
INSERT INTO `idtoad` VALUES (710827, 71, 8, 27, '台湾', '屏东县', '泰武乡', 1);
INSERT INTO `idtoad` VALUES (710828, 71, 8, 28, '台湾', '屏东县', '玛家乡', 1);
INSERT INTO `idtoad` VALUES (710829, 71, 8, 29, '台湾', '屏东县', '来义乡', 1);
INSERT INTO `idtoad` VALUES (710830, 71, 8, 30, '台湾', '屏东县', '春日乡', 1);
INSERT INTO `idtoad` VALUES (710831, 71, 8, 31, '台湾', '屏东县', '狮子乡', 1);
INSERT INTO `idtoad` VALUES (710832, 71, 8, 32, '台湾', '屏东县', '牡丹乡', 1);
INSERT INTO `idtoad` VALUES (710833, 71, 8, 33, '台湾', '屏东县', '三地门乡', 1);
INSERT INTO `idtoad` VALUES (710901, 71, 9, 1, '台湾', '云林县', '斗六市', 1);
INSERT INTO `idtoad` VALUES (710902, 71, 9, 2, '台湾', '云林县', '斗南镇', 1);
INSERT INTO `idtoad` VALUES (710903, 71, 9, 3, '台湾', '云林县', '林内乡', 1);
INSERT INTO `idtoad` VALUES (710904, 71, 9, 4, '台湾', '云林县', '古坑乡', 1);
INSERT INTO `idtoad` VALUES (710905, 71, 9, 5, '台湾', '云林县', '大埤乡', 1);
INSERT INTO `idtoad` VALUES (710906, 71, 9, 6, '台湾', '云林县', '莿桐乡', 1);
INSERT INTO `idtoad` VALUES (710907, 71, 9, 7, '台湾', '云林县', '虎尾镇', 1);
INSERT INTO `idtoad` VALUES (710908, 71, 9, 8, '台湾', '云林县', '西螺镇', 1);
INSERT INTO `idtoad` VALUES (710909, 71, 9, 9, '台湾', '云林县', '土库镇', 1);
INSERT INTO `idtoad` VALUES (710910, 71, 9, 10, '台湾', '云林县', '褒忠乡', 1);
INSERT INTO `idtoad` VALUES (710911, 71, 9, 11, '台湾', '云林县', '二仑乡', 1);
INSERT INTO `idtoad` VALUES (710912, 71, 9, 12, '台湾', '云林县', '仑背乡', 1);
INSERT INTO `idtoad` VALUES (710913, 71, 9, 13, '台湾', '云林县', '麦寮乡', 1);
INSERT INTO `idtoad` VALUES (710914, 71, 9, 14, '台湾', '云林县', '台西乡', 1);
INSERT INTO `idtoad` VALUES (710915, 71, 9, 15, '台湾', '云林县', '东势乡', 1);
INSERT INTO `idtoad` VALUES (710916, 71, 9, 16, '台湾', '云林县', '北港镇', 1);
INSERT INTO `idtoad` VALUES (710917, 71, 9, 17, '台湾', '云林县', '元长乡', 1);
INSERT INTO `idtoad` VALUES (710918, 71, 9, 18, '台湾', '云林县', '四湖乡', 1);
INSERT INTO `idtoad` VALUES (710919, 71, 9, 19, '台湾', '云林县', '口湖乡', 1);
INSERT INTO `idtoad` VALUES (710920, 71, 9, 20, '台湾', '云林县', '水林乡', 1);
INSERT INTO `idtoad` VALUES (711001, 71, 10, 1, '台湾', '苗栗县', '苗栗市', 1);
INSERT INTO `idtoad` VALUES (711002, 71, 10, 2, '台湾', '苗栗县', '造桥乡', 1);
INSERT INTO `idtoad` VALUES (711003, 71, 10, 3, '台湾', '苗栗县', '西湖乡', 1);
INSERT INTO `idtoad` VALUES (711004, 71, 10, 4, '台湾', '苗栗县', '头屋乡', 1);
INSERT INTO `idtoad` VALUES (711005, 71, 10, 5, '台湾', '苗栗县', '公馆乡', 1);
INSERT INTO `idtoad` VALUES (711006, 71, 10, 6, '台湾', '苗栗县', '铜锣乡', 1);
INSERT INTO `idtoad` VALUES (711007, 71, 10, 7, '台湾', '苗栗县', '三义乡', 1);
INSERT INTO `idtoad` VALUES (711008, 71, 10, 8, '台湾', '苗栗县', '大湖乡', 1);
INSERT INTO `idtoad` VALUES (711009, 71, 10, 9, '台湾', '苗栗县', '狮潭乡', 1);
INSERT INTO `idtoad` VALUES (711010, 71, 10, 10, '台湾', '苗栗县', '卓兰镇', 1);
INSERT INTO `idtoad` VALUES (711011, 71, 10, 11, '台湾', '苗栗县', '竹南镇', 1);
INSERT INTO `idtoad` VALUES (711012, 71, 10, 12, '台湾', '苗栗县', '头份市', 1);
INSERT INTO `idtoad` VALUES (711013, 71, 10, 13, '台湾', '苗栗县', '三湾乡', 1);
INSERT INTO `idtoad` VALUES (711014, 71, 10, 14, '台湾', '苗栗县', '南庄乡', 1);
INSERT INTO `idtoad` VALUES (711015, 71, 10, 15, '台湾', '苗栗县', '后龙镇', 1);
INSERT INTO `idtoad` VALUES (711016, 71, 10, 16, '台湾', '苗栗县', '通霄镇', 1);
INSERT INTO `idtoad` VALUES (711017, 71, 10, 17, '台湾', '苗栗县', '苑里镇', 1);
INSERT INTO `idtoad` VALUES (711018, 71, 10, 18, '台湾', '苗栗县', '泰安乡', 1);
INSERT INTO `idtoad` VALUES (711101, 71, 11, 1, '台湾', '新竹县', '竹北市', 1);
INSERT INTO `idtoad` VALUES (711102, 71, 11, 2, '台湾', '新竹县', '竹东镇', 1);
INSERT INTO `idtoad` VALUES (711103, 71, 11, 3, '台湾', '新竹县', '新埔镇', 1);
INSERT INTO `idtoad` VALUES (711104, 71, 11, 4, '台湾', '新竹县', '关西镇', 1);
INSERT INTO `idtoad` VALUES (711105, 71, 11, 5, '台湾', '新竹县', '湖口乡', 1);
INSERT INTO `idtoad` VALUES (711106, 71, 11, 6, '台湾', '新竹县', '新丰乡', 1);
INSERT INTO `idtoad` VALUES (711107, 71, 11, 7, '台湾', '新竹县', '峨眉乡', 1);
INSERT INTO `idtoad` VALUES (711108, 71, 11, 8, '台湾', '新竹县', '宝山乡', 1);
INSERT INTO `idtoad` VALUES (711109, 71, 11, 9, '台湾', '新竹县', '北埔乡', 1);
INSERT INTO `idtoad` VALUES (711110, 71, 11, 10, '台湾', '新竹县', '芎林乡', 1);
INSERT INTO `idtoad` VALUES (711111, 71, 11, 11, '台湾', '新竹县', '横山乡', 1);
INSERT INTO `idtoad` VALUES (711112, 71, 11, 12, '台湾', '新竹县', '尖石乡', 1);
INSERT INTO `idtoad` VALUES (711113, 71, 11, 13, '台湾', '新竹县', '五峰乡', 1);
INSERT INTO `idtoad` VALUES (711201, 71, 12, 1, '台湾', '嘉义县', '太保市', 1);
INSERT INTO `idtoad` VALUES (711202, 71, 12, 2, '台湾', '嘉义县', '朴子市', 1);
INSERT INTO `idtoad` VALUES (711203, 71, 12, 3, '台湾', '嘉义县', '布袋镇', 1);
INSERT INTO `idtoad` VALUES (711204, 71, 12, 4, '台湾', '嘉义县', '大林镇', 1);
INSERT INTO `idtoad` VALUES (711205, 71, 12, 5, '台湾', '嘉义县', '民雄乡', 1);
INSERT INTO `idtoad` VALUES (711206, 71, 12, 6, '台湾', '嘉义县', '溪口乡', 1);
INSERT INTO `idtoad` VALUES (711207, 71, 12, 7, '台湾', '嘉义县', '新港乡', 1);
INSERT INTO `idtoad` VALUES (711208, 71, 12, 8, '台湾', '嘉义县', '六脚乡', 1);
INSERT INTO `idtoad` VALUES (711209, 71, 12, 9, '台湾', '嘉义县', '东石乡', 1);
INSERT INTO `idtoad` VALUES (711210, 71, 12, 10, '台湾', '嘉义县', '义竹乡', 1);
INSERT INTO `idtoad` VALUES (711211, 71, 12, 11, '台湾', '嘉义县', '鹿草乡', 1);
INSERT INTO `idtoad` VALUES (711212, 71, 12, 12, '台湾', '嘉义县', '水上乡', 1);
INSERT INTO `idtoad` VALUES (711213, 71, 12, 13, '台湾', '嘉义县', '中埔乡', 1);
INSERT INTO `idtoad` VALUES (711214, 71, 12, 14, '台湾', '嘉义县', '竹崎乡', 1);
INSERT INTO `idtoad` VALUES (711215, 71, 12, 15, '台湾', '嘉义县', '梅山乡', 1);
INSERT INTO `idtoad` VALUES (711216, 71, 12, 16, '台湾', '嘉义县', '番路乡', 1);
INSERT INTO `idtoad` VALUES (711217, 71, 12, 17, '台湾', '嘉义县', '大埔乡', 1);
INSERT INTO `idtoad` VALUES (711218, 71, 12, 18, '台湾', '嘉义县', '阿里山乡', 1);
INSERT INTO `idtoad` VALUES (711301, 71, 13, 1, '台湾', '南投县', '南投市', 1);
INSERT INTO `idtoad` VALUES (711302, 71, 13, 2, '台湾', '南投县', '埔里镇', 1);
INSERT INTO `idtoad` VALUES (711303, 71, 13, 3, '台湾', '南投县', '草屯镇', 1);
INSERT INTO `idtoad` VALUES (711304, 71, 13, 4, '台湾', '南投县', '竹山镇', 1);
INSERT INTO `idtoad` VALUES (711305, 71, 13, 5, '台湾', '南投县', '集集镇', 1);
INSERT INTO `idtoad` VALUES (711306, 71, 13, 6, '台湾', '南投县', '名间乡', 1);
INSERT INTO `idtoad` VALUES (711307, 71, 13, 7, '台湾', '南投县', '鹿谷乡', 1);
INSERT INTO `idtoad` VALUES (711308, 71, 13, 8, '台湾', '南投县', '中寮乡', 1);
INSERT INTO `idtoad` VALUES (711309, 71, 13, 9, '台湾', '南投县', '鱼池乡', 1);
INSERT INTO `idtoad` VALUES (711310, 71, 13, 10, '台湾', '南投县', '国姓乡', 1);
INSERT INTO `idtoad` VALUES (711311, 71, 13, 11, '台湾', '南投县', '水里乡', 1);
INSERT INTO `idtoad` VALUES (711312, 71, 13, 12, '台湾', '南投县', '信义乡', 1);
INSERT INTO `idtoad` VALUES (711313, 71, 13, 13, '台湾', '南投县', '仁爱乡', 1);
INSERT INTO `idtoad` VALUES (711401, 71, 14, 1, '台湾', '宜兰县', '宜兰市', 1);
INSERT INTO `idtoad` VALUES (711402, 71, 14, 2, '台湾', '宜兰县', '头城镇', 1);
INSERT INTO `idtoad` VALUES (711403, 71, 14, 3, '台湾', '宜兰县', '礁溪乡', 1);
INSERT INTO `idtoad` VALUES (711404, 71, 14, 4, '台湾', '宜兰县', '壮围乡', 1);
INSERT INTO `idtoad` VALUES (711405, 71, 14, 5, '台湾', '宜兰县', '员山乡', 1);
INSERT INTO `idtoad` VALUES (711406, 71, 14, 6, '台湾', '宜兰县', '罗东镇', 1);
INSERT INTO `idtoad` VALUES (711407, 71, 14, 7, '台湾', '宜兰县', '苏澳镇', 1);
INSERT INTO `idtoad` VALUES (711408, 71, 14, 8, '台湾', '宜兰县', '五结乡', 1);
INSERT INTO `idtoad` VALUES (711409, 71, 14, 9, '台湾', '宜兰县', '三星乡', 1);
INSERT INTO `idtoad` VALUES (711410, 71, 14, 10, '台湾', '宜兰县', '冬山乡', 1);
INSERT INTO `idtoad` VALUES (711411, 71, 14, 11, '台湾', '宜兰县', '大同乡', 1);
INSERT INTO `idtoad` VALUES (711412, 71, 14, 12, '台湾', '宜兰县', '南澳乡', 1);
INSERT INTO `idtoad` VALUES (711501, 71, 15, 1, '台湾', '新竹市', '东区', 1);
INSERT INTO `idtoad` VALUES (711502, 71, 15, 2, '台湾', '新竹市', '北区', 1);
INSERT INTO `idtoad` VALUES (711503, 71, 15, 3, '台湾', '新竹市', '香山区', 1);
INSERT INTO `idtoad` VALUES (711601, 71, 16, 1, '台湾', '基隆市', '仁爱区', 1);
INSERT INTO `idtoad` VALUES (711602, 71, 16, 2, '台湾', '基隆市', '中正区', 1);
INSERT INTO `idtoad` VALUES (711603, 71, 16, 3, '台湾', '基隆市', '信义区', 1);
INSERT INTO `idtoad` VALUES (711604, 71, 16, 4, '台湾', '基隆市', '中山区', 1);
INSERT INTO `idtoad` VALUES (711605, 71, 16, 5, '台湾', '基隆市', '安乐区', 1);
INSERT INTO `idtoad` VALUES (711606, 71, 16, 6, '台湾', '基隆市', '暖暖区', 1);
INSERT INTO `idtoad` VALUES (711607, 71, 16, 7, '台湾', '基隆市', '七堵区', 1);
INSERT INTO `idtoad` VALUES (711701, 71, 17, 1, '台湾', '花莲县', '花莲市', 1);
INSERT INTO `idtoad` VALUES (711702, 71, 17, 2, '台湾', '花莲县', '凤林镇', 1);
INSERT INTO `idtoad` VALUES (711703, 71, 17, 3, '台湾', '花莲县', '玉里镇', 1);
INSERT INTO `idtoad` VALUES (711704, 71, 17, 4, '台湾', '花莲县', '新城乡', 1);
INSERT INTO `idtoad` VALUES (711705, 71, 17, 5, '台湾', '花莲县', '吉安乡', 1);
INSERT INTO `idtoad` VALUES (711706, 71, 17, 6, '台湾', '花莲县', '寿丰乡', 1);
INSERT INTO `idtoad` VALUES (711707, 71, 17, 7, '台湾', '花莲县', '光复乡', 1);
INSERT INTO `idtoad` VALUES (711708, 71, 17, 8, '台湾', '花莲县', '丰滨乡', 1);
INSERT INTO `idtoad` VALUES (711709, 71, 17, 9, '台湾', '花莲县', '瑞穗乡', 1);
INSERT INTO `idtoad` VALUES (711710, 71, 17, 10, '台湾', '花莲县', '富里乡', 1);
INSERT INTO `idtoad` VALUES (711711, 71, 17, 11, '台湾', '花莲县', '秀林乡', 1);
INSERT INTO `idtoad` VALUES (711712, 71, 17, 12, '台湾', '花莲县', '万荣乡', 1);
INSERT INTO `idtoad` VALUES (711713, 71, 17, 13, '台湾', '花莲县', '卓溪乡', 1);
INSERT INTO `idtoad` VALUES (711801, 71, 18, 1, '台湾', '嘉义市', '东区', 1);
INSERT INTO `idtoad` VALUES (711802, 71, 18, 2, '台湾', '嘉义市', '西区', 1);
INSERT INTO `idtoad` VALUES (711901, 71, 19, 1, '台湾', '台东县', '台东市', 1);
INSERT INTO `idtoad` VALUES (711902, 71, 19, 2, '台湾', '台东县', '成功镇', 1);
INSERT INTO `idtoad` VALUES (711903, 71, 19, 3, '台湾', '台东县', '关山镇', 1);
INSERT INTO `idtoad` VALUES (711904, 71, 19, 4, '台湾', '台东县', '长滨乡', 1);
INSERT INTO `idtoad` VALUES (711905, 71, 19, 5, '台湾', '台东县', '池上乡', 1);
INSERT INTO `idtoad` VALUES (711906, 71, 19, 6, '台湾', '台东县', '东河乡', 1);
INSERT INTO `idtoad` VALUES (711907, 71, 19, 7, '台湾', '台东县', '鹿野乡', 1);
INSERT INTO `idtoad` VALUES (711908, 71, 19, 8, '台湾', '台东县', '卑南乡', 1);
INSERT INTO `idtoad` VALUES (711909, 71, 19, 9, '台湾', '台东县', '大武乡', 1);
INSERT INTO `idtoad` VALUES (711910, 71, 19, 10, '台湾', '台东县', '绿岛乡', 1);
INSERT INTO `idtoad` VALUES (711911, 71, 19, 11, '台湾', '台东县', '太麻里乡', 1);
INSERT INTO `idtoad` VALUES (711912, 71, 19, 12, '台湾', '台东县', '海端乡', 1);
INSERT INTO `idtoad` VALUES (711913, 71, 19, 13, '台湾', '台东县', '延平乡', 1);
INSERT INTO `idtoad` VALUES (711914, 71, 19, 14, '台湾', '台东县', '金峰乡', 1);
INSERT INTO `idtoad` VALUES (711915, 71, 19, 15, '台湾', '台东县', '达仁乡', 1);
INSERT INTO `idtoad` VALUES (711916, 71, 19, 16, '台湾', '台东县', '兰屿乡', 1);
INSERT INTO `idtoad` VALUES (712001, 71, 20, 1, '台湾', '金门县', '金城镇', 1);
INSERT INTO `idtoad` VALUES (712002, 71, 20, 2, '台湾', '金门县', '金湖镇', 1);
INSERT INTO `idtoad` VALUES (712003, 71, 20, 3, '台湾', '金门县', '金沙镇', 1);
INSERT INTO `idtoad` VALUES (712004, 71, 20, 4, '台湾', '金门县', '金宁乡', 1);
INSERT INTO `idtoad` VALUES (712005, 71, 20, 5, '台湾', '金门县', '烈屿乡', 1);
INSERT INTO `idtoad` VALUES (712006, 71, 20, 6, '台湾', '金门县', '乌丘乡', 1);
INSERT INTO `idtoad` VALUES (712101, 71, 21, 1, '台湾', '澎湖县', '马公市', 1);
INSERT INTO `idtoad` VALUES (712102, 71, 21, 2, '台湾', '澎湖县', '湖西乡', 1);
INSERT INTO `idtoad` VALUES (712103, 71, 21, 3, '台湾', '澎湖县', '白沙乡', 1);
INSERT INTO `idtoad` VALUES (712104, 71, 21, 4, '台湾', '澎湖县', '西屿乡', 1);
INSERT INTO `idtoad` VALUES (712105, 71, 21, 5, '台湾', '澎湖县', '望安乡', 1);
INSERT INTO `idtoad` VALUES (712106, 71, 21, 6, '台湾', '澎湖县', '七美乡', 1);
INSERT INTO `idtoad` VALUES (712201, 71, 22, 1, '台湾', '连江县', '南竿乡', 1);
INSERT INTO `idtoad` VALUES (712202, 71, 22, 2, '台湾', '连江县', '北竿乡', 1);
INSERT INTO `idtoad` VALUES (712203, 71, 22, 3, '台湾', '连江县', '莒光乡', 1);
INSERT INTO `idtoad` VALUES (712204, 71, 22, 4, '台湾', '连江县', '东引乡', 1);
INSERT INTO `idtoad` VALUES (810101, 81, 1, 1, '香港', '香港岛', '中西区', 1);
INSERT INTO `idtoad` VALUES (810102, 81, 1, 2, '香港', '香港岛', '湾仔区', 1);
INSERT INTO `idtoad` VALUES (810103, 81, 1, 3, '香港', '香港岛', '东区', 1);
INSERT INTO `idtoad` VALUES (810104, 81, 1, 4, '香港', '香港岛', '南区', 1);
INSERT INTO `idtoad` VALUES (810201, 81, 2, 1, '香港', '九龙', '九龙城区', 1);
INSERT INTO `idtoad` VALUES (810202, 81, 2, 2, '香港', '九龙', '深水埗区', 1);
INSERT INTO `idtoad` VALUES (810203, 81, 2, 3, '香港', '九龙', '观塘区', 1);
INSERT INTO `idtoad` VALUES (810204, 81, 2, 4, '香港', '九龙', '黄大仙区', 1);
INSERT INTO `idtoad` VALUES (810205, 81, 2, 5, '香港', '九龙', '油尖旺区', 1);
INSERT INTO `idtoad` VALUES (810301, 81, 3, 1, '香港', '新界', '北区', 1);
INSERT INTO `idtoad` VALUES (810302, 81, 3, 2, '香港', '新界', '大埔区', 1);
INSERT INTO `idtoad` VALUES (810303, 81, 3, 3, '香港', '新界', '沙田区', 1);
INSERT INTO `idtoad` VALUES (810304, 81, 3, 4, '香港', '新界', '西贡区', 1);
INSERT INTO `idtoad` VALUES (810305, 81, 3, 5, '香港', '新界', '元朗区', 1);
INSERT INTO `idtoad` VALUES (810306, 81, 3, 6, '香港', '新界', '屯门区', 1);
INSERT INTO `idtoad` VALUES (810307, 81, 3, 7, '香港', '新界', '葵青区', 1);
INSERT INTO `idtoad` VALUES (810308, 81, 3, 8, '香港', '新界', '荃湾区', 1);
INSERT INTO `idtoad` VALUES (810309, 81, 3, 9, '香港', '新界', '离岛区', 1);
INSERT INTO `idtoad` VALUES (820101, 82, 1, 1, '澳门', '澳门半岛', '花地玛堂区', 1);
INSERT INTO `idtoad` VALUES (820102, 82, 1, 2, '澳门', '澳门半岛', '圣安多尼堂区', 1);
INSERT INTO `idtoad` VALUES (820103, 82, 1, 3, '澳门', '澳门半岛', '大堂区', 1);
INSERT INTO `idtoad` VALUES (820104, 82, 1, 4, '澳门', '澳门半岛', '望德堂区', 1);
INSERT INTO `idtoad` VALUES (820105, 82, 1, 5, '澳门', '澳门半岛', '风顺堂区', 1);
INSERT INTO `idtoad` VALUES (820201, 82, 2, 1, '澳门', '氹仔岛', '嘉模堂区', 1);
INSERT INTO `idtoad` VALUES (820301, 82, 3, 1, '澳门', '路环岛', '圣方济各堂区', 1);
INSERT INTO `idtoad` VALUES (820401, 82, 4, 1, '澳门', '非堂区', '路氹城', 1);
INSERT INTO `idtoad` VALUES (820402, 82, 4, 2, '澳门', '非堂区', '澳门新城区', 1);
COMMIT;

SET FOREIGN_KEY_CHECKS = 1;
